searchNodes=[{"doc":"A small DSL for declaring APIs Apis are the entrypoints for working with your resources. Apis may optionally include a list of resources, in which case they can be used as an Ash.Registry in various places. This is for backwards compatibility, but if at all possible you should define an Ash.Registry if you are using an extension that requires a list of resources. For example, most extensions look for two application environment variables called :ash_apis and :ash_registries to find any potential registries DSL Documentation Index api resources execution authorization Docs api General Api configuration Examples: api do description &quot;&quot;&quot; Resources related to the flux capacitor. &quot;&quot;&quot; end :description ( String.t/0 ) - A description for the api. resources List the resources present in this API Examples: resources do registry MyApp.Registry en :allow - Support a dynamic resource list by providing a callback that checks whether or not the resource should be allowed. :allow_unregistered? ( boolean/0 ) - Whether the Api will support only registered entries or not. The default value is false . :registry ( atom/0 ) - Configure the registry that contains the resources. It is recommended to use application config for this, to help with compile times. See the quick start guide for more. execution Options for how requests are executed using this Api Examples: execution do timeout :timer . seconds ( 30 ) end :timeout ( timeout/0 ) - The default timeout to use for requests using this API. See the timeouts guide for more. The default value is 30000 . :trace_name ( String.t/0 ) - The name to use in traces. Defaults to the last part of the module. See the monitoring guide for more authorization Options for how requests are authorized using this Api. See the security guide for more. Examples: authorization do authorize :by_default end :require_actor? ( boolean/0 ) - Requires that an actor has been supplied. The default value is false . :authorize - When to run authorization for a given request. The default value is :when_requested .","ref":"Ash.Api.Dsl.html","title":"Ash.Api.Dsl","type":"module"},{"doc":"An ETS (Erlang Term Storage) backed Ash Datalayer, for testing and lightweight usage. Remember, this does not have support for transactions! This is not recommended for production use, especially in multi-user applications. It can, however, be great for prototyping. DSL Documentation Index ets Docs ets A section for configuring the ets data layer Examples: ets do # Used in testing private? true end :private? ( boolean/0 ) - Sets the ets table protection to private, and scopes it to only this process. The table name will not be used directly if this is true, to allow multiple processes to use this resource separately. The default value is false . :table ( atom/0 ) - The name of the table. Defaults to the resource name.","ref":"Ash.DataLayer.Ets.html","title":"Ash.DataLayer.Ets","type":"module"},{"doc":"See Ash.DataLayer.Ets.Info.private?/1 .","ref":"Ash.DataLayer.Ets.html#private?/1","title":"Ash.DataLayer.Ets.private?/1","type":"function"},{"doc":"Stops the storage for a given resource/tenant (deleting all of the data)","ref":"Ash.DataLayer.Ets.html#stop/2","title":"Ash.DataLayer.Ets.stop/2","type":"function"},{"doc":"See Ash.DataLayer.Ets.Info.table/1 .","ref":"Ash.DataLayer.Ets.html#table/1","title":"Ash.DataLayer.Ets.table/1","type":"function"},{"doc":"An Mnesia backed Ash Datalayer. In your application initialization, you will need to call Mnesia.create_schema([node()]) . Additionally, you will want to create your mnesia tables there. This data layer is unoptimized , fetching all records from a table and filtering them in memory. For that reason, it is not recommended to use it with large amounts of data. It can be great for prototyping or light usage, though. DSL Documentation Index mnesia Docs mnesia A section for configuring the mnesia data layer Examples: mnesia do table :custom_table end :table ( atom/0 ) - The table name to use, defaults to the name of the resource","ref":"Ash.DataLayer.Mnesia.html","title":"Ash.DataLayer.Mnesia","type":"module"},{"doc":"Creates the table for each mnesia resource in an api","ref":"Ash.DataLayer.Mnesia.html#start/2","title":"Ash.DataLayer.Mnesia.start/2","type":"function"},{"doc":"See Ash.DataLayer.Mnesia.Info.table/1 .","ref":"Ash.DataLayer.Mnesia.html#table/1","title":"Ash.DataLayer.Mnesia.table/1","type":"function"},{"doc":"A data layer that returns structs. This is the data layer that is used under the hood by embedded resources, and resources without data layers.","ref":"Ash.DataLayer.Simple.html","title":"Ash.DataLayer.Simple","type":"module"},{"doc":"Sets the data for a query against a data-layer-less resource","ref":"Ash.DataLayer.Simple.html#set_data/2","title":"Ash.DataLayer.Simple.set_data/2","type":"function"},{"doc":"The built in flow DSL. DSL Documentation Index flow argument steps map branch create debug update destroy validate read run_flow custom transaction create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom transaction branch create debug update destroy validate read run_flow custom map create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom branch map create debug update destroy validate read run_flow custom transaction create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom Docs flow Details about the flow itself, like description and the successful return type. argument :api ( atom/0 ) - An api to use by default when calling actions :description ( String.t/0 ) - A description of the flow :trace_name ( String.t/0 ) - The name to use when creating traces. Defaults to the short name. :short_name ( atom/0 ) - A short name to use for the flow. Defaults to the last to parts of the module name, underscored. :returns ( term/0 ) - The step or step that should constitute the return value. argument An argument to be passed into the flow Examples: argument :params , :map do default %{ } end argument :retries , :integer do allow_nil? false end :name ( atom/0 ) - Required. The name to use for the argument :type ( term/0 ) - Required. The type of the argument. See Ash.Type for more. :default - A default value to use for the argument if not provided :allow_nil? ( boolean/0 ) - Whether or not the argument value may be nil The default value is true . :constraints ( keyword/0 ) - Constraints to provide to the type when casting the value. See the type's documentation for more information. The default value is [] . steps The steps to run. map branch create debug update destroy validate read run_flow custom transaction create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom transaction branch create debug update destroy validate read run_flow custom map create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom branch map create debug update destroy validate read run_flow custom transaction create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom Examples: steps do # invokes a create action create :create_post , MyApp.Post , :create end Imports: Ash.Flow.StepHelpers map Runs a set of steps for each item in a provided list. branch create debug update destroy validate read run_flow custom transaction create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom Examples: map :create_users , range ( 1 , arg ( :count ) ) do output :create_user create :create_user , Org , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end end :over ( term/0 ) - The value to be iterated over. Will be available inside the map step as element(:map_step_name) :output ( atom/0 ) - Which step to use when constructing the output list. Defaults to the last step. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. branch Runs a set of steps based on a given value. create debug update destroy validate read run_flow custom Examples: branch :create_users , result ( :create_users? ) do output :create_user create :create_user , Org , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end end :condition ( term/0 ) - A template that must evaluate to true for the branch to be executed. :output ( atom/0 ) - Which step to use as the output. Defaults to the last step. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. transaction Runs a set of steps in a transaction. create debug update destroy validate read run_flow custom Examples: transaction :create_users do create :create_user , User , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end create :create_user , Org , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end end :output ( term/0 ) - Which step or steps to use when constructing the output. Defaults to the last step. :timeout ( timeout/0 ) - A timeout to apply to the transaction. :resource - The Ash resource to use for the transaction. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. transaction Runs a set of steps in a transaction. branch create debug update destroy validate read run_flow custom map create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom Examples: transaction :create_users do create :create_user , User , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end create :create_user , Org , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end end :output ( term/0 ) - Which step or steps to use when constructing the output. Defaults to the last step. :timeout ( timeout/0 ) - A timeout to apply to the transaction. :resource - The Ash resource to use for the transaction. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. branch Runs a set of steps based on a given value. create debug update destroy validate read run_flow custom Examples: branch :create_users , result ( :create_users? ) do output :create_user create :create_user , Org , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end end :condition ( term/0 ) - A template that must evaluate to true for the branch to be executed. :output ( atom/0 ) - Which step to use as the output. Defaults to the last step. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. map Runs a set of steps for each item in a provided list. create debug update destroy validate read run_flow custom Examples: map :create_users , range ( 1 , arg ( :count ) ) do output :create_user create :create_user , Org , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end end :over ( term/0 ) - The value to be iterated over. Will be available inside the map step as element(:map_step_name) :output ( atom/0 ) - Which step to use when constructing the output list. Defaults to the last step. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. branch Runs a set of steps based on a given value. map create debug update destroy validate read run_flow custom transaction create debug update destroy validate read run_flow custom create debug update destroy validate read run_flow custom Examples: branch :create_users , result ( :create_users? ) do output :create_user create :create_user , Org , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end end :condition ( term/0 ) - A template that must evaluate to true for the branch to be executed. :output ( atom/0 ) - Which step to use as the output. Defaults to the last step. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. map Runs a set of steps for each item in a provided list. create debug update destroy validate read run_flow custom Examples: map :create_users , range ( 1 , arg ( :count ) ) do output :create_user create :create_user , Org , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end end :over ( term/0 ) - The value to be iterated over. Will be available inside the map step as element(:map_step_name) :output ( atom/0 ) - Which step to use when constructing the output list. Defaults to the last step. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. transaction Runs a set of steps in a transaction. create debug update destroy validate read run_flow custom Examples: transaction :create_users do create :create_user , User , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end create :create_user , Org , :create do input %{ first_name : { Faker.Person , :first_name , [ ] } , last_name : { Faker.Person , :last_name , [ ] } } end end :output ( term/0 ) - Which step or steps to use when constructing the output. Defaults to the last step. :timeout ( timeout/0 ) - A timeout to apply to the transaction. :resource - The Ash resource to use for the transaction. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. create Declares a step that will call a create action on a resource. Examples: create :create_post , MyApp.Post , :create :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. debug Declares a step that will inspect its input and provide additional debug information. Examples: debug :show_some_information do input %{ post : result ( :create_post ) } end :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. update Declares a step that will call a update action on a resource. Examples: update :update_post , MyApp.Post , :update do record result ( :get_post ) end :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. destroy Declares a step that will call a destroy action on a resource. Examples: destroy :destroy_post , MyApp.Post , :destroy :record ( term/0 ) - Required. The record to be updated, can use template helpers, e.g result(:step_name) . If the value is nil , the step is skipped and nil is the result of the step. Any other value is used as an input record. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. validate Validates some input against an action. Examples: validate :update_post , MyApp.Post , :update do record result ( :get_post ) only_keys [ :name ] end :record ( term/0 ) - The record to be created/updated/destroyed, if relevant. can use template helpers, e.g result(:step_name) . If the value is nil and would be required by the action type, the step is skipped and nil is the result of the step. Any other value is used as an input record. :only_keys - If the keys are set, the step will succeed as long as there are no errors for those specific fields. Additionally, only errors for those keys will be returned. Use a list for the key if you want to check for an error at a path, and use :_ to allow anything at that path :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. read Declares a step that will call a read action on a resource. Examples: read :destroy_post , MyApp.Post , :destroy :get? ( boolean/0 ) - Whether or not read action is expected to return a single result or nil . If the action is configured with get? true then this is automatically set to true . The default value is false . :not_found_error? ( boolean/0 ) - Whether or not finding no record should result in a not found error The default value is true . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. :resource ( term/0 ) - Required. The resource to call the action on. :action ( term/0 ) - Required. The action to call on the resource. :api ( term/0 ) - The api to use when calling the action. Defaults to the api set in the flow section. :tenant ( term/0 ) - A tenant to use for the operation. May be a template or a literal value. :input ( term/0 ) - A template for the input. run_flow Runs another flow as part of the current flow. The return value of the step is the return value of the flow. Examples: run_flow :get_org , GetOrgByName do input %{ name : arg ( :org_name ) } :flow ( atom/0 ) - Required. The flow to run. :input ( term/0 ) - A template for the input. :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step. custom Runs a custom step module. See Ash.Flow.Step for the necessary callbacks and more information. Examples: custom :do_custom_thing , MyApp.DoCustomThing do input %{ ... } end custom :do_custom_thing , { MyApp.DoCustomThing , opt1 : :foo , opt2 : :bar } do input %{ ... } end :input ( term/0 ) - A template for the input. :custom - The module that implements the step behaviour. Also accepts a 2 argument function that takes the input and the context. :async? ( boolean/0 ) - Whether or not this step can be run outside of the current process. Defaults to true. The default value is false . :name ( atom/0 ) - Required. The name of the step. Will be used when expressing dependencies, and step inputs. :short_name ( String.t/0 ) - Set a short name for the step. Will be used when building things like mermaid charts. :wait_for ( term/0 ) - Ensures that the step happens after the configured step or steps. This value is just a template that isn't used, except to determine dependencies, so you can use it like this wait_for [result(:step_one), result(:step_two)] or wait_for result(:step) . :touches_resources (list of atom/0 ) - A list of resources touched by any custom logic in this step. This is used in the case that this step is run in a transaction. This is primarily only needed for custom steps. :halt_if ( term/0 ) - Halts the step by emitting an error (with an Ash.Error.Flow.Halted ). Can use template variables. To attach a specific reason, use a halt_reason . If you need more complex halting logic, then you'd want to use a custom step, and return {:error, Ash.Error.Flow.Halted.exception(...)} :halt_reason ( term/0 ) - Configures the reason for the halt_if clause. The default value is :halted . :description ( String.t/0 ) - A description for the step.","ref":"Ash.Flow.Dsl.html","title":"Ash.Flow.Dsl","type":"module"},{"doc":"A pubsub notifier extension. DSL Documentation Index pub_sub publish publish_all Docs pub_sub A section for configuring how resource actions are published over pubsub See the PubSub and Notifiers guide for more. publish publish_all Examples: pub_sub do module MyEndpoint prefix &quot;post&quot; broadcast_type :phoenix_broadcast publish :destroy , [ &quot;foo&quot; , :id ] publish :update , [ &quot;bar&quot; , :name ] event : &quot;name_change&quot; publish_all :create , &quot;created&quot; end :module ( atom/0 ) - Required. The module to call broadcast/3 on e.g module.broadcast(topic, event, message). :prefix ( String.t/0 ) - A prefix for all pubsub messages, e.g users . A message with created would be published as users:created :broadcast_type - What shape the event payloads will be in. :notification just sends the notification, phoenix_broadcast sends a %Phoenix.Socket.Broadcast{} , and :broadcast sends %{topic: (topic), event: (event), notification: (notification)} The default value is :notification . :name ( atom/0 ) - A named pub sub to pass as the first argument to broadcast. If you are using a phoenix Endpoint module for pubsub then this is unnecessary. If you want to use a custom pub sub started with something like {Phoenix.PubSub, name: MyName} , then you can provide MyName to here. publish Configure a given action to publish its results over a given topic. See the PubSub and Notifiers guides for more. Examples: publish :create , &quot;created&quot; publish :assign , &quot;assigned&quot; :action ( atom/0 ) - Required. The name of the action that should be published :topic - Required. The topic to publish :event ( String.t/0 ) - The name of the event to publish. Defaults to the action name :dispatcher ( atom/0 ) - The module to use as a dispatcher. If none is set, the pubsub module provided is used. publish_all Works just like publish , except that it takes a type and publishes all actions of that type See the PubSub and Notifiers guides for more. Examples: publish_all :create , &quot;created&quot; :type - Publish on all actions of a given type :action ( atom/0 ) - The name of the action that should be published :topic - Required. The topic to publish :event ( String.t/0 ) - The name of the event to publish. Defaults to the action name :dispatcher ( atom/0 ) - The module to use as a dispatcher. If none is set, the pubsub module provided is used.","ref":"Ash.Notifier.PubSub.html","title":"Ash.Notifier.PubSub","type":"module"},{"doc":"See Ash.Notifier.PubSub.Info.module/1 .","ref":"Ash.Notifier.PubSub.html#module/1","title":"Ash.Notifier.PubSub.module/1","type":"function"},{"doc":"See Ash.Notifier.PubSub.Info.name/1 .","ref":"Ash.Notifier.PubSub.html#name/1","title":"Ash.Notifier.PubSub.name/1","type":"function"},{"doc":"See Ash.Notifier.PubSub.Info.prefix/1 .","ref":"Ash.Notifier.PubSub.html#prefix/1","title":"Ash.Notifier.PubSub.prefix/1","type":"function"},{"doc":"See Ash.Notifier.PubSub.Info.publications/1 .","ref":"Ash.Notifier.PubSub.html#publications/1","title":"Ash.Notifier.PubSub.publications/1","type":"function"},{"doc":"","ref":"Ash.Notifier.PubSub.html#to_payload/3","title":"Ash.Notifier.PubSub.to_payload/3","type":"function"},{"doc":"An authorization extension for ash resources. To add this extension to a resource, add it to the list of authorizers like so: use Ash.Resource , ... , authorizers : [ Ash.Policy.Authorizer ] A resource can be given a set of policies, which are enforced on each call to a resource action. For reads, policies can be configured to filter out data that the actor shouldn't see, as opposed to resulting in a forbidden error. See the policies guide for practical examples. Policies are solved/managed via a boolean satisfiability solver. To read more about boolean satisfiability, see this page: https://en.wikipedia.org/wiki/Boolean_satisfiability_problem . At the end of the day, however, it is not necessary to understand exactly how Ash takes your authorization requirements and determines if a request is allowed. The important thing to understand is that Ash may or may not run any/all of your authorization rules as they may be deemed unnecessary. As such, authorization checks should have no side effects. Ideally, the checks built-in to ash should cover the bulk of your needs. DSL Documentation Index policies policy authorize_if forbid_if authorize_unless forbid_unless bypass authorize_if forbid_if authorize_unless forbid_unless Docs policies A section for declaring authorization policies. Each policy that applies must pass independently in order for the request to be authorized. See the policies guide for more. policy authorize_if forbid_if authorize_unless forbid_unless bypass authorize_if forbid_if authorize_unless forbid_unless Examples: policies do # Anything you can use in a condition, you can use in a check, and vice-versa # This policy applies if the actor is a super_user # Additionally, this policy is declared as a `bypass`. That means that this check is allowed to fail without # failing the whole request, and that if this check *passes*, the entire request passes. bypass actor_attribute_equals ( :super_user , true ) do authorize_if always ( ) end # This will likely be a common occurrence. Specifically, policies that apply to all read actions policy action_type ( :read ) do # unless the actor is an active user, forbid their request forbid_unless actor_attribute_equals ( :active , true ) # if the record is marked as public, authorize the request authorize_if attribute ( :public , true ) # if the actor is related to the data via that data&#39;s `owner` relationship, authorize the request authorize_if relates_to_actor_via ( :owner ) end end Imports: Ash.Policy.Check.Builtins Ash.Filter.TemplateHelpers :default_access_type - The default access type of policies for this resource. The default value is :filter . policy A policy has a name, a condition, and a list of checks. Checks apply logically in the order they are specified, from top to bottom. If no check explicitly authorizes the request, then the request is forbidden. This means that, if you want to &quot;blacklist&quot; instead of &quot;whitelist&quot;, you likely want to add an authorize_if always() at the bottom of your policy, like so: policy action_type ( :read ) do forbid_if not_logged_in ( ) forbid_if user_is_denylisted ( ) forbid_if user_is_in_denylisted_group ( ) authorize_if always ( ) end If the policy should always run, use the always() check, like so: policy always ( ) do ... end See the policies guide for more. authorize_if forbid_if authorize_unless forbid_unless :description ( String.t/0 ) - A description for the policy, used when explaining authorization results :access_type - What portion of the checks inside the policy are allowed to run. See the guide for more. :condition - A check or list of checks that must be true in order for this policy to apply. authorize_if If the check is true, the request is authorized, otherwise run remaining checks. Examples: authorize_if logged_in ( ) authorize_if actor_attribute_matches_record ( :group , :group ) :check - Required. The check to run. See Ash.Policy.Check for more. :name ( String.t/0 ) - A short name or description for the check, used when explaining authorization results forbid_if If the check is true, the request is forbidden, otherwise run remaining checks. Examples: forbid_if not_logged_in ( ) forbid_if actor_attribute_matches_record ( :group , :blacklisted_groups ) :check - Required. The check to run. See Ash.Policy.Check for more. :name ( String.t/0 ) - A short name or description for the check, used when explaining authorization results authorize_unless If the check is false, the request is authorized, otherwise run remaining checks. Examples: authorize_unless not_logged_in ( ) authorize_unless actor_attribute_matches_record ( :group , :blacklisted_groups ) :check - Required. The check to run. See Ash.Policy.Check for more. :name ( String.t/0 ) - A short name or description for the check, used when explaining authorization results forbid_unless If the check is true, the request is forbidden, otherwise run remaining checks. Examples: forbid_unless logged_in ( ) forbid_unless actor_attribute_matches_record ( :group , :group ) :check - Required. The check to run. See Ash.Policy.Check for more. :name ( String.t/0 ) - A short name or description for the check, used when explaining authorization results bypass A policy that, if passed, will skip all following policies. If failed, authorization moves on to the next policy authorize_if forbid_if authorize_unless forbid_unless :description ( String.t/0 ) - A description for the policy, used when explaining authorization results :access_type - What portion of the checks inside the policy are allowed to run. See the guide for more. :condition - A check or list of checks that must be true in order for this policy to apply. authorize_if If the check is true, the request is authorized, otherwise run remaining checks. Examples: authorize_if logged_in ( ) authorize_if actor_attribute_matches_record ( :group , :group ) :check - Required. The check to run. See Ash.Policy.Check for more. :name ( String.t/0 ) - A short name or description for the check, used when explaining authorization results forbid_if If the check is true, the request is forbidden, otherwise run remaining checks. Examples: forbid_if not_logged_in ( ) forbid_if actor_attribute_matches_record ( :group , :blacklisted_groups ) :check - Required. The check to run. See Ash.Policy.Check for more. :name ( String.t/0 ) - A short name or description for the check, used when explaining authorization results authorize_unless If the check is false, the request is authorized, otherwise run remaining checks. Examples: authorize_unless not_logged_in ( ) authorize_unless actor_attribute_matches_record ( :group , :blacklisted_groups ) :check - Required. The check to run. See Ash.Policy.Check for more. :name ( String.t/0 ) - A short name or description for the check, used when explaining authorization results forbid_unless If the check is true, the request is forbidden, otherwise run remaining checks. Examples: forbid_unless logged_in ( ) forbid_unless actor_attribute_matches_record ( :group , :group ) :check - Required. The check to run. See Ash.Policy.Check for more. :name ( String.t/0 ) - A short name or description for the check, used when explaining authorization results","ref":"Ash.Policy.Authorizer.html","title":"Ash.Policy.Authorizer","type":"module"},{"doc":"","ref":"Ash.Policy.Authorizer.html#print_tuple_boolean/1","title":"Ash.Policy.Authorizer.print_tuple_boolean/1","type":"function"},{"doc":"","ref":"Ash.Policy.Authorizer.html#t:t/0","title":"Ash.Policy.Authorizer.t/0","type":"type"},{"doc":"A registry allows you to separate your resources from your api module, to reduce improve compile times and reduce compile time dependencies. For example: defmodule MyApp.MyRegistry do use Ash.Registry , extensions : [ Ash.Registry.ResourceValidations ] # This extension adds some simple validations, for example that # all related resources are also present in this registry. entries do entry MyApp.Resource entry MyApp.OtherResource end end","ref":"Ash.Registry.html","title":"Ash.Registry","type":"module"},{"doc":"","ref":"Ash.Registry.html#default_extensions/0","title":"Ash.Registry.default_extensions/0","type":"function"},{"doc":"See Ash.Registry.Info.entries/1 .","ref":"Ash.Registry.html#entries/1","title":"Ash.Registry.entries/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.explain/2 .","ref":"Ash.Registry.html#explain/2","title":"Ash.Registry.explain/2","type":"function"},{"doc":"Callback implementation for Spark.Dsl.handle_before_compile/1 .","ref":"Ash.Registry.html#handle_before_compile/1","title":"Ash.Registry.handle_before_compile/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.handle_opts/1 .","ref":"Ash.Registry.html#handle_opts/1","title":"Ash.Registry.handle_opts/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.init/1 .","ref":"Ash.Registry.html#init/1","title":"Ash.Registry.init/1","type":"function"},{"doc":"See Ash.Registry.Info.warn_on_empty?/1 .","ref":"Ash.Registry.html#warn_on_empty?/1","title":"Ash.Registry.warn_on_empty?/1","type":"function"},{"doc":"","ref":"Ash.Registry.html#t:t/0","title":"Ash.Registry.t/0","type":"type"},{"doc":"A small DSL for declaring an Ash.Registry . Ash.Registry can be used generically, but the main way it is used in Ash is to provide a compile-time registry for an Ash Api. DSL Documentation Index entries entry Docs entries List the entries present in this registry entry Examples: entries do entry MyApp.User entry MyApp.Post entry MyApp.Comment end :warn_on_empty? ( boolean/0 ) - Set to false to ignore warnings about an empty registry The default value is true . entry A reference to an ash module (typically a resource) Examples: entry MyApp.User :entry ( atom/0 ) - Required. The referenced module","ref":"Ash.Registry.Dsl.html","title":"Ash.Registry.Dsl","type":"module"},{"doc":"A resource is a static definition of an entity in your system. Resource DSL documentation: Ash.Resource.Dsl","ref":"Ash.Resource.html","title":"Ash.Resource","type":"module"},{"doc":"","ref":"Ash.Resource.html#default_extensions/0","title":"Ash.Resource.default_extensions/0","type":"function"},{"doc":"","ref":"Ash.Resource.html#get_metadata/2","title":"Ash.Resource.get_metadata/2","type":"function"},{"doc":"Returns true if the load or path to load has been loaded","ref":"Ash.Resource.html#loaded?/2","title":"Ash.Resource.loaded?/2","type":"function"},{"doc":"","ref":"Ash.Resource.html#put_metadata/3","title":"Ash.Resource.put_metadata/3","type":"function"},{"doc":"","ref":"Ash.Resource.html#selected?/2","title":"Ash.Resource.selected?/2","type":"function"},{"doc":"","ref":"Ash.Resource.html#set_metadata/2","title":"Ash.Resource.set_metadata/2","type":"function"},{"doc":"Sets a loaded key or path to a key back to its original unloaded stated","ref":"Ash.Resource.html#unload/2","title":"Ash.Resource.unload/2","type":"function"},{"doc":"Sets a list of loaded key or paths to a key back to their original unloaded stated","ref":"Ash.Resource.html#unload_many/2","title":"Ash.Resource.unload_many/2","type":"function"},{"doc":"","ref":"Ash.Resource.html#t:record/0","title":"Ash.Resource.record/0","type":"type"},{"doc":"","ref":"Ash.Resource.html#t:t/0","title":"Ash.Resource.t/0","type":"type"},{"doc":"The built in resource DSL. DSL Documentation Index attributes attribute create_timestamp update_timestamp integer_primary_key uuid_primary_key relationships has_one has_many many_to_many belongs_to actions create change validate argument metadata read argument prepare pagination metadata update change validate metadata argument destroy change validate metadata argument code_interface define define_calculation resource identities identity changes change preparations prepare validations validate aggregates count first sum list max min avg custom calculations calculate argument multitenancy Docs attributes A section for declaring attributes on the resource. attribute create_timestamp update_timestamp integer_primary_key uuid_primary_key Examples: attributes do uuid_primary_key :id attribute :first_name , :string do allow_nil? false end attribute :last_name , :string do allow_nil? false end attribute :email , :string do allow_nil? false constraints [ match : ~r/^[a-zA-Z0-9_.+-]+@[a-zA-Z0-9-]+.[a-zA-Z0-9-.]+$/ ] end attribute :type , :atom do constraints [ one_of : [ :admin , :teacher , :student ] ] end create_timestamp :inserted_at update_timestamp :updated_at end Imports: Ash.Resource.Attribute.Helpers attribute Declares an attribute on the resource. Examples: attribute :name , :string do allow_nil? false end :name ( atom/0 ) - The name of the attribute. :type ( term/0 ) - The type of the attribute. See Ash.Type for more. :constraints ( keyword/0 ) - Constraints to provide to the type when casting the value. For more information see the specific type's documentation, for general type information see Ash.Type and for practical example see the constraints topic . :description ( String.t/0 ) - An optional description for the attribute. :sensitive? ( boolean/0 ) - Whether or not the attribute value contains sensitive information, like PII. Using this option will cause the attribute to be ** Redacted ** from the resource when logging or inspecting. See the Security guide for more. The default value is false . :source ( atom/0 ) - If the field should be mapped to a different name in the data layer. Support varies by data layer. :always_select? ( boolean/0 ) - Whether or not to ensure this attribute is always selected when reading from the database. When this option is true and performing a read action, the attribute will always be selected even if it was explicitly selected out of the query. For example say there is a resource with two attributes :foo and :bar . Say :foo has always_select? true set. The query Ash.Query.select(MyResource, [:bar]) would return both :foo and :bar even though :foo was not selected in the query. The default value is false . :primary_key? ( boolean/0 ) - Whether the attribute is the primary key. Composite primary key is also possible by using primary_key? true in more than one attribute. If primary_key? is true, allow_nil? must be false. The default value is false . :allow_nil? ( boolean/0 ) - Whether or not the attribute can be set to nil. If nil value is given error is raised. The default value is true . :generated? ( boolean/0 ) - Whether or not the value may be generated by the data layer. The default value is false . :writable? ( boolean/0 ) - Whether or not the value can be written to. If writable? false then attribute is read-only and cannot be written to even when creating a record. This can be overridden with Ash.Changeset.force_change_attribute/3 . The default value is true . :private? ( boolean/0 ) - If private? true then attribute is read-only and cannot be written to even when creating a record. Additionally it tells other extensions (e.g. AshJsonApi or AshGraphql) not to expose these attributes through the API. The value of the attribute can be overridden with Ash.Changeset.force_change_attribute/3 . See the security guide for more. The default value is false . :default - A value to be set on all creates, unless a value is being provided already. :update_default - A value to be set on all updates, unless a value is being provided already. :filterable? - Whether or not the attribute can be referenced in filters. Can be used to prevent filtering on large text columns with no indexing. The default value is true . :match_other_defaults? ( boolean/0 ) - Ensures that other attributes that use the same &quot;lazy&quot; default (a function or an mfa), use the same default value. Has no effect unless default is a zero argument function. For example, create and update timestamps use this option, and have the same lazy function &amp;DateTime.utc_now/0 , so they get the same value, instead of having slightly different timestamps. The default value is false . create_timestamp Declares a non-writable attribute with a create default of &amp;DateTime.utc_now/0 Accepts all the same options as d:Ash.Resource.Dsl.attributes.attribute , except it sets the following different defaults: writable? false private? true default &amp; DateTime . utc_now / 0 match_other_defaults? true type Ash.Type.UTCDatetimeUsec allow_nil? false Examples: create_timestamp :inserted_at :name ( atom/0 ) - The name of the attribute. update_timestamp Declares a non-writable attribute with a create and update default of &amp;DateTime.utc_now/0 Accepts all the same options as d:Ash.Resource.Dsl.attributes.attribute , except it sets the following different defaults: writable? false private? true default &amp; DateTime . utc_now / 0 match_other_defaults? true update_default &amp; DateTime . utc_now / 0 type Ash.Type.UTCDatetimeUsec allow_nil? false Examples: update_timestamp :inserted_at :name ( atom/0 ) - The name of the attribute. integer_primary_key Declares a generated, non writable, non-nil, primary key column of type integer. Generated integer primary keys must be supported by the data layer. Accepts all the same options as d:Ash.Resource.Dsl.attributes.attribute , except for allow_nil? , but it sets the following different defaults: writable? false primary_key? true generated? true type :integer Examples: integer_primary_key :id :name ( atom/0 ) - The name of the attribute. uuid_primary_key Declares a non writable, non-nil, primary key column of type uuid, which defaults to Ash.UUID.generate/0 . Accepts all the same options as d:Ash.Resource.Dsl.attributes.attribute , except for allow_nil? , but it sets the following different defaults: writable? false default &amp; Ash.UUID . generate / 0 primary_key? true generated? true type :uuid Examples: uuid_primary_key :id :name ( atom/0 ) - The name of the attribute. relationships A section for declaring relationships on the resource. Relationships are a core component of resource oriented design. Many components of Ash will use these relationships. A simple use case is loading relationships (done via the Ash.Query.load/2 ). See the relationships guide for more. has_one has_many many_to_many belongs_to Examples: relationships do belongs_to :post , MyApp.Post do primary_key? true end belongs_to :category , MyApp.Category do primary_key? true end end relationships do belongs_to :author , MyApp.Author many_to_many :categories , MyApp.Category do through MyApp.PostCategory destination_attribute_on_join_resource :category_id source_attribute_on_join_resource :post_id end end relationships do has_many :posts , MyApp.Post do destination_attribute :author_id end has_many :composite_key_posts , MyApp.CompositeKeyPost do destination_attribute :author_id end end Imports: Ash.Filter.TemplateHelpers has_one Declares a has_one relationship. In a relational database, the foreign key would be on the other table. Generally speaking, a has_one also implies that the destination table is unique on that foreign key. See the relationships guide for more. Examples: # In a resource called `Word` has_one :dictionary_entry , DictionaryEntry do source_attribute :text destination_attribute :word_text end :manual - A module that implements Ash.Resource.ManualRelationship . Also accepts a 2 argument function that takes the source records and the context. :no_attributes? ( boolean/0 ) - If true, all existing entities are considered related, i.e this relationship is not based on any fields, and source_attribute and destination_attribute are ignored. This can be very useful when combined with multitenancy. Specifically, if you have a tenant resource like Organization , you can use no_attributes? to do things like has_many :employees, Employee, no_attributes?: true , which lets you avoid having an unnecessary organization_id field on Employee . The same works in reverse: has_one :organization, Organization, no_attributes?: true allows relating the employee to their organization. Some important caveats here: You can still manage relationships from one to the other, but &quot;relate&quot; and &quot;unrelate&quot; will have no effect, because there are no fields to change. Loading the relationship on a list of resources will not behave as expected in all circumstances involving multitenancy. For example, if you get a list of Organization and then try to load employees , you would need to set a single tenant on the load query, meaning you'll get all organizations back with the set of employees from one tenant. This could eventually be solved, but for now it is considered an edge case. :allow_nil? ( boolean/0 ) - Marks the relationship as required. Has no effect on validations, but can inform extensions that there will always be a related entity. The default value is true . :name ( atom/0 ) - The name of the relationship :destination ( atom/0 ) - The destination resource :description ( String.t/0 ) - An optional description for the relationship :destination_attribute ( atom/0 ) - The attribute on the related resource that should match the source_attribute configured on this resource. :validate_destination_attribute? ( boolean/0 ) - Whether or not to validate that the destination field exists on the destination resource The default value is true . :source_attribute ( atom/0 ) - The field on this resource that should match the destination_attribute on the related resource. The default value is :id . :relationship_context ( term/0 ) - Context to be set on any queries or changesets generated for managing or querying this relationship. :private? ( boolean/0 ) - Whether or not the relationship will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql See the security guide for more. The default value is false . :not_found_message ( String.t/0 ) - A message to show if there is a conflict with this relationship in the database on update or create, or when managing relationships. :writable? ( boolean/0 ) - Whether or not the relationship may be managed. The default value is true . :read_action ( atom/0 ) - The read action on the destination resource to use when loading data and filtering. :api ( atom/0 ) - The API module to use when working with the related entity. :filter ( term/0 ) - A filter to be applied when reading the relationship. :filterable? ( boolean/0 ) - If set to false , the relationship will not be usable in filters. The default value is true . :sort ( term/0 ) - A sort statement to be applied when loading the relationship. :could_be_related_at_creation? ( boolean/0 ) - Whether or not related values may exist for this relationship at creation. The default value is false . :violation_message ( String.t/0 ) - A message to show if there is a conflict with this relationship in the database on destroy. For example, if a record is deleted while related records still exist (and aren't configured to cascade deletes) has_many Declares a has_many relationship. There can be any number of related entities. See the relationships guide for more. Examples: # In a resource called `Word` has_many :definitions , DictionaryDefinition do source_attribute :text destination_attribute :word_text end :manual - A module that implements Ash.Resource.ManualRelationship . Also accepts a 2 argument function that takes the source records and the context. :no_attributes? ( boolean/0 ) - If true, all existing entities are considered related, i.e this relationship is not based on any fields, and source_attribute and destination_attribute are ignored. This can be very useful when combined with multitenancy. Specifically, if you have a tenant resource like Organization , you can use no_attributes? to do things like has_many :employees, Employee, no_attributes?: true , which lets you avoid having an unnecessary organization_id field on Employee . The same works in reverse: has_one :organization, Organization, no_attributes?: true allows relating the employee to their organization. Some important caveats here: You can still manage relationships from one to the other, but &quot;relate&quot; and &quot;unrelate&quot; will have no effect, because there are no fields to change. Loading the relationship on a list of resources will not behave as expected in all circumstances involving multitenancy. For example, if you get a list of Organization and then try to load employees , you would need to set a single tenant on the load query, meaning you'll get all organizations back with the set of employees from one tenant. This could eventually be solved, but for now it is considered an edge case. :name ( atom/0 ) - The name of the relationship :destination ( atom/0 ) - The destination resource :description ( String.t/0 ) - An optional description for the relationship :destination_attribute ( atom/0 ) - The attribute on the related resource that should match the source_attribute configured on this resource. :validate_destination_attribute? ( boolean/0 ) - Whether or not to validate that the destination field exists on the destination resource The default value is true . :source_attribute ( atom/0 ) - The field on this resource that should match the destination_attribute on the related resource. The default value is :id . :relationship_context ( term/0 ) - Context to be set on any queries or changesets generated for managing or querying this relationship. :private? ( boolean/0 ) - Whether or not the relationship will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql See the security guide for more. The default value is false . :not_found_message ( String.t/0 ) - A message to show if there is a conflict with this relationship in the database on update or create, or when managing relationships. :writable? ( boolean/0 ) - Whether or not the relationship may be managed. The default value is true . :read_action ( atom/0 ) - The read action on the destination resource to use when loading data and filtering. :api ( atom/0 ) - The API module to use when working with the related entity. :filter ( term/0 ) - A filter to be applied when reading the relationship. :filterable? ( boolean/0 ) - If set to false , the relationship will not be usable in filters. The default value is true . :sort ( term/0 ) - A sort statement to be applied when loading the relationship. :could_be_related_at_creation? ( boolean/0 ) - Whether or not related values may exist for this relationship at creation. The default value is false . :violation_message ( String.t/0 ) - A message to show if there is a conflict with this relationship in the database on destroy. For example, if a record is deleted while related records still exist (and aren't configured to cascade deletes) many_to_many Declares a many_to_many relationship. Many to many relationships require a join resource. A join resource is a resource that consists of a relationship to the source and destination of the many to many. See the relationships guide for more. Examples: # In a resource called `Word` many_to_many :books , Book do through BookWord source_attribute :text source_attribute_on_join_resource :word_text destination_attribute :id destination_attribute_on_join_resource :book_id end # And in `BookWord` (the join resource) belongs_to :book , Book , primary_key? : true , allow_nil? : false belongs_to :word , Word , primary_key? : true , allow_nil? : false :source_attribute_on_join_resource ( atom/0 ) - Required. The attribute on the join resource that should line up with source_attribute on this resource. :destination_attribute_on_join_resource ( atom/0 ) - Required. The attribute on the join resource that should line up with destination_attribute on the related resource. :through ( atom/0 ) - Required. The resource to use as the join resource. :join_relationship ( atom/0 ) - The has_many relationship to the join resource. Defaults to &lt;relationship_name&gt;_join_assoc :name ( atom/0 ) - The name of the relationship :destination ( atom/0 ) - The destination resource :description ( String.t/0 ) - An optional description for the relationship :destination_attribute ( atom/0 ) - The attribute on the related resource that should match the source_attribute configured on this resource. The default value is :id . :validate_destination_attribute? ( boolean/0 ) - Whether or not to validate that the destination field exists on the destination resource The default value is true . :source_attribute ( atom/0 ) - The field on this resource that should match the destination_attribute on the related resource. The default value is :id . :relationship_context ( term/0 ) - Context to be set on any queries or changesets generated for managing or querying this relationship. :private? ( boolean/0 ) - Whether or not the relationship will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql See the security guide for more. The default value is false . :not_found_message ( String.t/0 ) - A message to show if there is a conflict with this relationship in the database on update or create, or when managing relationships. :writable? ( boolean/0 ) - Whether or not the relationship may be managed. The default value is true . :read_action ( atom/0 ) - The read action on the destination resource to use when loading data and filtering. :api ( atom/0 ) - The API module to use when working with the related entity. :filter ( term/0 ) - A filter to be applied when reading the relationship. :filterable? ( boolean/0 ) - If set to false , the relationship will not be usable in filters. The default value is true . :sort ( term/0 ) - A sort statement to be applied when loading the relationship. :could_be_related_at_creation? ( boolean/0 ) - Whether or not related values may exist for this relationship at creation. The default value is false . :violation_message ( String.t/0 ) - A message to show if there is a conflict with this relationship in the database on destroy. For example, if a record is deleted while related records still exist (and aren't configured to cascade deletes) belongs_to Declares a belongs_to relationship. In a relational database, the foreign key would be on the source table. This creates a field on the resource with the corresponding name and type, unless define_attribute?: false is provided. See the relationships guide for more. Examples: # In a resource called `Word` belongs_to :dictionary_entry , DictionaryEntry do source_attribute :text , destination_attribute :word_text end :primary_key? ( boolean/0 ) - Whether the generated attribute is, or is part of, the primary key of a resource. The default value is false . :allow_nil? ( boolean/0 ) - Whether this relationship must always be present, e.g: must be included on creation, and never removed (it may be modified). The generated attribute will not allow nil values. The default value is true . :attribute_writable? ( boolean/0 ) - Whether the generated attribute will be marked as public &amp; writable. The default value is false . :define_attribute? ( boolean/0 ) - If set to false an attribute is not created on the resource for this relationship, and one must be manually added in attributes , invalidating many other options. The default value is true . :attribute_type ( term/0 ) - The type of the generated created attribute. See Ash.Type for more. The default value is :uuid . :name ( atom/0 ) - The name of the relationship :destination ( atom/0 ) - The destination resource :description ( String.t/0 ) - An optional description for the relationship :destination_attribute ( atom/0 ) - The attribute on the related resource that should match the source_attribute configured on this resource. The default value is :id . :validate_destination_attribute? ( boolean/0 ) - Whether or not to validate that the destination field exists on the destination resource The default value is true . :source_attribute ( atom/0 ) - The field on this resource that should match the destination_attribute on the related resource. - Defaults to &lt;name&gt;_id :relationship_context ( term/0 ) - Context to be set on any queries or changesets generated for managing or querying this relationship. :private? ( boolean/0 ) - Whether or not the relationship will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql See the security guide for more. The default value is false . :not_found_message ( String.t/0 ) - A message to show if there is a conflict with this relationship in the database on update or create, or when managing relationships. :writable? ( boolean/0 ) - Whether or not the relationship may be managed. The default value is true . :read_action ( atom/0 ) - The read action on the destination resource to use when loading data and filtering. :api ( atom/0 ) - The API module to use when working with the related entity. :filter ( term/0 ) - A filter to be applied when reading the relationship. :filterable? ( boolean/0 ) - If set to false , the relationship will not be usable in filters. The default value is true . :sort ( term/0 ) - A sort statement to be applied when loading the relationship. :violation_message ( String.t/0 ) - A message to show if there is a conflict with this relationship in the database on destroy. For example, if a record is deleted while related records still exist (and aren't configured to cascade deletes) actions A section for declaring resource actions. All manipulation of data through the underlying data layer happens through actions. There are four types of action: create , read , update , and destroy . You may recognize these from the acronym CRUD . You can have multiple actions of the same type, as long as they have different names. This is the primary mechanism for customizing your resources to conform to your business logic. It is normal and expected to have multiple actions of each type in a large application. create change validate argument metadata read argument prepare pagination metadata update change validate metadata argument destroy change validate metadata argument Examples: actions do create :signup do argument :password , :string argument :password_confirmation , :string validate confirm ( :password , :password_confirmation ) change { MyApp.HashPassword , [ ] } # A custom implemented Change end read :me do # An action that auto filters to only return the user for the current user filter [ id : actor ( :id ) ] end update :update do accept [ :first_name , :last_name ] end destroy do change set_attribute ( :deleted_at , &amp; DateTime . utc_now / 0 ) # This tells it that even though this is a delete action, it # should be treated like an update because `deleted_at` is set. # This should be coupled with a `base_filter` on the resource # or with the read actions having a `filter` for `is_nil: :deleted_at` soft? true end end :defaults - Creates a simple action of each specified type, with the same name as the type. These actions will be the primary actions, unless you've declared a different action of the same type that is explicitly set as primary. By default, resources have no default actions. Embedded resources, however, have a default of all resource types. :default_accept (list of atom/0 ) - A default value for the accept option for each action. Defaults to all public attributes. create Declares a create action. For calling this action, see the Ash.Api documentation. change validate argument metadata Examples: create :register do primary? true end :allow_nil_input (list of atom/0 ) - A list of attributes that would normally be required, but should not be for this action. They will still be validated just before the record is created. :manual - Override the creation behavior. See the manual action guides for more. Accepts a module or module and opts, or a function that takes the changeset and context. See the manual actions guide for more. :upsert? ( boolean/0 ) - Wether or not this action is always an upsert. If this is false, the action can still be used as an upsert by passing upsert?: true when using it. This option forces all uses of this action to be treated as an upsert The default value is false . :upsert_identity ( atom/0 ) - The identity to use for the upsert. Cannot be overriden by the caller. Ignored if upsert? is not set to true . The default value is false . :name ( atom/0 ) - Required. The name of the action :primary? ( boolean/0 ) - Whether or not this action should be used when no action is specified by the caller. The default value is false . :description ( String.t/0 ) - An optional description for the action :transaction? ( boolean/0 ) - Whether or not the action should be run in transactions. Reads default to false, while create/update/destroy actions default to true . Has no effect if the data layer does not support transactions, or if that data layer is already in a transaction. :touches_resources (list of atom/0 ) - A list of resources that the action may touch, used when building transactions. :accept - The list of attributes to accept. Defaults to all attributes on the resource :reject - A list of attributes not to accept. This is useful if you want to say 'accept all but x' If this is specified along with accept , then everything in the accept list minus any matches in the reject list will be accepted. :require_attributes (list of atom/0 ) - A list of attributes that would normally allow_nil? , to require for this action. No need to include attributes that already do not allow nil? :error_handler - Sets the error handler on the changeset. See Ash.Changeset.handle_errors/2 for more :manual? ( boolean/0 ) - Instructs Ash to skip the actual update/create/destroy step at the data layer. See the manual action guides for more. See the manual actions guide for more. change A change to be applied to the changeset. See Ash.Resource.Change for more. Examples: change relate_actor ( :reporter ) change { MyCustomChange , :foo } :only_when_valid? ( boolean/0 ) - If the change should only be run on valid changes. By default, all changes are run unless stated otherwise here. The default value is false . :description ( String.t/0 ) - An optional description for the change :change - Required. The module and options for a change. Also accepts a function that takes the changeset and the context. See Ash.Resource.Change.Builtins for more. :where - Validations that should pass in order for this validation to apply. These validations failing will not invalidate the changes, but instead just result in this change being ignored. Also accepts functions take the changeset. The default value is [] . validate Declares a validation to be applied to the changeset. See Ash.Resource.Validation for more. Examples: validate changing ( :email ) :validation - Required. The module (or module and opts) that implements the Ash.Resource.Validation behaviour. Also accepts a one argument function that takes the changeset. :where - Validations that should pass in order for this validation to apply. These validations failing will not invalidate the changes, but will instead result in this validation being ignored. Accepts a module, module and opts, or a 1 argument function that takes the changeset. The default value is [] . :only_when_valid? ( boolean/0 ) - If the validation should only run on valid changes. Useful for expensive validations or validations that depend on valid data. The default value is false . :message ( String.t/0 ) - If provided, overrides any message set by the validation error :description ( String.t/0 ) - An optional description for the validation :before_action? ( boolean/0 ) - If set to true , the validation will be run in a before_action hook The default value is false . argument Declares an argument on the action Examples: argument :password_confirmation , :string :name ( atom/0 ) - Required. The name of the argument :type ( term/0 ) - Required. The type of the argument. See Ash.Type for more. :description ( String.t/0 ) - An optional description for the argument. :constraints ( keyword/0 ) - Constraints to provide to the type when casting the value. For more information see the specific type's documentation, for general type information see Ash.Type and for practical example see the constraints topic . The default value is [] . :allow_nil? ( boolean/0 ) - Whether or not the argument value may be nil (or may be not provided) If nil value is given error is raised. The default value is true . :private? ( boolean/0 ) - Whether or not the argument should be suppliable by the client. The default value is false . :sensitive? ( boolean/0 ) - Whether or not the argument value contains sensitive information, like PII. Using this option will cause the argument to be ** Redacted ** from the resource when logging or inspecting. See the security guide for more. The default value is false . :default ( term/0 ) - The default value for the argument to take. It can be a zero argument function e.g &amp;MyMod.my_fun/0 or a value metadata A special kind of attribute that is only added to specific actions. Nothing sets this value, it must be set in a custom change via Ash.Resource.Info.put_metadata/3 . Examples: metadata :api_token , :string , allow_nil? : false metadata :operation_id , :string , allow_nil? : false :name ( atom/0 ) - Required. The name of the metadata :type ( term/0 ) - Required. The type of the metadata. See Ash.Type for more. :constraints ( keyword/0 ) - Type constraints on the metadata The default value is [] . :description ( String.t/0 ) - An optional description for the metadata. :allow_nil? ( boolean/0 ) - Whether or not the metadata may return nil The default value is true . :default ( term/0 ) - The default value for the metadata to take. It can be a zero argument function e.g &amp;MyMod.my_fun/0 or a value read Declares a read action. For calling this action, see the Ash.Api documentation. argument prepare pagination metadata Examples: read :read_all do primary? true end :filter ( term/0 ) - A filter template that will be applied whenever the action is used. See Ash.Filter for more on templates :manual - Delegates running of the query to the provided module. Accepts a module or module and opts, or a function that takes the changeset and context. See the manual actions guide for more. :get? ( boolean/0 ) - Expresses that this action innately only returns a single result. Can be used by extensions to validate that you have not hooked something up that expects a list to an action that can only return one thing. Used by the code interface when defining functions for read actions. See the code interface guide for more. The default value is false . :modify_query - Allows direct manipulation of the data layer query via an MFA. The ash query and the data layer query will be provided as additional arguments. The result must be {:ok, new_data_layer_query} | {:error, error} . Here be dragons. :name ( atom/0 ) - Required. The name of the action :primary? ( boolean/0 ) - Whether or not this action should be used when no action is specified by the caller. The default value is false . :description ( String.t/0 ) - An optional description for the action :transaction? ( boolean/0 ) - Whether or not the action should be run in transactions. Reads default to false, while create/update/destroy actions default to true . Has no effect if the data layer does not support transactions, or if that data layer is already in a transaction. :touches_resources (list of atom/0 ) - A list of resources that the action may touch, used when building transactions. argument Declares an argument on the action Examples: argument :password_confirmation , :string :name ( atom/0 ) - Required. The name of the argument :type ( term/0 ) - Required. The type of the argument. See Ash.Type for more. :description ( String.t/0 ) - An optional description for the argument. :constraints ( keyword/0 ) - Constraints to provide to the type when casting the value. For more information see the specific type's documentation, for general type information see Ash.Type and for practical example see the constraints topic . The default value is [] . :allow_nil? ( boolean/0 ) - Whether or not the argument value may be nil (or may be not provided) If nil value is given error is raised. The default value is true . :private? ( boolean/0 ) - Whether or not the argument should be suppliable by the client. The default value is false . :sensitive? ( boolean/0 ) - Whether or not the argument value contains sensitive information, like PII. Using this option will cause the argument to be ** Redacted ** from the resource when logging or inspecting. See the security guide for more. The default value is false . :default ( term/0 ) - The default value for the argument to take. It can be a zero argument function e.g &amp;MyMod.my_fun/0 or a value prepare Declares a preparation, which can be used to prepare a query for a read action. Examples: prepare build ( sort : [ :foo , :bar ] ) :preparation - Required. The module and options for a preparation. Also accepts functions take the query and the context. pagination Adds pagination options to a resource :keyset? ( boolean/0 ) - Whether or not keyset based pagination is supported The default value is false . :offset? ( boolean/0 ) - Whether or not offset based pagination is supported The default value is false . :default_limit ( pos_integer/0 ) - The default page size to apply, if one is not supplied :countable - Whether not a returned page will have a full count of all records. Use :by_default to do it automatically. The default value is false . :max_page_size ( pos_integer/0 ) - The maximum amount of records that can be requested in a single page The default value is 250 . :required? ( boolean/0 ) - Whether or not pagination can be disabled. Only relevant if some pagination configuration is supplied. The default value is true . metadata A special kind of attribute that is only added to specific actions. Nothing sets this value, it must be set in a custom change via Ash.Resource.Info.put_metadata/3 . Examples: metadata :api_token , :string , allow_nil? : false metadata :operation_id , :string , allow_nil? : false :name ( atom/0 ) - Required. The name of the metadata :type ( term/0 ) - Required. The type of the metadata. See Ash.Type for more. :constraints ( keyword/0 ) - Type constraints on the metadata The default value is [] . :description ( String.t/0 ) - An optional description for the metadata. :allow_nil? ( boolean/0 ) - Whether or not the metadata may return nil The default value is true . :default ( term/0 ) - The default value for the metadata to take. It can be a zero argument function e.g &amp;MyMod.my_fun/0 or a value update Declares a update action. For calling this action, see the Ash.Api documentation. change validate metadata argument Examples: update :flag_for_review , primary? : true :manual - Override the update behavior. See the manual action guides for more. Accepts a module or module and opts, or a function that takes the changeset and context. See the manual actions guide for more. :name ( atom/0 ) - Required. The name of the action :primary? ( boolean/0 ) - Whether or not this action should be used when no action is specified by the caller. The default value is false . :description ( String.t/0 ) - An optional description for the action :transaction? ( boolean/0 ) - Whether or not the action should be run in transactions. Reads default to false, while create/update/destroy actions default to true . Has no effect if the data layer does not support transactions, or if that data layer is already in a transaction. :touches_resources (list of atom/0 ) - A list of resources that the action may touch, used when building transactions. :accept - The list of attributes to accept. Defaults to all attributes on the resource :reject - A list of attributes not to accept. This is useful if you want to say 'accept all but x' If this is specified along with accept , then everything in the accept list minus any matches in the reject list will be accepted. :require_attributes (list of atom/0 ) - A list of attributes that would normally allow_nil? , to require for this action. No need to include attributes that already do not allow nil? :error_handler - Sets the error handler on the changeset. See Ash.Changeset.handle_errors/2 for more :manual? ( boolean/0 ) - Instructs Ash to skip the actual update/create/destroy step at the data layer. See the manual action guides for more. See the manual actions guide for more. change A change to be applied to the changeset. See Ash.Resource.Change for more. Examples: change relate_actor ( :reporter ) change { MyCustomChange , :foo } :only_when_valid? ( boolean/0 ) - If the change should only be run on valid changes. By default, all changes are run unless stated otherwise here. The default value is false . :description ( String.t/0 ) - An optional description for the change :change - Required. The module and options for a change. Also accepts a function that takes the changeset and the context. See Ash.Resource.Change.Builtins for more. :where - Validations that should pass in order for this validation to apply. These validations failing will not invalidate the changes, but instead just result in this change being ignored. Also accepts functions take the changeset. The default value is [] . validate Declares a validation to be applied to the changeset. See Ash.Resource.Validation for more. Examples: validate changing ( :email ) :validation - Required. The module (or module and opts) that implements the Ash.Resource.Validation behaviour. Also accepts a one argument function that takes the changeset. :where - Validations that should pass in order for this validation to apply. These validations failing will not invalidate the changes, but will instead result in this validation being ignored. Accepts a module, module and opts, or a 1 argument function that takes the changeset. The default value is [] . :only_when_valid? ( boolean/0 ) - If the validation should only run on valid changes. Useful for expensive validations or validations that depend on valid data. The default value is false . :message ( String.t/0 ) - If provided, overrides any message set by the validation error :description ( String.t/0 ) - An optional description for the validation :before_action? ( boolean/0 ) - If set to true , the validation will be run in a before_action hook The default value is false . metadata A special kind of attribute that is only added to specific actions. Nothing sets this value, it must be set in a custom change via Ash.Resource.Info.put_metadata/3 . Examples: metadata :api_token , :string , allow_nil? : false metadata :operation_id , :string , allow_nil? : false :name ( atom/0 ) - Required. The name of the metadata :type ( term/0 ) - Required. The type of the metadata. See Ash.Type for more. :constraints ( keyword/0 ) - Type constraints on the metadata The default value is [] . :description ( String.t/0 ) - An optional description for the metadata. :allow_nil? ( boolean/0 ) - Whether or not the metadata may return nil The default value is true . :default ( term/0 ) - The default value for the metadata to take. It can be a zero argument function e.g &amp;MyMod.my_fun/0 or a value argument Declares an argument on the action Examples: argument :password_confirmation , :string :name ( atom/0 ) - Required. The name of the argument :type ( term/0 ) - Required. The type of the argument. See Ash.Type for more. :description ( String.t/0 ) - An optional description for the argument. :constraints ( keyword/0 ) - Constraints to provide to the type when casting the value. For more information see the specific type's documentation, for general type information see Ash.Type and for practical example see the constraints topic . The default value is [] . :allow_nil? ( boolean/0 ) - Whether or not the argument value may be nil (or may be not provided) If nil value is given error is raised. The default value is true . :private? ( boolean/0 ) - Whether or not the argument should be suppliable by the client. The default value is false . :sensitive? ( boolean/0 ) - Whether or not the argument value contains sensitive information, like PII. Using this option will cause the argument to be ** Redacted ** from the resource when logging or inspecting. See the security guide for more. The default value is false . :default ( term/0 ) - The default value for the argument to take. It can be a zero argument function e.g &amp;MyMod.my_fun/0 or a value destroy Declares a destroy action. For calling this action, see the Ash.Api documentation. change validate metadata argument Examples: destroy :soft_delete do primary? true end :soft? ( atom/0 ) - If specified, the destroy action behaves as an update internally The default value is false . :manual - Override the update behavior. See the manual action guides for more. Accepts a module or module and opts, or a function that takes the changeset and context. See the manual actions guide for more. :name ( atom/0 ) - Required. The name of the action :primary? ( boolean/0 ) - Whether or not this action should be used when no action is specified by the caller. The default value is false . :description ( String.t/0 ) - An optional description for the action :transaction? ( boolean/0 ) - Whether or not the action should be run in transactions. Reads default to false, while create/update/destroy actions default to true . Has no effect if the data layer does not support transactions, or if that data layer is already in a transaction. :touches_resources (list of atom/0 ) - A list of resources that the action may touch, used when building transactions. :accept - The list of attributes to accept. Defaults to all attributes on the resource :reject - A list of attributes not to accept. This is useful if you want to say 'accept all but x' If this is specified along with accept , then everything in the accept list minus any matches in the reject list will be accepted. :require_attributes (list of atom/0 ) - A list of attributes that would normally allow_nil? , to require for this action. No need to include attributes that already do not allow nil? :error_handler - Sets the error handler on the changeset. See Ash.Changeset.handle_errors/2 for more :manual? ( boolean/0 ) - Instructs Ash to skip the actual update/create/destroy step at the data layer. See the manual action guides for more. See the manual actions guide for more. change A change to be applied to the changeset. See Ash.Resource.Change for more. Examples: change relate_actor ( :reporter ) change { MyCustomChange , :foo } :only_when_valid? ( boolean/0 ) - If the change should only be run on valid changes. By default, all changes are run unless stated otherwise here. The default value is false . :description ( String.t/0 ) - An optional description for the change :change - Required. The module and options for a change. Also accepts a function that takes the changeset and the context. See Ash.Resource.Change.Builtins for more. :where - Validations that should pass in order for this validation to apply. These validations failing will not invalidate the changes, but instead just result in this change being ignored. Also accepts functions take the changeset. The default value is [] . validate Declares a validation to be applied to the changeset. See Ash.Resource.Validation for more. Examples: validate changing ( :email ) :validation - Required. The module (or module and opts) that implements the Ash.Resource.Validation behaviour. Also accepts a one argument function that takes the changeset. :where - Validations that should pass in order for this validation to apply. These validations failing will not invalidate the changes, but will instead result in this validation being ignored. Accepts a module, module and opts, or a 1 argument function that takes the changeset. The default value is [] . :only_when_valid? ( boolean/0 ) - If the validation should only run on valid changes. Useful for expensive validations or validations that depend on valid data. The default value is false . :message ( String.t/0 ) - If provided, overrides any message set by the validation error :description ( String.t/0 ) - An optional description for the validation :before_action? ( boolean/0 ) - If set to true , the validation will be run in a before_action hook The default value is false . metadata A special kind of attribute that is only added to specific actions. Nothing sets this value, it must be set in a custom change via Ash.Resource.Info.put_metadata/3 . Examples: metadata :api_token , :string , allow_nil? : false metadata :operation_id , :string , allow_nil? : false :name ( atom/0 ) - Required. The name of the metadata :type ( term/0 ) - Required. The type of the metadata. See Ash.Type for more. :constraints ( keyword/0 ) - Type constraints on the metadata The default value is [] . :description ( String.t/0 ) - An optional description for the metadata. :allow_nil? ( boolean/0 ) - Whether or not the metadata may return nil The default value is true . :default ( term/0 ) - The default value for the metadata to take. It can be a zero argument function e.g &amp;MyMod.my_fun/0 or a value argument Declares an argument on the action Examples: argument :password_confirmation , :string :name ( atom/0 ) - Required. The name of the argument :type ( term/0 ) - Required. The type of the argument. See Ash.Type for more. :description ( String.t/0 ) - An optional description for the argument. :constraints ( keyword/0 ) - Constraints to provide to the type when casting the value. For more information see the specific type's documentation, for general type information see Ash.Type and for practical example see the constraints topic . The default value is [] . :allow_nil? ( boolean/0 ) - Whether or not the argument value may be nil (or may be not provided) If nil value is given error is raised. The default value is true . :private? ( boolean/0 ) - Whether or not the argument should be suppliable by the client. The default value is false . :sensitive? ( boolean/0 ) - Whether or not the argument value contains sensitive information, like PII. Using this option will cause the argument to be ** Redacted ** from the resource when logging or inspecting. See the security guide for more. The default value is false . :default ( term/0 ) - The default value for the argument to take. It can be a zero argument function e.g &amp;MyMod.my_fun/0 or a value code_interface Functions that will be defined on the Api module to interact with this resource. See the code interface guide for more. define define_calculation Examples: code_interface do define_for MyApp.Api define :create_user , action : :create define :get_user_by_id , action : :get_by_id , args : [ :id ] , get? : true end :define_for ( atom/0 ) - Defines the code interface on the resource module directly, using the provided Api. The default value is false . define Defines a function with the corresponding name and arguments. See the code interface guide for more. Examples: define :get_user_by_id , action : :get_by_id , args : [ :id ] , get? : true :name ( atom/0 ) - Required. The name of the function that will be defined :action ( atom/0 ) - The name of the action that will be called. Defaults to the same name as the function. :args - Map specific arguments to named inputs. Can provide any argument/attributes that the action allows. :not_found_error? ( boolean/0 ) - If the action or interface is configured with get?: true , this determines whether or not an error is raised or nil is returned. The default value is true . :get? ( boolean/0 ) - Expects to only receive a single result from a read action, and returns a single result instead of a list. Ignored for other action types. :get_by (list of atom/0 ) - Takes a list of fields and adds those fields as arguments, which will then be used to filter. Sets get? to true automatically. Ignored for non-read actions. :get_by_identity ( atom/0 ) - Only relevant for read actions. Takes an identity, and gets its field list, performing the same logic as get_by once it has the list of fields. define_calculation Defines a function with the corresponding name and arguments, that evaluates a calculation. Use :_record to take an instance of a record. See the code interface guide for more. Examples: define_calculation :referral_link , args : [ :id ] define_calculation :referral_link , args : [ { :arg , :id } , { :ref , :id } ] :name ( atom/0 ) - Required. The name of the function that will be defined :calculation ( atom/0 ) - The name of the calculation that will be evaluated. Defaults to the same name as the function. :args ( term/0 ) - Supply field or argument values referenced by the calculation. By default, the value will be provided for any matching named reference and argument. This is normally fine, but in the case that you have an argument and a reference with the same name, you can specify it by supplying {:arg, :name} and {:ref, :name} . For example: define_calculation :id_matches , args : [ { :arg , :id } , { :ref , :id } ] To make arguments optional, wrap them in {:optional, ..} , for example: define_calculation :id_matches , args : [ { :arg , :id } , { :optional , { :ref , :id } } ] ` ` ` The default value is ` [ ] ` . resource General resource configuration Examples: resource do description &quot;A description of this resource&quot; base_filter [ is_nil : :deleted_at ] end Imports: Ash.Filter.TemplateHelpers :description ( String.t/0 ) - A human readable description of the resource, to be used in generated documentation :base_filter ( term/0 ) - A filter statement to be applied to any queries on the resource :default_context ( term/0 ) - Default context to apply to any queries/changesets generated for this resource. :trace_name ( String.t/0 ) - The name to use in traces. Defaults to the short_name stringified. See the monitoring guide for more. :short_name ( atom/0 ) - A short identifier for the resource, which should be unique. See the monitoring guide for more. :simple_notifiers (list of atom/0 ) - A list of notifiers that require no DSL. Can be used to avoid compile time dependencies on notifiers identities Unique identifiers for the resource identity Examples: identities do identity :full_name , [ :first_name , :last_name ] identity :email , [ :email ] end identity Represents a unique constraint on the resource. See the identities guide for more. Examples: identity :name , [ :name ] identity :full_name , [ :first_name , :last_name ] :name ( atom/0 ) - Required. The name of the identity. :keys - Required. The names of the attributes that uniquely identify this resource. :eager_check_with ( atom/0 ) - Validates that the unique identity provided is unique at validation time, outside of any transactions, using the api module provided. :pre_check_with ( atom/0 ) - Validates that the unique identity provided is unique in a before_action hook. :description ( String.t/0 ) - An optional description for the identity :message ( String.t/0 ) - An error message to use when the unique identity would be violated changes Declare changes that occur on create/update/destroy actions against the resource See Ash.Resource.Change for more. change Examples: changes do change { Mod , [ foo : :bar ] } change set_context ( %{ some : :context } ) end Imports: Ash.Resource.Validation.Builtins Ash.Resource.Change.Builtins Ash.Filter.TemplateHelpers change A change to be applied to the changeset. See Ash.Resource.Change for more. Examples: change relate_actor ( :reporter ) change { MyCustomChange , :foo } :on - The action types the validation should run on. Destroy actions are omitted by default as most changes don't make sense for a destroy. The default value is [:create, :update] . :only_when_valid? ( boolean/0 ) - If the change should only be run on valid changes. By default, all changes are run unless stated otherwise here. The default value is false . :description ( String.t/0 ) - An optional description for the change :change - Required. The module and options for a change. Also accepts a function that takes the changeset and the context. See Ash.Resource.Change.Builtins for more. :where - Validations that should pass in order for this validation to apply. These validations failing will not invalidate the changes, but instead just result in this change being ignored. Also accepts functions take the changeset. The default value is [] . preparations Declare preparations that occur on all read actions for a given resource prepare Examples: preparations do prepare { Mod , [ foo : :bar ] } prepare set_context ( %{ some : :context } ) end Imports: Ash.Resource.Preparation.Builtins Ash.Resource.Validation.Builtins prepare Declares a preparation, which can be used to prepare a query for a read action. Examples: prepare build ( sort : [ :foo , :bar ] ) :preparation - Required. The module and options for a preparation. Also accepts functions take the query and the context. validations Declare validations prior to performing actions against the resource validate Examples: validations do validate { Mod , [ foo : :bar ] } validate at_least_one_of_present ( [ :first_name , :last_name ] ) end Imports: Ash.Resource.Validation.Builtins validate Declares a validation for creates and updates. See Ash.Resource.Change for more. Examples: validate { Mod , [ foo : :bar ] } validate at_least_one_of_present ( [ :first_name , :last_name ] ) :validation - Required. The module (or module and opts) that implements the Ash.Resource.Validation behaviour. Also accepts a one argument function that takes the changeset. :where - Validations that should pass in order for this validation to apply. These validations failing will not invalidate the changes, but will instead result in this validation being ignored. Accepts a module, module and opts, or a 1 argument function that takes the changeset. The default value is [] . :on - The action types the validation should run on. Many validations don't make sense in the context of deletion, so by default it is left out of the list. The default value is [:create, :update] . :only_when_valid? ( boolean/0 ) - If the validation should only run on valid changes. Useful for expensive validations or validations that depend on valid data. The default value is false . :message ( String.t/0 ) - If provided, overrides any message set by the validation error :description ( String.t/0 ) - An optional description for the validation :before_action? ( boolean/0 ) - If set to true , the validation will be run in a before_action hook The default value is false . aggregates Declare named aggregates on the resource. These are aggregates that can be loaded only by name using Ash.Query.load/2 . They are also available as top level fields on the resource. See the aggregates guide for more. count first sum list max min avg custom Examples: aggregates do count :assigned_ticket_count , :reported_tickets do filter [ active : true ] end end Imports: Ash.Filter.TemplateHelpers count Declares a named count aggregate on the resource Supports filter , but not sort (because that wouldn't affect the count) See the aggregates guide for more. Examples: count :assigned_ticket_count , :assigned_tickets do filter [ active : true ] end :uniq? ( boolean/0 ) - Wether or not to count unique values only The default value is false . :name ( atom/0 ) - Required. The field to place the aggregate in :read_action ( atom/0 ) - The read action to use when building the aggregate Defaults to the primary read action. Keep in mind this action must not have any required arguments. :relationship_path - Required. The relationship or relationship path to use for the aggregate :kind - Required. The kind of the aggregate :field ( atom/0 ) - The field to aggregate. Defaults to the first field in the primary key of the resource :filter ( term/0 ) - A filter to apply to the aggregate The default value is [] . :description ( String.t/0 ) - An optional description for the aggregate :default ( term/0 ) - A default value to use in cases where nil would be used. Count defaults to 0 . :private? ( boolean/0 ) - Whether or not the aggregate will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql The default value is false . :filterable? - Whether or not the aggregate should be usable in filters. The default value is true . first Declares a named first aggregate on the resource First aggregates return the first value of the related record that matches. Supports both filter and sort . See the aggregates guide for more. Examples: first :first_assigned_ticket_subject , :assigned_tickets , :subject do filter [ active : true ] sort [ :subject ] end :name ( atom/0 ) - Required. The field to place the aggregate in :read_action ( atom/0 ) - The read action to use when building the aggregate Defaults to the primary read action. Keep in mind this action must not have any required arguments. :relationship_path - Required. The relationship or relationship path to use for the aggregate :kind - Required. The kind of the aggregate :field ( atom/0 ) - The field to aggregate. Defaults to the first field in the primary key of the resource :filter ( term/0 ) - A filter to apply to the aggregate The default value is [] . :sort ( term/0 ) - A sort to be applied to the aggregate :description ( String.t/0 ) - An optional description for the aggregate :default ( term/0 ) - A default value to use in cases where nil would be used. Count defaults to 0 . :private? ( boolean/0 ) - Whether or not the aggregate will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql The default value is false . :filterable? - Whether or not the aggregate should be usable in filters. The default value is true . sum Declares a named sum aggregate on the resource Supports filter , but not sort (because that wouldn't affect the sum) See the aggregates guide for more. Examples: sum :assigned_ticket_price_sum , :assigned_tickets , :price do filter [ active : true ] end :name ( atom/0 ) - Required. The field to place the aggregate in :read_action ( atom/0 ) - The read action to use when building the aggregate Defaults to the primary read action. Keep in mind this action must not have any required arguments. :relationship_path - Required. The relationship or relationship path to use for the aggregate :kind - Required. The kind of the aggregate :field ( atom/0 ) - The field to aggregate. Defaults to the first field in the primary key of the resource :filter ( term/0 ) - A filter to apply to the aggregate The default value is [] . :description ( String.t/0 ) - An optional description for the aggregate :default ( term/0 ) - A default value to use in cases where nil would be used. Count defaults to 0 . :private? ( boolean/0 ) - Whether or not the aggregate will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql The default value is false . :filterable? - Whether or not the aggregate should be usable in filters. The default value is true . list Declares a named list aggregate on the resource. A list aggregate selects the list of all values for the given field and relationship combination. See the aggregates guide for more. Examples: list :assigned_ticket_prices , :assigned_tickets , :price do filter [ active : true ] end :uniq? ( boolean/0 ) - Wether or not to count unique values only The default value is false . :name ( atom/0 ) - Required. The field to place the aggregate in :read_action ( atom/0 ) - The read action to use when building the aggregate Defaults to the primary read action. Keep in mind this action must not have any required arguments. :relationship_path - Required. The relationship or relationship path to use for the aggregate :kind - Required. The kind of the aggregate :field ( atom/0 ) - The field to aggregate. Defaults to the first field in the primary key of the resource :filter ( term/0 ) - A filter to apply to the aggregate The default value is [] . :sort ( term/0 ) - A sort to be applied to the aggregate :description ( String.t/0 ) - An optional description for the aggregate :default ( term/0 ) - A default value to use in cases where nil would be used. Count defaults to 0 . :private? ( boolean/0 ) - Whether or not the aggregate will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql The default value is false . :filterable? - Whether or not the aggregate should be usable in filters. The default value is true . max Declares a named max aggregate on the resource Supports filter , but not sort (because that wouldn't affect the max) See the aggregates guide for more. Examples: max :first_assigned_ticket_subject , :assigned_tickets , :severity do filter [ active : true ] end :name ( atom/0 ) - Required. The field to place the aggregate in :read_action ( atom/0 ) - The read action to use when building the aggregate Defaults to the primary read action. Keep in mind this action must not have any required arguments. :relationship_path - Required. The relationship or relationship path to use for the aggregate :kind - Required. The kind of the aggregate :field ( atom/0 ) - The field to aggregate. Defaults to the first field in the primary key of the resource :filter ( term/0 ) - A filter to apply to the aggregate The default value is [] . :description ( String.t/0 ) - An optional description for the aggregate :default ( term/0 ) - A default value to use in cases where nil would be used. Count defaults to 0 . :private? ( boolean/0 ) - Whether or not the aggregate will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql The default value is false . :filterable? - Whether or not the aggregate should be usable in filters. The default value is true . min Declares a named min aggregate on the resource Supports filter , but not sort (because that wouldn't affect the min) See the aggregates guide for more. Examples: min :first_assigned_ticket_subject , :assigned_tickets , :severity do filter [ active : true ] end :name ( atom/0 ) - Required. The field to place the aggregate in :read_action ( atom/0 ) - The read action to use when building the aggregate Defaults to the primary read action. Keep in mind this action must not have any required arguments. :relationship_path - Required. The relationship or relationship path to use for the aggregate :kind - Required. The kind of the aggregate :field ( atom/0 ) - The field to aggregate. Defaults to the first field in the primary key of the resource :filter ( term/0 ) - A filter to apply to the aggregate The default value is [] . :description ( String.t/0 ) - An optional description for the aggregate :default ( term/0 ) - A default value to use in cases where nil would be used. Count defaults to 0 . :private? ( boolean/0 ) - Whether or not the aggregate will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql The default value is false . :filterable? - Whether or not the aggregate should be usable in filters. The default value is true . avg Declares a named avg aggregate on the resource Supports filter , but not sort (because that wouldn't affect the avg) See the aggregates guide for more. Examples: avg :assigned_ticket_price_sum , :assigned_tickets , :price do filter [ active : true ] end :name ( atom/0 ) - Required. The field to place the aggregate in :read_action ( atom/0 ) - The read action to use when building the aggregate Defaults to the primary read action. Keep in mind this action must not have any required arguments. :relationship_path - Required. The relationship or relationship path to use for the aggregate :kind - Required. The kind of the aggregate :field ( atom/0 ) - The field to aggregate. Defaults to the first field in the primary key of the resource :filter ( term/0 ) - A filter to apply to the aggregate The default value is [] . :description ( String.t/0 ) - An optional description for the aggregate :default ( term/0 ) - A default value to use in cases where nil would be used. Count defaults to 0 . :private? ( boolean/0 ) - Whether or not the aggregate will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql The default value is false . :filterable? - Whether or not the aggregate should be usable in filters. The default value is true . custom Declares a named custom aggregate on the resource Supports filter and sort . Custom aggregates provide an implementation which must implement data layer specific callbacks. See the relevant data layer documentation and the aggregates guide for more. Examples: custom :author_names , :authors , :string do implementation { StringAgg , delimiter : &quot;,&quot; } end :implementation - Required. The module that implements the relevant data layer callbacks :type ( atom/0 ) - Required. The type of the value returned by the aggregate :name ( atom/0 ) - Required. The field to place the aggregate in :read_action ( atom/0 ) - The read action to use when building the aggregate Defaults to the primary read action. Keep in mind this action must not have any required arguments. :relationship_path - Required. The relationship or relationship path to use for the aggregate :kind - Required. The kind of the aggregate :field ( atom/0 ) - The field to aggregate. Defaults to the first field in the primary key of the resource :filter ( term/0 ) - A filter to apply to the aggregate The default value is [] . :sort ( term/0 ) - A sort to be applied to the aggregate :description ( String.t/0 ) - An optional description for the aggregate :default ( term/0 ) - A default value to use in cases where nil would be used. Count defaults to 0 . :private? ( boolean/0 ) - Whether or not the aggregate will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql The default value is false . :filterable? - Whether or not the aggregate should be usable in filters. The default value is true . calculations Declare named calculations on the resource. These are calculations that can be loaded only by name using Ash.Query.load/2 . They are also available as top level fields on the resource. See the calculations guide for more. calculate argument Examples: calculations do calculate :full_name , :string , MyApp.MyResource.FullName end Imports: Ash.Resource.Calculation.Builtins Ash.Filter.TemplateHelpers calculate Declares a named calculation on the resource. Takes a module that must adopt the Ash.Calculation behaviour. See that module for more information. To ensure that the necessary fields are selected: 1.) Specifying the select option on a calculation in the resource. 2.) Define a select/2 callback in the calculation module 3.) Set always_select? on the attribute in question See the calculations guide for more. argument Examples: Ash.Calculation implementation example: calculate :full_name , :string , { MyApp.FullName , keys : [ :first_name , :last_name ] } , select : [ :first_name , :last_name ] expr/1 example: calculate :full_name , :string , expr ( first_name &lt;&gt; &quot; &quot; &lt;&gt; last_name ) :name ( atom/0 ) - Required. The field name to use for the calculation value :type ( term/0 ) - Required. The type of the calculation. See Ash.Type for more. :constraints ( keyword/0 ) - Constraints to provide to the type. See Ash.Type for more. The default value is [] . :calculation - Required. The module or {module, opts} to use for the calculation Also accepts a function that takes the list of records and the context. :description ( String.t/0 ) - An optional description for the calculation :private? ( boolean/0 ) - Whether or not the calculation will appear in any interfaces created off of this resource, e.g AshJsonApi and AshGraphql See the security guide for more. The default value is false . :select (list of atom/0 ) - A list of fields to ensure selected if the calculation is used. The default value is [] . :load ( term/0 ) - A load statement to be applied if the calculation is used. The default value is [] . :allow_nil? ( boolean/0 ) - Whether or not the calculation can return nil. The default value is true . :filterable? - Whether or not the calculation should be usable in filters. The default value is true . argument An argument to be passed into the calculation's arguments map See the calculations guide for more. Examples: argument :params , :map do default %{ } end argument :retries , :integer do allow_nil? false end :name ( atom/0 ) - Required. The name of the argument :type ( term/0 ) - Required. The type of the argument. See Ash.Type for more. :default - A default value to use for the argument if not provided :allow_nil? ( boolean/0 ) - Whether or not the argument value may be nil (or may be not provided) The default value is true . :allow_expr? ( boolean/0 ) - Allow passing expressions as argument values. Expressions cannot be type validated. The default value is false . :constraints ( keyword/0 ) - Constraints to provide to the type when casting the value. See the type's documentation and Ash.Type for more. The default value is [] . multitenancy Options for configuring the multitenancy behavior of a resource. To specify a tenant, use Ash.Query.set_tenant/2 or Ash.Changeset.set_tenant/2 before passing it to an operation. See the multitenancy guide Examples: multitenancy do strategy :attribute attribute :organization_id global? true end :strategy - Determine if multitenancy is performed with attribute filters or using data layer features. The default value is :context . :attribute ( atom/0 ) - If using the attribute strategy, the attribute to use, e.g org_id :global? ( boolean/0 ) - Whether or not the data also exists outside of each tenant. The default value is false . :parse_attribute - An mfa ({module, function, args}) pointing to a function that takes a tenant and returns the attribute value The default value is {Ash.Resource.Dsl, :identity, []} .","ref":"Ash.Resource.Dsl.html","title":"Ash.Resource.Dsl","type":"module"},{"doc":"An Api allows you to interact with your resources, and holds non-resource-specific configuration. For example, the json api extension adds an api extension that lets you toggle authorization on/off for all resources in that Api. You include them in an Api like so: defmodule MyApp.Registry do use Ash.Registry , extensions : [ Ash.Registry.ResourceValidations ] entries do entry OneResource entry SecondResource end end defmodule MyApp.Api do use Ash.Api resources do registry MyApp.Registry end end Then you can interact through that Api with the actions that those resources expose. For example: MyApp.Api.create(changeset) , or MyApp.Api.read(query) . Corresponding actions must be defined in your resources in order to call them through the Api. Interface The functions documented here can be used to call any action on any resource in the Api. For example, MyApi.read(Myresource, [...]) . Additionally, you can define a code_interface on each resource. See the code interface guide for more.","ref":"Ash.Api.html","title":"Ash.Api","type":"behaviour"},{"doc":"Runs an aggregate or aggregates over a resource query :timeout ( timeout/0 ) - A positive integer, or :infinity . If none is provided, the timeout configured on the api is used (which defaults to 30_000 ). :tracer ( atom/0 ) - A tracer that implements the Ash.Tracer behaviour. See that module for more. :verbose? ( boolean/0 ) - Log engine operations (very verbose!) The default value is false . :action ( term/0 ) - The action to use, either an Action struct or the name of the action :authorize? - If an actor option is provided (even if it is nil ), authorization happens automatically. If not, this flag can be used to authorize with no user. :stacktraces? ( boolean/0 ) - For Ash errors, whether or not each error has a stacktrace. See the error_handling guide for more. The default value is true . :tenant ( term/0 ) - A tenant to set on the query or changeset :actor ( term/0 ) - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#aggregate/4","title":"Ash.Api.aggregate/4","type":"function"},{"doc":"See Ash.Api.Info.allow/1 .","ref":"Ash.Api.html#allow/1","title":"Ash.Api.allow/1","type":"function"},{"doc":"See Ash.Api.Info.allow_unregistered?/1 .","ref":"Ash.Api.html#allow_unregistered?/1","title":"Ash.Api.allow_unregistered?/1","type":"function"},{"doc":"See Ash.Api.Info.authorize/1 .","ref":"Ash.Api.html#authorize/1","title":"Ash.Api.authorize/1","type":"function"},{"doc":"","ref":"Ash.Api.html#c:calculate!/3","title":"Ash.Api.calculate!/3","type":"callback"},{"doc":"Evaluates the calculation on the resource. If a record is provided, its field values will be used to evaluate the calculation. :args ( map/0 ) - Values for arguments referenced by the calculation. The default value is %{} . :refs ( map/0 ) - Values for references used by the calculation. The default value is %{} . :actor ( term/0 ) - The actor for handling ^actor/1 templates, supplied to calculation context. :tenant ( term/0 ) - The tenant, supplied to calculation context. :authorize? ( boolean/0 ) - Wether or not the request is being authorized, provided to calculation context. The default value is true . :tracer ( term/0 ) - A tracer, provided to the calculation context. :record ( term/0 ) - A record to use as the base of the calculation","ref":"Ash.Api.html#calculate/3","title":"Ash.Api.calculate/3","type":"function"},{"doc":"","ref":"Ash.Api.html#c:calculate/3","title":"Ash.Api.calculate/3","type":"callback"},{"doc":"Create a record. See create/2 for more information.","ref":"Ash.Api.html#c:create!/2","title":"Ash.Api.create!/2","type":"callback"},{"doc":"Create a record. :upsert? ( boolean/0 ) - If a conflict is found based on the primary key, the record is updated in the database (requires upsert support) The default value is false . :upsert_identity ( atom/0 ) - The identity to use when detecting conflicts for upsert? , e.g. upsert_identity: :full_name . By default, the primary key is used. Has no effect if upsert?: true is not provided :timeout ( timeout/0 ) - A positive integer, or :infinity . If none is provided, the timeout configured on the api is used (which defaults to 30_000 ). :tracer ( atom/0 ) - A tracer that implements the Ash.Tracer behaviour. See that module for more. :verbose? ( boolean/0 ) - Log engine operations (very verbose!) The default value is false . :action ( term/0 ) - The action to use, either an Action struct or the name of the action :authorize? - If an actor option is provided (even if it is nil ), authorization happens automatically. If not, this flag can be used to authorize with no user. :stacktraces? ( boolean/0 ) - For Ash errors, whether or not each error has a stacktrace. See the error_handling guide for more. The default value is true . :tenant ( term/0 ) - A tenant to set on the query or changeset :actor ( term/0 ) - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access :after_action ( term/0 ) - A hook to be run just before the action returns, but before fields are selected (still inside the same transaction, if your data layer supports transactions). This is mostly important if you want to load calculations after the action, which depend on having fields selected, but you want to authorize with the minimal set of fields that are actually being selected. Runs only if the action is successful, and is passed the changeset and result of the action. Should return {:ok, result} or {:error, error} . For example, if you had a full_name calculation, but were only selecting, first_name and full_name , you might do something like this: MyApp.User |&gt; Ash.Changeset . for_create ( :create , %{ first_name : &quot;first_name&quot; , last_name : &quot;last_name&quot; } |&gt; Ash.Changeset . select ( :first_name ) ) |&gt; Api . create ( after_action : fn _changeset , user -&gt; Api . load ( user , :full_name ) end ) If you tried to load that :full_name calculation after receiving the data, the last_name would not be selected and as such would not be usable in the calculation, regardless of whether or not the calculation includes that field in its select list. :return_notifications? ( boolean/0 ) - Use this if you're running ash actions in your own transaction and you want notifications to happen still. If a transaction is ongoing, and this is false, notifications will be discarded, otherwise the return value is {:ok, result, notifications} (or {:ok, notifications} ) To send notifications later, use Ash.Notifier.notify(notifications) . It sends any notifications that can be sent, and returns the rest. The default value is false . :notification_metadata ( term/0 ) - Metadata to be merged into the metadata field for all notifications sent from this operation. The default value is %{} .","ref":"Ash.Api.html#c:create/2","title":"Ash.Api.create/2","type":"callback"},{"doc":"","ref":"Ash.Api.html#default_extensions/0","title":"Ash.Api.default_extensions/0","type":"function"},{"doc":"Destroy a record. See destroy/2 for more information.","ref":"Ash.Api.html#c:destroy!/2","title":"Ash.Api.destroy!/2","type":"callback"},{"doc":"Destroy a record. :return_destroyed? ( boolean/0 ) - If true, the destroyed record is included in the return result, e.g {:ok, destroyed} or {:ok, destroyed, notifications} The default value is false . :timeout ( timeout/0 ) - A positive integer, or :infinity . If none is provided, the timeout configured on the api is used (which defaults to 30_000 ). :tracer ( atom/0 ) - A tracer that implements the Ash.Tracer behaviour. See that module for more. :verbose? ( boolean/0 ) - Log engine operations (very verbose!) The default value is false . :action ( term/0 ) - The action to use, either an Action struct or the name of the action :authorize? - If an actor option is provided (even if it is nil ), authorization happens automatically. If not, this flag can be used to authorize with no user. :stacktraces? ( boolean/0 ) - For Ash errors, whether or not each error has a stacktrace. See the error_handling guide for more. The default value is true . :tenant ( term/0 ) - A tenant to set on the query or changeset :actor ( term/0 ) - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access :return_notifications? ( boolean/0 ) - Use this if you're running ash actions in your own transaction and you want notifications to happen still. If a transaction is ongoing, and this is false, notifications will be discarded, otherwise the return value is {:ok, result, notifications} (or {:ok, notifications} ) To send notifications later, use Ash.Notifier.notify(notifications) . It sends any notifications that can be sent, and returns the rest. The default value is false . :notification_metadata ( term/0 ) - Metadata to be merged into the metadata field for all notifications sent from this operation. The default value is %{} .","ref":"Ash.Api.html#c:destroy/2","title":"Ash.Api.destroy/2","type":"callback"},{"doc":"","ref":"Ash.Api.html#destroy_opts_schema/0","title":"Ash.Api.destroy_opts_schema/0","type":"function"},{"doc":"Get a record by a primary key. See get/3 for more.","ref":"Ash.Api.html#c:get!/3","title":"Ash.Api.get!/3","type":"callback"},{"doc":"Get a record by a primary key. For a resource with a composite primary key, pass a keyword list, e.g MyApi.get(MyResource, first_key: 1, second_key: 2) :error? ( boolean/0 ) - Whether or not an error should be returned or raised when the record is not found. If set to false, nil will be returned. The default value is true . :load ( term/0 ) - Fields or relationships to load in the query. See Ash.Query.load/2 :context ( term/0 ) - Context to be set on the query being run :timeout ( timeout/0 ) - A positive integer, or :infinity . If none is provided, the timeout configured on the api is used (which defaults to 30_000 ). :tracer ( atom/0 ) - A tracer that implements the Ash.Tracer behaviour. See that module for more. :verbose? ( boolean/0 ) - Log engine operations (very verbose!) The default value is false . :action ( term/0 ) - The action to use, either an Action struct or the name of the action :authorize? - If an actor option is provided (even if it is nil ), authorization happens automatically. If not, this flag can be used to authorize with no user. :stacktraces? ( boolean/0 ) - For Ash errors, whether or not each error has a stacktrace. See the error_handling guide for more. The default value is true . :tenant ( term/0 ) - A tenant to set on the query or changeset :actor ( term/0 ) - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:get/3","title":"Ash.Api.get/3","type":"callback"},{"doc":"Callback implementation for Spark.Dsl.init/1 .","ref":"Ash.Api.html#init/1","title":"Ash.Api.init/1","type":"function"},{"doc":"Load fields or relationships on already fetched records. See load/3 for more information.","ref":"Ash.Api.html#c:load!/3","title":"Ash.Api.load!/3","type":"callback"},{"doc":"Load fields or relationships on already fetched records. Accepts a list of non-loaded fields and loads them on the provided records or a query, in which case the loaded fields of the query are used. Relationship loads can be nested, for example: MyApi.load(record, [posts: [:comments]]) . :lazy? ( boolean/0 ) - If set to true, values will only be loaded if the related value isn't currently loaded. The default value is false . :timeout ( timeout/0 ) - A positive integer, or :infinity . If none is provided, the timeout configured on the api is used (which defaults to 30_000 ). :tracer ( atom/0 ) - A tracer that implements the Ash.Tracer behaviour. See that module for more. :verbose? ( boolean/0 ) - Log engine operations (very verbose!) The default value is false . :action ( term/0 ) - The action to use, either an Action struct or the name of the action :authorize? - If an actor option is provided (even if it is nil ), authorization happens automatically. If not, this flag can be used to authorize with no user. :stacktraces? ( boolean/0 ) - For Ash errors, whether or not each error has a stacktrace. See the error_handling guide for more. The default value is true . :tenant ( term/0 ) - A tenant to set on the query or changeset :actor ( term/0 ) - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:load/3","title":"Ash.Api.load/3","type":"callback"},{"doc":"Fetch a page relative to the provided page.","ref":"Ash.Api.html#c:page!/2","title":"Ash.Api.page!/2","type":"callback"},{"doc":"Fetch a page relative to the provided page. A page is the return value of a paginated action called via read/2 .","ref":"Ash.Api.html#c:page/2","title":"Ash.Api.page/2","type":"callback"},{"doc":"Run an ash query. See read/2 for more.","ref":"Ash.Api.html#c:read!/2","title":"Ash.Api.read!/2","type":"callback"},{"doc":"Run a query on a resource. For more information on building a query, see Ash.Query . :page - Pagination options, see the pagination docs for more :load ( term/0 ) - A load statement to add onto the query :return_query? ( boolean/0 ) - If true , the query that was ultimately used is returned as a third tuple element. The query goes through many potential changes during a request, potentially adding authorization filters, or replacing relationships for other data layers with their corresponding ids. This option can be used to get the true query that was sent to the data layer. The default value is false . :timeout ( timeout/0 ) - A positive integer, or :infinity . If none is provided, the timeout configured on the api is used (which defaults to 30_000 ). :tracer ( atom/0 ) - A tracer that implements the Ash.Tracer behaviour. See that module for more. :verbose? ( boolean/0 ) - Log engine operations (very verbose!) The default value is false . :action ( term/0 ) - The action to use, either an Action struct or the name of the action :authorize? - If an actor option is provided (even if it is nil ), authorization happens automatically. If not, this flag can be used to authorize with no user. :stacktraces? ( boolean/0 ) - For Ash errors, whether or not each error has a stacktrace. See the error_handling guide for more. The default value is true . :tenant ( term/0 ) - A tenant to set on the query or changeset :actor ( term/0 ) - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access Pagination Limit/offset pagination :offset ( non_neg_integer/0 ) - The number of records to skip from the beginning of the query :limit ( pos_integer/0 ) - The number of records to include in the page :filter ( term/0 ) - A filter to apply for pagination purposes, that should not be considered in the full count. This is used by the liveview paginator to only fetch the records that were already on the page when refreshing data, to avoid pages jittering. :count ( boolean/0 ) - Whether or not to return the page with a full count of all records Keyset pagination :before ( String.t/0 ) - Get records that appear before the provided keyset (mutually exclusive with after ) :after ( String.t/0 ) - Get records that appear after the provided keyset (mutually exclusive with before ) :limit ( pos_integer/0 ) - How many records to include in the page :filter ( term/0 ) - See the filter option for offset pagination, this behaves the same. :count ( boolean/0 ) - Whether or not to return the page with a full count of all records","ref":"Ash.Api.html#c:read/2","title":"Ash.Api.read/2","type":"callback"},{"doc":"Run an ash query, raising on more than one result. See read_one/2 for more.","ref":"Ash.Api.html#c:read_one!/2","title":"Ash.Api.read_one!/2","type":"callback"},{"doc":"Run a query on a resource, but fail on more than one result. This is useful if you have a query that doesn't include a primary key but you know that it will only ever return a single result.","ref":"Ash.Api.html#c:read_one/2","title":"Ash.Api.read_one/2","type":"callback"},{"doc":"See Ash.Api.Info.registry/1 .","ref":"Ash.Api.html#registry/1","title":"Ash.Api.registry/1","type":"function"},{"doc":"Refetches a record by primary key. See reload/1 for more.","ref":"Ash.Api.html#c:reload!/2","title":"Ash.Api.reload!/2","type":"callback"},{"doc":"Refetches a record by primary key.","ref":"Ash.Api.html#c:reload/1","title":"Ash.Api.reload/1","type":"callback"},{"doc":"See Ash.Api.Info.require_actor?/1 .","ref":"Ash.Api.html#require_actor?/1","title":"Ash.Api.require_actor?/1","type":"function"},{"doc":"See Ash.Api.Info.resource/2 .","ref":"Ash.Api.html#resource/2","title":"Ash.Api.resource/2","type":"function"},{"doc":"See Ash.Api.Info.resources/1 .","ref":"Ash.Api.html#resources/1","title":"Ash.Api.resources/1","type":"function"},{"doc":"See Ash.Api.Info.timeout/1 .","ref":"Ash.Api.html#timeout/1","title":"Ash.Api.timeout/1","type":"function"},{"doc":"Update a record. See update/2 for more information.","ref":"Ash.Api.html#c:update!/2","title":"Ash.Api.update!/2","type":"callback"},{"doc":"Update a record. :timeout ( timeout/0 ) - A positive integer, or :infinity . If none is provided, the timeout configured on the api is used (which defaults to 30_000 ). :tracer ( atom/0 ) - A tracer that implements the Ash.Tracer behaviour. See that module for more. :verbose? ( boolean/0 ) - Log engine operations (very verbose!) The default value is false . :action ( term/0 ) - The action to use, either an Action struct or the name of the action :authorize? - If an actor option is provided (even if it is nil ), authorization happens automatically. If not, this flag can be used to authorize with no user. :stacktraces? ( boolean/0 ) - For Ash errors, whether or not each error has a stacktrace. See the error_handling guide for more. The default value is true . :tenant ( term/0 ) - A tenant to set on the query or changeset :actor ( term/0 ) - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access :after_action ( term/0 ) - A hook to be run just before the action returns, but before fields are selected (still inside the same transaction, if your data layer supports transactions). This is mostly important if you want to load calculations after the action, which depend on having fields selected, but you want to authorize with the minimal set of fields that are actually being selected. Runs only if the action is successful, and is passed the changeset and result of the action. Should return {:ok, result} or {:error, error} . For example, if you had a full_name calculation, but were only selecting, first_name and full_name , you might do something like this: MyApp.User |&gt; Ash.Changeset . for_create ( :create , %{ first_name : &quot;first_name&quot; , last_name : &quot;last_name&quot; } |&gt; Ash.Changeset . select ( :first_name ) ) |&gt; Api . create ( after_action : fn _changeset , user -&gt; Api . load ( user , :full_name ) end ) If you tried to load that :full_name calculation after receiving the data, the last_name would not be selected and as such would not be usable in the calculation, regardless of whether or not the calculation includes that field in its select list. :return_notifications? ( boolean/0 ) - Use this if you're running ash actions in your own transaction and you want notifications to happen still. If a transaction is ongoing, and this is false, notifications will be discarded, otherwise the return value is {:ok, result, notifications} (or {:ok, notifications} ) To send notifications later, use Ash.Notifier.notify(notifications) . It sends any notifications that can be sent, and returns the rest. The default value is false . :notification_metadata ( term/0 ) - Metadata to be merged into the metadata field for all notifications sent from this operation. The default value is %{} .","ref":"Ash.Api.html#c:update/2","title":"Ash.Api.update/2","type":"callback"},{"doc":"","ref":"Ash.Api.html#t:load_statement/0","title":"Ash.Api.load_statement/0","type":"type"},{"doc":"","ref":"Ash.Api.html#t:page_request/0","title":"Ash.Api.page_request/0","type":"type"},{"doc":"","ref":"Ash.Api.html#t:t/0","title":"Ash.Api.t/0","type":"type"},{"doc":"The behaviour for a calculation module Use select/2 to apply a select statement when the calculation is loaded. This does not apply in the case that you are loading on existing resources using MyApi.load . It also doesn't apply when the calculation is used in a filter or sort, because it is not necessary to select fields to power filters done in the data layer.","ref":"Ash.Calculation.html","title":"Ash.Calculation","type":"behaviour"},{"doc":"","ref":"Ash.Calculation.html#c:calculate/3","title":"Ash.Calculation.calculate/3","type":"callback"},{"doc":"","ref":"Ash.Calculation.html#c:describe/1","title":"Ash.Calculation.describe/1","type":"callback"},{"doc":"","ref":"Ash.Calculation.html#c:expression/2","title":"Ash.Calculation.expression/2","type":"callback"},{"doc":"","ref":"Ash.Calculation.html#c:init/1","title":"Ash.Calculation.init/1","type":"callback"},{"doc":"","ref":"Ash.Calculation.html#c:load/3","title":"Ash.Calculation.load/3","type":"callback"},{"doc":"","ref":"Ash.Calculation.html#c:select/3","title":"Ash.Calculation.select/3","type":"callback"},{"doc":"Used to define the functions of a code interface for a resource.","ref":"Ash.CodeInterface.html","title":"Ash.CodeInterface","type":"module"},{"doc":"Defines the code interface for a given resource + api combination in the current module. For example: defmodule MyApp.Accounting do require Ash.CodeInterface Ash.CodeInterface . define_interface ( MyApp.Accounting , MyApp.Accounting.Transaction ) Ash.CodeInterface . define_interface ( MyApp.Accounting , MyApp.Accounting.Account ) Ash.CodeInterface . define_interface ( MyApp.Accounting , MyApp.Accounting.Invoice ) end Keep in mind that you can have this &quot;automatically&quot; defined in your resources by using the define_for flag in a resource. For example: defmodule MyApp.Accounting.Transaction do use Ash.Resource ... code_interface do define_for MyApp.Accounting define :start do args [ :invoice_id ] end end end # Which can now be used like so: MyApp.Accounting.Transaction . start! ( invoice . id )","ref":"Ash.CodeInterface.html#define_interface/2","title":"Ash.CodeInterface.define_interface/2","type":"macro"},{"doc":"","ref":"Ash.CodeInterface.html#unwrap_calc_interface_args/3","title":"Ash.CodeInterface.unwrap_calc_interface_args/3","type":"function"},{"doc":"","ref":"Ash.CodeInterface.html#without_optional/1","title":"Ash.CodeInterface.without_optional/1","type":"function"},{"doc":"The interface for being an ash data layer. This is a large behaviour, and this capability is not complete, but the idea is to have a large amount of optional callbacks, and use the can?/2 callback to ensure that the engine only ever tries to interact with the data layer in ways that it supports.","ref":"Ash.DataLayer.html","title":"Ash.DataLayer","type":"behaviour"},{"doc":"","ref":"Ash.DataLayer.html#c:add_aggregate/3","title":"Ash.DataLayer.add_aggregate/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#add_aggregates/3","title":"Ash.DataLayer.add_aggregates/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:add_aggregates/3","title":"Ash.DataLayer.add_aggregates/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#c:add_calculation/4","title":"Ash.DataLayer.add_calculation/4","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#add_calculations/3","title":"Ash.DataLayer.add_calculations/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:add_calculations/3","title":"Ash.DataLayer.add_calculations/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#can?/2","title":"Ash.DataLayer.can?/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:can?/2","title":"Ash.DataLayer.can?/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#create/2","title":"Ash.DataLayer.create/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:create/2","title":"Ash.DataLayer.create/2","type":"callback"},{"doc":"The data layer of the resource, or nil if it does not have one","ref":"Ash.DataLayer.html#data_layer/1","title":"Ash.DataLayer.data_layer/1","type":"function"},{"doc":"Whether or not the data layer supports a specific feature","ref":"Ash.DataLayer.html#data_layer_can?/2","title":"Ash.DataLayer.data_layer_can?/2","type":"function"},{"doc":"Custom functions supported by the data layer of the resource","ref":"Ash.DataLayer.html#data_layer_functions/1","title":"Ash.DataLayer.data_layer_functions/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#destroy/2","title":"Ash.DataLayer.destroy/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:destroy/2","title":"Ash.DataLayer.destroy/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#distinct/3","title":"Ash.DataLayer.distinct/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:distinct/3","title":"Ash.DataLayer.distinct/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#filter/3","title":"Ash.DataLayer.filter/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:filter/3","title":"Ash.DataLayer.filter/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#functions/1","title":"Ash.DataLayer.functions/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:functions/1","title":"Ash.DataLayer.functions/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#in_transaction?/1","title":"Ash.DataLayer.in_transaction?/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:in_transaction?/1","title":"Ash.DataLayer.in_transaction?/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#limit/3","title":"Ash.DataLayer.limit/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:limit/3","title":"Ash.DataLayer.limit/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#offset/3","title":"Ash.DataLayer.offset/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:offset/3","title":"Ash.DataLayer.offset/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#resource_to_query/2","title":"Ash.DataLayer.resource_to_query/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:resource_to_query/2","title":"Ash.DataLayer.resource_to_query/2","type":"callback"},{"doc":"Rolls back the current transaction","ref":"Ash.DataLayer.html#rollback/2","title":"Ash.DataLayer.rollback/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:rollback/2","title":"Ash.DataLayer.rollback/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#run_aggregate_query/3","title":"Ash.DataLayer.run_aggregate_query/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:run_aggregate_query/3","title":"Ash.DataLayer.run_aggregate_query/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#run_aggregate_query_with_lateral_join/5","title":"Ash.DataLayer.run_aggregate_query_with_lateral_join/5","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:run_aggregate_query_with_lateral_join/5","title":"Ash.DataLayer.run_aggregate_query_with_lateral_join/5","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#run_query/2","title":"Ash.DataLayer.run_query/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:run_query/2","title":"Ash.DataLayer.run_query/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#run_query_with_lateral_join/4","title":"Ash.DataLayer.run_query_with_lateral_join/4","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:run_query_with_lateral_join/4","title":"Ash.DataLayer.run_query_with_lateral_join/4","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#select/3","title":"Ash.DataLayer.select/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:select/3","title":"Ash.DataLayer.select/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#set_context/3","title":"Ash.DataLayer.set_context/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:set_context/3","title":"Ash.DataLayer.set_context/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#set_tenant/3","title":"Ash.DataLayer.set_tenant/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:set_tenant/3","title":"Ash.DataLayer.set_tenant/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#sort/3","title":"Ash.DataLayer.sort/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:sort/3","title":"Ash.DataLayer.sort/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#source/1","title":"Ash.DataLayer.source/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:source/1","title":"Ash.DataLayer.source/1","type":"callback"},{"doc":"Wraps the execution of the function in a transaction with the resource's data_layer","ref":"Ash.DataLayer.html#transaction/4","title":"Ash.DataLayer.transaction/4","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:transaction/4","title":"Ash.DataLayer.transaction/4","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#transform_query/1","title":"Ash.DataLayer.transform_query/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:transform_query/1","title":"Ash.DataLayer.transform_query/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#update/2","title":"Ash.DataLayer.update/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:update/2","title":"Ash.DataLayer.update/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#upsert/3","title":"Ash.DataLayer.upsert/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:upsert/3","title":"Ash.DataLayer.upsert/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#t:data_layer_query/0","title":"Ash.DataLayer.data_layer_query/0","type":"type"},{"doc":"","ref":"Ash.DataLayer.html#t:feature/0","title":"Ash.DataLayer.feature/0","type":"type"},{"doc":"","ref":"Ash.DataLayer.html#t:lateral_join_link/0","title":"Ash.DataLayer.lateral_join_link/0","type":"type"},{"doc":"","ref":"Ash.DataLayer.html#t:t/0","title":"Ash.DataLayer.t/0","type":"type"},{"doc":"","ref":"Ash.DataLayer.html#t:transaction_reason/0","title":"Ash.DataLayer.transaction_reason/0","type":"type"},{"doc":"Helpers for building filter templates","ref":"Ash.Filter.TemplateHelpers.html","title":"Ash.Filter.TemplateHelpers","type":"module"},{"doc":"A helper for using actor values in filter templates","ref":"Ash.Filter.TemplateHelpers.html#actor/1","title":"Ash.Filter.TemplateHelpers.actor/1","type":"function"},{"doc":"A helper for using action arguments in filter templates","ref":"Ash.Filter.TemplateHelpers.html#arg/1","title":"Ash.Filter.TemplateHelpers.arg/1","type":"function"},{"doc":"A helper for using query context in filter templates An atom will just get the key, and a list will be accessed via get_in .","ref":"Ash.Filter.TemplateHelpers.html#context/1","title":"Ash.Filter.TemplateHelpers.context/1","type":"function"},{"doc":"A helper for building an expression style filter","ref":"Ash.Filter.TemplateHelpers.html#expr/1","title":"Ash.Filter.TemplateHelpers.expr/1","type":"macro"},{"doc":"","ref":"Ash.Filter.TemplateHelpers.html#expr?/1","title":"Ash.Filter.TemplateHelpers.expr?/1","type":"function"},{"doc":"","ref":"Ash.Filter.TemplateHelpers.html#is_expr/1","title":"Ash.Filter.TemplateHelpers.is_expr/1","type":"macro"},{"doc":"A helper for creating a reference","ref":"Ash.Filter.TemplateHelpers.html#ref/1","title":"Ash.Filter.TemplateHelpers.ref/1","type":"function"},{"doc":"A helper for creating a reference to a related path","ref":"Ash.Filter.TemplateHelpers.html#ref/2","title":"Ash.Filter.TemplateHelpers.ref/2","type":"function"},{"doc":"A notifier is an extension that receives various events","ref":"Ash.Notifier.html","title":"Ash.Notifier","type":"behaviour"},{"doc":"Sends any notifications that can be sent, and returns the rest. A notification can only be sent if you are not currently in a transaction for the resource in question.","ref":"Ash.Notifier.html#notify/1","title":"Ash.Notifier.notify/1","type":"function"},{"doc":"","ref":"Ash.Notifier.html#c:notify/1","title":"Ash.Notifier.notify/1","type":"callback"},{"doc":"Represents a notification that will be handled by a resource's notifiers Set the for key to a notifier or a list of notifiers to route the notification to them. This allows you to produce notifications inside of a change module and target specific notifiers with them. metadata is freeform data to be set however you want. resource , action , data , changeset and actor are all set by default based on the details of the action, so they can be omitted. When creating a notification, a resource is required to ensure that the notification isn't sent until the current transaction for that resource is closed. If you don't need this behavior you can explicitly supply nil for the resource. If you supply nil for the resource, however, you must manually set the for option, e.g: for: Notifier or for: [Notifier1, Notifier2]","ref":"Ash.Notifier.Notification.html","title":"Ash.Notifier.Notification","type":"module"},{"doc":"","ref":"Ash.Notifier.Notification.html#new/2","title":"Ash.Notifier.Notification.new/2","type":"function"},{"doc":"","ref":"Ash.Notifier.Notification.html#t:t/0","title":"Ash.Notifier.Notification.t/0","type":"type"},{"doc":"Helpers for building attributes","ref":"Ash.Resource.Attribute.Helpers.html","title":"Ash.Resource.Attribute.Helpers","type":"module"},{"doc":"","ref":"Ash.Resource.Attribute.Helpers.html#timestamps/1","title":"Ash.Resource.Attribute.Helpers.timestamps/1","type":"macro"},{"doc":"Built in calculations that are automatically imported in the calculations section","ref":"Ash.Resource.Calculation.Builtins.html","title":"Ash.Resource.Calculation.Builtins","type":"module"},{"doc":"An example concatenation calculation, that accepts the delimiter as an argument Examples calculate :full_name , concat ( [ :first_name , :last_name ] , &quot; &quot; )","ref":"Ash.Resource.Calculation.Builtins.html#concat/2","title":"Ash.Resource.Calculation.Builtins.concat/2","type":"function"},{"doc":"A module to implement manual create actions.","ref":"Ash.Resource.ManualCreate.html","title":"Ash.Resource.ManualCreate","type":"behaviour"},{"doc":"","ref":"Ash.Resource.ManualCreate.html#c:create/3","title":"Ash.Resource.ManualCreate.create/3","type":"callback"},{"doc":"","ref":"Ash.Resource.ManualCreate.html#t:context/0","title":"Ash.Resource.ManualCreate.context/0","type":"type"},{"doc":"A module to implement manual destroy actions.","ref":"Ash.Resource.ManualDestroy.html","title":"Ash.Resource.ManualDestroy","type":"behaviour"},{"doc":"","ref":"Ash.Resource.ManualDestroy.html#c:destroy/3","title":"Ash.Resource.ManualDestroy.destroy/3","type":"callback"},{"doc":"","ref":"Ash.Resource.ManualDestroy.html#t:context/0","title":"Ash.Resource.ManualDestroy.context/0","type":"type"},{"doc":"A module to implement manual read actions.","ref":"Ash.Resource.ManualRead.html","title":"Ash.Resource.ManualRead","type":"behaviour"},{"doc":"","ref":"Ash.Resource.ManualRead.html#c:read/4","title":"Ash.Resource.ManualRead.read/4","type":"callback"},{"doc":"","ref":"Ash.Resource.ManualRead.html#t:context/0","title":"Ash.Resource.ManualRead.context/0","type":"type"},{"doc":"A module to implement manual relationships.","ref":"Ash.Resource.ManualRelationship.html","title":"Ash.Resource.ManualRelationship","type":"behaviour"},{"doc":"","ref":"Ash.Resource.ManualRelationship.html#c:load/3","title":"Ash.Resource.ManualRelationship.load/3","type":"callback"},{"doc":"","ref":"Ash.Resource.ManualRelationship.html#t:context/0","title":"Ash.Resource.ManualRelationship.context/0","type":"type"},{"doc":"A module to implement manual update actions.","ref":"Ash.Resource.ManualUpdate.html","title":"Ash.Resource.ManualUpdate","type":"behaviour"},{"doc":"","ref":"Ash.Resource.ManualUpdate.html#c:update/3","title":"Ash.Resource.ManualUpdate.update/3","type":"callback"},{"doc":"","ref":"Ash.Resource.ManualUpdate.html#t:context/0","title":"Ash.Resource.ManualUpdate.context/0","type":"type"},{"doc":"Utilities around constructing/manipulating ash queries. Ash queries are used for read actions and loads, and ultimately map to queries to a resource's data layer. Queries are run by calling read on an API that contains the resource in question Examples: MyApp.Post |&gt; Ash.Query . filter ( likes &gt; 10 ) |&gt; Ash.Query . sort ( [ :title ] ) |&gt; MyApp.Api . read! ( ) MyApp.Author |&gt; Ash.Query . aggregate ( :published_post_count , :posts , filter : [ published : true ] ) |&gt; Ash.Query . sort ( published_post_count : :desc ) |&gt; Ash.Query . limit ( 10 ) |&gt; MyApp.Api . read! ( ) MyApp.Author |&gt; Ash.Query . load ( [ :post_count , :comment_count ] ) |&gt; Ash.Query . load ( posts : [ :comments ] ) |&gt; MyApp.Api . read! ( )","ref":"Ash.Query.html","title":"Ash.Query","type":"module"},{"doc":"","ref":"Ash.Query.html#add_error/3","title":"Ash.Query.add_error/3","type":"function"},{"doc":"","ref":"Ash.Query.html#after_action/2","title":"Ash.Query.after_action/2","type":"function"},{"doc":"Adds an aggregation to the query. Aggregations are made available on the aggregates field of the records returned The filter option accepts either a filter or a keyword list of options to supply to build a limiting query for that aggregate. See the DSL docs for each aggregate type in Ash.Resource.Dsl for more information. Options: query: The query over the destination resource to use as a base for aggregation default: The default value to use if the aggregate returns nil filterable?: Wether or not this aggregate may be referenced in filters type: The type of the aggregate constraints: Type constraints for the aggregate's type implementation: An implementation used when the aggregate kind is custom","ref":"Ash.Query.html#aggregate/4","title":"Ash.Query.aggregate/4","type":"function"},{"doc":"","ref":"Ash.Query.html#aggregate/5","title":"Ash.Query.aggregate/5","type":"function"},{"doc":"Adds an aggregation to the query. Aggregations are made available on the aggregates field of the records returned The filter option accepts either a filter or a keyword list of options to supply to build a limiting query for that aggregate. See the DSL docs for each aggregate type in Ash.Resource.Dsl for more information.","ref":"Ash.Query.html#aggregate/11","title":"Ash.Query.aggregate/11","type":"function"},{"doc":"","ref":"Ash.Query.html#before_action/2","title":"Ash.Query.before_action/2","type":"function"},{"doc":"Builds a query from a keyword list. This is used by certain query constructs like aggregates. It can also be used to manipulate a data structure before passing it to an ash query. It allows for building an entire query struct using only a keyword list. For example: Ash.Query . build ( MyResource , filter : [ name : &quot;fred&quot; ] , sort : [ name : :asc ] , load : [ :foo , :bar ] , offset : 10 ) If you want to use the expression style filters, you can use expr/1 . For example: import Ash.Expr , only : [ expr : 1 ] Ash.Query . build ( Myresource , filter : expr ( name == &quot;marge&quot; ) ) Options :filter ( term/0 ) - A filter keyword, expression or %Ash.Filter{} :sort ( term/0 ) - A sort list or keyword :limit ( integer/0 ) - A limit to apply :offset ( integer/0 ) - An offset to apply :load ( term/0 ) - A load statement to add to the query :aggregate ( term/0 ) - A custom aggregate to add to the query. Can be {name, type, relationship} or {name, type, relationship, build_opts} :calculate ( term/0 ) - A custom calculation to add to the query. Can be {name, module_and_opts} or {name, module_and_opts, context} :distinct (list of atom/0 ) - A distinct clause to add to the query :context ( map/0 ) - A map to merge into the query context","ref":"Ash.Query.html#build/3","title":"Ash.Query.build/3","type":"function"},{"doc":"Adds a calculation to the query. Calculations are made available on the calculations field of the records returned The module_and_opts argument accepts either a module or a {module, opts} . For more information on what that module should look like, see Ash.Calculation .","ref":"Ash.Query.html#calculate/6","title":"Ash.Query.calculate/6","type":"function"},{"doc":"Removes a result set previously with set_result/2","ref":"Ash.Query.html#clear_result/1","title":"Ash.Query.clear_result/1","type":"function"},{"doc":"Return the underlying data layer query for an ash query","ref":"Ash.Query.html#data_layer_query/2","title":"Ash.Query.data_layer_query/2","type":"function"},{"doc":"Remove an argument from the query","ref":"Ash.Query.html#delete_argument/2","title":"Ash.Query.delete_argument/2","type":"function"},{"doc":"Ensure the the specified attributes are nil in the query results.","ref":"Ash.Query.html#deselect/2","title":"Ash.Query.deselect/2","type":"function"},{"doc":"Get results distinct on the provided fields. Takes a list of fields to distinct on. Each call is additive, so to remove the distinct use unset/2 . Examples: Ash.Query . distinct ( query , [ :first_name , :last_name ] ) Ash.Query . distinct ( query , :email )","ref":"Ash.Query.html#distinct/2","title":"Ash.Query.distinct/2","type":"function"},{"doc":"Ensures that the given attributes are selected. The first call to select/2 will limit the fields to only the provided fields. Use ensure_selected/2 to say &quot;select this field (or these fields) without deselecting anything else&quot;. See select/2 for more.","ref":"Ash.Query.html#ensure_selected/2","title":"Ash.Query.ensure_selected/2","type":"function"},{"doc":"Determines if the filter statement of a query is equivalent to the provided expression. This uses the satisfiability solver that is used when solving for policy authorizations. In complex scenarios, or when using custom database expressions, (like fragments in ash_postgres), this function may return :maybe . Use supserset_of? to always return a boolean.","ref":"Ash.Query.html#equivalent_to/2","title":"Ash.Query.equivalent_to/2","type":"macro"},{"doc":"Same as equivalent_to/2 but always returns a boolean. :maybe returns false .","ref":"Ash.Query.html#equivalent_to?/2","title":"Ash.Query.equivalent_to?/2","type":"macro"},{"doc":"Creates an Ash expression for evaluation later.","ref":"Ash.Query.html#expr/1","title":"Ash.Query.expr/1","type":"macro"},{"doc":"fetches the value of an argument provided to the query or :error","ref":"Ash.Query.html#fetch_argument/2","title":"Ash.Query.fetch_argument/2","type":"function"},{"doc":"Attach a filter statement to the query. The filter is applied as an &quot;and&quot; to any filters currently on the query. For more information on writing filters, see: Ash.Filter .","ref":"Ash.Query.html#filter/2","title":"Ash.Query.filter/2","type":"macro"},{"doc":"Creates a query for a given read action and prepares it. Multitenancy is not validated until an action is called. This allows you to avoid specifying a tenant until just before calling the api action. Arguments Provide a map or keyword list of arguments for the read action Opts :actor ( term/0 ) - set the actor, which can be used in any Ash.Resource.Change s configured on the action. (in the context argument) :authorize? ( boolean/0 ) - set authorize?, which can be used in any Ash.Resource.Change s configured on the action. (in the context argument) :authorize? ( boolean/0 ) - set tracer, which can be used in any Ash.Resource.Change s configured on the action. (in the context argument) :tracer ( atom/0 ) - A tracer to use. Will be carried over to the action. For more information see Ash.Tracer . :tenant ( term/0 ) - set the tenant on the query","ref":"Ash.Query.html#for_read/4","title":"Ash.Query.for_read/4","type":"function"},{"doc":"","ref":"Ash.Query.html#for_read_opts/0","title":"Ash.Query.for_read_opts/0","type":"function"},{"doc":"Gets the value of an argument provided to the query","ref":"Ash.Query.html#get_argument/2","title":"Ash.Query.get_argument/2","type":"function"},{"doc":"Returns true if the value is one of the expression structs.","ref":"Ash.Query.html#is_expr?/1","title":"Ash.Query.is_expr?/1","type":"function"},{"doc":"Limit the results returned from the query","ref":"Ash.Query.html#limit/2","title":"Ash.Query.limit/2","type":"function"},{"doc":"Loads relationships, calculations, or aggregates on the resource. Currently, loading attributes has no effects, as all attributes are returned. Before long, we will have the default list to load as the attributes, but if you say load(query, [:attribute1]) , that will be the only field filled in. This will let data layers make more intelligent &quot;select&quot; statements as well. # Loading nested relationships Ash.Query . load ( query , [ comments : [ :author , :ratings ] ] ) # Loading relationships with a query Ash.Query . load ( query , [ comments : [ author : author_query ] ] )","ref":"Ash.Query.html#load/2","title":"Ash.Query.load/2","type":"function"},{"doc":"Adds a resource calculation to the query as a custom calculation with the provided name.","ref":"Ash.Query.html#load_calculation_as/4","title":"Ash.Query.load_calculation_as/4","type":"function"},{"doc":"Returns true if the field/relationship or path to field/relationship is being loaded. It accepts an atom or a list of atoms, which is treated for as a &quot;path&quot;, i.e: Resource |&gt; Ash.Query . load ( friends : [ enemies : [ :score ] ] ) |&gt; Ash.Query . loaded? ( [ :friends , :enemies , :score ] ) iex&gt; true Resource |&gt; Ash.Query . load ( friends : [ enemies : [ :score ] ] ) |&gt; Ash.Query . loaded? ( [ :friends , :score ] ) iex&gt; false Resource |&gt; Ash.Query . load ( friends : [ enemies : [ :score ] ] ) |&gt; Ash.Query . loaded? ( :friends ) iex&gt; true","ref":"Ash.Query.html#loading?/2","title":"Ash.Query.loading?/2","type":"function"},{"doc":"Create a new query","ref":"Ash.Query.html#new/3","title":"Ash.Query.new/3","type":"function"},{"doc":"Skip the first n records","ref":"Ash.Query.html#offset/2","title":"Ash.Query.offset/2","type":"function"},{"doc":"Sets a specific context key to a specific value See set_context/2 for more information.","ref":"Ash.Query.html#put_context/3","title":"Ash.Query.put_context/3","type":"function"},{"doc":"Ensure that only the specified attributes are present in the results. The first call to select/2 will replace the default behavior of selecting all attributes. Subsequent calls to select/2 will combine the provided fields unless the replace? option is provided with a value of true . If a field has been deselected, selecting it again will override that (because a single list of fields is tracked for selection) Primary key attributes are always selected and cannot be deselected. When attempting to load a relationship (or manage it with Ash.Changeset.manage_relationship/3 ), if the source field is not selected on the query/provided data an error will be produced. If loading a relationship with a query, an error is produced if the query does not select the destination field of the relationship. Use ensure_selected/2 if you wish to make sure a field has been selected, without deselecting any other fields.","ref":"Ash.Query.html#select/3","title":"Ash.Query.select/3","type":"function"},{"doc":"","ref":"Ash.Query.html#selecting?/2","title":"Ash.Query.selecting?/2","type":"function"},{"doc":"Set the query's api, and any loaded query's api","ref":"Ash.Query.html#set_api/2","title":"Ash.Query.set_api/2","type":"function"},{"doc":"Add an argument to the query, which can be used in filter templates on actions","ref":"Ash.Query.html#set_argument/3","title":"Ash.Query.set_argument/3","type":"function"},{"doc":"Merge a map of arguments to the arguments list","ref":"Ash.Query.html#set_arguments/2","title":"Ash.Query.set_arguments/2","type":"function"},{"doc":"Merge a map of values into the query context","ref":"Ash.Query.html#set_context/2","title":"Ash.Query.set_context/2","type":"function"},{"doc":"Set the result of the action. This will prevent running the underlying datalayer behavior","ref":"Ash.Query.html#set_result/2","title":"Ash.Query.set_result/2","type":"function"},{"doc":"","ref":"Ash.Query.html#set_tenant/2","title":"Ash.Query.set_tenant/2","type":"function"},{"doc":"Sort the results based on attributes, aggregates or calculations. Calculations are supported if they are defined with expressions, which can be done one of two ways. with the shorthand calculate :calc, :type, expr(a + b) By defining expression/2 in a custom calculation module See the guide on calculations for more. Takes a list of fields to sort on, or a keyword list/mixed keyword list of fields and sort directions. The default sort direction is :asc . Examples: Ash.Query . sort ( query , [ :foo , :bar ] ) Ash.Query . sort ( query , [ :foo , bar : :desc ] ) Ash.Query . sort ( query , [ foo : :desc , bar : :asc ] ) Options prepend? - set to true to put your sort at the front of the list of a sort is already specified","ref":"Ash.Query.html#sort/3","title":"Ash.Query.sort/3","type":"function"},{"doc":"","ref":"Ash.Query.html#struct?/1","title":"Ash.Query.struct?/1","type":"function"},{"doc":"Determines if the provided expression would return data that is a suprset of the data returned by the filter on the query. This uses the satisfiability solver that is used when solving for policy authorizations. In complex scenarios, or when using custom database expressions, (like fragments in ash_postgres), this function may return :maybe . Use subset_of? to always return a boolean.","ref":"Ash.Query.html#subset_of/2","title":"Ash.Query.subset_of/2","type":"macro"},{"doc":"Same as subset_of/2 but always returns a boolean. :maybe returns false .","ref":"Ash.Query.html#subset_of?/2","title":"Ash.Query.subset_of?/2","type":"macro"},{"doc":"Determines if the provided expression would return data that is a subset of the data returned by the filter on the query. This uses the satisfiability solver that is used when solving for policy authorizations. In complex scenarios, or when using custom database expressions, (like fragments in ash_postgres), this function may return :maybe . Use supserset_of? to always return a boolean.","ref":"Ash.Query.html#superset_of/2","title":"Ash.Query.superset_of/2","type":"macro"},{"doc":"Same as superset_of/2 but always returns a boolean. :maybe returns false .","ref":"Ash.Query.html#superset_of?/2","title":"Ash.Query.superset_of?/2","type":"macro"},{"doc":"","ref":"Ash.Query.html#timeout/2","title":"Ash.Query.timeout/2","type":"function"},{"doc":"Takes a resource or a query and returns a query.","ref":"Ash.Query.html#to_query/1","title":"Ash.Query.to_query/1","type":"function"},{"doc":"Removes a field from the list of fields to load","ref":"Ash.Query.html#unload/2","title":"Ash.Query.unload/2","type":"function"},{"doc":"","ref":"Ash.Query.html#unset/2","title":"Ash.Query.unset/2","type":"function"},{"doc":"","ref":"Ash.Query.html#t:t/0","title":"Ash.Query.t/0","type":"type"},{"doc":"Represents an aggregated association value","ref":"Ash.Query.Aggregate.html","title":"Ash.Query.Aggregate","type":"module"},{"doc":"","ref":"Ash.Query.Aggregate.html#default_value/1","title":"Ash.Query.Aggregate.default_value/1","type":"function"},{"doc":"","ref":"Ash.Query.Aggregate.html#new!/4","title":"Ash.Query.Aggregate.new!/4","type":"function"},{"doc":"Create a new aggregate, used with Query.aggregate or Api.aggregate Options: :path (list of atom/0 ) - The relationship path to aggregate over. Only used when adding aggregates to a query. :query ( term/0 ) - A base query to use for the aggregate, or a keyword list to be passed to Ash.Query.build/2 :field ( atom/0 ) - The field to use for the aggregate. Not necessary for all aggregate types. :default ( term/0 ) - A default value to use for the aggregate if it returns nil . :filterable? ( boolean/0 ) - Wether or not this aggregate may be used in filters. :type ( term/0 ) - A type to use for the aggregate. :constraints ( term/0 ) - Type constraints to use for the aggregate. :implementation ( term/0 ) - The implementation for any custom aggregates. :uniq? ( boolean/0 ) - Wether or not to only consider unique values. Only relevant for count and list aggregates.","ref":"Ash.Query.Aggregate.html#new/4","title":"Ash.Query.Aggregate.new/4","type":"function"},{"doc":"","ref":"Ash.Query.Aggregate.html#new/12","title":"Ash.Query.Aggregate.new/12","type":"function"},{"doc":"","ref":"Ash.Query.Aggregate.html#requests/5","title":"Ash.Query.Aggregate.requests/5","type":"function"},{"doc":"","ref":"Ash.Query.Aggregate.html#t:kind/0","title":"Ash.Query.Aggregate.kind/0","type":"type"},{"doc":"","ref":"Ash.Query.Aggregate.html#t:t/0","title":"Ash.Query.Aggregate.t/0","type":"type"},{"doc":"Represents a calculated attribute requested on a query","ref":"Ash.Query.Calculation.html","title":"Ash.Query.Calculation","type":"module"},{"doc":"","ref":"Ash.Query.Calculation.html#new/7","title":"Ash.Query.Calculation.new/7","type":"function"},{"doc":"","ref":"Ash.Query.Calculation.html#t:t/0","title":"Ash.Query.Calculation.t/0","type":"type"},{"doc":"The behaviour for an action-specific query preparation. init/1 is defined automatically by use Ash.Resource.Preparation , but can be implemented if you want to validate/transform any options passed to the module. The main function is prepare/3 . It takes the changeset, any options that were provided when this change was configured on a resource, and the context, which currently only has the actor. To access any query arguments from within a preparation, make sure you are using Ash.Query.get_argument/2 as the argument keys may be strings or atoms.","ref":"Ash.Resource.Preparation.html","title":"Ash.Resource.Preparation","type":"behaviour"},{"doc":"","ref":"Ash.Resource.Preparation.html#c:init/1","title":"Ash.Resource.Preparation.init/1","type":"callback"},{"doc":"","ref":"Ash.Resource.Preparation.html#c:prepare/3","title":"Ash.Resource.Preparation.prepare/3","type":"callback"},{"doc":"","ref":"Ash.Resource.Preparation.html#t:context/0","title":"Ash.Resource.Preparation.context/0","type":"type"},{"doc":"","ref":"Ash.Resource.Preparation.html#t:ref/0","title":"Ash.Resource.Preparation.ref/0","type":"type"},{"doc":"","ref":"Ash.Resource.Preparation.html#t:t/0","title":"Ash.Resource.Preparation.t/0","type":"type"},{"doc":"Builtin query preparations","ref":"Ash.Resource.Preparation.Builtins.html","title":"Ash.Resource.Preparation.Builtins","type":"module"},{"doc":"Passes the given keyword list to Ash.Query.build/2 with the query being prepared. This allows declaring simple query modifications in-line. To see the available options, see Ash.Query.build/2 Examples prepare build ( sort : [ song_rank : :desc ] , limit : 10 ) prepare build ( load : [ :friends ] )","ref":"Ash.Resource.Preparation.Builtins.html#build/1","title":"Ash.Resource.Preparation.Builtins.build/1","type":"function"},{"doc":"Merges the given query context. If an MFA is provided, it will be called with the changeset. The MFA should return {:ok, context_to_be_merged} or {:error, term} Examples change set_context ( %{ something_used_internally : true } ) change set_context ( { MyApp.Context , :set_context , [ ] } )","ref":"Ash.Resource.Preparation.Builtins.html#set_context/1","title":"Ash.Resource.Preparation.Builtins.set_context/1","type":"function"},{"doc":"Changesets are used to create and update data in Ash. Create a changeset with new/1 or new/2 , and alter the attributes and relationships using the functions provided in this module. Nothing in this module actually incurs changes in a data layer. To commit a changeset, see Ash.Api.create/2 and Ash.Api.update/2 . See the action DSL documentation for more.","ref":"Ash.Changeset.html","title":"Ash.Changeset","type":"module"},{"doc":"Adds an error to the changesets errors list, and marks the change as valid?: false","ref":"Ash.Changeset.html#add_error/3","title":"Ash.Changeset.add_error/3","type":"function"},{"doc":"Adds an after_action hook to the changeset. Provide the option prepend?: true to place the hook before all other hooks instead of after.","ref":"Ash.Changeset.html#after_action/3","title":"Ash.Changeset.after_action/3","type":"function"},{"doc":"Adds an after_transaction hook to the changeset. after_transaction hooks differ from after_action hooks in that they are run on success and failure of the action or some previous hook. Provide the option prepend?: true to place the hook before all other hooks instead of after.","ref":"Ash.Changeset.html#after_transaction/3","title":"Ash.Changeset.after_transaction/3","type":"function"},{"doc":"Appends a record or a list of records to a relationship. Alias for: manage_relationship ( changeset , relationship , input , on_lookup : :relate , # If a record is not in the relationship, and can be found, relate it on_no_match : :error , # If a record is not found in the relationship or the database, we error on_match : :ignore , # If a record is found in the relationship we don&#39;t change it on_missing : :ignore , # If a record is not found in the input, we ignore it ) Provide opts to customize/override the behavior.","ref":"Ash.Changeset.html#append_to_relationship/4","title":"Ash.Changeset.append_to_relationship/4","type":"function"},{"doc":"Returns the original data with attribute changes merged, if the changeset is valid. Options: force? - applies current attributes even if the changeset is not valid","ref":"Ash.Changeset.html#apply_attributes/2","title":"Ash.Changeset.apply_attributes/2","type":"function"},{"doc":"Adds an around_action hook to the changeset. Your function will get the changeset, and a callback that must be called with a changeset (that may be modified). The callback will return {:ok, result, instructions} or {:error, error} . You can modify these values, but the return value must be one of those types. Instructions contains the notifications in its notifications key, i.e %{notifications: [%Ash.Resource.Notification{}, ...]} . The around_action calls happen first, and then (after they each resolve their callbacks) the before_action hooks are called, followed by the action itself occurring at the data layer and then the after_action hooks being run. Then, the code that appeared after the callbacks were called is then run. For example: changeset |&gt; Ash.Changeset . around_action ( fn changeset , callback -&gt; IO . puts ( &quot;first around: before&quot; ) result = callback . ( changeset ) IO . puts ( &quot;first around: after&quot; ) end ) |&gt; Ash.Changeset . around_action ( fn changeset , callback -&gt; IO . puts ( &quot;second around: before&quot; ) result = callback . ( changeset ) IO . puts ( &quot;second around: after&quot; ) end ) |&gt; Ash.Changeset . before_action ( fn changeset -&gt; IO . puts ( &quot;first before&quot; ) changeset end ) |&gt; Ash.Changeset . before_action ( fn changeset -&gt; IO . puts ( &quot;second before&quot; ) changeset end ) |&gt; Ash.Changeset . after_action ( fn changeset , result -&gt; IO . puts ( &quot;first after&quot; ) { :ok , result } end ) |&gt; Ash.Changeset . after_action ( fn changeset -&gt; IO . puts ( &quot;second after&quot; ) { :ok , result } end ) This would print: first around : before second around : before first before second before &lt;- - action happens here first after second after second around : after &lt;- - Notice that because of the callbacks , the after of the around hooks is reversed from the before first around : after Warning: using this without understanding how it works can cause big problems. You must call the callback function that is provided to your hook, and the return value must contain the same structure that was given to you, i.e {:ok, result_of_action, instructions} . You can almost always get the same effect by using before_action , setting some context on the changeset and reading it out in an after_action hook.","ref":"Ash.Changeset.html#around_action/2","title":"Ash.Changeset.around_action/2","type":"function"},{"doc":"Adds a before_action hook to the changeset. Provide the option append?: true to place the hook after all other hooks instead of before.","ref":"Ash.Changeset.html#before_action/3","title":"Ash.Changeset.before_action/3","type":"function"},{"doc":"Adds a before_transaction hook to the changeset. Provide the option append?: true to place the hook after all other hooks instead of before.","ref":"Ash.Changeset.html#before_transaction/3","title":"Ash.Changeset.before_transaction/3","type":"function"},{"doc":"Adds a change to the changeset, unless the value matches the existing value","ref":"Ash.Changeset.html#change_attribute/3","title":"Ash.Changeset.change_attribute/3","type":"function"},{"doc":"Calls change_attribute/3 for each key/value pair provided","ref":"Ash.Changeset.html#change_attributes/2","title":"Ash.Changeset.change_attributes/2","type":"function"},{"doc":"The same as change_attribute , but annotates that the attribute is currently holding a default value. This information can be used in changes to see if a value was explicitly set or if it was set by being the default. Additionally, this is used in upsert actions to not overwrite existing values with the default","ref":"Ash.Changeset.html#change_default_attribute/3","title":"Ash.Changeset.change_default_attribute/3","type":"function"},{"doc":"Change an attribute only if is not currently being changed","ref":"Ash.Changeset.html#change_new_attribute/3","title":"Ash.Changeset.change_new_attribute/3","type":"function"},{"doc":"Change an attribute if is not currently being changed, by calling the provided function Use this if you want to only perform some expensive calculation for an attribute value only if there isn't already a change for that attribute","ref":"Ash.Changeset.html#change_new_attribute_lazy/3","title":"Ash.Changeset.change_new_attribute_lazy/3","type":"function"},{"doc":"Returns true if an attribute exists in the changes","ref":"Ash.Changeset.html#changing_attribute?/2","title":"Ash.Changeset.changing_attribute?/2","type":"function"},{"doc":"Returns true if any attributes on the resource are being changed.","ref":"Ash.Changeset.html#changing_attributes?/1","title":"Ash.Changeset.changing_attributes?/1","type":"function"},{"doc":"Returns true if a relationship exists in the changes","ref":"Ash.Changeset.html#changing_relationship?/2","title":"Ash.Changeset.changing_relationship?/2","type":"function"},{"doc":"Clears an attribute or relationship change off of the changeset","ref":"Ash.Changeset.html#clear_change/2","title":"Ash.Changeset.clear_change/2","type":"function"},{"doc":"Remove an argument from the changeset","ref":"Ash.Changeset.html#delete_argument/2","title":"Ash.Changeset.delete_argument/2","type":"function"},{"doc":"Ensure the the specified attributes are nil in the changeset results.","ref":"Ash.Changeset.html#deselect/2","title":"Ash.Changeset.deselect/2","type":"function"},{"doc":"Ensures that the given attributes are selected. The first call to select/2 will limit the fields to only the provided fields. Use ensure_selected/2 to say &quot;select this field (or these fields) without deselecting anything else&quot;. See select/2 for more.","ref":"Ash.Changeset.html#ensure_selected/2","title":"Ash.Changeset.ensure_selected/2","type":"function"},{"doc":"fetches the value of an argument provided to the changeset or :error","ref":"Ash.Changeset.html#fetch_argument/2","title":"Ash.Changeset.fetch_argument/2","type":"function"},{"doc":"Gets the value of an argument provided to the changeset, falling back to Ash.Changeset.fetch_change/2 if nothing was provided","ref":"Ash.Changeset.html#fetch_argument_or_change/2","title":"Ash.Changeset.fetch_argument_or_change/2","type":"function"},{"doc":"Gets the new value for an attribute, or :error if it is not being changed","ref":"Ash.Changeset.html#fetch_change/2","title":"Ash.Changeset.fetch_change/2","type":"function"},{"doc":"Constructs a changeset for a given action, and validates it. Calls for_create/4 , for_update/4 or for_destroy/4 based on the type of action passed in. See those functions for more explanation.","ref":"Ash.Changeset.html#for_action/4","title":"Ash.Changeset.for_action/4","type":"function"},{"doc":"Constructs a changeset for a given create action, and validates it. Anything that is modified prior to for_create/4 is validated against the rules of the action, while anything after it is not . This runs any change s contained on your action. To have your logic execute only during the action, you can use after_action/2 or before_action/2 . Multitenancy is not validated until an action is called. This allows you to avoid specifying a tenant until just before calling the api action. Params params may be attributes, relationships, or arguments. You can safely pass user/form input directly into this function. Only public attributes and relationships are supported. If you want to change private attributes as well, see the Customization section below. params are stored directly as given in the params field of the changeset, which is used Opts :require? ( boolean/0 ) - If set to true , values are only required when the action is run (instead of immediately). The default value is false . :actor ( term/0 ) - set the actor, which can be used in any Ash.Resource.Change s configured on the action. (in the context argument) :authorize? ( term/0 ) - set authorize?, which can be used in any Ash.Resource.Change s configured on the action. (in the context argument) :tracer ( atom/0 ) - A tracer to use. Will be carried over to the action. For more information see Ash.Tracer . :tenant ( term/0 ) - set the tenant on the changeset Customization A changeset can be provided as the first argument, instead of a resource, to allow setting specific attributes ahead of time. For example: MyResource |&gt; Ash.Changeset . new ( ) |&gt; Ash.Changeset . change_attribute ( :foo , 1 ) |&gt; Ash.Changeset . for_create ( :create , ... opts ) Once a changeset has been validated by for_create/4 (or for_update/4 ), it isn't validated again in the action. New changes added are validated individually, though. This allows you to create a changeset according to a given action, and then add custom changes if necessary.","ref":"Ash.Changeset.html#for_create/4","title":"Ash.Changeset.for_create/4","type":"function"},{"doc":"Constructs a changeset for a given destroy action, and validates it. Opts :actor - set the actor, which can be used in any Ash.Resource.Change s configured on the action. (in the context argument) :tenant - set the tenant on the changeset Anything that is modified prior to for_destroy/4 is validated against the rules of the action, while anything after it is not . Once a changeset has been validated by for_destroy/4 , it isn't validated again in the action. New changes added are validated individually, though. This allows you to create a changeset according to a given action, and then add custom changes if necessary.","ref":"Ash.Changeset.html#for_destroy/4","title":"Ash.Changeset.for_destroy/4","type":"function"},{"doc":"Constructs a changeset for a given update action, and validates it. Anything that is modified prior to for_update/4 is validated against the rules of the action, while anything after it is not . See for_create/4 for more information","ref":"Ash.Changeset.html#for_update/4","title":"Ash.Changeset.for_update/4","type":"function"},{"doc":"Changes an attribute even if it isn't writable","ref":"Ash.Changeset.html#force_change_attribute/3","title":"Ash.Changeset.force_change_attribute/3","type":"function"},{"doc":"Calls force_change_attribute/3 for each key/value pair provided","ref":"Ash.Changeset.html#force_change_attributes/2","title":"Ash.Changeset.force_change_attributes/2","type":"function"},{"doc":"Force change an attribute if it is not currently being changed See change_new_attribute/3 for more.","ref":"Ash.Changeset.html#force_change_new_attribute/3","title":"Ash.Changeset.force_change_new_attribute/3","type":"function"},{"doc":"Force change an attribute if it is not currently being changed, by calling the provided function See change_new_attribute_lazy/3 for more.","ref":"Ash.Changeset.html#force_change_new_attribute_lazy/3","title":"Ash.Changeset.force_change_new_attribute_lazy/3","type":"function"},{"doc":"Add an argument to the changeset, which will be provided to the action Does not show a warning when used in before/after action hooks","ref":"Ash.Changeset.html#force_set_argument/3","title":"Ash.Changeset.force_set_argument/3","type":"function"},{"doc":"Merge a map of arguments to the arguments list Does not show a warning when used in before/after action hooks","ref":"Ash.Changeset.html#force_set_arguments/2","title":"Ash.Changeset.force_set_arguments/2","type":"function"},{"doc":"Gets the value of an argument provided to the changeset","ref":"Ash.Changeset.html#get_argument/2","title":"Ash.Changeset.get_argument/2","type":"function"},{"doc":"Gets the value of an argument provided to the changeset, falling back to Ash.Changeset.get_attribute/2 if nothing was provided","ref":"Ash.Changeset.html#get_argument_or_attribute/2","title":"Ash.Changeset.get_argument_or_attribute/2","type":"function"},{"doc":"Gets the changing value or the original value of an attribute","ref":"Ash.Changeset.html#get_attribute/2","title":"Ash.Changeset.get_attribute/2","type":"function"},{"doc":"Gets the original value for an attribute","ref":"Ash.Changeset.html#get_data/2","title":"Ash.Changeset.get_data/2","type":"function"},{"doc":"Sets a custom error handler on the changeset. The error handler should be a two argument function or an mfa, in which case the first two arguments will be set to the changeset and the error, w/ the supplied arguments following those. Any errors generated are passed to handle_errors , which can return any of the following: :ignore - the error is discarded, and the changeset is not marked as invalid changeset - a new (or the same) changeset. The error is not added (you'll want to add an error yourself), but the changeset is marked as invalid. {changeset, error} - a new (or the same) error and changeset. The error is added to the changeset, and the changeset is marked as invalid. anything_else - is treated as a new, transformed version of the error. The result is added as an error to the changeset, and the changeset is marked as invalid.","ref":"Ash.Changeset.html#handle_errors/2","title":"Ash.Changeset.handle_errors/2","type":"function"},{"doc":"Manages the related records by creating, updating, or destroying them as necessary. Keep in mind that the default values for all on_* are :ignore , meaning nothing will happen unless you provide instructions. The input provided to manage_relationship should be a map, in the case of to_one relationships, or a list of maps in the case of to_many relationships. The following steps are followed for each input provided: The input is checked against the currently related records to find any matches. The primary key and unique identities are used to find matches. For any input that had a match in the current relationship, the :on_match behavior is triggered For any input that does not have a match: if there is on_lookup behavior: we try to find the record in the data layer. if the record is found, the on_lookup behavior is triggered if the record is not found, the on_no_match behavior is triggered if there is no on_lookup behavior: the on_no_match behavior is triggered finally, for any records present in the current relationship that had no match in the input , the on_missing behavior is triggered Options :type - If the type is specified, the default values of each option is modified to match that type of operation. This allows for specifying certain operations much more succinctly. The defaults that are modified are listed below :append_and_remove [ on_lookup : :relate , on_no_match : :error , on_match : :ignore , on_missing : :unrelate ] :append [ on_lookup : :relate , on_no_match : :error , on_match : :ignore , on_missing : :ignore ] :remove [ on_no_match : :error , on_match : :unrelate , on_missing : :ignore ] :direct_control [ on_lookup : :ignore , on_no_match : :create , on_match : :update , on_missing : :destroy ] :create [ on_no_match : :create , on_match : :ignore ] :authorize? ( boolean/0 ) - Authorize reads and changes to the destination records, if the primary change is being authorized as well. The default value is true . :eager_validate_with ( atom/0 ) - Validates that any referenced entities exist before the action is being performed, using the provided api for the read. The default value is false . :on_no_match ( term/0 ) - instructions for handling records where no matching record existed in the relationship * ` :ignore ` ( default ) - those inputs are ignored * ` :match ` - For &quot;has_one&quot; and &quot;belongs_to&quot; only , any input is treated as a match for an existing value . For has_many and many_to_many , this is the same as :ignore . * ` :create ` - the records are created using the destination &#39; s primary create action * ` { :create , :action_name } ` - the records are created using the specified action on the destination resource * ` { :create , :action_name , :join_table_action_name , [ :list , :of , :join_table , :params ] } ` - Same as ` { :create , :action_name } ` but takes the list of params specified out and applies them when creating the join record , with the provided join_table_action_name . * ` :error ` - an eror is returned indicating that a record would have been created * If ` on_lookup ` is set , and the data contained a primary key or identity , then the error is a ` NotFound ` error * Otherwise , an ` InvalidRelationship ` error is returned The default value is ` :ignore ` . :value_is_key ( atom/0 ) - Configures what key to use when a single value is provided. This is useful when you use things like a list of strings i.e friend_emails to manage the relationship, instead of a list of maps. By default, we assume it is the primary key of the destination resource, unless it is a composite primary key. :identity_priority (list of atom/0 ) - The list, in priority order, of identities to use when looking up records for on_lookup , and matching records with on_match . Use :_primary_key to prioritize checking a match with the primary key. All identities, along with :_primary_key are checked regardless, this only allows ensuring that some are checked first. Defaults to the list provided by use_identities , so you typically won't need this option. :use_identities (list of atom/0 ) - A list of identities that may be used to look up and compare records. Use :_primary_key to include the primary key. By default, only [:_primary_key] is used, unless you have config :ash, :use_all_identities_in_manage_relationship?: true (an old configuration that you should not set to true ). :on_lookup ( term/0 ) - Before creating a record(because no match was found in the relationship), the record can be looked up and related. * ` :ignore ` ( default ) - Does not look for existing entries ( matches in the current relationship are still considered updates ) * ` :relate ` - Same as calling ` { :relate , primary_action_name } ` * ` { :relate , :action_name } ` - the records are looked up by primary key / the first identity that is found ( using the primary read action ) , and related . The action should be : * many_to_many - a create action on the join resource * has_many - an update action on the destination resource * has_one - an update action on the destination resource * belongs_to - an update action on the source resource * ` { :relate , :action_name , :read_action_name } ` - Same as the above , but customizes the read action called to search for matches . * ` :relate_and_update ` - Same as ` :relate ` , but the remaining parameters from the lookup are passed into the action that is used to change the relationship key * ` { :relate_and_update , :action_name } ` - Same as the above , but customizes the action used . The action should be : * many_to_many - a create action on the join resource * has_many - an update action on the destination resource * has_one - an update action on the destination resource * belongs_to - an update action on the source resource * ` { :relate_and_update , :action_name , :read_action_name } ` - Same as the above , but customizes the read action called to search for matches . * ` { :relate_and_update , :action_name , :read_action_name , [ :list , :of , :join_table , :params ] } ` - Same as the above , but uses the provided list of parameters when creating the join row ( only relevant for many to many relationships ) . Use ` :all ` to * only * update the join record , and pass all parameters to its action The default value is ` :ignore ` . :on_match ( term/0 ) - instructions for handling records where a matching record existed in the relationship already * ` :ignore ` ( default ) - those inputs are ignored * ` :update ` - the record is updated using the destination &#39; s primary update action * ` { :update , :action_name } ` - the record is updated using the specified action on the destination resource * ` { :update , :action_name , :join_table_action_name , [ :list , :of , :params ] } ` - Same as ` { :update , :action_name } ` but takes the list of params specified out and applies them as an update to the join record ( only valid for many to many ) . * ` { :destroy , :action_name } ` - the record is destroyed using the specified action on the destination resource . The action should be : * many_to_many - a destroy action on the join record * has_many - a destroy action on the destination resource * has_one - a destroy action on the destination resource * belongs_to - a destroy action on the destination resource * ` :error ` - an eror is returned indicating that a record would have been updated * ` :no_match ` - ignores the primary key match and follows the on_no_match instructions with these records instead . * ` :unrelate ` - the related item is not destroyed , but the data is &quot;unrelated&quot; , making this behave like ` remove_from_relationship / 3 ` . The action should be : * many_to_many - the join resource row is destroyed * has_many - the destination_attribute ( on the related record ) is set to ` nil ` * has_one - the destination_attribute ( on the related record ) is set to ` nil ` * belongs_to - the source_attribute ( on this record ) is set to ` nil ` * ` { :unrelate , :action_name } ` - the record is unrelated using the provided update action . The action should be : * many_to_many - a destroy action on the join resource * has_many - an update action on the destination resource * has_one - an update action on the destination resource * belongs_to - an update action on the source resource The default value is ` :ignore ` . :on_missing ( term/0 ) - instructions for handling records that existed in the current relationship but not in the input * ` :ignore ` ( default ) - those inputs are ignored * ` :destroy ` - the record is destroyed using the destination &#39; s primary destroy action * ` { :destroy , :action_name } ` - the record is destroyed using the specified action on the destination resource * ` { :destroy , :action_name , :join_resource_action_name , [ :join , :keys ] } ` - the record is destroyed using the specified action on the destination resource , but first the join resource is destroyed with its specified action * ` :error ` - an error is returned indicating that a record would have been updated * ` :unrelate ` - the related item is not destroyed , but the data is &quot;unrelated&quot; , making this behave like ` remove_from_relationship / 3 ` . The action should be : * many_to_many - the join resource row is destroyed * has_many - the destination_attribute ( on the related record ) is set to ` nil ` * has_one - the destination_attribute ( on the related record ) is set to ` nil ` * belongs_to - the source_attribute ( on this record ) is set to ` nil ` * ` { :unrelate , :action_name } ` - the record is unrelated using the provided update action . The action should be : * many_to_many - a destroy action on the join resource * has_many - an update action on the destination resource * has_one - an update action on the destination resource * belongs_to - an update action on the source resource The default value is ` :ignore ` . :error_path ( term/0 ) - By default, errors added to the changeset will use the path [:relationship_name] , or [:relationship_name, &lt;index&gt;] . If you want to modify this path, you can specify error_path , e.g if had a change on an action that takes an argument and uses that argument data to call manage_relationship , you may want any generated errors to appear under the name of that argument, so you could specify error_path: :argument_name when calling manage_relationship . :meta ( term/0 ) - Freeform data that will be retained along with the options, which can be used to track/manage the changes that are added to the relationships key. :ignore? ( term/0 ) - This tells Ash to ignore the provided inputs when actually running the action. This can be useful for building up a set of instructions that you intend to handle manually The default value is false . Each call to this function adds new records that will be handled according to their options. For example, if you tracked &quot;tags to add&quot; and &quot;tags to remove&quot; in separate fields, you could input them like so: changeset |&gt; Ash.Changeset . manage_relationship ( :tags , [ %{ name : &quot;backend&quot; } ] , on_lookup : :relate , #relate that tag if it exists in the database on_no_match : :error # error if a tag with that name doesn&#39;t exist ) |&gt; Ash.Changeset . manage_relationship ( :tags , [ %{ name : &quot;frontend&quot; } ] , on_no_match : :error , # error if a tag with that name doesn&#39;t exist in the relationship on_match : :unrelate # if a tag with that name is related, unrelate it ) When calling this multiple times with the on_missing option set, the list of records that are considered missing are checked after each set of inputs is processed. For example, if you manage the relationship once with on_missing: :unrelate , the records missing from your input will be removed, and then your next call to manage_relationship will be resolved (with those records unrelated). For this reason, it is suggested that you don't call this function multiple times with an on_missing instruction, as you may be surprised by the result. If you want the input to update existing entities, you need to ensure that the primary key (or unique identity) is provided as part of the input. See the example below: changeset |&gt; Ash.Changeset . manage_relationship ( :comments , [ %{ rating : 10 , contents : &quot;foo&quot; } ] , on_no_match : { :create , :create_action } , on_missing : :ignore ) |&gt; Ash.Changeset . manage_relationship ( :comments , [ %{ id : 10 , rating : 10 , contents : &quot;foo&quot; } ] , on_match : { :update , :update_action } , on_no_match : { :create , :create_action } ) This is a simple way to manage a relationship. If you need custom behavior, you can customize the action that is called, which allows you to add arguments/changes. However, at some point you may want to forego this function and make the changes yourself. For example: input = [ %{ id : 10 , rating : 10 , contents : &quot;foo&quot; } ] changeset |&gt; Ash.Changeset . after_action ( fn _changeset , result -&gt; # An example of updating comments based on a result of other changes for comment &lt;- input do comment = MyApi . get ( Comment , comment . id ) comment |&gt; Map . update ( :rating , 0 , &amp; ( &amp;1 * result . rating_weight ) ) |&gt; MyApi . update! ( ) end { :ok , result } end ) Using records as input Records can be supplied as the input values. If you do: if it would be looked up due to on_lookup , the record is used as-is if it would be created due to on_no_match , the record is used as-is Instead of specifying join_keys , those keys must go in __metadata__.join_keys . If join_keys is specified in the options, it is ignored. For example: post1 = changeset |&gt; Api . create! ( ) |&gt; Ash.Resource . put_metadata ( :join_keys , %{ type : &quot;a&quot; } ) post1 = changeset2 |&gt; Api . create! ( ) |&gt; Ash.Resource . put_metadata ( :join_keys , %{ type : &quot;b&quot; } ) author = Api . create! ( author_changeset ) Ash.Changeset . manage_relationship ( author , :posts , [ post1 , post2 ] , on_lookup : :relate )","ref":"Ash.Changeset.html#manage_relationship/4","title":"Ash.Changeset.manage_relationship/4","type":"function"},{"doc":"","ref":"Ash.Changeset.html#manage_relationship_opts/1","title":"Ash.Changeset.manage_relationship_opts/1","type":"function"},{"doc":"Returns a new changeset over a resource. Prefer for_action or for_create , etc. over this function if possible. Warning: You almost always want to use for_action/4 (or for_create , etc...) You can use this to start a changeset and make a few changes prior to calling for_action . For example: Resource |&gt; Ash.Changeset . new ( ) |&gt; Ash.Changeset . change_attribute ( :name , &quot;foobar&quot; ) |&gt; Ash.Changeset . for_action ( ... )","ref":"Ash.Changeset.html#new/2","title":"Ash.Changeset.new/2","type":"function"},{"doc":"Puts a key/value in the changeset context that can be used later Do not use the private key in your custom context, as that is reserved for internal use.","ref":"Ash.Changeset.html#put_context/3","title":"Ash.Changeset.put_context/3","type":"function"},{"doc":"Removes a record or a list of records to a relationship. Alias for: manage_relationship ( changeset , relationship , record_or_records , on_no_match : :error , # If a record is not found in the relationship, we error on_match : :unrelate , # If a record is found in the relationship we unrelate it on_missing : :ignore , # If a record is not found in the relationship authorize? : false )","ref":"Ash.Changeset.html#remove_from_relationship/4","title":"Ash.Changeset.remove_from_relationship/4","type":"function"},{"doc":"Alias for: manage_relationship ( changeset , relationship , record_or_records , on_lookup : :relate , # If a record is not found in the relationship, but is found in the database, relate it and apply the input as an update on_no_match : :error , # If a record is not found in the relationship or the database, we error on_match : :ignore , # If a record is found in the relationship we make no changes to it on_missing : :unrelate , # If a record is not found in the relationship, we unrelate it authorize? : false )","ref":"Ash.Changeset.html#replace_relationship/4","title":"Ash.Changeset.replace_relationship/4","type":"function"},{"doc":"Ensure that only the specified attributes are present in the results. The first call to select/2 will replace the default behavior of selecting all attributes. Subsequent calls to select/2 will combine the provided fields unless the replace? option is provided with a value of true . If a field has been deselected, selecting it again will override that (because a single list of fields is tracked for selection) Primary key attributes always selected and cannot be deselected. When attempting to load a relationship (or manage it with Ash.Changeset.manage_relationship/3 ), if the source field is not selected on the query/provided data an error will be produced. If loading a relationship with a query, an error is produced if the query does not select the destination field of the relationship. Datalayers currently are not notified of the select for a changeset(unlike queries), and creates/updates select all fields when they are performed. A select provided on a changeset sets the unselected fields to nil before returning the result. Use ensure_selected/2 if you wish to make sure a field has been selected, without deselecting any other fields.","ref":"Ash.Changeset.html#select/3","title":"Ash.Changeset.select/3","type":"function"},{"doc":"","ref":"Ash.Changeset.html#selecting?/2","title":"Ash.Changeset.selecting?/2","type":"function"},{"doc":"Add an argument to the changeset, which will be provided to the action","ref":"Ash.Changeset.html#set_argument/3","title":"Ash.Changeset.set_argument/3","type":"function"},{"doc":"Merge a map of arguments to the arguments list","ref":"Ash.Changeset.html#set_arguments/2","title":"Ash.Changeset.set_arguments/2","type":"function"},{"doc":"Deep merges the provided map into the changeset context that can be used later Do not use the private key in your custom context, as that is reserved for internal use.","ref":"Ash.Changeset.html#set_context/2","title":"Ash.Changeset.set_context/2","type":"function"},{"doc":"","ref":"Ash.Changeset.html#set_on_upsert/2","title":"Ash.Changeset.set_on_upsert/2","type":"function"},{"doc":"Set the result of the action. This will prevent running the underlying datalayer behavior","ref":"Ash.Changeset.html#set_result/2","title":"Ash.Changeset.set_result/2","type":"function"},{"doc":"","ref":"Ash.Changeset.html#set_tenant/2","title":"Ash.Changeset.set_tenant/2","type":"function"},{"doc":"","ref":"Ash.Changeset.html#timeout/3","title":"Ash.Changeset.timeout/3","type":"function"},{"doc":"Wraps a function in the before/after action hooks of a changeset. The function takes a changeset and if it returns {:ok, result} , the result will be passed through the after action hooks.","ref":"Ash.Changeset.html#with_hooks/3","title":"Ash.Changeset.with_hooks/3","type":"function"},{"doc":"","ref":"Ash.Changeset.html#t:around_callback/0","title":"Ash.Changeset.around_callback/0","type":"type"},{"doc":"","ref":"Ash.Changeset.html#t:around_result/0","title":"Ash.Changeset.around_result/0","type":"type"},{"doc":"","ref":"Ash.Changeset.html#t:manage_relationship_type/0","title":"Ash.Changeset.manage_relationship_type/0","type":"type"},{"doc":"","ref":"Ash.Changeset.html#t:t/0","title":"Ash.Changeset.t/0","type":"type"},{"doc":"The behaviour for an action-specific resource change. init/1 is defined automatically by use Ash.Resource.Change , but can be implemented if you want to validate/transform any options passed to the module. The main function is change/3 . It takes the changeset, any options that were provided when this change was configured on a resource, and the context, which currently only has the actor.","ref":"Ash.Resource.Change.html","title":"Ash.Resource.Change","type":"behaviour"},{"doc":"","ref":"Ash.Resource.Change.html#c:change/3","title":"Ash.Resource.Change.change/3","type":"callback"},{"doc":"","ref":"Ash.Resource.Change.html#c:init/1","title":"Ash.Resource.Change.init/1","type":"callback"},{"doc":"","ref":"Ash.Resource.Change.html#t:context/0","title":"Ash.Resource.Change.context/0","type":"type"},{"doc":"","ref":"Ash.Resource.Change.html#t:ref/0","title":"Ash.Resource.Change.ref/0","type":"type"},{"doc":"","ref":"Ash.Resource.Change.html#t:t/0","title":"Ash.Resource.Change.t/0","type":"type"},{"doc":"Built in changes that are available to all resources The functions in this module are imported by default in the actions section.","ref":"Ash.Resource.Change.Builtins.html","title":"Ash.Resource.Change.Builtins","type":"module"},{"doc":"Passes the provided value into Ash.Changeset.ensure_selected/2 If the value is not already selected, this makes sure it is. Does not deselect anything else. Example change ensure_selected([:necessary_field])","ref":"Ash.Resource.Change.Builtins.html#ensure_selected/1","title":"Ash.Resource.Change.Builtins.ensure_selected/1","type":"function"},{"doc":"Passes the provided value into changeset.api.load() , after the action has completed. Example change load ( :comments ) change load ( [ :friend_count , :friends ] )","ref":"Ash.Resource.Change.Builtins.html#load/1","title":"Ash.Resource.Change.Builtins.load/1","type":"function"},{"doc":"Calls Ash.Changeset.manage_relationship/4 with the changeset and relationship provided, using the value provided for the named argument. If relationship_name is not specified, it is assumed to be the same as the argument. For information on the available options, see Ash.Changeset.manage_relationship/4 . Examples change manage_relationship ( :comments , type : :append ) change manage_relationship ( :remove_comments , :comments , type : :remove )","ref":"Ash.Resource.Change.Builtins.html#manage_relationship/3","title":"Ash.Resource.Change.Builtins.manage_relationship/3","type":"function"},{"doc":"Clears a change off of the changeset before the action runs. Does not fail if it is being changed, but ensures it is cleared just before the action. Can be useful if a change is only used in validations but shouldn't ultimately be written to the data layer. Examples change prevent_change ( :email )","ref":"Ash.Resource.Change.Builtins.html#prevent_change/1","title":"Ash.Resource.Change.Builtins.prevent_change/1","type":"function"},{"doc":"","ref":"Ash.Resource.Change.Builtins.html#relate_actor/2","title":"Ash.Resource.Change.Builtins.relate_actor/2","type":"function"},{"doc":"Relates the actor to the data being changed, as the provided relationship. Options :relationship ( atom/0 ) - Required. The relationship to set the actor to. :allow_nil? ( boolean/0 ) - Whether or not to allow the actor to be nil, in which case nothing will happen. The default value is false . Examples change relate_actor ( :owner , allow_nil? : true )","ref":"Ash.Resource.Change.Builtins.html#relate_actor_opts/0","title":"Ash.Resource.Change.Builtins.relate_actor_opts/0","type":"function"},{"doc":"Passes the provided value into Ash.Changeset.select/3 Keep in mind, this will limit the fields that are selected. You may want ensure_selected/1 if you want to make sure that something is selected, without deselecting anything else. Selecting in changesets does not actually do a select in the data layer. It nils out any fields that were not selected after completing the action. This can be useful if you are writing policies that have to do with specific fields being selected. Example change select ( [ :name ] )","ref":"Ash.Resource.Change.Builtins.html#select/1","title":"Ash.Resource.Change.Builtins.select/1","type":"function"},{"doc":"Sets the attribute to the value provided. If a zero argument function is provided, it is called to determine the value. Use arg(:argument_name) to use the value of the given argument. If the argument is not supplied then nothing happens. Examples change set_attribute ( :active , false ) change set_attribute ( :opened_at , &amp; DateTime . utc_now / 0 ) change set_attribute ( :status , arg ( :status ) )","ref":"Ash.Resource.Change.Builtins.html#set_attribute/2","title":"Ash.Resource.Change.Builtins.set_attribute/2","type":"function"},{"doc":"Merges the given query context. If an MFA is provided, it will be called with the changeset. The MFA should return {:ok, context_to_be_merged} or {:error, term} Examples change set_context ( %{ something_used_internally : true } ) change set_context ( { MyApp.Context , :set_context , [ ] } )","ref":"Ash.Resource.Change.Builtins.html#set_context/1","title":"Ash.Resource.Change.Builtins.set_context/1","type":"function"},{"doc":"Sets the attribute to the value provided if the attribute is not already being changed. If a zero argument function is provided, it is called to determine the value. Use arg(:argument_name) to use the value of the given argument. If the argument is not supplied then nothing happens. Examples change set_new_attribute ( :active , false ) change set_new_attribute ( :opened_at , &amp; DateTime . utc_now / 0 ) change set_new_attribute ( :status , arg ( :status ) )","ref":"Ash.Resource.Change.Builtins.html#set_new_attribute/2","title":"Ash.Resource.Change.Builtins.set_new_attribute/2","type":"function"},{"doc":"Represents a validation in Ash. See Ash.Resource.Validation.Builtins for a list of builtin validations. To write your own validation, define a module that implements the init/1 callback to validate options at compile time, and validate/2 callback to do the validation. Then, in a resource, you can say: validations do validate { MyValidation , [ foo : :bar ] } end","ref":"Ash.Resource.Validation.html","title":"Ash.Resource.Validation","type":"behaviour"},{"doc":"","ref":"Ash.Resource.Validation.html#action_schema/0","title":"Ash.Resource.Validation.action_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Validation.html#c:init/1","title":"Ash.Resource.Validation.init/1","type":"callback"},{"doc":"","ref":"Ash.Resource.Validation.html#on/1","title":"Ash.Resource.Validation.on/1","type":"function"},{"doc":"","ref":"Ash.Resource.Validation.html#opt_schema/0","title":"Ash.Resource.Validation.opt_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Validation.html#c:validate/2","title":"Ash.Resource.Validation.validate/2","type":"callback"},{"doc":"","ref":"Ash.Resource.Validation.html#t:path/0","title":"Ash.Resource.Validation.path/0","type":"type"},{"doc":"","ref":"Ash.Resource.Validation.html#t:ref/0","title":"Ash.Resource.Validation.ref/0","type":"type"},{"doc":"","ref":"Ash.Resource.Validation.html#t:t/0","title":"Ash.Resource.Validation.t/0","type":"type"},{"doc":"Built in validations that are available to all resources The functions in this module are imported by default in the validations section.","ref":"Ash.Resource.Validation.Builtins.html","title":"Ash.Resource.Validation.Builtins","type":"module"},{"doc":"Validates the absence of a list of attributes or arguments. If no options are provided, validates that they are all absent. This works by changing your options and providing them to the present validation. Options :at_least ( non_neg_integer/0 ) - At least this many must be absent. Defaults to the number of attributes provided :at_most ( non_neg_integer/0 ) - At most this many must be absent. Defaults to the number of attributes provided :exactly ( non_neg_integer/0 ) - Exactly this many must be absent","ref":"Ash.Resource.Validation.Builtins.html#absent/2","title":"Ash.Resource.Validation.Builtins.absent/2","type":"function"},{"doc":"Validates that the action is a specific action. Primarily meant for use in where . Examples validate present ( :foo ) , where : [ action_is ( :bar ) ]","ref":"Ash.Resource.Validation.Builtins.html#action_is/1","title":"Ash.Resource.Validation.Builtins.action_is/1","type":"function"},{"doc":"Validates that an attribute is not being changed to a specific value, or does not equal the given value if it is not being changed. Examples validate attribute_does_not_equal ( :admin , true ) # Or to only check for changing to a given value validate attribute_does_not_equal ( :admin , true ) , where : [ changing ( :admin ) ]","ref":"Ash.Resource.Validation.Builtins.html#attribute_does_not_equal/2","title":"Ash.Resource.Validation.Builtins.attribute_does_not_equal/2","type":"function"},{"doc":"Validates that an attribute is being changed to a specific value, or equals the given value if it is not being changed. Examples validate attribute_equals ( :admin , true ) # Or to only check for changing to a given value validate attribute_equals ( :admin , true ) , where : [ changing ( :admin ) ]","ref":"Ash.Resource.Validation.Builtins.html#attribute_equals/2","title":"Ash.Resource.Validation.Builtins.attribute_equals/2","type":"function"},{"doc":"Validates that an attribute or relationship is being changed Examples validate changing ( :first_name ) validate changing ( :comments )","ref":"Ash.Resource.Validation.Builtins.html#changing/1","title":"Ash.Resource.Validation.Builtins.changing/1","type":"function"},{"doc":"Validates that an attribute or argument meets the given comparison criteria. The values provided for each option may be a literal value, attribute, argument, or a zero argument function. Options :greater_than - The value that the attribute should be greater than. :greater_than_or_equal_to - The value that the attribute should be greater than or equal to :less_than - The value that the attribute should be less than :less_than_or_equal_to - The value that the attribute should be less than or equal to Examples validate compare ( :age , greater_than_or_equal_to : 18 ) , where : [ attribute_equals ( :show_adult_content , true ) ] , message : &quot;Must be over %{greater_than_or_equal_to} to enable adult content.&quot; validate compare ( :points , greater_than : 0 , less_than_or_equal_to : 100 )","ref":"Ash.Resource.Validation.Builtins.html#compare/2","title":"Ash.Resource.Validation.Builtins.compare/2","type":"function"},{"doc":"Validates that a field or argument matches another field or argument Examples validate confirm ( :password , :password_confirmation ) validate confirm ( :email , :email_confirmation )","ref":"Ash.Resource.Validation.Builtins.html#confirm/2","title":"Ash.Resource.Validation.Builtins.confirm/2","type":"function"},{"doc":"Validates that an attribute's value matches a given regex. String.match?/2 is used to determine if the value matches. Examples validate match(:slug, ~r/^[0-9a-z-_]+$/)","ref":"Ash.Resource.Validation.Builtins.html#match/2","title":"Ash.Resource.Validation.Builtins.match/2","type":"function"},{"doc":"Validates that an attribute or argument meets the given comparison criteria. The values provided for each option may be a literal value, attribute, argument, or a zero argument function. Options :greater_than - The value that the attribute should be greater than. :greater_than_or_equal_to - The value that the attribute should be greater than or equal to :less_than - The value that the attribute should be less than :less_than_or_equal_to - The value that the attribute should be less than or equal to Examples validate numericality ( :age , greater_than_or_equal_to : 18 ) , where : [ attribute_equals ( :show_adult_content , true ) ] , message : &quot;Must be over %{greater_than_or_equal_to} to enable adult content.&quot; validate numericality ( :points , greater_than : 0 , less_than_or_equal_to : 100 )","ref":"Ash.Resource.Validation.Builtins.html#numericality/2","title":"Ash.Resource.Validation.Builtins.numericality/2","type":"function"},{"doc":"Validates that an attribute's value is in a given list Examples validate one_of ( :status , [ :closed_won , :closed_lost ] )","ref":"Ash.Resource.Validation.Builtins.html#one_of/2","title":"Ash.Resource.Validation.Builtins.one_of/2","type":"function"},{"doc":"Validates the presence of a list of attributes or arguments. If no options are provided, validates that they are all present. Options :at_least ( non_neg_integer/0 ) - At least this many must be present. Defaults to the number of attributes provided :at_most ( non_neg_integer/0 ) - At most this many must be present. Defaults to the number of attributes provided :exactly ( non_neg_integer/0 ) - Exactly this many must be present","ref":"Ash.Resource.Validation.Builtins.html#present/2","title":"Ash.Resource.Validation.Builtins.present/2","type":"function"},{"doc":"Validates that an attribute on the original record meets the given length criteria Options :min ( non_neg_integer/0 ) - String must be this length at least :max ( non_neg_integer/0 ) - String must be this length at most :exact ( non_neg_integer/0 ) - String must be this length exactly Examples validate string_length ( :slug , exactly : 8 ) validate string_length ( :password , min : 6 ) validate string_length ( :secret , min : 4 , max : 12 )","ref":"Ash.Resource.Validation.Builtins.html#string_length/2","title":"Ash.Resource.Validation.Builtins.string_length/2","type":"function"},{"doc":"The interface for an ash authorizer These will typically be implemented by an extension, but a custom one can be implemented by defining an extension that also adopts this behaviour. Then you can extend a resource with authorizers: [YourAuthorizer]","ref":"Ash.Authorizer.html","title":"Ash.Authorizer","type":"behaviour"},{"doc":"","ref":"Ash.Authorizer.html#c:check/2","title":"Ash.Authorizer.check/2","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#check/3","title":"Ash.Authorizer.check/3","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:check_context/1","title":"Ash.Authorizer.check_context/1","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#check_context/2","title":"Ash.Authorizer.check_context/2","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:exception/2","title":"Ash.Authorizer.exception/2","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#exception/3","title":"Ash.Authorizer.exception/3","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:initial_state/4","title":"Ash.Authorizer.initial_state/4","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#initial_state/5","title":"Ash.Authorizer.initial_state/5","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:strict_check/2","title":"Ash.Authorizer.strict_check/2","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#strict_check/3","title":"Ash.Authorizer.strict_check/3","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:strict_check_context/1","title":"Ash.Authorizer.strict_check_context/1","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#strict_check_context/2","title":"Ash.Authorizer.strict_check_context/2","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#t:context/0","title":"Ash.Authorizer.context/0","type":"type"},{"doc":"","ref":"Ash.Authorizer.html#t:state/0","title":"Ash.Authorizer.state/0","type":"type"},{"doc":"A behaviour for declaring checks, which can be used to easily construct authorization rules. If a check can be expressed simply, i.e as a function of the actor, or the context of the request, see Ash.Policy.SimpleCheck for an easy way to write that check. If a check can be expressed with a filter statement, see Ash.Policy.FilterCheck for an easy way to write that check.","ref":"Ash.Policy.Check.html","title":"Ash.Policy.Check","type":"behaviour"},{"doc":"An optional callback, that allows the check to work with policies set to access_type :filter Return a keyword list filter that will be applied to the query being made, and will scope the results to match the rule","ref":"Ash.Policy.Check.html#c:auto_filter/3","title":"Ash.Policy.Check.auto_filter/3","type":"callback"},{"doc":"An optional callback, hat allows the check to work with policies set to access_type :runtime Takes a list of records, and returns the subset of authorized records.","ref":"Ash.Policy.Check.html#c:check/4","title":"Ash.Policy.Check.check/4","type":"callback"},{"doc":"","ref":"Ash.Policy.Check.html#defines_auto_filter?/1","title":"Ash.Policy.Check.defines_auto_filter?/1","type":"function"},{"doc":"","ref":"Ash.Policy.Check.html#defines_check?/1","title":"Ash.Policy.Check.defines_check?/1","type":"function"},{"doc":"Describe the check in human readable format, given the options","ref":"Ash.Policy.Check.html#c:describe/1","title":"Ash.Policy.Check.describe/1","type":"callback"},{"doc":"Strict checks should be cheap, and should never result in external calls (like database or api) It should return {:ok, true} if it can tell that the request is authorized, and {:ok, false} if it can tell that it is not. If unsure, it should return {:ok, :unknown}","ref":"Ash.Policy.Check.html#c:strict_check/3","title":"Ash.Policy.Check.strict_check/3","type":"callback"},{"doc":"The type of the check :manual checks must be written by hand as standard check modules :filter checks can use Ash.Policy.FilterCheck for simplicity :simple checks can use Ash.Policy.SimpleCheck for simplicity","ref":"Ash.Policy.Check.html#c:type/0","title":"Ash.Policy.Check.type/0","type":"callback"},{"doc":"","ref":"Ash.Policy.Check.html#t:authorizer/0","title":"Ash.Policy.Check.authorizer/0","type":"type"},{"doc":"","ref":"Ash.Policy.Check.html#t:check_type/0","title":"Ash.Policy.Check.check_type/0","type":"type"},{"doc":"","ref":"Ash.Policy.Check.html#t:options/0","title":"Ash.Policy.Check.options/0","type":"type"},{"doc":"","ref":"Ash.Policy.Check.html#t:ref/0","title":"Ash.Policy.Check.ref/0","type":"type"},{"doc":"","ref":"Ash.Policy.Check.html#t:t/0","title":"Ash.Policy.Check.t/0","type":"type"},{"doc":"The global authorization checks built into ash","ref":"Ash.Policy.Check.Builtins.html","title":"Ash.Policy.Check.Builtins","type":"module"},{"doc":"This check is true when the action name matches the provided action name. This is a very common pattern, allowing action-specific policies.","ref":"Ash.Policy.Check.Builtins.html#action/1","title":"Ash.Policy.Check.Builtins.action/1","type":"function"},{"doc":"This check is true when the action type matches the provided type This is useful for writing policies that apply to all actions of a given type. For example: policy action_type ( :read ) do authorize_if relates_to_actor_via ( :owner ) end","ref":"Ash.Policy.Check.Builtins.html#action_type/1","title":"Ash.Policy.Check.Builtins.action_type/1","type":"function"},{"doc":"This check is true when the value of the specified attribute of the actor equals the specified value. This check will never pass if the actor does not have the specified key. For example, actor_attribute_equals(:missing_key, nil)","ref":"Ash.Policy.Check.Builtins.html#actor_attribute_equals/2","title":"Ash.Policy.Check.Builtins.actor_attribute_equals/2","type":"function"},{"doc":"This check is true when there is an actor specified, and false when the actor is nil .","ref":"Ash.Policy.Check.Builtins.html#actor_present/0","title":"Ash.Policy.Check.Builtins.actor_present/0","type":"function"},{"doc":"This check always passes. Can be useful for &quot;deny-list&quot; style authorization. For example: policy action_type ( :read ) do forbid_if actor_attribute_equals ( :disabled , true ) forbid_if actor_attribute_equals ( :active , false ) authorize_if always ( ) end Without that last clause, the policy would never pass.","ref":"Ash.Policy.Check.Builtins.html#always/0","title":"Ash.Policy.Check.Builtins.always/0","type":"function"},{"doc":"This check is true when a field on the record matches a specific filter.","ref":"Ash.Policy.Check.Builtins.html#attribute/2","title":"Ash.Policy.Check.Builtins.attribute/2","type":"function"},{"doc":"This check is true when attribute changes correspond to the provided options. Provide a keyword list of options or just an atom representing the attribute. For example: # if you are changing both first name and last name changing_attributes ( [ :first_name , :last_name ] ) # if you are changing first name to fred changing_attributes ( first_name : [ to : &quot;fred&quot; ] ) # if you are changing last name from bob changing_attributes ( last_name : [ from : &quot;bob&quot; ] ) # if you are changing :first_name at all, last_name from &quot;bob&quot; and middle name from &quot;tom&quot; to &quot;george&quot; changing_attributes ( [ :first_name , last_name : [ from : &quot;bob&quot; ] , middle_name : [ from : &quot;tom&quot; , to : &quot; george ] ] )","ref":"Ash.Policy.Check.Builtins.html#changing_attributes/1","title":"Ash.Policy.Check.Builtins.changing_attributes/1","type":"function"},{"doc":"This check is true when the specified relationship is changing","ref":"Ash.Policy.Check.Builtins.html#changing_relationship/1","title":"Ash.Policy.Check.Builtins.changing_relationship/1","type":"function"},{"doc":"This check is true when the specified relationships are changing","ref":"Ash.Policy.Check.Builtins.html#changing_relationships/1","title":"Ash.Policy.Check.Builtins.changing_relationships/1","type":"function"},{"doc":"This check is true when the value of the specified key or path in the changeset or query context equals the specified value.","ref":"Ash.Policy.Check.Builtins.html#context_equals/2","title":"Ash.Policy.Check.Builtins.context_equals/2","type":"function"},{"doc":"This check is true when the field provided is being referenced anywhere in a filter statement. This applies to related filters as well. For example: policy actor_attribute_equals ( :is_admin , false ) do forbid_if filtering_on ( :email ) # a path can be provided as well forbid_if filtering_on ( [ :owner ] , :email ) end The first will return true in situations like: Ash.Query . filter ( User , email == &quot;blah&quot; ) Ash.Query . filter ( Tweet , author . email == &quot;blah&quot; ) The second will return true on queries like: Ash.Query . filter ( Post , owner . email == &quot;blah&quot; ) Ash.Query . filter ( Comment , post . owner . email == &quot;blah&quot; )","ref":"Ash.Policy.Check.Builtins.html#filtering_on/2","title":"Ash.Policy.Check.Builtins.filtering_on/2","type":"function"},{"doc":"This check is true when the field or relationship, or path to field, is being loaded and false when it is not. This is always false for create / update / destroy actions, because you cannot load fields on those action types.","ref":"Ash.Policy.Check.Builtins.html#loading/1","title":"Ash.Policy.Check.Builtins.loading/1","type":"function"},{"doc":"This check never passes. There is, generally speaking, no reason to use this, but it exists for completeness sake.","ref":"Ash.Policy.Check.Builtins.html#never/0","title":"Ash.Policy.Check.Builtins.never/0","type":"function"},{"doc":"This check passes if the data relates to the actor via the specified relationship or path of relationships. For update &amp; destroy actions, this check will apply to the original data before the changes are applied. For create actions this check is very unlikely to pass. This is because relationships are modified after authorization happens, not before.","ref":"Ash.Policy.Check.Builtins.html#relates_to_actor_via/1","title":"Ash.Policy.Check.Builtins.relates_to_actor_via/1","type":"function"},{"doc":"This check is true when the specified relationship is being changed to the current actor. This only supports belongs_to relationships at the moment, and will detect two cases: the source_attribute is being changed directly the relationship is being changed with on_lookup?: :relate , and a single input is being provided.","ref":"Ash.Policy.Check.Builtins.html#relating_to_actor/1","title":"Ash.Policy.Check.Builtins.relating_to_actor/1","type":"function"},{"doc":"This check is true when the field is being selected and false when it is not. This won't affect filters placed on this resource, so you may also want to either: Mark the given field as filterable? false Add another check for filtering_on(:field) For example: policy action_type ( :read ) do # The actor can read and filter on their own email authorize_if expr ( id == ^ actor ( :id ) ) # No one else can select or filter on their email forbid_if selecting ( :email ) forbid_if filtering_on ( :email ) # Otherwise, the policy passes authorize_if always ( ) end","ref":"Ash.Policy.Check.Builtins.html#selecting/1","title":"Ash.Policy.Check.Builtins.selecting/1","type":"function"},{"doc":"A type of check that is represented by a filter statement That filter statement can be templated, currently only supporting {:_actor, field} which will replace that portion of the filter with the appropriate field value from the actor and {:_actor, :_primary_key} which will replace the value with a keyword list of the primary key fields of an actor to their values, like [id: 1] . If the actor is not present {:_actor, field} becomes nil , and {:_actor, :_primary_key} becomes false . You can customize what the &quot;negative&quot; filter looks like by defining reject/1 . This is important for filters over related data. For example, given an owner relationship and a data layer like ash_postgres where column != NULL does not evaluate to true (see postgres docs on NULL for more): # The opposite of ` owner . id == 1 ` # in most cases is not ` not ( owner . id == 1 ) ` # because in postgres that would be `NOT (owner.id = NULL)` in cases where there was no owner # A better opposite would be ` owner . id != 1 or is_nil ( owner . id ) ` # alternatively ` not ( owner . id == 1 ) or is_nil ( owner . id ) ` By being able to customize the reject filter, you can use related filters in your policies. Without it, they will likely have undesired effects.","ref":"Ash.Policy.FilterCheck.html","title":"Ash.Policy.FilterCheck","type":"behaviour"},{"doc":"","ref":"Ash.Policy.FilterCheck.html#c:filter/1","title":"Ash.Policy.FilterCheck.filter/1","type":"callback"},{"doc":"","ref":"Ash.Policy.FilterCheck.html#is_filter_check?/1","title":"Ash.Policy.FilterCheck.is_filter_check?/1","type":"function"},{"doc":"","ref":"Ash.Policy.FilterCheck.html#c:reject/1","title":"Ash.Policy.FilterCheck.reject/1","type":"callback"},{"doc":"","ref":"Ash.Policy.FilterCheck.html#t:options/0","title":"Ash.Policy.FilterCheck.options/0","type":"type"},{"doc":"A type of check that is represented by a filter statement, and has access to the context.","ref":"Ash.Policy.FilterCheckWithContext.html","title":"Ash.Policy.FilterCheckWithContext","type":"behaviour"},{"doc":"","ref":"Ash.Policy.FilterCheckWithContext.html#c:filter/3","title":"Ash.Policy.FilterCheckWithContext.filter/3","type":"callback"},{"doc":"","ref":"Ash.Policy.FilterCheckWithContext.html#is_filter_check?/1","title":"Ash.Policy.FilterCheckWithContext.is_filter_check?/1","type":"function"},{"doc":"","ref":"Ash.Policy.FilterCheckWithContext.html#c:reject/3","title":"Ash.Policy.FilterCheckWithContext.reject/3","type":"callback"},{"doc":"","ref":"Ash.Policy.FilterCheckWithContext.html#t:context/0","title":"Ash.Policy.FilterCheckWithContext.context/0","type":"type"},{"doc":"","ref":"Ash.Policy.FilterCheckWithContext.html#t:options/0","title":"Ash.Policy.FilterCheckWithContext.options/0","type":"type"},{"doc":"A type of check that operates only on request context, never on the data Define match?/3 , which gets the actor, request context, and opts, and returns true or false","ref":"Ash.Policy.SimpleCheck.html","title":"Ash.Policy.SimpleCheck","type":"behaviour"},{"doc":"Whether or not the request matches the check","ref":"Ash.Policy.SimpleCheck.html#c:match?/3","title":"Ash.Policy.SimpleCheck.match?/3","type":"callback"},{"doc":"","ref":"Ash.Policy.SimpleCheck.html#t:context/0","title":"Ash.Policy.SimpleCheck.context/0","type":"type"},{"doc":"","ref":"Ash.Policy.SimpleCheck.html#t:options/0","title":"Ash.Policy.SimpleCheck.options/0","type":"type"},{"doc":"Introspection tools for Ash.Api","ref":"Ash.Api.Info.html","title":"Ash.Api.Info","type":"module"},{"doc":"The allow MFA for an api","ref":"Ash.Api.Info.html#allow/1","title":"Ash.Api.Info.allow/1","type":"function"},{"doc":"Whether or not the api allows unregistered resources to be used with it","ref":"Ash.Api.Info.html#allow_unregistered?/1","title":"Ash.Api.Info.allow_unregistered?/1","type":"function"},{"doc":"When authorization should happen for a given api","ref":"Ash.Api.Info.html#authorize/1","title":"Ash.Api.Info.authorize/1","type":"function"},{"doc":"Gets the resources of an Api module. Can be used at compile time. Liberal use of this can greatly increase compile times, or even cause compiler deadlocks. Use with care.","ref":"Ash.Api.Info.html#depend_on_resources/1","title":"Ash.Api.Info.depend_on_resources/1","type":"macro"},{"doc":"The description of the api","ref":"Ash.Api.Info.html#description/1","title":"Ash.Api.Info.description/1","type":"function"},{"doc":"","ref":"Ash.Api.Info.html#find_manage_relationships_with_identity_not_configured/1","title":"Ash.Api.Info.find_manage_relationships_with_identity_not_configured/1","type":"function"},{"doc":"The resource registry for an api","ref":"Ash.Api.Info.html#registry/1","title":"Ash.Api.Info.registry/1","type":"function"},{"doc":"Whether or not the actor is always required for an api","ref":"Ash.Api.Info.html#require_actor?/1","title":"Ash.Api.Info.require_actor?/1","type":"function"},{"doc":"Returns {:ok, resource} if the resource can be used by the api, or {:error, error} .","ref":"Ash.Api.Info.html#resource/2","title":"Ash.Api.Info.resource/2","type":"function"},{"doc":"Gets the resources of an Api module. DO NOT USE AT COMPILE TIME. If you need the resource list at compile time, use depend_on_resources/1","ref":"Ash.Api.Info.html#resources/1","title":"Ash.Api.Info.resources/1","type":"function"},{"doc":"The short name for an api","ref":"Ash.Api.Info.html#short_name/1","title":"Ash.Api.Info.short_name/1","type":"function"},{"doc":"The span_name for an api and resource combination","ref":"Ash.Api.Info.html#span_name/3","title":"Ash.Api.Info.span_name/3","type":"function"},{"doc":"Names a telemetry event for a given api/resource combo","ref":"Ash.Api.Info.html#telemetry_event_name/2","title":"Ash.Api.Info.telemetry_event_name/2","type":"function"},{"doc":"The execution timeout for an api","ref":"Ash.Api.Info.html#timeout/1","title":"Ash.Api.Info.timeout/1","type":"function"},{"doc":"The trace name for an api","ref":"Ash.Api.Info.html#trace_name/1","title":"Ash.Api.Info.trace_name/1","type":"function"},{"doc":"Introspection helpers for the Ets data layer","ref":"Ash.DataLayer.Ets.Info.html","title":"Ash.DataLayer.Ets.Info","type":"module"},{"doc":"Whether or not the ets table for the resource should be private","ref":"Ash.DataLayer.Ets.Info.html#private?/1","title":"Ash.DataLayer.Ets.Info.private?/1","type":"function"},{"doc":"The ets table name for a resource","ref":"Ash.DataLayer.Ets.Info.html#table/1","title":"Ash.DataLayer.Ets.Info.table/1","type":"function"},{"doc":"Introspection helpers for Ash.DataLayer.Mnesia","ref":"Ash.DataLayer.Mnesia.Info.html","title":"Ash.DataLayer.Mnesia.Info","type":"module"},{"doc":"The mnesia table for a resource","ref":"Ash.DataLayer.Mnesia.Info.html#table/1","title":"Ash.DataLayer.Mnesia.Info.table/1","type":"function"},{"doc":"Flow introspection functions.","ref":"Ash.Flow.Info.html","title":"Ash.Flow.Info","type":"module"},{"doc":"","ref":"Ash.Flow.Info.html#api/1","title":"Ash.Flow.Info.api/1","type":"function"},{"doc":"","ref":"Ash.Flow.Info.html#arguments/1","title":"Ash.Flow.Info.arguments/1","type":"function"},{"doc":"","ref":"Ash.Flow.Info.html#description/1","title":"Ash.Flow.Info.description/1","type":"function"},{"doc":"","ref":"Ash.Flow.Info.html#returns/1","title":"Ash.Flow.Info.returns/1","type":"function"},{"doc":"","ref":"Ash.Flow.Info.html#short_name/1","title":"Ash.Flow.Info.short_name/1","type":"function"},{"doc":"","ref":"Ash.Flow.Info.html#steps/1","title":"Ash.Flow.Info.steps/1","type":"function"},{"doc":"","ref":"Ash.Flow.Info.html#trace_name/1","title":"Ash.Flow.Info.trace_name/1","type":"function"},{"doc":"Introspection helpers for Ash.Notifier.PubSub","ref":"Ash.Notifier.PubSub.Info.html","title":"Ash.Notifier.PubSub.Info","type":"module"},{"doc":"The broadcast type for aresource","ref":"Ash.Notifier.PubSub.Info.html#broadcast_type/1","title":"Ash.Notifier.PubSub.Info.broadcast_type/1","type":"function"},{"doc":"The pubsub module for a resource","ref":"Ash.Notifier.PubSub.Info.html#module/1","title":"Ash.Notifier.PubSub.Info.module/1","type":"function"},{"doc":"The pubsub name for a resource","ref":"Ash.Notifier.PubSub.Info.html#name/1","title":"Ash.Notifier.PubSub.Info.name/1","type":"function"},{"doc":"The topic prefix for a resource","ref":"Ash.Notifier.PubSub.Info.html#prefix/1","title":"Ash.Notifier.PubSub.Info.prefix/1","type":"function"},{"doc":"The list of publications for a resource","ref":"Ash.Notifier.PubSub.Info.html#publications/1","title":"Ash.Notifier.PubSub.Info.publications/1","type":"function"},{"doc":"An authorization extension for ash resources. For more information, see Ash.Policy.Authorizer","ref":"Ash.Policy.Info.html","title":"Ash.Policy.Info","type":"module"},{"doc":"A utility to determine if an actor is or may be authorized for a given action/query/changeset. This only runs the &quot;strict check&quot; portion of policies, meaning that it can return :maybe in some cases. If you have access_type :runtime in any of your policies, then you may get :maybe from this function. To customize what is returned in the case of :maybe you can provide the maybe_is option, i.e maybe_is: true . This makes sense when you want to a show a button, but only if the user may be able to perform the action. For read actions, an important thing to factor in here is that typically policies just end up filtering the action. This means that even if you try to read something you can't read, your read action will succeed but nothing will be returned, and this function would return true .","ref":"Ash.Policy.Info.html#can/4","title":"Ash.Policy.Info.can/4","type":"function"},{"doc":"A utility to determine if an actor is or may be authorized for a given action. A shortcut for calling can/4 but with the maybe_is option defaulting to false , so this should always return a boolean. See the documentation of can/4 for more.","ref":"Ash.Policy.Info.html#can?/4","title":"Ash.Policy.Info.can?/4","type":"function"},{"doc":"","ref":"Ash.Policy.Info.html#default_access_type/1","title":"Ash.Policy.Info.default_access_type/1","type":"function"},{"doc":"","ref":"Ash.Policy.Info.html#describe_resource/1","title":"Ash.Policy.Info.describe_resource/1","type":"function"},{"doc":"Whether or not Ash policy authorizer is configured to log policy breakdowns","ref":"Ash.Policy.Info.html#log_policy_breakdowns/0","title":"Ash.Policy.Info.log_policy_breakdowns/0","type":"function"},{"doc":"Whether or not Ash policy authorizer is configured to log successful policy breakdowns","ref":"Ash.Policy.Info.html#log_successful_policy_breakdowns/0","title":"Ash.Policy.Info.log_successful_policy_breakdowns/0","type":"function"},{"doc":"","ref":"Ash.Policy.Info.html#policies/1","title":"Ash.Policy.Info.policies/1","type":"function"},{"doc":"Whether or not Ash policy authorizer is configured to show policy breakdowns in error messages","ref":"Ash.Policy.Info.html#show_policy_breakdowns?/0","title":"Ash.Policy.Info.show_policy_breakdowns?/0","type":"function"},{"doc":"A utility to determine if a given query/changeset would pass authorization. This is still experimental.","ref":"Ash.Policy.Info.html#strict_check/3","title":"Ash.Policy.Info.strict_check/3","type":"function"},{"doc":"","ref":"Ash.Policy.Info.html#t:can_option/0","title":"Ash.Policy.Info.can_option/0","type":"type"},{"doc":"","ref":"Ash.Policy.Info.html#t:can_option?/0","title":"Ash.Policy.Info.can_option?/0","type":"type"},{"doc":"","ref":"Ash.Policy.Info.html#t:request/0","title":"Ash.Policy.Info.request/0","type":"type"},{"doc":"Introspection helpers for Ash.Registry","ref":"Ash.Registry.Info.html","title":"Ash.Registry.Info","type":"module"},{"doc":"The list of entries in the registry","ref":"Ash.Registry.Info.html#entries/1","title":"Ash.Registry.Info.entries/1","type":"function"},{"doc":"Whether or not the registry will warn if it has no entries","ref":"Ash.Registry.Info.html#warn_on_empty?/1","title":"Ash.Registry.Info.warn_on_empty?/1","type":"function"},{"doc":"Introspection for resources","ref":"Ash.Resource.Info.html","title":"Ash.Resource.Info","type":"module"},{"doc":"Returns the action with the matching name and type on the resource","ref":"Ash.Resource.Info.html#action/3","title":"Ash.Resource.Info.action/3","type":"function"},{"doc":"Returns all actions of a resource","ref":"Ash.Resource.Info.html#actions/1","title":"Ash.Resource.Info.actions/1","type":"function"},{"doc":"Get an aggregate by name","ref":"Ash.Resource.Info.html#aggregate/2","title":"Ash.Resource.Info.aggregate/2","type":"function"},{"doc":"Gets the type of an aggregate for a given resource.","ref":"Ash.Resource.Info.html#aggregate_type/2","title":"Ash.Resource.Info.aggregate_type/2","type":"function"},{"doc":"Returns all aggregates of a resource","ref":"Ash.Resource.Info.html#aggregates/1","title":"Ash.Resource.Info.aggregates/1","type":"function"},{"doc":"Get an attribute name from the resource","ref":"Ash.Resource.Info.html#attribute/2","title":"Ash.Resource.Info.attribute/2","type":"function"},{"doc":"Returns all attributes of a resource","ref":"Ash.Resource.Info.html#attributes/1","title":"Ash.Resource.Info.attributes/1","type":"function"},{"doc":"A list of authorizers to be used when accessing","ref":"Ash.Resource.Info.html#authorizers/1","title":"Ash.Resource.Info.authorizers/1","type":"function"},{"doc":"The base filter of the resource","ref":"Ash.Resource.Info.html#base_filter/1","title":"Ash.Resource.Info.base_filter/1","type":"function"},{"doc":"Get a calculation by name","ref":"Ash.Resource.Info.html#calculation/2","title":"Ash.Resource.Info.calculation/2","type":"function"},{"doc":"The list of code interface calculation definitions.","ref":"Ash.Resource.Info.html#calculation_interfaces/1","title":"Ash.Resource.Info.calculation_interfaces/1","type":"function"},{"doc":"Returns all calculations of a resource","ref":"Ash.Resource.Info.html#calculations/1","title":"Ash.Resource.Info.calculations/1","type":"function"},{"doc":"A list of all changes for the resource","ref":"Ash.Resource.Info.html#changes/1","title":"Ash.Resource.Info.changes/1","type":"function"},{"doc":"A list of all changes for the resource for a given action type","ref":"Ash.Resource.Info.html#changes/2","title":"Ash.Resource.Info.changes/2","type":"function"},{"doc":"Returns the configured default actions","ref":"Ash.Resource.Info.html#default_actions/1","title":"Ash.Resource.Info.default_actions/1","type":"function"},{"doc":"The default context of the resource","ref":"Ash.Resource.Info.html#default_context/1","title":"Ash.Resource.Info.default_context/1","type":"function"},{"doc":"The Api to define the interface for, when defining it in the resource","ref":"Ash.Resource.Info.html#define_interface_for/1","title":"Ash.Resource.Info.define_interface_for/1","type":"function"},{"doc":"The description of the resource","ref":"Ash.Resource.Info.html#description/1","title":"Ash.Resource.Info.description/1","type":"function"},{"doc":"Whether or not the resource is an embedded resource","ref":"Ash.Resource.Info.html#embedded?/1","title":"Ash.Resource.Info.embedded?/1","type":"function"},{"doc":"Get a field from a resource by name","ref":"Ash.Resource.Info.html#field/2","title":"Ash.Resource.Info.field/2","type":"function"},{"doc":"See Ash.Resource.get_metadata/2 .","ref":"Ash.Resource.Info.html#get_metadata/2","title":"Ash.Resource.Info.get_metadata/2","type":"function"},{"doc":"A list of identities for the resource","ref":"Ash.Resource.Info.html#identities/1","title":"Ash.Resource.Info.identities/1","type":"function"},{"doc":"Get an identity by name from the resource","ref":"Ash.Resource.Info.html#identity/2","title":"Ash.Resource.Info.identity/2","type":"function"},{"doc":"The list of code interface definitions.","ref":"Ash.Resource.Info.html#interfaces/1","title":"Ash.Resource.Info.interfaces/1","type":"function"},{"doc":"The multitenancy attribute for a resource","ref":"Ash.Resource.Info.html#multitenancy_attribute/1","title":"Ash.Resource.Info.multitenancy_attribute/1","type":"function"},{"doc":"The MFA to parse the tenant from the attribute","ref":"Ash.Resource.Info.html#multitenancy_global?/1","title":"Ash.Resource.Info.multitenancy_global?/1","type":"function"},{"doc":"The function to parse the tenant from the attribute","ref":"Ash.Resource.Info.html#multitenancy_parse_attribute/1","title":"Ash.Resource.Info.multitenancy_parse_attribute/1","type":"function"},{"doc":"The multitenancy strategy for a resource","ref":"Ash.Resource.Info.html#multitenancy_strategy/1","title":"Ash.Resource.Info.multitenancy_strategy/1","type":"function"},{"doc":"The template for creating the tenant name","ref":"Ash.Resource.Info.html#multitenancy_template/1","title":"Ash.Resource.Info.multitenancy_template/1","type":"function"},{"doc":"A list of notifiers to be used when accessing","ref":"Ash.Resource.Info.html#notifiers/1","title":"Ash.Resource.Info.notifiers/1","type":"function"},{"doc":"","ref":"Ash.Resource.Info.html#preparations/1","title":"Ash.Resource.Info.preparations/1","type":"function"},{"doc":"Returns the primary action of the given type","ref":"Ash.Resource.Info.html#primary_action!/2","title":"Ash.Resource.Info.primary_action!/2","type":"function"},{"doc":"Returns the primary action of a given type","ref":"Ash.Resource.Info.html#primary_action/2","title":"Ash.Resource.Info.primary_action/2","type":"function"},{"doc":"A list of field names corresponding to the primary key","ref":"Ash.Resource.Info.html#primary_key/1","title":"Ash.Resource.Info.primary_key/1","type":"function"},{"doc":"Wether or not all primary key attributes can be compared with simple_equality","ref":"Ash.Resource.Info.html#primary_key_simple_equality?/1","title":"Ash.Resource.Info.primary_key_simple_equality?/1","type":"function"},{"doc":"Get an aggregate by name","ref":"Ash.Resource.Info.html#public_aggregate/2","title":"Ash.Resource.Info.public_aggregate/2","type":"function"},{"doc":"Returns all public aggregates of a resource","ref":"Ash.Resource.Info.html#public_aggregates/1","title":"Ash.Resource.Info.public_aggregates/1","type":"function"},{"doc":"Get a public attribute name from the resource","ref":"Ash.Resource.Info.html#public_attribute/2","title":"Ash.Resource.Info.public_attribute/2","type":"function"},{"doc":"Returns all public attributes of a resource","ref":"Ash.Resource.Info.html#public_attributes/1","title":"Ash.Resource.Info.public_attributes/1","type":"function"},{"doc":"Get a public calculation by name","ref":"Ash.Resource.Info.html#public_calculation/2","title":"Ash.Resource.Info.public_calculation/2","type":"function"},{"doc":"Returns all public calculations of a resource","ref":"Ash.Resource.Info.html#public_calculations/1","title":"Ash.Resource.Info.public_calculations/1","type":"function"},{"doc":"Get a public field from a resource by name","ref":"Ash.Resource.Info.html#public_field/2","title":"Ash.Resource.Info.public_field/2","type":"function"},{"doc":"Get a public relationship by name or path","ref":"Ash.Resource.Info.html#public_relationship/2","title":"Ash.Resource.Info.public_relationship/2","type":"function"},{"doc":"Returns all public relationships of a resource","ref":"Ash.Resource.Info.html#public_relationships/1","title":"Ash.Resource.Info.public_relationships/1","type":"function"},{"doc":"See Ash.Resource.put_metadata/3 .","ref":"Ash.Resource.Info.html#put_metadata/3","title":"Ash.Resource.Info.put_metadata/3","type":"function"},{"doc":"","ref":"Ash.Resource.Info.html#related/2","title":"Ash.Resource.Info.related/2","type":"function"},{"doc":"Get a relationship by name or path","ref":"Ash.Resource.Info.html#relationship/2","title":"Ash.Resource.Info.relationship/2","type":"function"},{"doc":"Returns all relationships of a resource","ref":"Ash.Resource.Info.html#relationships/1","title":"Ash.Resource.Info.relationships/1","type":"function"},{"doc":"Whether or not a given module is a resource module","ref":"Ash.Resource.Info.html#resource?/1","title":"Ash.Resource.Info.resource?/1","type":"function"},{"doc":"Retrieves a relationship path from the resource related by path, to the provided resource.","ref":"Ash.Resource.Info.html#reverse_relationship/3","title":"Ash.Resource.Info.reverse_relationship/3","type":"function"},{"doc":"See Ash.Resource.selected?/2 .","ref":"Ash.Resource.Info.html#selected?/2","title":"Ash.Resource.Info.selected?/2","type":"function"},{"doc":"See Ash.Resource.set_metadata/2 .","ref":"Ash.Resource.Info.html#set_metadata/2","title":"Ash.Resource.Info.set_metadata/2","type":"function"},{"doc":"The short_name of the resource","ref":"Ash.Resource.Info.html#short_name/1","title":"Ash.Resource.Info.short_name/1","type":"function"},{"doc":"A list of simple notifiers (require no DSL, used to avoid compile time dependencies)","ref":"Ash.Resource.Info.html#simple_notifiers/1","title":"Ash.Resource.Info.simple_notifiers/1","type":"function"},{"doc":"Determine if a field is sortable by name","ref":"Ash.Resource.Info.html#sortable?/3","title":"Ash.Resource.Info.sortable?/3","type":"function"},{"doc":"The trace_name of the resource","ref":"Ash.Resource.Info.html#trace_name/1","title":"Ash.Resource.Info.trace_name/1","type":"function"},{"doc":"See Ash.Resource.unload/2 .","ref":"Ash.Resource.Info.html#unload/2","title":"Ash.Resource.Info.unload/2","type":"function"},{"doc":"See Ash.Resource.unload_many/2 .","ref":"Ash.Resource.Info.html#unload_many/2","title":"Ash.Resource.Info.unload_many/2","type":"function"},{"doc":"A list of all validations for the resource","ref":"Ash.Resource.Info.html#validations/1","title":"Ash.Resource.Info.validations/1","type":"function"},{"doc":"A list of all validations for the resource for a given action type","ref":"Ash.Resource.Info.html#validations/2","title":"Ash.Resource.Info.validations/2","type":"function"},{"doc":"General purpose tools for working with Ash. Currently only contains setters/getters for process context.","ref":"Ash.html","title":"Ash","type":"module"},{"doc":"Gets the current actor from the process dictionary","ref":"Ash.html#get_actor/0","title":"Ash.get_actor/0","type":"function"},{"doc":"Gets the current authorize? from the process dictionary","ref":"Ash.html#get_authorize?/0","title":"Ash.get_authorize?/0","type":"function"},{"doc":"Gets the current context from the process dictionary","ref":"Ash.html#get_context/0","title":"Ash.get_context/0","type":"function"},{"doc":"Gets all of the ash context so it can be set into a new process. Use transfer_context/1 in the new process to set the context.","ref":"Ash.html#get_context_for_transfer/1","title":"Ash.get_context_for_transfer/1","type":"function"},{"doc":"Gets the current tenant from the process dictionary","ref":"Ash.html#get_tenant/0","title":"Ash.get_tenant/0","type":"function"},{"doc":"Gets the current tracer","ref":"Ash.html#get_tracer/0","title":"Ash.get_tracer/0","type":"function"},{"doc":"Sets actor into the process dictionary that is used for all changesets and queries.","ref":"Ash.html#set_actor/1","title":"Ash.set_actor/1","type":"function"},{"doc":"Sets authorize? into the process dictionary that is used for all changesets and queries.","ref":"Ash.html#set_authorize?/1","title":"Ash.set_authorize?/1","type":"function"},{"doc":"Sets context into the process dictionary that is used for all changesets and queries.","ref":"Ash.html#set_context/1","title":"Ash.set_context/1","type":"function"},{"doc":"Sets tenant into the process dictionary that is used for all changesets and queries.","ref":"Ash.html#set_tenant/1","title":"Ash.set_tenant/1","type":"function"},{"doc":"Sets the tracer into the process dictionary that will be used to trace requests","ref":"Ash.html#set_tracer/1","title":"Ash.set_tracer/1","type":"function"},{"doc":"","ref":"Ash.html#transfer_context/2","title":"Ash.transfer_context/2","type":"function"},{"doc":"Tools for introspecting managed relationships. Extensions can use this to look at an argument that will be passed to a manage_relationship change and determine what their behavior should be. For example, AshAdmin uses these to find out what kind of nested form it should offer for each argument that manages a relationship.","ref":"Ash.Changeset.ManagedRelationshipHelpers.html","title":"Ash.Changeset.ManagedRelationshipHelpers","type":"module"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#could_create?/1","title":"Ash.Changeset.ManagedRelationshipHelpers.could_create?/1","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#could_handle_missing?/1","title":"Ash.Changeset.ManagedRelationshipHelpers.could_handle_missing?/1","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#could_lookup?/1","title":"Ash.Changeset.ManagedRelationshipHelpers.could_lookup?/1","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#could_update?/1","title":"Ash.Changeset.ManagedRelationshipHelpers.could_update?/1","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#must_load?/2","title":"Ash.Changeset.ManagedRelationshipHelpers.must_load?/2","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#on_lookup_read_action/2","title":"Ash.Changeset.ManagedRelationshipHelpers.on_lookup_read_action/2","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#on_lookup_update_action/2","title":"Ash.Changeset.ManagedRelationshipHelpers.on_lookup_update_action/2","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#on_match_destination_actions/2","title":"Ash.Changeset.ManagedRelationshipHelpers.on_match_destination_actions/2","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#on_missing_destination_actions/2","title":"Ash.Changeset.ManagedRelationshipHelpers.on_missing_destination_actions/2","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#on_no_match_destination_actions/2","title":"Ash.Changeset.ManagedRelationshipHelpers.on_no_match_destination_actions/2","type":"function"},{"doc":"","ref":"Ash.Changeset.ManagedRelationshipHelpers.html#sanitize_opts/2","title":"Ash.Changeset.ManagedRelationshipHelpers.sanitize_opts/2","type":"function"},{"doc":"Represents a case insensitive string While some data layers are aware of case insensitive string types, in order for values of this type to be used in other parts of Ash Framework, it has to be embedded in a module this allows us to implement the Comparable protocol for it. For the type implementation, see Ash.Type.CiString","ref":"Ash.CiString.html","title":"Ash.CiString","type":"module"},{"doc":"","ref":"Ash.CiString.html#compare/2","title":"Ash.CiString.compare/2","type":"function"},{"doc":"","ref":"Ash.CiString.html#new/2","title":"Ash.CiString.new/2","type":"function"},{"doc":"Creates a case insensitive string","ref":"Ash.CiString.html#sigil_i/2","title":"Ash.CiString.sigil_i/2","type":"function"},{"doc":"Returns the downcased value, only downcasing if it hasn't already been done","ref":"Ash.CiString.html#to_comparable_string/1","title":"Ash.CiString.to_comparable_string/1","type":"function"},{"doc":"","ref":"Ash.CiString.html#value/1","title":"Ash.CiString.value/1","type":"function"},{"doc":"","ref":"Ash.CiString.html#t:t/0","title":"Ash.CiString.t/0","type":"type"},{"doc":"The representation of a filter in Ash. Filter Templates To see the available templates, see Ash.Filter.TemplateHelpers . You can pass a filter template to build_filter_from_template/2 with an actor, and it will return the new result Additionally, you can ask if the filter template contains an actor reference via template_references_actor?/1 Writing a filter Built In Predicates is_nil == != in &lt; &gt; &lt;= &gt;= &amp;&amp; || &lt;&gt; / - * + equals (alias for == ) not_equals (alias for != ) gt (alias for &gt; ) lt (alias for &lt; ) gte (alias for &gt;= ) lte (alias for &lt;= ) eq (alias for == ) not_eq (alias for != ) less_than (alias for &lt; ) greater_than (alias for &gt; ) less_than_or_equal (alias for &lt;= ) greater_than_or_equal (alias for &gt;= ) and (alias for &amp;&amp; ) or (alias for || ) concat (alias for &lt;&gt; ) div (alias for / ) minus (alias for - ) times (alias for * ) plus (alias for + ) BooleanExpression syntax The expression syntax ultimately just builds the keyword list style filter, but with lots of conveniences that would be very annoying to do manually. Examples Ash.Query . filter ( resource , name == &quot;Zardoz&quot; ) Ash.Query . filter ( resource , first_name == &quot;Zar&quot; and last_name == &quot;Doz&quot; ) Ash.Query . filter ( resource , first_name == &quot;Zar&quot; and last_name in [ &quot;Doz&quot; , &quot;Daz&quot; ] and high_score &gt; 10 ) Ash.Query . filter ( resource , first_name == &quot;Zar&quot; or last_name == &quot;Doz&quot; or ( high_score &gt; 10 and high_score &lt; - 10 ) ) Keyword list syntax A filter is a nested keyword list (with some exceptions, like true for everything and false for nothing). The key is the &quot;predicate&quot; (or &quot;condition&quot;) and the value is the parameter. You can use and and or to create nested filters. Data layers can expose custom predicates. Eventually, you will be able to define your own custom predicates, which will be a mechanism for you to attach complex filters supported by the data layer to your queries. Important In a given keyword list, all predicates are considered to be &quot;ands&quot;. So [or: [first_name: &quot;Tom&quot;, last_name: &quot;Bombadil&quot;]] doesn't mean 'First name == &quot;tom&quot; or last_name == &quot;bombadil&quot;'. To say that, you want to provide a list of filters, like so: [or: [[first_name: &quot;Tom&quot;], [last_name: &quot;Bombadil&quot;]]] Some example filters: Ash.Query . filter ( resource , [ name : &quot;Zardoz&quot; ] ) ) Ash.Query . filter ( resource , [ first_name : &quot;Zar&quot; , last_name : &quot;Doz&quot; ] ) Ash.Query . filter ( resource , [ first_name : &quot;Zar&quot; , last_name : [ in : [ &quot;Doz&quot; , &quot;Daz&quot; ] ] , high_score : [ greater_than : 10 ] ] ) Ash.Query . filter ( resource , [ or : [ [ first_name : &quot;Zar&quot; ] , [ last_name : &quot;Doz&quot; ] , [ or : [ [ high_score : [ greater_than : 10 ] ] ] , [ high_score : [ less_than : - 10 ] ] ] ] ] ) Other formats Maps are also accepted, as are maps with string keys. Technically, a list of [{&quot;string_key&quot;, value}] would also work. If you are using a map with string keys, it is likely that you are parsing input. It is important to note that, before passing a filter supplied from an external source directly to Ash.Query.filter/2 , you should first call Ash.Filter.parse_input/2 (or Ash.Filter.parse_input/4 if your query has aggregates/calculations in it). This ensures that the filter only uses public attributes, relationships, aggregates and calculations. You may additionally wish to pass in the query context, in the case that you have calculations that use the provided context.","ref":"Ash.Filter.html","title":"Ash.Filter","type":"module"},{"doc":"","ref":"Ash.Filter.html#add_to_filter!/6","title":"Ash.Filter.add_to_filter!/6","type":"function"},{"doc":"","ref":"Ash.Filter.html#add_to_filter/6","title":"Ash.Filter.add_to_filter/6","type":"function"},{"doc":"Replace any actor value references in a template with the values from a given actor","ref":"Ash.Filter.html#build_filter_from_template/4","title":"Ash.Filter.build_filter_from_template/4","type":"function"},{"doc":"","ref":"Ash.Filter.html#builtin_functions/0","title":"Ash.Filter.builtin_functions/0","type":"function"},{"doc":"","ref":"Ash.Filter.html#builtin_operators/0","title":"Ash.Filter.builtin_operators/0","type":"function"},{"doc":"","ref":"Ash.Filter.html#builtin_predicate_operators/0","title":"Ash.Filter.builtin_predicate_operators/0","type":"function"},{"doc":"","ref":"Ash.Filter.html#builtins/0","title":"Ash.Filter.builtins/0","type":"function"},{"doc":"","ref":"Ash.Filter.html#do_hydrate_refs/2","title":"Ash.Filter.do_hydrate_refs/2","type":"function"},{"doc":"Find an expression inside of a filter that matches the provided predicate","ref":"Ash.Filter.html#find/2","title":"Ash.Filter.find/2","type":"function"},{"doc":"Can be used to find a simple equality predicate on an attribute Use this when your attribute is configured with filterable? :simple_equality , and you want to to find the value that it is being filtered on with (if any).","ref":"Ash.Filter.html#find_simple_equality_predicate/2","title":"Ash.Filter.find_simple_equality_predicate/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#find_value/2","title":"Ash.Filter.find_value/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#flat_map/2","title":"Ash.Filter.flat_map/2","type":"function"},{"doc":"Returns a filter statement that would find a single record based on the input. For example: iex&gt; get_filter ( MyApp.Post , 1 ) { :ok , %{ id : 1 } } #using primary key iex&gt; get_filter ( MyApp.Post , id : 1 ) { :ok , %{ id : 1 } } #using primary key iex&gt; get_filter ( MyApp.Post , author_id : 1 , publication_id : 2 , first_name : &quot;fred&quot; ) { :ok , %{ author_id : 1 , publication_id : 1 } } # using a unique identity iex&gt; get_filter ( MyApp.Post , first_name : &quot;fred&quot; ) :error # not enough information","ref":"Ash.Filter.html#get_filter/2","title":"Ash.Filter.get_filter/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#get_function/3","title":"Ash.Filter.get_function/3","type":"function"},{"doc":"","ref":"Ash.Filter.html#get_operator/1","title":"Ash.Filter.get_operator/1","type":"function"},{"doc":"","ref":"Ash.Filter.html#hydrate_refs/2","title":"Ash.Filter.hydrate_refs/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#list_predicates/1","title":"Ash.Filter.list_predicates/1","type":"function"},{"doc":"","ref":"Ash.Filter.html#list_refs/3","title":"Ash.Filter.list_refs/3","type":"function"},{"doc":"","ref":"Ash.Filter.html#map/2","title":"Ash.Filter.map/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#move_exprs_to_relationship_path/2","title":"Ash.Filter.move_exprs_to_relationship_path/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#move_to_relationship_path/2","title":"Ash.Filter.move_to_relationship_path/2","type":"function"},{"doc":"Parses a filter statement See parse/2 for more","ref":"Ash.Filter.html#parse!/5","title":"Ash.Filter.parse!/5","type":"function"},{"doc":"Parses a filter statement See the module documentation for more information on the supported formats for filter statements. Important If you are trying to validate a filter supplied from an external/untrusted source, be sure to use parse_input/2 instead! The only difference is that it only accepts filters over public attributes/relationships. Aggregates and calculations Since custom aggregates/calculations can be added to a query, and they must be explicitly loaded into a query, the filter parser does not parse them by default. If you wish to support parsing filters over aggregates/calculations, provide them as the third argument. The best way to do this is to build a query with them added/loaded, and then use the aggregates and calculations keys on the query. NOTE A change was made recently that will automatically load any aggregates/calculations that are used in a filter, but if you are using this function you still need to pass them in. Ash.Filter . parse ( MyResource , [ id : 1 ] , query . aggregates , query . calculations )","ref":"Ash.Filter.html#parse/5","title":"Ash.Filter.parse/5","type":"function"},{"doc":"Parses a filter statement, accepting only public attributes/relationships, raising on errors. See parse_input/2 for more","ref":"Ash.Filter.html#parse_input!/5","title":"Ash.Filter.parse_input!/5","type":"function"},{"doc":"Parses a filter statement, accepting only public attributes/relationships See parse/2 for more","ref":"Ash.Filter.html#parse_input/5","title":"Ash.Filter.parse_input/5","type":"function"},{"doc":"","ref":"Ash.Filter.html#prefix_refs/2","title":"Ash.Filter.prefix_refs/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#put_at_path/2","title":"Ash.Filter.put_at_path/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#read_requests/5","title":"Ash.Filter.read_requests/5","type":"function"},{"doc":"","ref":"Ash.Filter.html#relationship_paths/3","title":"Ash.Filter.relationship_paths/3","type":"function"},{"doc":"","ref":"Ash.Filter.html#run_other_data_layer_filters/4","title":"Ash.Filter.run_other_data_layer_filters/4","type":"function"},{"doc":"Returns true if the second argument is a strict subset (always returns the same or less data) of the first","ref":"Ash.Filter.html#strict_subset_of/2","title":"Ash.Filter.strict_subset_of/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#strict_subset_of?/2","title":"Ash.Filter.strict_subset_of?/2","type":"function"},{"doc":"Whether or not a given template contains an actor reference","ref":"Ash.Filter.html#template_references_actor?/1","title":"Ash.Filter.template_references_actor?/1","type":"function"},{"doc":"Transform an expression based filter to a simple filter, which is just a list of predicates Options: skip_invalid?:","ref":"Ash.Filter.html#to_simple_filter/2","title":"Ash.Filter.to_simple_filter/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#update_aggregates/2","title":"Ash.Filter.update_aggregates/2","type":"function"},{"doc":"","ref":"Ash.Filter.html#used_aggregates/3","title":"Ash.Filter.used_aggregates/3","type":"function"},{"doc":"","ref":"Ash.Filter.html#used_calculations/5","title":"Ash.Filter.used_calculations/5","type":"function"},{"doc":"","ref":"Ash.Filter.html#t:t/0","title":"Ash.Filter.t/0","type":"type"},{"doc":"Checks a record to see if it matches a filter statement. We can't always tell if a record matches a filter statement, and as such this function may return :unknown . Additionally, some expressions wouldn't ever make sense outside of the context of the data layer, and will always be an error. For example, if you used the trigram search features in ash_postgres . That logic would need to be handwritten in Elixir and would need to be a perfect copy of the postgres implementation. That isn't a realistic goal. This generally should not affect anyone using the standard framework features, but if you were to attempt to use this module with a data layer like ash_postgres , certain expressions will behave unpredictably.","ref":"Ash.Filter.Runtime.html","title":"Ash.Filter.Runtime","type":"module"},{"doc":"Removes any records that don't match the filter. Automatically loads if necessary. If there are any ambiguous terms in the filter (e.g things that could only be determined by data layer), it is assumed that they are not matches.","ref":"Ash.Filter.Runtime.html#filter_matches/4","title":"Ash.Filter.Runtime.filter_matches/4","type":"function"},{"doc":"","ref":"Ash.Filter.Runtime.html#load_parent_requirements/3","title":"Ash.Filter.Runtime.load_parent_requirements/3","type":"function"},{"doc":"Represents a simplified filter, with a simple list of predicates","ref":"Ash.Filter.Simple.html","title":"Ash.Filter.Simple","type":"module"},{"doc":"A negated predicate","ref":"Ash.Filter.Simple.Not.html","title":"Ash.Filter.Simple.Not","type":"module"},{"doc":"Used when an aggregate or relationship hasn't been loaded.","ref":"Ash.NotLoaded.html","title":"Ash.NotLoaded","type":"module"},{"doc":"","ref":"Ash.NotLoaded.html#t:t/0","title":"Ash.NotLoaded.t/0","type":"type"},{"doc":"Helpers for working with nimble options","ref":"Ash.OptionsHelpers.html","title":"Ash.OptionsHelpers","type":"module"},{"doc":"","ref":"Ash.OptionsHelpers.html#ash_resource/0","title":"Ash.OptionsHelpers.ash_resource/0","type":"function"},{"doc":"","ref":"Ash.OptionsHelpers.html#ash_type/0","title":"Ash.OptionsHelpers.ash_type/0","type":"function"},{"doc":"","ref":"Ash.OptionsHelpers.html#hide_all_except/2","title":"Ash.OptionsHelpers.hide_all_except/2","type":"function"},{"doc":"Types for Ash pages","ref":"Ash.Page.html","title":"Ash.Page","type":"module"},{"doc":"","ref":"Ash.Page.html#t:page/0","title":"Ash.Page.page/0","type":"type"},{"doc":"","ref":"Ash.Page.html#t:type/0","title":"Ash.Page.type/0","type":"type"},{"doc":"A page of results from keyset based pagination. The results are generated with a keyset metadata, which can be used to fetch the next/previous pages.","ref":"Ash.Page.Keyset.html","title":"Ash.Page.Keyset","type":"module"},{"doc":"","ref":"Ash.Page.Keyset.html#data_with_keyset/3","title":"Ash.Page.Keyset.data_with_keyset/3","type":"function"},{"doc":"","ref":"Ash.Page.Keyset.html#filter/4","title":"Ash.Page.Keyset.filter/4","type":"function"},{"doc":"","ref":"Ash.Page.Keyset.html#new/6","title":"Ash.Page.Keyset.new/6","type":"function"},{"doc":"A restricted version of :erlang.binary_to_term/2 that forbids executable terms, such as anonymous functions. The opts are given to the underlying :erlang.binary_to_term/2 call, with an empty list as a default. By default this function does not restrict atoms, as an atom interned in one node may not yet have been interned on another (except for releases, which preload all code). If you want to avoid atoms from being created, then you can pass [:safe] as options, as that will also enable the safety mechanisms from :erlang.binary_to_term/2 itself. Ripped from https://github.com/elixir-plug/plug_crypto/blob/v1.2.0/lib/plug/crypto.ex","ref":"Ash.Page.Keyset.html#non_executable_binary_to_term/2","title":"Ash.Page.Keyset.non_executable_binary_to_term/2","type":"function"},{"doc":"","ref":"Ash.Page.Keyset.html#t:t/0","title":"Ash.Page.Keyset.t/0","type":"type"},{"doc":"A page of results from offset based pagination. If a resource supports keyset pagination as well, it will also have the keyset metadata.","ref":"Ash.Page.Offset.html","title":"Ash.Page.Offset","type":"module"},{"doc":"","ref":"Ash.Page.Offset.html#new/5","title":"Ash.Page.Offset.new/5","type":"function"},{"doc":"","ref":"Ash.Page.Offset.html#t:t/0","title":"Ash.Page.Offset.t/0","type":"type"},{"doc":"Tools for transforming resources in DSL Transformers.","ref":"Ash.Resource.Builder.html","title":"Ash.Resource.Builder","type":"module"},{"doc":"Builds and adds an action","ref":"Ash.Resource.Builder.html#add_action/4","title":"Ash.Resource.Builder.add_action/4","type":"function"},{"doc":"Builds and adds an attribute to a resource","ref":"Ash.Resource.Builder.html#add_attribute/4","title":"Ash.Resource.Builder.add_attribute/4","type":"function"},{"doc":"Builds and adds a calculation to a resource","ref":"Ash.Resource.Builder.html#add_calculation/5","title":"Ash.Resource.Builder.add_calculation/5","type":"function"},{"doc":"Builds and adds a change","ref":"Ash.Resource.Builder.html#add_change/3","title":"Ash.Resource.Builder.add_change/3","type":"function"},{"doc":"Builds and adds a create_timestamp to a resource","ref":"Ash.Resource.Builder.html#add_create_timestamp/3","title":"Ash.Resource.Builder.add_create_timestamp/3","type":"function"},{"doc":"Builds and adds a new action unless an action with that name already exists","ref":"Ash.Resource.Builder.html#add_new_action/4","title":"Ash.Resource.Builder.add_new_action/4","type":"function"},{"doc":"Builds and adds an attribute unless an attribute with that name already exists","ref":"Ash.Resource.Builder.html#add_new_attribute/4","title":"Ash.Resource.Builder.add_new_attribute/4","type":"function"},{"doc":"Builds and adds a calculation unless a calculation with that name already exists","ref":"Ash.Resource.Builder.html#add_new_calculation/5","title":"Ash.Resource.Builder.add_new_calculation/5","type":"function"},{"doc":"Builds and adds a create_timestamp unless a create_timestamp with that name already exists","ref":"Ash.Resource.Builder.html#add_new_create_timestamp/3","title":"Ash.Resource.Builder.add_new_create_timestamp/3","type":"function"},{"doc":"Builds and adds an update_timestamp unless an update_timestamp with that name already exists","ref":"Ash.Resource.Builder.html#add_new_update_timestamp/3","title":"Ash.Resource.Builder.add_new_update_timestamp/3","type":"function"},{"doc":"Builds and adds a preparation","ref":"Ash.Resource.Builder.html#add_preparation/3","title":"Ash.Resource.Builder.add_preparation/3","type":"function"},{"doc":"Builds and adds an update_timestamp","ref":"Ash.Resource.Builder.html#add_update_timestamp/3","title":"Ash.Resource.Builder.add_update_timestamp/3","type":"function"},{"doc":"Builds an action","ref":"Ash.Resource.Builder.html#build_action/3","title":"Ash.Resource.Builder.build_action/3","type":"function"},{"doc":"Builds an action argument","ref":"Ash.Resource.Builder.html#build_action_argument/3","title":"Ash.Resource.Builder.build_action_argument/3","type":"function"},{"doc":"Builds an action change","ref":"Ash.Resource.Builder.html#build_action_change/2","title":"Ash.Resource.Builder.build_action_change/2","type":"function"},{"doc":"Builds an attribute with the given name, type, and options","ref":"Ash.Resource.Builder.html#build_attribute/3","title":"Ash.Resource.Builder.build_attribute/3","type":"function"},{"doc":"Builds a calculation with the given name, type, and options","ref":"Ash.Resource.Builder.html#build_calculation/4","title":"Ash.Resource.Builder.build_calculation/4","type":"function"},{"doc":"Builds a change","ref":"Ash.Resource.Builder.html#build_change/2","title":"Ash.Resource.Builder.build_change/2","type":"function"},{"doc":"Builds an create_timestamp with the given name, type, and options","ref":"Ash.Resource.Builder.html#build_create_timestamp/2","title":"Ash.Resource.Builder.build_create_timestamp/2","type":"function"},{"doc":"Builds a preparation","ref":"Ash.Resource.Builder.html#build_preparation/2","title":"Ash.Resource.Builder.build_preparation/2","type":"function"},{"doc":"Builds an update_timestamp with the given name, type, and options","ref":"Ash.Resource.Builder.html#build_update_timestamp/2","title":"Ash.Resource.Builder.build_update_timestamp/2","type":"function"},{"doc":"Utilities and types for sorting. Important Keyset pagination cannot currently be used in conjunction with aggregate and calculation sorting. Combining them will result in an error on the query.","ref":"Ash.Sort.html","title":"Ash.Sort","type":"module"},{"doc":"Same as parse_input/2 except raises any errors See parse_input/2 for more.","ref":"Ash.Sort.html#parse_input!/3","title":"Ash.Sort.parse_input!/3","type":"function"},{"doc":"A utility for parsing sorts provided from external input. Only allows sorting on public attributes and aggregates. The supported formats are: Sort Strings A comma separated list of fields to sort on, each with an optional prefix. The prefixes are: &quot;+&quot; - Same as no prefix. Sorts :asc . &quot;++&quot; - Sorts :asc_nils_first &quot;-&quot; - Sorts :desc &quot;--&quot; - Sorts :desc_nils_last For example &quot;foo,-bar,++baz,--buz&quot; A list of sort strings Same prefix rules as above, but provided as a list. For example: [ &quot;foo&quot; , &quot;-bar&quot; , &quot;++baz&quot; , &quot;--buz&quot; ] Handling specific values A handler function may be provided that takes a string, and returns the relevant sort It won't be given any prefixes, only the field. This allows for things like parsing the calculation values out of the sort, or setting calculation values if they are not included in the sort string. To return calculation parameters, return {:field, %{param: :value}} . This will end up as something like {:field, {:desc, %{param: :value}}} , with the corresponding sort order. This handler function will only be called if you pass in a string or list of strings for the sort. Atoms will be assumed to have already been handled. The handler should return nil if it is not handling the given field.","ref":"Ash.Sort.html#parse_input/3","title":"Ash.Sort.parse_input/3","type":"function"},{"doc":"","ref":"Ash.Sort.html#parse_sort/3","title":"Ash.Sort.parse_sort/3","type":"function"},{"doc":"Reverses an Ash sort statement.","ref":"Ash.Sort.html#reverse/1","title":"Ash.Sort.reverse/1","type":"function"},{"doc":"A utility for sorting a list of records at runtime. For example: Ash.Sort . runtime_sort ( [ record1 , record2 , record3 ] , name : :asc , type : :desc_nils_last ) Keep in mind that it is unrealistic to expect this runtime sort to always be exactly the same as a sort that may have been applied by your data layer. This is especially true for strings. For example, Postgres strings have a collation that affects their sorting, making it unpredictable from the perspective of a tool using the database: https://www.postgresql.org/docs/current/collation.html","ref":"Ash.Sort.html#runtime_sort/3","title":"Ash.Sort.runtime_sort/3","type":"function"},{"doc":"","ref":"Ash.Sort.html#t:sort_order/0","title":"Ash.Sort.sort_order/0","type":"type"},{"doc":"","ref":"Ash.Sort.html#t:t/0","title":"Ash.Sort.t/0","type":"type"},{"doc":"A behaviour for implementing tracing for an Ash application.","ref":"Ash.Tracer.html","title":"Ash.Tracer","type":"behaviour"},{"doc":"","ref":"Ash.Tracer.html#c:get_span_context/0","title":"Ash.Tracer.get_span_context/0","type":"callback"},{"doc":"","ref":"Ash.Tracer.html#c:set_error/1","title":"Ash.Tracer.set_error/1","type":"callback"},{"doc":"Set metadata for the current span. This may be called multiple times per span, and should ideally merge with previous metadata.","ref":"Ash.Tracer.html#c:set_metadata/2","title":"Ash.Tracer.set_metadata/2","type":"callback"},{"doc":"","ref":"Ash.Tracer.html#set_metadata/3","title":"Ash.Tracer.set_metadata/3","type":"function"},{"doc":"","ref":"Ash.Tracer.html#c:set_span_context/1","title":"Ash.Tracer.set_span_context/1","type":"callback"},{"doc":"","ref":"Ash.Tracer.html#span/4","title":"Ash.Tracer.span/4","type":"macro"},{"doc":"","ref":"Ash.Tracer.html#c:start_span/2","title":"Ash.Tracer.start_span/2","type":"callback"},{"doc":"","ref":"Ash.Tracer.html#c:stop_span/0","title":"Ash.Tracer.stop_span/0","type":"callback"},{"doc":"","ref":"Ash.Tracer.html#telemetry_span/3","title":"Ash.Tracer.telemetry_span/3","type":"macro"},{"doc":"","ref":"Ash.Tracer.html#t:metadata/0","title":"Ash.Tracer.metadata/0","type":"type"},{"doc":"","ref":"Ash.Tracer.html#t:span_type/0","title":"Ash.Tracer.span_type/0","type":"type"},{"doc":"Helpers for working with UUIDs","ref":"Ash.UUID.html","title":"Ash.UUID","type":"module"},{"doc":"Generates a new uuid","ref":"Ash.UUID.html#generate/0","title":"Ash.UUID.generate/0","type":"function"},{"doc":"A wrapper for values that are sourced from Ash.Type.Union .","ref":"Ash.Union.html","title":"Ash.Union","type":"module"},{"doc":"","ref":"Ash.Union.html#t:t/0","title":"Ash.Union.t/0","type":"type"},{"doc":"Tools for generating input to Ash resource actions, as well as for seeds. These tools are young, and various factors are not taken into account. For example, validations and identities are not automatically considered. If you want to use this with stream data testing, you will likely want to get familiar with StreamData . Many functions in this module support overrides, which allow passing down either constant values or your own generators. For example: # All generated posts will have text as `&quot;text&quot;`. Equivalent to providing `StreamData.constant(&quot;text&quot;)`. Ash.Generator . seed_input ( Post , %{ text : &quot;text&quot; } )","ref":"Ash.Generator.html","title":"Ash.Generator","type":"module"},{"doc":"Generate input meant to be passed into a resource action. Currently input for arguments that are passed to a manage_relationship are excluded, and you will have to generate them yourself by passing your own generators/values down See the module documentation for more. This is meant to be used in property testing. If you want to generate a finite list of","ref":"Ash.Generator.html#action_input/3","title":"Ash.Generator.action_input/3","type":"function"},{"doc":"Creates the input for the provided action with action_input/3 , and creates a changeset for that action with that input. See action_input/3 and the module documentation for more.","ref":"Ash.Generator.html#changeset/4","title":"Ash.Generator.changeset/4","type":"function"},{"doc":"Generate n changesets and return them as a list.","ref":"Ash.Generator.html#many_changesets/5","title":"Ash.Generator.many_changesets/5","type":"function"},{"doc":"Generate n queries and return them as a list.","ref":"Ash.Generator.html#many_queries/5","title":"Ash.Generator.many_queries/5","type":"function"},{"doc":"Creates a generator map where the keys are required except the list provided","ref":"Ash.Generator.html#mixed_map/2","title":"Ash.Generator.mixed_map/2","type":"function"},{"doc":"Creates the input for the provided action with action_input/3 , and creates a query for that action with that input. See action_input/3 and the module documentation for more.","ref":"Ash.Generator.html#query/4","title":"Ash.Generator.query/4","type":"function"},{"doc":"Gets input using seed_input/2 and passes it to Ash.Seed.seed!/2 , returning the result","ref":"Ash.Generator.html#seed!/2","title":"Ash.Generator.seed!/2","type":"function"},{"doc":"Generate input meant to be passed into Ash.Seed.seed!/2 . A map of custom StreamData generators can be provided to add to or overwrite the generated input, for example: Ash.Generator.for_seed(Post, %{text: StreamData.constant(&quot;Post&quot;)})","ref":"Ash.Generator.html#seed_input/2","title":"Ash.Generator.seed_input/2","type":"function"},{"doc":"Generates an input n times, and passes them all to seed, returning the list of seeded items.","ref":"Ash.Generator.html#seed_many!/3","title":"Ash.Generator.seed_many!/3","type":"function"},{"doc":"Helpers for seeding data, useful for quickly creating lots of data either for database seeding or testing. Important: this bypasses resource actions, and goes straight to the data layer. No action changes or validations are run. The only thing that it does at the moment is ensure that default values for attributes are set, it does not validate that required attributes are set (although the data layer may do that for you, e.g with ash_postgres).","ref":"Ash.Seed.html","title":"Ash.Seed","type":"module"},{"doc":"Returns :__keep_nil__ , allowing to ensure a default value is not used when you want the value to be nil .","ref":"Ash.Seed.html#keep_nil/0","title":"Ash.Seed.keep_nil/0","type":"function"},{"doc":"Seed using a record (instance of a resource) as input. If the passed in struct was retrieved from the data layer already (i.e already seeded), then it is returned and nothing is done. Otherwise, the attributes and relationships are used as input to seed/2 , after having any %Ash.NotLoaded{} values stripped out. Any nil values will be overwritten with their default values. To avoid this, either use seed/2 in which providing the key will have it not set the default values. If you want to force nil to be accepted and prevent the default value from being set, use the keep_nil/0 function provided here, which returns :__keep_nil__ . Alternatively, use seed!(Post, %{text: nil}) . See seed!/2 for more information.","ref":"Ash.Seed.html#seed!/1","title":"Ash.Seed.seed!/1","type":"function"},{"doc":"Performs a direct call to the data layer of a resource with the provided input. If a list is provided as input, then you will get back that many results.","ref":"Ash.Seed.html#seed!/2","title":"Ash.Seed.seed!/2","type":"function"},{"doc":"Testing helpers for Ash.","ref":"Ash.Test.html","title":"Ash.Test","type":"module"},{"doc":"Clears the __metadata__ field and the underlying ecto __meta__ field This allows for easier comparison of changeset/query results","ref":"Ash.Test.html#strip_metadata/1","title":"Ash.Test.strip_metadata/1","type":"function"},{"doc":"A flow is a static definition of a set of steps to be . See the guide for more.","ref":"Ash.Flow.html","title":"Ash.Flow","type":"module"},{"doc":"","ref":"Ash.Flow.html#arg_refs/1","title":"Ash.Flow.arg_refs/1","type":"function"},{"doc":"","ref":"Ash.Flow.html#default_extensions/0","title":"Ash.Flow.default_extensions/0","type":"function"},{"doc":"","ref":"Ash.Flow.html#do_fetch_in/2","title":"Ash.Flow.do_fetch_in/2","type":"function"},{"doc":"","ref":"Ash.Flow.html#element_refs/1","title":"Ash.Flow.element_refs/1","type":"function"},{"doc":"","ref":"Ash.Flow.html#handle_input_template/2","title":"Ash.Flow.handle_input_template/2","type":"function"},{"doc":"","ref":"Ash.Flow.html#handle_modifiers/1","title":"Ash.Flow.handle_modifiers/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.handle_opts/1 .","ref":"Ash.Flow.html#handle_opts/1","title":"Ash.Flow.handle_opts/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.init/1 .","ref":"Ash.Flow.html#init/1","title":"Ash.Flow.init/1","type":"function"},{"doc":"","ref":"Ash.Flow.html#remap_result_references/2","title":"Ash.Flow.remap_result_references/2","type":"function"},{"doc":"","ref":"Ash.Flow.html#result_refs/1","title":"Ash.Flow.result_refs/1","type":"function"},{"doc":"","ref":"Ash.Flow.html#run!/3","title":"Ash.Flow.run!/3","type":"function"},{"doc":"","ref":"Ash.Flow.html#run/3","title":"Ash.Flow.run/3","type":"function"},{"doc":"","ref":"Ash.Flow.html#set_dependent_values/2","title":"Ash.Flow.set_dependent_values/2","type":"function"},{"doc":"","ref":"Ash.Flow.html#t:t/0","title":"Ash.Flow.t/0","type":"type"},{"doc":"Tools to render an Ash.Flow as a mermaid chart.","ref":"Ash.Flow.Chart.Mermaid.html","title":"Ash.Flow.Chart.Mermaid","type":"module"},{"doc":"","ref":"Ash.Flow.Chart.Mermaid.html#add_links/4","title":"Ash.Flow.Chart.Mermaid.add_links/4","type":"function"},{"doc":"","ref":"Ash.Flow.Chart.Mermaid.html#chart/2","title":"Ash.Flow.Chart.Mermaid.chart/2","type":"function"},{"doc":"A flow executor runs a given flow module","ref":"Ash.Flow.Executor.html","title":"Ash.Flow.Executor","type":"behaviour"},{"doc":"","ref":"Ash.Flow.Executor.html#c:build/3","title":"Ash.Flow.Executor.build/3","type":"callback"},{"doc":"","ref":"Ash.Flow.Executor.html#c:execute/3","title":"Ash.Flow.Executor.execute/3","type":"callback"},{"doc":"","ref":"Ash.Flow.Executor.html#t:built_flow/0","title":"Ash.Flow.Executor.built_flow/0","type":"type"},{"doc":"A behaviour for implementing a custom step in a flow.","ref":"Ash.Flow.Step.html","title":"Ash.Flow.Step","type":"behaviour"},{"doc":"","ref":"Ash.Flow.Step.html#c:describe/1","title":"Ash.Flow.Step.describe/1","type":"callback"},{"doc":"","ref":"Ash.Flow.Step.html#c:run/3","title":"Ash.Flow.Step.run/3","type":"callback"},{"doc":"","ref":"Ash.Flow.Step.html#c:short_name/1","title":"Ash.Flow.Step.short_name/1","type":"callback"},{"doc":"Template functions available while declaring steps.","ref":"Ash.Flow.StepHelpers.html","title":"Ash.Flow.StepHelpers","type":"module"},{"doc":"Accesses a flow argument","ref":"Ash.Flow.StepHelpers.html#arg/1","title":"Ash.Flow.StepHelpers.arg/1","type":"function"},{"doc":"Accesses the value being iterated over for a given map step. The name is required so that map steps can be nested.","ref":"Ash.Flow.StepHelpers.html#element/1","title":"Ash.Flow.StepHelpers.element/1","type":"function"},{"doc":"Constructs an expression that can access","ref":"Ash.Flow.StepHelpers.html#expr/1","title":"Ash.Flow.StepHelpers.expr/1","type":"macro"},{"doc":"Accesses a flow argument","ref":"Ash.Flow.StepHelpers.html#merge/1","title":"Ash.Flow.StepHelpers.merge/1","type":"function"},{"doc":"Accesses a path in a value lazily. Supports the value being a template, e.g path(result(:foo), [:bar, 0, :baz])","ref":"Ash.Flow.StepHelpers.html#path/2","title":"Ash.Flow.StepHelpers.path/2","type":"function"},{"doc":"Creates a range lazily. Supports the start or finish being a template, e.g range(result(:foo), result(:bar))","ref":"Ash.Flow.StepHelpers.html#range/2","title":"Ash.Flow.StepHelpers.range/2","type":"function"},{"doc":"Accesses the result of a step","ref":"Ash.Flow.StepHelpers.html#result/1","title":"Ash.Flow.StepHelpers.result/1","type":"function"},{"doc":"Describes how to convert data to Ecto.Type and eventually into the database. This behaviour is a superset of the Ecto.Type behaviour, that also contains API level information, like what kinds of filters are allowed. Built in types :map - Ash.Type.Map :term - Ash.Type.Term :atom - Ash.Type.Atom :string - Ash.Type.String :integer - Ash.Type.Integer :float - Ash.Type.Float :duration_name - Ash.Type.DurationName :function - Ash.Type.Function :boolean - Ash.Type.Boolean :struct - Ash.Type.Struct :uuid - Ash.Type.UUID :binary - Ash.Type.Binary :date - Ash.Type.Date :time - Ash.Type.Time :decimal - Ash.Type.Decimal :ci_string - Ash.Type.CiString :naive_datetime - Ash.Type.NaiveDatetime :utc_datetime - Ash.Type.UtcDatetime :utc_datetime_usec - Ash.Type.UtcDatetimeUsec :url_encoded_binary - Ash.Type.UrlEncodedBinary :union - Ash.Type.Union Composite Types Currently, the only composite type supported is a list type, specified via: {:array, Type} . The constraints available are: :items ( term/0 ) - Constraints for the elements of the list. See the contained type's docs for more. :min_length ( non_neg_integer/0 ) - A minimum length for the items :max_length ( non_neg_integer/0 ) - A maximum length for the items :nil_items? ( boolean/0 ) - Whether or not the list can contain nil items The default value is false . :empty_values (list of term/0 ) - A set of values that, if encountered, will be considered an empty list. The default value is [&quot;&quot;] . Defining Custom Types Generally you add use Ash.Type to your module (it is possible to add @behaviour Ash.Type and define everything yourself, but this is more work and error-prone). Overriding the {:array, type} behaviour. By defining the *_array versions of cast_input , cast_stored , dump_to_native and apply_constraints , you can override how your type behaves as a collection. This is how the features of embedded resources are implemented. No need to implement them unless you wish to override the default behaviour. Simple example of a float custom type defmodule GenTracker.AshFloat do use Ash.Type @impl Ash.Type def storage_type, do: :float @impl Ash.Type def cast_input(value, _) do Ecto.Type.cast(:float, value) end @impl Ash.Type def cast_stored(value, _) do Ecto.Type.load(:float, value) end @impl Ash.Type def dump_to_native(value, _) do Ecto.Type.dump(:float, value) end end All the Ash built-in types are implemented with use Ash.Type so they are good examples to look at to create your own Ash.Type . Short names You can define short :atom_names for your custom types by adding them to your Ash configuration: config :ash, :custom_types, [ash_float: GenTracker.AshFloat] Doing this will require a recompilation of the :ash dependency which can be triggered by calling: $ mix deps.compile ash --force","ref":"Ash.Type.html","title":"Ash.Type","type":"behaviour"},{"doc":"","ref":"Ash.Type.html#c:apply_constraints/2","title":"Ash.Type.apply_constraints/2","type":"callback"},{"doc":"Confirms if a casted value matches the provided constraints.","ref":"Ash.Type.html#apply_constraints/3","title":"Ash.Type.apply_constraints/3","type":"function"},{"doc":"","ref":"Ash.Type.html#c:apply_constraints_array/2","title":"Ash.Type.apply_constraints_array/2","type":"callback"},{"doc":"","ref":"Ash.Type.html#c:array_constraints/0","title":"Ash.Type.array_constraints/0","type":"callback"},{"doc":"","ref":"Ash.Type.html#array_constraints/1","title":"Ash.Type.array_constraints/1","type":"function"},{"doc":"","ref":"Ash.Type.html#ash_type_option/1","title":"Ash.Type.ash_type_option/1","type":"function"},{"doc":"Returns true if the value is a builtin type or adopts the Ash.Type behaviour","ref":"Ash.Type.html#ash_type?/1","title":"Ash.Type.ash_type?/1","type":"function"},{"doc":"","ref":"Ash.Type.html#builtin?/1","title":"Ash.Type.builtin?/1","type":"function"},{"doc":"Useful for typed data layers (like ash_postgres) to instruct them not to attempt to cast input values. You generally won't need this, but it can be an escape hatch for certain cases.","ref":"Ash.Type.html#c:cast_in_query?/1","title":"Ash.Type.cast_in_query?/1","type":"callback"},{"doc":"","ref":"Ash.Type.html#cast_in_query?/2","title":"Ash.Type.cast_in_query?/2","type":"function"},{"doc":"","ref":"Ash.Type.html#c:cast_input/2","title":"Ash.Type.cast_input/2","type":"callback"},{"doc":"Casts input (e.g. unknown) data to an instance of the type, or errors Maps to Ecto.Type.cast/2","ref":"Ash.Type.html#cast_input/3","title":"Ash.Type.cast_input/3","type":"function"},{"doc":"","ref":"Ash.Type.html#c:cast_input_array/2","title":"Ash.Type.cast_input_array/2","type":"callback"},{"doc":"","ref":"Ash.Type.html#c:cast_stored/2","title":"Ash.Type.cast_stored/2","type":"callback"},{"doc":"Casts a value from the data store to an instance of the type, or errors Maps to Ecto.Type.load/2","ref":"Ash.Type.html#cast_stored/3","title":"Ash.Type.cast_stored/3","type":"function"},{"doc":"","ref":"Ash.Type.html#c:cast_stored_array/2","title":"Ash.Type.cast_stored_array/2","type":"callback"},{"doc":"","ref":"Ash.Type.html#c:constraints/0","title":"Ash.Type.constraints/0","type":"callback"},{"doc":"","ref":"Ash.Type.html#constraints/1","title":"Ash.Type.constraints/1","type":"function"},{"doc":"","ref":"Ash.Type.html#constraints/3","title":"Ash.Type.constraints/3","type":"function"},{"doc":"","ref":"Ash.Type.html#c:describe/1","title":"Ash.Type.describe/1","type":"callback"},{"doc":"","ref":"Ash.Type.html#describe/2","title":"Ash.Type.describe/2","type":"function"},{"doc":"","ref":"Ash.Type.html#c:dump_to_embedded/2","title":"Ash.Type.dump_to_embedded/2","type":"callback"},{"doc":"Casts a value from the Elixir type to a value that can be embedded in another data structure. Embedded resources expect to be stored in JSON, so this allows things like UUIDs to be stored as strings in embedded resources instead of binary.","ref":"Ash.Type.html#dump_to_embedded/3","title":"Ash.Type.dump_to_embedded/3","type":"function"},{"doc":"","ref":"Ash.Type.html#c:dump_to_embedded_array/2","title":"Ash.Type.dump_to_embedded_array/2","type":"callback"},{"doc":"","ref":"Ash.Type.html#c:dump_to_native/2","title":"Ash.Type.dump_to_native/2","type":"callback"},{"doc":"Casts a value from the Elixir type to a value that the data store can persist Maps to Ecto.Type.dump/2","ref":"Ash.Type.html#dump_to_native/3","title":"Ash.Type.dump_to_native/3","type":"function"},{"doc":"","ref":"Ash.Type.html#c:dump_to_native_array/2","title":"Ash.Type.dump_to_native_array/2","type":"callback"},{"doc":"","ref":"Ash.Type.html#c:ecto_type/0","title":"Ash.Type.ecto_type/0","type":"callback"},{"doc":"Returns the ecto compatible type for an Ash.Type. If you use Ash.Type , this is created for you. For builtin types this may return a corresponding ecto builtin type (atom)","ref":"Ash.Type.html#ecto_type/1","title":"Ash.Type.ecto_type/1","type":"function"},{"doc":"","ref":"Ash.Type.html#embedded_type?/1","title":"Ash.Type.embedded_type?/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:embedded?/0","title":"Ash.Type.embedded?/0","type":"callback"},{"doc":"","ref":"Ash.Type.html#c:equal?/2","title":"Ash.Type.equal?/2","type":"callback"},{"doc":"Determines if two values of a given type are equal. Maps to Ecto.Type.equal?/3","ref":"Ash.Type.html#equal?/3","title":"Ash.Type.equal?/3","type":"function"},{"doc":"","ref":"Ash.Type.html#c:generator/1","title":"Ash.Type.generator/1","type":"callback"},{"doc":"","ref":"Ash.Type.html#generator/2","title":"Ash.Type.generator/2","type":"function"},{"doc":"","ref":"Ash.Type.html#get_type/1","title":"Ash.Type.get_type/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:handle_change/3","title":"Ash.Type.handle_change/3","type":"callback"},{"doc":"Process the old casted values alongside the new casted values. This is leveraged by embedded types to know if something is being updated or destroyed. This is not called on creates.","ref":"Ash.Type.html#handle_change/4","title":"Ash.Type.handle_change/4","type":"function"},{"doc":"","ref":"Ash.Type.html#c:handle_change_array/3","title":"Ash.Type.handle_change_array/3","type":"callback"},{"doc":"","ref":"Ash.Type.html#c:prepare_change/3","title":"Ash.Type.prepare_change/3","type":"callback"},{"doc":"Process the old casted values alongside the new un casted values. This is leveraged by embedded types to know if something is being updated or destroyed. This is not called on creates.","ref":"Ash.Type.html#prepare_change/4","title":"Ash.Type.prepare_change/4","type":"function"},{"doc":"","ref":"Ash.Type.html#c:prepare_change_array/3","title":"Ash.Type.prepare_change_array/3","type":"callback"},{"doc":"","ref":"Ash.Type.html#c:simple_equality?/0","title":"Ash.Type.simple_equality?/0","type":"callback"},{"doc":"Determines if a type can be compared using ==","ref":"Ash.Type.html#simple_equality?/1","title":"Ash.Type.simple_equality?/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:storage_type/0","title":"Ash.Type.storage_type/0","type":"callback"},{"doc":"Returns the underlying storage type (the underlying type of the ecto type of the ash type )","ref":"Ash.Type.html#storage_type/1","title":"Ash.Type.storage_type/1","type":"function"},{"doc":"","ref":"Ash.Type.html#t:constraint_error/0","title":"Ash.Type.constraint_error/0","type":"type"},{"doc":"","ref":"Ash.Type.html#t:constraints/0","title":"Ash.Type.constraints/0","type":"type"},{"doc":"","ref":"Ash.Type.html#t:error/0","title":"Ash.Type.error/0","type":"type"},{"doc":"","ref":"Ash.Type.html#t:t/0","title":"Ash.Type.t/0","type":"type"},{"doc":"Stores an atom as a string in the database A builtin type that can be referenced via :atom Constraints :one_of ( term/0 ) - Allows constraining the value of an atom to a pre-defined list","ref":"Ash.Type.Atom.html","title":"Ash.Type.Atom","type":"module"},{"doc":"Represents a binary. A builtin type that can be referenced via :binary","ref":"Ash.Type.Binary.html","title":"Ash.Type.Binary","type":"module"},{"doc":"Represents a boolean. A builtin type that can be referenced via :boolean","ref":"Ash.Type.Boolean.html","title":"Ash.Type.Boolean","type":"module"},{"doc":"Stores a case insensitive string in the database See Ash.CiString for more information. A builtin type that can be referenced via :ci_string Constraints :max_length ( non_neg_integer/0 ) - Enforces a maximum length on the value :min_length ( non_neg_integer/0 ) - Enforces a minimum length on the value :match - Enforces that the string matches a passed in regex :trim? ( boolean/0 ) - Trims the value. The default value is true . :allow_empty? ( boolean/0 ) - Sets the value to nil if it's empty. The default value is false . :casing - Lowercases or uppercases the value, fully discarding case information. For example, if you don't set this, a value of FrEd could be saved to the data layer. FrEd and fReD would still compare as equal, but the original casing information is retained. In many cases, this is what you want. In some cases, however, you want to remove all case information. For example, in an email, you may want to support a user inputting an upper case letter, but discard it when saved. The default value is nil .","ref":"Ash.Type.CiString.html","title":"Ash.Type.CiString","type":"module"},{"doc":"","ref":"Ash.Type.CiString.html#match/1","title":"Ash.Type.CiString.match/1","type":"function"},{"doc":"Helpers for working with Comparable","ref":"Ash.Type.Comparable.html","title":"Ash.Type.Comparable","type":"module"},{"doc":"","ref":"Ash.Type.Comparable.html#defcomparable/3","title":"Ash.Type.Comparable.defcomparable/3","type":"macro"},{"doc":"Represents a date in the database A builtin type that can be referenced via :date","ref":"Ash.Type.Date.html","title":"Ash.Type.Date","type":"module"},{"doc":"Represents a decimal. A builtin type that can be referenced via :decimal Constraints :max - Enforces a maximum on the value :min - Enforces a minimum on the value","ref":"Ash.Type.Decimal.html","title":"Ash.Type.Decimal","type":"module"},{"doc":"An interval of time, primarily meant to be used in expression functions Valid intervals are (as strings or atoms): [:year, :month, :week, :day, :hour, :minute, :second, :millisecond, :microsecond]","ref":"Ash.Type.DurationName.html","title":"Ash.Type.DurationName","type":"module"},{"doc":"A type for abstracting enums into a single type. For example, your existing app might look like: attribute :status , :atom , constraints : [ one_of : [ :open , :closed ] ] But as that starts to spread around your system you may find that you want to centralize that logic. To do that, use this module to define an Ash type easily: defmodule MyApp.TicketStatus do use Ash.Type.Enum , values : [ :open , :closed ] end Valid values are: The atom itself, e.g :open A string that matches the atom, e.g &quot;open&quot; A string that matches the atom after being downcased, e.g &quot;OPEN&quot; or &quot;oPeN&quot; A string that matches the stringified, downcased atom, after itself being downcased. This allows for enum values like :Open , :SomeState and :Some_State","ref":"Ash.Type.Enum.html","title":"Ash.Type.Enum","type":"behaviour"},{"doc":"finds the valid value that matches a given input term","ref":"Ash.Type.Enum.html#c:match/1","title":"Ash.Type.Enum.match/1","type":"callback"},{"doc":"true if a given term matches a value","ref":"Ash.Type.Enum.html#c:match?/1","title":"Ash.Type.Enum.match?/1","type":"callback"},{"doc":"The list of valid values (not all input types that match them)","ref":"Ash.Type.Enum.html#c:values/0","title":"Ash.Type.Enum.values/0","type":"callback"},{"doc":"Represents a float (floating point number) A builtin type that be referenced via :float Constraints :max - Enforces a maximum on the value :min - Enforces a minimum on the value","ref":"Ash.Type.Float.html","title":"Ash.Type.Float","type":"module"},{"doc":"Represents a function. If the type would be dumped to a native format, :erlang.term_to_binary(term, [:safe]) is used. Please keep in mind, this is not safe to use with external input. This could easily cause you t More information available here: https://erlang.org/doc/man/erlang.html#binary_to_term-2","ref":"Ash.Type.Function.html","title":"Ash.Type.Function","type":"module"},{"doc":"Represents a simple integer A builtin type that can be referenced via :integer Constraints :max - Enforces a maximum on the value :min - Enforces a minimum on the value","ref":"Ash.Type.Integer.html","title":"Ash.Type.Integer","type":"module"},{"doc":"Represents a map stored in the database. In postgres, for example, this represents binary encoded json A builtin type that can be referenced via :map","ref":"Ash.Type.Map.html","title":"Ash.Type.Map","type":"module"},{"doc":"Represents a Naive datetime A builtin type that can be referenced via :naive_datetime","ref":"Ash.Type.NaiveDatetime.html","title":"Ash.Type.NaiveDatetime","type":"module"},{"doc":"Stores a string in the database. A built-in type that can be referenced via :string . By default, values are trimmed and empty values are set to nil . You can use the allow_empty? and trim? constraints to change these behaviors. Constraints :max_length ( non_neg_integer/0 ) - Enforces a maximum length on the value :min_length ( non_neg_integer/0 ) - Enforces a minimum length on the value :match - Enforces that the string matches a passed in regex :trim? ( boolean/0 ) - Trims the value. The default value is true . :allow_empty? ( boolean/0 ) - If false, the value is set to nil if it's empty. The default value is false .","ref":"Ash.Type.String.html","title":"Ash.Type.String","type":"module"},{"doc":"","ref":"Ash.Type.String.html#match/1","title":"Ash.Type.String.match/1","type":"function"},{"doc":"Represents a struct. This cannot be loaded from a database, it can only be used to cast input. Use the instance_of constraint to specify that it must be an instance of a specific struct.","ref":"Ash.Type.Struct.html","title":"Ash.Type.Struct","type":"module"},{"doc":"Represents a raw elixir term in the database A builtin type that can be referenced via :string","ref":"Ash.Type.Term.html","title":"Ash.Type.Term","type":"module"},{"doc":"Represents a time in the database A builtin type that can be referenced via :time","ref":"Ash.Type.Time.html","title":"Ash.Type.Time","type":"module"},{"doc":"Represents a UUID. A builtin type that can be referenced via :uuid","ref":"Ash.Type.UUID.html","title":"Ash.Type.UUID","type":"module"},{"doc":"A union between multiple types, distinguished with a tag or by attempting to validate. Constraints :types - The types to be unioned, a map of an identifier for the enum value to its configuration. When using tag and tag_value we are referring to a map key that must equal a certain value in order for the value to be considered an instance of that type. For example: types : [ int : [ type : :integer , constraints : [ max : 10 ] ] , object : [ type : MyObjectType , tag : :type , tag_value : &quot;my_object&quot; ] , other_object : [ type : MyOtherObjectType , tag : :type , tag_value : &quot;my_other_object&quot; ] , other_object_without_type : [ type : MyOtherObjectTypeWithoutType , tag : :type , tag_value : nil ] ] IMPORTANT: This is stored as a map under the hood. Filters over the data will need to take this into account. Additionally, if you are not using a tag, a value will be considered to be of the given type if it successfully casts. This means that, for example, if you try to cast &quot;10&quot; as a union of a string and an integer, it will end up as &quot;10&quot; because it is a string. If you put the integer type ahead of the string type, it will cast first and 10 will be the value.","ref":"Ash.Type.Union.html","title":"Ash.Type.Union","type":"module"},{"doc":"Represents a binary that attempts to decode input strings as a url encoded base64 string. A builtin type that can be referenced via :url_encoded_binary","ref":"Ash.Type.UrlEncodedBinary.html","title":"Ash.Type.UrlEncodedBinary","type":"module"},{"doc":"Represents a utc datetime A builtin type that can be referenced via :utc_datetime","ref":"Ash.Type.UtcDatetime.html","title":"Ash.Type.UtcDatetime","type":"module"},{"doc":"Represents a utc datetime with microsecond precision. A builtin type that can be referenced via :utc_datetime_usec","ref":"Ash.Type.UtcDatetimeUsec.html","title":"Ash.Type.UtcDatetimeUsec","type":"module"},{"doc":"Tools and utilities used by Ash to manage and conform errors","ref":"Ash.Error.html","title":"Ash.Error","type":"module"},{"doc":"","ref":"Ash.Error.html#ash_error?/1","title":"Ash.Error.ash_error?/1","type":"function"},{"doc":"","ref":"Ash.Error.html#choose_error/2","title":"Ash.Error.choose_error/2","type":"function"},{"doc":"","ref":"Ash.Error.html#clear_stacktraces/1","title":"Ash.Error.clear_stacktraces/1","type":"function"},{"doc":"","ref":"Ash.Error.html#error_descriptions/1","title":"Ash.Error.error_descriptions/1","type":"function"},{"doc":"","ref":"Ash.Error.html#error_messages/3","title":"Ash.Error.error_messages/3","type":"function"},{"doc":"A utility to flatten a list, but preserve keyword list elements","ref":"Ash.Error.html#flatten_preserving_keywords/1","title":"Ash.Error.flatten_preserving_keywords/1","type":"function"},{"doc":"Converts a term into an Ash Error. The term could be a simple string, the second element in an {:error, error} tuple, an Ash Error, or a list of any of these. In most cases the returned error is an Ash.Error.Unknown.UnknownError. A stacktrace is added to the error, and any existing stacktrace (i.e. when the term is an Ash Error) is preserved. to_ash_error converts string(s) into UnknownError(s): iex(1)&gt; Ash.Error . to_ash_error ( &quot;whoops!&quot; , nil , error_context : &quot;some context&quot; ) % Ash.Error.Unknown.UnknownError { changeset : nil , class : :unknown , error : &quot;whoops!&quot; , error_context : [ &quot;some context&quot; ] , field : nil , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , vars : [ ] } iex(2)&gt; Ash.Error . to_ash_error ( [ &quot;whoops!&quot; , &quot;whoops, again!!&quot; ] , nil , error_context : &quot;some context&quot; ) [ % Ash.Error.Unknown.UnknownError { changeset : nil , class : :unknown , error : &quot;whoops!&quot; , error_context : [ &quot;some context&quot; ] , field : nil , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , vars : [ ] } , % Ash.Error.Unknown.UnknownError { changeset : nil , class : :unknown , error : &quot;whoops, again!!&quot; , error_context : [ &quot;some context&quot; ] , field : nil , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , vars : [ ] } ] to_ash_error can preserve error-like data from a keyword-list and accumulate context if called against an Ash Error: iex(1)&gt; err = Ash.Error . to_ash_error ( [ vars : [ :some_var ] , message : &quot;whoops!&quot; ] , nil , error_context : &quot; some context&quot; ) % Ash.Error.Unknown.UnknownError { changeset : nil , class : :unknown , error : &quot;whoops!&quot; , error_context : [ &quot;some context&quot; ] , field : nil , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , vars : [ :some_var ] } iex(2)&gt; Ash.Error . to_ash_error ( err , nil , error_context : &quot;some higher context&quot; ) % Ash.Error.Unknown.UnknownError { changeset : nil , class : :unknown , error : &quot;whoops!&quot; , error_context : [ &quot;some higher context&quot; , &quot;some context&quot; ] , field : nil , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , vars : [ :some_var ] } Options: error_context : a sting message providing extra context around the error","ref":"Ash.Error.html#to_ash_error/3","title":"Ash.Error.to_ash_error/3","type":"function"},{"doc":"Conforms a term into one of the built-in Ash Error classes . The provided term would usually be an Ash Error or a list of Ash Errors. If the term is: a map/struct/Ash Error with a key :class having a value :special , a list with a single map/struct/Ash Error element as above, or an Ash.Error.Invalid containing such a list in its :errors field then the term is returned unchanged. Example: iex(1)&gt; Ash.Error . to_error_class ( &quot;oops&quot; , changeset : Ash.Changeset . new ( % Post { } ) , error_context : &quot;some context&quot; ) % Ash.Error.Unknown { changeset : # Ash.Changeset &lt; errors : [ % Ash.Error.Unknown.UnknownError { changeset : nil , class : :unknown , error : &quot;oops&quot; , error_context : [ &quot;some context&quot; ] , field : nil , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , vars : [ ] } ] , ... &gt; , class : :unknown , error_context : [ &quot;some context&quot; ] , errors : [ % Ash.Error.Unknown.UnknownError { changeset : nil , class : :unknown , error : &quot;oops&quot; , error_context : [ &quot;some context&quot; ] , field : nil , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , vars : [ ] } ] , stacktrace : # Stacktrace &lt; &gt; , stacktraces? : true , vars : [ ] } Example of nested errors: iex(1)&gt; error1 = Ash.Error . to_ash_error ( &quot;whoops!&quot; , nil , error_context : &quot;some context&quot; ) iex(2)&gt; error2 = Ash.Error . to_ash_error ( &quot;whoops, again!!&quot; , nil , error_context : &quot;some other context&quot; ) iex(3)&gt; Ash.Error . to_error_class ( [ error1 , error2 ] , error_context : &quot;some higher context&quot; ) % Ash.Error.Unknown { changeset : nil , class : :unknown , error_context : [ &quot;some higher context&quot; ] , errors : [ % Ash.Error.Unknown.UnknownError { changeset : nil , class : :unknown , error : &quot;whoops!&quot; , error_context : [ &quot;some higher context&quot; , &quot;some context&quot; ] , field : nil , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , vars : [ ] } , % Ash.Error.Unknown.UnknownError { changeset : nil , class : :unknown , error : &quot;whoops, again!!&quot; , error_context : [ &quot;some higher context&quot; , &quot;some other context&quot; ] , field : nil , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , vars : [ ] } ] , path : [ ] , query : nil , stacktrace : # Stacktrace &lt; &gt; , stacktraces? : true , vars : [ ] } Options: changeset : a changeset related to the error query : a query related to the error error_context : a sting message providing extra context around the error","ref":"Ash.Error.html#to_error_class/2","title":"Ash.Error.to_error_class/2","type":"function"},{"doc":"","ref":"Ash.Error.html#t:error_class/0","title":"Ash.Error.error_class/0","type":"type"},{"doc":"","ref":"Ash.Error.html#t:t/0","title":"Ash.Error.t/0","type":"type"},{"doc":"Used when an invalid value is provided for an action argument","ref":"Ash.Error.Changes.InvalidArgument.html","title":"Ash.Error.Changes.InvalidArgument","type":"exception"},{"doc":"Used when an invalid value is provided for an attribute change","ref":"Ash.Error.Changes.InvalidAttribute.html","title":"Ash.Error.Changes.InvalidAttribute","type":"exception"},{"doc":"Used when a change is provided that covers multiple attributes/relationships","ref":"Ash.Error.Changes.InvalidChanges.html","title":"Ash.Error.Changes.InvalidChanges","type":"exception"},{"doc":"Used when an invalid value is provided for a relationship change","ref":"Ash.Error.Changes.InvalidRelationship.html","title":"Ash.Error.Changes.InvalidRelationship","type":"exception"},{"doc":"Used when a change is provided for an attribute that does not exist","ref":"Ash.Error.Changes.NoSuchAttribute.html","title":"Ash.Error.Changes.NoSuchAttribute","type":"exception"},{"doc":"Used when a change is provided for an relationship that does not exist","ref":"Ash.Error.Changes.NoSuchRelationship.html","title":"Ash.Error.Changes.NoSuchRelationship","type":"exception"},{"doc":"Used when an attribute or relationship is required","ref":"Ash.Error.Changes.Required.html","title":"Ash.Error.Changes.Required","type":"exception"},{"doc":"Used when a change fails for an unknown reason","ref":"Ash.Error.Changes.UnknownError.html","title":"Ash.Error.Changes.UnknownError","type":"exception"},{"doc":"Used when the Ash engine has an internal error","ref":"Ash.Error.EngineError.html","title":"Ash.Error.EngineError","type":"exception"},{"doc":"Tooling for creating an Ash exception","ref":"Ash.Error.Exception.html","title":"Ash.Error.Exception","type":"module"},{"doc":"","ref":"Ash.Error.Exception.html#def_ash_error/2","title":"Ash.Error.Exception.def_ash_error/2","type":"macro"},{"doc":"Used when a flow has been halted for some reason","ref":"Ash.Error.Flow.Halted.html","title":"Ash.Error.Flow.Halted","type":"exception"},{"doc":"Used when authorization for an action fails","ref":"Ash.Error.Forbidden.html","title":"Ash.Error.Forbidden","type":"exception"},{"doc":"Used when an api that has require_actor? true is provided no actor","ref":"Ash.Error.Forbidden.ApiRequiresActor.html","title":"Ash.Error.Forbidden.ApiRequiresActor","type":"exception"},{"doc":"Used when a create action would be filtered","ref":"Ash.Error.Forbidden.CannotFilterCreates.html","title":"Ash.Error.Forbidden.CannotFilterCreates","type":"exception"},{"doc":"Used when unreachable code/conditions are reached in the framework","ref":"Ash.Error.Forbidden.MustPassStrictCheck.html","title":"Ash.Error.Forbidden.MustPassStrictCheck","type":"exception"},{"doc":"Raised when policy authorization for an action fails","ref":"Ash.Error.Forbidden.Policy.html","title":"Ash.Error.Forbidden.Policy","type":"exception"},{"doc":"Print a report of an authorization failure from authorization information. Options: :help_text? : Defaults to true. Displays help text at the top of the policy breakdown. :success? : Defaults to false. Changes the messaging/graphics around to indicate successful policy authorization. :must_pass_strict_check? : Defaults to false. Adds a message about this authorization requiring passing strict check.","ref":"Ash.Error.Forbidden.Policy.html#get_breakdown/4","title":"Ash.Error.Forbidden.Policy.get_breakdown/4","type":"function"},{"doc":"Print a report of an authorization failure from a forbidden error Options: :help_text? : Defaults to true. Displays help text at the top of the policy breakdown.","ref":"Ash.Error.Forbidden.Policy.html#report/2","title":"Ash.Error.Forbidden.Policy.report/2","type":"function"},{"doc":"Used when an unknown/generic framework error occurs","ref":"Ash.Error.Framework.html","title":"Ash.Error.Framework","type":"exception"},{"doc":"Used when unreachable code/conditions are reached in the framework","ref":"Ash.Error.Framework.AssumptionFailed.html","title":"Ash.Error.Framework.AssumptionFailed","type":"exception"},{"doc":"Used when a manual action should have produced a result, but did not","ref":"Ash.Error.Framework.ManualActionMissed.html","title":"Ash.Error.Framework.ManualActionMissed","type":"exception"},{"doc":"Used when the sycnrhonous engine cannot proceed","ref":"Ash.Error.Framework.SynchronousEngineStuck.html","title":"Ash.Error.Framework.SynchronousEngineStuck","type":"exception"},{"doc":"The top level invalid error","ref":"Ash.Error.Invalid.html","title":"Ash.Error.Invalid","type":"exception"},{"doc":"Used when multiple requests with the same path are passed to the internal engine","ref":"Ash.Error.Invalid.DuplicatedPath.html","title":"Ash.Error.Invalid.DuplicatedPath","type":"exception"},{"doc":"Used when a request expresses a dependency on another request that doesn't exist","ref":"Ash.Error.Invalid.ImpossiblePath.html","title":"Ash.Error.Invalid.ImpossiblePath","type":"exception"},{"doc":"Used when an invalid primary key is given to an Api's get","ref":"Ash.Error.Invalid.InvalidPrimaryKey.html","title":"Ash.Error.Invalid.InvalidPrimaryKey","type":"exception"},{"doc":"Used when no limit is provided, pagination is required, and no default page size is configured","ref":"Ash.Error.Invalid.LimitRequired.html","title":"Ash.Error.Invalid.LimitRequired","type":"exception"},{"doc":"Used when multiple requests with the same path are passed to the internal engine","ref":"Ash.Error.Invalid.MultipleResults.html","title":"Ash.Error.Invalid.MultipleResults","type":"exception"},{"doc":"Used when an action name is provided that doesn't exist","ref":"Ash.Error.Invalid.NoPrimaryAction.html","title":"Ash.Error.Invalid.NoPrimaryAction","type":"exception"},{"doc":"Used when an action name is provided that doesn't exist","ref":"Ash.Error.Invalid.NoSuchAction.html","title":"Ash.Error.Invalid.NoSuchAction","type":"exception"},{"doc":"Used when a resource or alias is provided that doesn't exist","ref":"Ash.Error.Invalid.NoSuchResource.html","title":"Ash.Error.Invalid.NoSuchResource","type":"exception"},{"doc":"Used when page option is passed but pagination is not enabled.","ref":"Ash.Error.Invalid.PageRequiresPagination.html","title":"Ash.Error.Invalid.PageRequiresPagination","type":"exception"},{"doc":"Used when page: false is provided but pagination is required","ref":"Ash.Error.Invalid.PaginationRequired.html","title":"Ash.Error.Invalid.PaginationRequired","type":"exception"},{"doc":"Used when a tenant is not specified","ref":"Ash.Error.Invalid.TenantRequired.html","title":"Ash.Error.Invalid.TenantRequired","type":"exception"},{"doc":"Used when a request to the api times out.","ref":"Ash.Error.Invalid.Timeout.html","title":"Ash.Error.Invalid.Timeout","type":"exception"},{"doc":"Used when timeouts are not supported by the data layer, but one is set","ref":"Ash.Error.Invalid.TimeoutNotSupported.html","title":"Ash.Error.Invalid.TimeoutNotSupported","type":"exception"},{"doc":"Used when an invalid query is provided in a load","ref":"Ash.Error.Load.InvalidQuery.html","title":"Ash.Error.Load.InvalidQuery","type":"exception"},{"doc":"Used when attempting to load a relationship that does not exist","ref":"Ash.Error.Load.NoSuchRelationship.html","title":"Ash.Error.Load.NoSuchRelationship","type":"exception"},{"doc":"Used when a value is provided for a keyset that cannot be Base64 decoded.","ref":"Ash.Error.Page.InvalidKeyset.html","title":"Ash.Error.Page.InvalidKeyset","type":"exception"},{"doc":"Used when the data_layer does not support aggregates, or filtering/sorting them","ref":"Ash.Error.Query.AggregatesNotSupported.html","title":"Ash.Error.Query.AggregatesNotSupported","type":"exception"},{"doc":"Used when the data_layer does not support calculations, or filtering/sorting them","ref":"Ash.Error.Query.CalculationsNotSupported.html","title":"Ash.Error.Query.CalculationsNotSupported","type":"exception"},{"doc":"Used when an invalid value is provided for an action argument","ref":"Ash.Error.Query.InvalidArgument.html","title":"Ash.Error.Query.InvalidArgument","type":"exception"},{"doc":"Used when an invalid expression is used in a filter","ref":"Ash.Error.Query.InvalidExpression.html","title":"Ash.Error.Query.InvalidExpression","type":"exception"},{"doc":"Used when an invalid reference is used in a filter","ref":"Ash.Error.Query.InvalidFilterReference.html","title":"Ash.Error.Query.InvalidFilterReference","type":"exception"},{"doc":"Used when an invalid value is provided for a filter","ref":"Ash.Error.Query.InvalidFilterValue.html","title":"Ash.Error.Query.InvalidFilterValue","type":"exception"},{"doc":"Used when an invalid limit is provided","ref":"Ash.Error.Query.InvalidLimit.html","title":"Ash.Error.Query.InvalidLimit","type":"exception"},{"doc":"Used when an invalid load is provided","ref":"Ash.Error.Query.InvalidLoad.html","title":"Ash.Error.Query.InvalidLoad","type":"exception"},{"doc":"Used when an invalid offset is provided","ref":"Ash.Error.Query.InvalidOffset.html","title":"Ash.Error.Query.InvalidOffset","type":"exception"},{"doc":"A generic error that can be used to add an error to a query for a specific field","ref":"Ash.Error.Query.InvalidQuery.html","title":"Ash.Error.Query.InvalidQuery","type":"exception"},{"doc":"Used when an invalid sort order is provided","ref":"Ash.Error.Query.InvalidSortOrder.html","title":"Ash.Error.Query.InvalidSortOrder","type":"exception"},{"doc":"Due to the filter-based implementation of keyset pagination, it cannot be used with sorts on calculations. We could solve this problem by making the keyset only be the primary key of the record, and then fetching that value loading the calculations/aggregates that we need. If we do this we should either: 1.) make it a new pagination mode or 2.) add an option like mode: :strict | :fetch to pagination options. Let me know if you're reading this and want to help implement it.","ref":"Ash.Error.Query.NoComplexSortsWithKeysetPagination.html","title":"Ash.Error.Query.NoComplexSortsWithKeysetPagination","type":"exception"},{"doc":"Used when a resource would be read but has no read action","ref":"Ash.Error.Query.NoReadAction.html","title":"Ash.Error.Query.NoReadAction","type":"exception"},{"doc":"Used when an attribute that doesn't exist is used in a query","ref":"Ash.Error.Query.NoSuchAttribute.html","title":"Ash.Error.Query.NoSuchAttribute","type":"exception"},{"doc":"Used when a key in a filter contains something that is neither an attribute or a relationship","ref":"Ash.Error.Query.NoSuchAttributeOrRelationship.html","title":"Ash.Error.Query.NoSuchAttributeOrRelationship","type":"exception"},{"doc":"Used when a filter predicate that does not exist is referenced","ref":"Ash.Error.Query.NoSuchFilterPredicate.html","title":"Ash.Error.Query.NoSuchFilterPredicate","type":"exception"},{"doc":"Used when an function that doesn't exist is used in a query","ref":"Ash.Error.Query.NoSuchFunction.html","title":"Ash.Error.Query.NoSuchFunction","type":"exception"},{"doc":"Used when an operator that doesn't exist is used in a query","ref":"Ash.Error.Query.NoSuchOperator.html","title":"Ash.Error.Query.NoSuchOperator","type":"exception"},{"doc":"Used when an relationship that doesn't exist is used in a query","ref":"Ash.Error.Query.NoSuchRelationship.html","title":"Ash.Error.Query.NoSuchRelationship","type":"exception"},{"doc":"Used when an entity that not exist is referenced","ref":"Ash.Error.Query.NotFound.html","title":"Ash.Error.Query.NotFound","type":"exception"},{"doc":"Used when a relationship is filtered and the destination does not have a default read action","ref":"Ash.Error.Query.ReadActionRequired.html","title":"Ash.Error.Query.ReadActionRequired","type":"exception"},{"doc":"Used when an actor is referenced in a filter template, but no actor exists","ref":"Ash.Error.Query.ReadActionRequiresActor.html","title":"Ash.Error.Query.ReadActionRequiresActor","type":"exception"},{"doc":"Used when a filter or argument is required in a query","ref":"Ash.Error.Query.Required.html","title":"Ash.Error.Query.Required","type":"exception"},{"doc":"Used when attempting to sort on a field that cannot be used for sorting","ref":"Ash.Error.Query.UnsortableAttribute.html","title":"Ash.Error.Query.UnsortableAttribute","type":"exception"},{"doc":"Used when the data_layer does not support a provided predicate","ref":"Ash.Error.Query.UnsupportedPredicate.html","title":"Ash.Error.Query.UnsupportedPredicate","type":"exception"},{"doc":"Used when no data was provided to the simple data layer","ref":"Ash.Error.SimpleDataLayer.NoDataProvided.html","title":"Ash.Error.SimpleDataLayer.NoDataProvided","type":"exception"},{"doc":"A placeholder for a stacktrace so that we can avoid printing it everywhere","ref":"Ash.Error.Stacktrace.html","title":"Ash.Error.Stacktrace","type":"module"},{"doc":"The top level unknown error container","ref":"Ash.Error.Unknown.html","title":"Ash.Error.Unknown","type":"exception"},{"doc":"Used when an unknown error occurs","ref":"Ash.Error.Unknown.UnknownError.html","title":"Ash.Error.Unknown.UnknownError","type":"exception"},{"doc":"Ensures that all identities have a pre_check_with configured, or raises.","ref":"Ash.DataLayer.Transformers.RequirePreCheckWith.html","title":"Ash.DataLayer.Transformers.RequirePreCheckWith","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.DataLayer.Transformers.RequirePreCheckWith.html#after?/1","title":"Ash.DataLayer.Transformers.RequirePreCheckWith.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.DataLayer.Transformers.RequirePreCheckWith.html#before?/1","title":"Ash.DataLayer.Transformers.RequirePreCheckWith.before?/1","type":"function"},{"doc":"Sets the api on the steps of a flow to the default api, unless an api is set explicitly.","ref":"Ash.Flow.Transformers.SetApi.html","title":"Ash.Flow.Transformers.SetApi","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Flow.Transformers.SetApi.html#after_compile?/0","title":"Ash.Flow.Transformers.SetApi.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Flow.Transformers.SetApi.html#after?/1","title":"Ash.Flow.Transformers.SetApi.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Flow.Transformers.SetApi.html#before?/1","title":"Ash.Flow.Transformers.SetApi.before?/1","type":"function"},{"doc":"","ref":"Ash.Flow.Transformers.SetApi.html#set_api/2","title":"Ash.Flow.Transformers.SetApi.set_api/2","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Flow.Transformers.SetApi.html#transform/1","title":"Ash.Flow.Transformers.SetApi.transform/1","type":"function"},{"doc":"Validates that no nested steps contain no steps","ref":"Ash.Flow.Transformers.ValidateNoEmptySteps.html","title":"Ash.Flow.Transformers.ValidateNoEmptySteps","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Flow.Transformers.ValidateNoEmptySteps.html#after_compile?/0","title":"Ash.Flow.Transformers.ValidateNoEmptySteps.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Flow.Transformers.ValidateNoEmptySteps.html#after?/1","title":"Ash.Flow.Transformers.ValidateNoEmptySteps.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Flow.Transformers.ValidateNoEmptySteps.html#before?/1","title":"Ash.Flow.Transformers.ValidateNoEmptySteps.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Flow.Transformers.ValidateNoEmptySteps.html#transform/1","title":"Ash.Flow.Transformers.ValidateNoEmptySteps.transform/1","type":"function"},{"doc":"Validates that steps have unique names.","ref":"Ash.Flow.Transformers.ValidateUniqueNames.html","title":"Ash.Flow.Transformers.ValidateUniqueNames","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Flow.Transformers.ValidateUniqueNames.html#after_compile?/0","title":"Ash.Flow.Transformers.ValidateUniqueNames.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Flow.Transformers.ValidateUniqueNames.html#after?/1","title":"Ash.Flow.Transformers.ValidateUniqueNames.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Flow.Transformers.ValidateUniqueNames.html#before?/1","title":"Ash.Flow.Transformers.ValidateUniqueNames.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Flow.Transformers.ValidateUniqueNames.html#transform/1","title":"Ash.Flow.Transformers.ValidateUniqueNames.transform/1","type":"function"},{"doc":"Adds some top level validations of resources present in a registry","ref":"Ash.Registry.ResourceValidations.html","title":"Ash.Registry.ResourceValidations","type":"module"},{"doc":"Warns if a registry has no entries in it","ref":"Ash.Registry.Transformers.WarnOnEmpty.html","title":"Ash.Registry.Transformers.WarnOnEmpty","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Registry.Transformers.WarnOnEmpty.html#after_compile?/0","title":"Ash.Registry.Transformers.WarnOnEmpty.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Registry.Transformers.WarnOnEmpty.html#after?/1","title":"Ash.Registry.Transformers.WarnOnEmpty.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Registry.Transformers.WarnOnEmpty.html#before?/1","title":"Ash.Registry.Transformers.WarnOnEmpty.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Registry.Transformers.WarnOnEmpty.html#transform/1","title":"Ash.Registry.Transformers.WarnOnEmpty.transform/1","type":"function"},{"doc":"Creates the attribute for belongs_to relationships that have define_attribute?: true","ref":"Ash.Resource.Transformers.BelongsToAttribute.html","title":"Ash.Resource.Transformers.BelongsToAttribute","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#after_compile?/0","title":"Ash.Resource.Transformers.BelongsToAttribute.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#after?/1","title":"Ash.Resource.Transformers.BelongsToAttribute.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#before?/1","title":"Ash.Resource.Transformers.BelongsToAttribute.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#transform/1","title":"Ash.Resource.Transformers.BelongsToAttribute.transform/1","type":"function"},{"doc":"Sets the default source_attribute for belongs_to attributes","ref":"Ash.Resource.Transformers.BelongsToSourceField.html","title":"Ash.Resource.Transformers.BelongsToSourceField","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#after_compile?/0","title":"Ash.Resource.Transformers.BelongsToSourceField.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#after?/1","title":"Ash.Resource.Transformers.BelongsToSourceField.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#before?/1","title":"Ash.Resource.Transformers.BelongsToSourceField.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#transform/1","title":"Ash.Resource.Transformers.BelongsToSourceField.transform/1","type":"function"},{"doc":"Validates and caches the primary key of a resource","ref":"Ash.Resource.Transformers.CachePrimaryKey.html","title":"Ash.Resource.Transformers.CachePrimaryKey","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#after_compile?/0","title":"Ash.Resource.Transformers.CachePrimaryKey.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#after?/1","title":"Ash.Resource.Transformers.CachePrimaryKey.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#before?/1","title":"Ash.Resource.Transformers.CachePrimaryKey.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#transform/1","title":"Ash.Resource.Transformers.CachePrimaryKey.transform/1","type":"function"},{"doc":"Ensures that countable paginated actions do not exist for resources that are not countable","ref":"Ash.Resource.Transformers.CountableActions.html","title":"Ash.Resource.Transformers.CountableActions","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.CountableActions.html#after_compile?/0","title":"Ash.Resource.Transformers.CountableActions.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.CountableActions.html#after?/1","title":"Ash.Resource.Transformers.CountableActions.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.CountableActions.html#before?/1","title":"Ash.Resource.Transformers.CountableActions.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.CountableActions.html#transform/1","title":"Ash.Resource.Transformers.CountableActions.transform/1","type":"function"},{"doc":"Creates an automatically named has_many relationship for each many_to_many. This will likely not be around for long, as our logic around many to many relationships will update soon.","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html","title":"Ash.Resource.Transformers.CreateJoinRelationship","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#after_compile?/0","title":"Ash.Resource.Transformers.CreateJoinRelationship.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#after?/1","title":"Ash.Resource.Transformers.CreateJoinRelationship.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#before?/1","title":"Ash.Resource.Transformers.CreateJoinRelationship.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#transform/1","title":"Ash.Resource.Transformers.CreateJoinRelationship.transform/1","type":"function"},{"doc":"Sets the default accept for each action","ref":"Ash.Resource.Transformers.DefaultAccept.html","title":"Ash.Resource.Transformers.DefaultAccept","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.DefaultAccept.html#after_compile?/0","title":"Ash.Resource.Transformers.DefaultAccept.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.DefaultAccept.html#after?/1","title":"Ash.Resource.Transformers.DefaultAccept.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.DefaultAccept.html#before?/1","title":"Ash.Resource.Transformers.DefaultAccept.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.DefaultAccept.html#transform/1","title":"Ash.Resource.Transformers.DefaultAccept.transform/1","type":"function"},{"doc":"Creates the default primary key if one applies. Currently, the only resources that get a default primary key are embedded resources. The reason for this is that resources must have a primary key, and embedded resources actually make sense without one. But this is simulated with a private uuid primary key.","ref":"Ash.Resource.Transformers.DefaultPrimaryKey.html","title":"Ash.Resource.Transformers.DefaultPrimaryKey","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.DefaultPrimaryKey.html#after_compile?/0","title":"Ash.Resource.Transformers.DefaultPrimaryKey.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.DefaultPrimaryKey.html#after?/1","title":"Ash.Resource.Transformers.DefaultPrimaryKey.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.DefaultPrimaryKey.html#before?/1","title":"Ash.Resource.Transformers.DefaultPrimaryKey.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.DefaultPrimaryKey.html#transform/1","title":"Ash.Resource.Transformers.DefaultPrimaryKey.transform/1","type":"function"},{"doc":"Guesses the destination_attribute for has many and has one relationships unless provided","ref":"Ash.Resource.Transformers.HasDestinationField.html","title":"Ash.Resource.Transformers.HasDestinationField","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.HasDestinationField.html#after_compile?/0","title":"Ash.Resource.Transformers.HasDestinationField.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.HasDestinationField.html#after?/1","title":"Ash.Resource.Transformers.HasDestinationField.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.HasDestinationField.html#before?/1","title":"Ash.Resource.Transformers.HasDestinationField.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.HasDestinationField.html#transform/1","title":"Ash.Resource.Transformers.HasDestinationField.transform/1","type":"function"},{"doc":"Confirms that a resource does not use reserved names for field names. Reserved field names are: [: struct , : meta , : metadata , : order , :calculations, :aggregates].","ref":"Ash.Resource.Transformers.NoReservedFieldNames.html","title":"Ash.Resource.Transformers.NoReservedFieldNames","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.NoReservedFieldNames.html#after_compile?/0","title":"Ash.Resource.Transformers.NoReservedFieldNames.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.NoReservedFieldNames.html#after?/1","title":"Ash.Resource.Transformers.NoReservedFieldNames.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.NoReservedFieldNames.html#before?/1","title":"Ash.Resource.Transformers.NoReservedFieldNames.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.NoReservedFieldNames.html#transform/1","title":"Ash.Resource.Transformers.NoReservedFieldNames.transform/1","type":"function"},{"doc":"Ensures that all actions have unique names.","ref":"Ash.Resource.Transformers.RequireUniqueActionNames.html","title":"Ash.Resource.Transformers.RequireUniqueActionNames","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.RequireUniqueActionNames.html#after_compile?/0","title":"Ash.Resource.Transformers.RequireUniqueActionNames.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.RequireUniqueActionNames.html#after?/1","title":"Ash.Resource.Transformers.RequireUniqueActionNames.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.RequireUniqueActionNames.html#before?/1","title":"Ash.Resource.Transformers.RequireUniqueActionNames.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.RequireUniqueActionNames.html#transform/1","title":"Ash.Resource.Transformers.RequireUniqueActionNames.transform/1","type":"function"},{"doc":"Confirms that a resource does not have multiple fields(attributes, calculations, aggregates, and relationships) with the same name.","ref":"Ash.Resource.Transformers.RequireUniqueFieldNames.html","title":"Ash.Resource.Transformers.RequireUniqueFieldNames","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.RequireUniqueFieldNames.html#after_compile?/0","title":"Ash.Resource.Transformers.RequireUniqueFieldNames.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.RequireUniqueFieldNames.html#after?/1","title":"Ash.Resource.Transformers.RequireUniqueFieldNames.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.RequireUniqueFieldNames.html#before?/1","title":"Ash.Resource.Transformers.RequireUniqueFieldNames.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.RequireUniqueFieldNames.html#transform/1","title":"Ash.Resource.Transformers.RequireUniqueFieldNames.transform/1","type":"function"},{"doc":"Sets the source key on relationships to be the resource they were defined on","ref":"Ash.Resource.Transformers.SetRelationshipSource.html","title":"Ash.Resource.Transformers.SetRelationshipSource","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#after_compile?/0","title":"Ash.Resource.Transformers.SetRelationshipSource.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#after?/1","title":"Ash.Resource.Transformers.SetRelationshipSource.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#before?/1","title":"Ash.Resource.Transformers.SetRelationshipSource.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#transform/1","title":"Ash.Resource.Transformers.SetRelationshipSource.transform/1","type":"function"},{"doc":"Validates that accept and reject lists only contain valid attributes","ref":"Ash.Resource.Transformers.ValidateAccept.html","title":"Ash.Resource.Transformers.ValidateAccept","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.ValidateAccept.html#after?/1","title":"Ash.Resource.Transformers.ValidateAccept.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.ValidateAccept.html#before?/1","title":"Ash.Resource.Transformers.ValidateAccept.before?/1","type":"function"},{"doc":"Confirms that all action types declared on a resource are supported by its data layer","ref":"Ash.Resource.Transformers.ValidateActionTypesSupported.html","title":"Ash.Resource.Transformers.ValidateActionTypesSupported","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.ValidateActionTypesSupported.html#after_compile?/0","title":"Ash.Resource.Transformers.ValidateActionTypesSupported.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.ValidateActionTypesSupported.html#after?/1","title":"Ash.Resource.Transformers.ValidateActionTypesSupported.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.ValidateActionTypesSupported.html#before?/1","title":"Ash.Resource.Transformers.ValidateActionTypesSupported.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.ValidateActionTypesSupported.html#transform/1","title":"Ash.Resource.Transformers.ValidateActionTypesSupported.transform/1","type":"function"},{"doc":"Confirms that all aggregates are supported by the data layer","ref":"Ash.Resource.Transformers.ValidateAggregatesSupported.html","title":"Ash.Resource.Transformers.ValidateAggregatesSupported","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.ValidateAggregatesSupported.html#after_compile?/0","title":"Ash.Resource.Transformers.ValidateAggregatesSupported.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.ValidateAggregatesSupported.html#after?/1","title":"Ash.Resource.Transformers.ValidateAggregatesSupported.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.ValidateAggregatesSupported.html#before?/1","title":"Ash.Resource.Transformers.ValidateAggregatesSupported.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.ValidateAggregatesSupported.html#transform/1","title":"Ash.Resource.Transformers.ValidateAggregatesSupported.transform/1","type":"function"},{"doc":"Confirms that eager identities are not declared on a resource with no primary read.","ref":"Ash.Resource.Transformers.ValidateEagerIdentities.html","title":"Ash.Resource.Transformers.ValidateEagerIdentities","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.ValidateEagerIdentities.html#after_compile?/0","title":"Ash.Resource.Transformers.ValidateEagerIdentities.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.ValidateEagerIdentities.html#after?/1","title":"Ash.Resource.Transformers.ValidateEagerIdentities.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.ValidateEagerIdentities.html#before?/1","title":"Ash.Resource.Transformers.ValidateEagerIdentities.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.ValidateEagerIdentities.html#transform/1","title":"Ash.Resource.Transformers.ValidateEagerIdentities.transform/1","type":"function"},{"doc":"Confirms that all action types declared on a resource are supported by its data layer","ref":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts.html","title":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts.html#after_compile?/0","title":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts.html#after?/1","title":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts.html#before?/1","title":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts.html#transform/1","title":"Ash.Resource.Transformers.ValidateManagedRelationshipOpts.transform/1","type":"function"},{"doc":"Ensures that the multitenancy configuration is valid for the given resource","ref":"Ash.Resource.Transformers.ValidateMultitenancy.html","title":"Ash.Resource.Transformers.ValidateMultitenancy","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.ValidateMultitenancy.html#after_compile?/0","title":"Ash.Resource.Transformers.ValidateMultitenancy.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.ValidateMultitenancy.html#after?/1","title":"Ash.Resource.Transformers.ValidateMultitenancy.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.ValidateMultitenancy.html#before?/1","title":"Ash.Resource.Transformers.ValidateMultitenancy.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.ValidateMultitenancy.html#transform/1","title":"Ash.Resource.Transformers.ValidateMultitenancy.transform/1","type":"function"},{"doc":"Validates the primary action configuration If multiple primary actions exist this results in an error.","ref":"Ash.Resource.Transformers.ValidatePrimaryActions.html","title":"Ash.Resource.Transformers.ValidatePrimaryActions","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.ValidatePrimaryActions.html#after_compile?/0","title":"Ash.Resource.Transformers.ValidatePrimaryActions.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.ValidatePrimaryActions.html#after?/1","title":"Ash.Resource.Transformers.ValidatePrimaryActions.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.ValidatePrimaryActions.html#before?/1","title":"Ash.Resource.Transformers.ValidatePrimaryActions.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.ValidatePrimaryActions.html#transform/1","title":"Ash.Resource.Transformers.ValidatePrimaryActions.transform/1","type":"function"},{"doc":"Validates and caches the primary key of a resource","ref":"Ash.Resource.Transformers.ValidatePrimaryKey.html","title":"Ash.Resource.Transformers.ValidatePrimaryKey","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"Ash.Resource.Transformers.ValidatePrimaryKey.html#after_compile?/0","title":"Ash.Resource.Transformers.ValidatePrimaryKey.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.ValidatePrimaryKey.html#after?/1","title":"Ash.Resource.Transformers.ValidatePrimaryKey.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.ValidatePrimaryKey.html#before?/1","title":"Ash.Resource.Transformers.ValidatePrimaryKey.before?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"Ash.Resource.Transformers.ValidatePrimaryKey.html#transform/1","title":"Ash.Resource.Transformers.ValidatePrimaryKey.transform/1","type":"function"},{"doc":"Validates that all relationships point to valid fields","ref":"Ash.Resource.Transformers.ValidateRelationshipAttributes.html","title":"Ash.Resource.Transformers.ValidateRelationshipAttributes","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"Ash.Resource.Transformers.ValidateRelationshipAttributes.html#after?/1","title":"Ash.Resource.Transformers.ValidateRelationshipAttributes.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"Ash.Resource.Transformers.ValidateRelationshipAttributes.html#before?/1","title":"Ash.Resource.Transformers.ValidateRelationshipAttributes.before?/1","type":"function"},{"doc":"Generate Mermaid diagrams from a specified API. Limitations We can't easily model Ash relationships with Mermaid diagrams because they are unidirectional and could be asymmetric. Mermaid assumes symmetrical, bidirectional relationships. If we try to model all unidirectional relationships as separate lines in the diagram it gets very hard to read very quickly.","ref":"Ash.Api.Info.Diagram.html","title":"Ash.Api.Info.Diagram","type":"module"},{"doc":"Generates a Mermaid Class Diagram for a given API. Shows only public attributes, calculations, aggregates and actions. Shows a connecting line for relationships with the type of relationship indicated in the attribute list.","ref":"Ash.Api.Info.Diagram.html#mermaid_class_diagram/2","title":"Ash.Api.Info.Diagram.mermaid_class_diagram/2","type":"function"},{"doc":"Generates a Mermaid Entity Relationship Diagram for a given API. Shows only public attributes, calculations, aggregates and actions. Shows a one-to-one line for relationships as enumerating all unidirectional relationships is far too noisy.","ref":"Ash.Api.Info.Diagram.html#mermaid_er_diagram/2","title":"Ash.Api.Info.Diagram.mermaid_er_diagram/2","type":"function"},{"doc":"Generate a Livebook from a specified API.","ref":"Ash.Api.Info.Livebook.html","title":"Ash.Api.Info.Livebook","type":"module"},{"doc":"","ref":"Ash.Api.Info.Livebook.html#action_header/0","title":"Ash.Api.Info.Livebook.action_header/0","type":"function"},{"doc":"","ref":"Ash.Api.Info.Livebook.html#action_input_section/2","title":"Ash.Api.Info.Livebook.action_input_section/2","type":"function"},{"doc":"","ref":"Ash.Api.Info.Livebook.html#action_section/2","title":"Ash.Api.Info.Livebook.action_section/2","type":"function"},{"doc":"","ref":"Ash.Api.Info.Livebook.html#api_section/1","title":"Ash.Api.Info.Livebook.api_section/1","type":"function"},{"doc":"","ref":"Ash.Api.Info.Livebook.html#attr_header/0","title":"Ash.Api.Info.Livebook.attr_header/0","type":"function"},{"doc":"","ref":"Ash.Api.Info.Livebook.html#attr_section/1","title":"Ash.Api.Info.Livebook.attr_section/1","type":"function"},{"doc":"","ref":"Ash.Api.Info.Livebook.html#overview/1","title":"Ash.Api.Info.Livebook.overview/1","type":"function"},{"doc":"","ref":"Ash.Api.Info.Livebook.html#resource_section/1","title":"Ash.Api.Info.Livebook.resource_section/1","type":"function"},{"doc":"","ref":"Ash.EmbeddableType.ShadowApi.html","title":"Ash.EmbeddableType.ShadowApi","type":"module"},{"doc":"","ref":"Ash.EmbeddableType.ShadowApi.html#aggregate!/3","title":"Ash.EmbeddableType.ShadowApi.aggregate!/3","type":"function"},{"doc":"","ref":"Ash.EmbeddableType.ShadowApi.html#aggregate/3","title":"Ash.EmbeddableType.ShadowApi.aggregate/3","type":"function"},{"doc":"Get the avg of the given field from the given query, raising any errors.","ref":"Ash.EmbeddableType.ShadowApi.html#avg!/3","title":"Ash.EmbeddableType.ShadowApi.avg!/3","type":"function"},{"doc":"Get the avg of the given field from the given query.","ref":"Ash.EmbeddableType.ShadowApi.html#avg/3","title":"Ash.EmbeddableType.ShadowApi.avg/3","type":"function"},{"doc":"Callback implementation for Ash.Api.calculate!/3 .","ref":"Ash.EmbeddableType.ShadowApi.html#calculate!/3","title":"Ash.EmbeddableType.ShadowApi.calculate!/3","type":"function"},{"doc":"Callback implementation for Ash.Api.calculate/3 .","ref":"Ash.EmbeddableType.ShadowApi.html#calculate/3","title":"Ash.EmbeddableType.ShadowApi.calculate/3","type":"function"},{"doc":"Get the count of results that a query would return, raising any errors.","ref":"Ash.EmbeddableType.ShadowApi.html#count!/2","title":"Ash.EmbeddableType.ShadowApi.count!/2","type":"function"},{"doc":"Get the count of results that a query would return.","ref":"Ash.EmbeddableType.ShadowApi.html#count/2","title":"Ash.EmbeddableType.ShadowApi.count/2","type":"function"},{"doc":"Callback implementation for Ash.Api.create!/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#create!/2","title":"Ash.EmbeddableType.ShadowApi.create!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.create/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#create/2","title":"Ash.EmbeddableType.ShadowApi.create/2","type":"function"},{"doc":"","ref":"Ash.EmbeddableType.ShadowApi.html#default_short_name/0","title":"Ash.EmbeddableType.ShadowApi.default_short_name/0","type":"function"},{"doc":"Callback implementation for Ash.Api.destroy!/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#destroy!/2","title":"Ash.EmbeddableType.ShadowApi.destroy!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.destroy/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#destroy/2","title":"Ash.EmbeddableType.ShadowApi.destroy/2","type":"function"},{"doc":"Get the first of the given field from the given query, raising any errors.","ref":"Ash.EmbeddableType.ShadowApi.html#first!/3","title":"Ash.EmbeddableType.ShadowApi.first!/3","type":"function"},{"doc":"Get the first of the given field from the given query.","ref":"Ash.EmbeddableType.ShadowApi.html#first/3","title":"Ash.EmbeddableType.ShadowApi.first/3","type":"function"},{"doc":"Callback implementation for Ash.Api.get!/3 .","ref":"Ash.EmbeddableType.ShadowApi.html#get!/3","title":"Ash.EmbeddableType.ShadowApi.get!/3","type":"function"},{"doc":"Callback implementation for Ash.Api.get/3 .","ref":"Ash.EmbeddableType.ShadowApi.html#get/3","title":"Ash.EmbeddableType.ShadowApi.get/3","type":"function"},{"doc":"Get the list of the given field from the given query, raising any errors.","ref":"Ash.EmbeddableType.ShadowApi.html#list!/3","title":"Ash.EmbeddableType.ShadowApi.list!/3","type":"function"},{"doc":"Get the list of the given field from the given query.","ref":"Ash.EmbeddableType.ShadowApi.html#list/3","title":"Ash.EmbeddableType.ShadowApi.list/3","type":"function"},{"doc":"Callback implementation for Ash.Api.load!/3 .","ref":"Ash.EmbeddableType.ShadowApi.html#load!/3","title":"Ash.EmbeddableType.ShadowApi.load!/3","type":"function"},{"doc":"Callback implementation for Ash.Api.load/3 .","ref":"Ash.EmbeddableType.ShadowApi.html#load/3","title":"Ash.EmbeddableType.ShadowApi.load/3","type":"function"},{"doc":"Get the max of the given field from the given query, raising any errors.","ref":"Ash.EmbeddableType.ShadowApi.html#max!/3","title":"Ash.EmbeddableType.ShadowApi.max!/3","type":"function"},{"doc":"Get the max of the given field from the given query.","ref":"Ash.EmbeddableType.ShadowApi.html#max/3","title":"Ash.EmbeddableType.ShadowApi.max/3","type":"function"},{"doc":"Get the min of the given field from the given query, raising any errors.","ref":"Ash.EmbeddableType.ShadowApi.html#min!/3","title":"Ash.EmbeddableType.ShadowApi.min!/3","type":"function"},{"doc":"Get the min of the given field from the given query.","ref":"Ash.EmbeddableType.ShadowApi.html#min/3","title":"Ash.EmbeddableType.ShadowApi.min/3","type":"function"},{"doc":"Callback implementation for Ash.Api.page!/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#page!/2","title":"Ash.EmbeddableType.ShadowApi.page!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.page/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#page/2","title":"Ash.EmbeddableType.ShadowApi.page/2","type":"function"},{"doc":"Callback implementation for Ash.Api.read!/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#read!/2","title":"Ash.EmbeddableType.ShadowApi.read!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.read/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#read/2","title":"Ash.EmbeddableType.ShadowApi.read/2","type":"function"},{"doc":"Callback implementation for Ash.Api.read_one!/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#read_one!/2","title":"Ash.EmbeddableType.ShadowApi.read_one!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.read_one/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#read_one/2","title":"Ash.EmbeddableType.ShadowApi.read_one/2","type":"function"},{"doc":"Callback implementation for Ash.Api.reload!/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#reload!/2","title":"Ash.EmbeddableType.ShadowApi.reload!/2","type":"function"},{"doc":"","ref":"Ash.EmbeddableType.ShadowApi.html#reload/2","title":"Ash.EmbeddableType.ShadowApi.reload/2","type":"function"},{"doc":"","ref":"Ash.EmbeddableType.ShadowApi.html#spark_dsl_config/0","title":"Ash.EmbeddableType.ShadowApi.spark_dsl_config/0","type":"function"},{"doc":"","ref":"Ash.EmbeddableType.ShadowApi.html#spark_is/0","title":"Ash.EmbeddableType.ShadowApi.spark_is/0","type":"function"},{"doc":"Get the sum of the given field from the given query, raising any errors.","ref":"Ash.EmbeddableType.ShadowApi.html#sum!/3","title":"Ash.EmbeddableType.ShadowApi.sum!/3","type":"function"},{"doc":"Get the sum of the given field from the given query.","ref":"Ash.EmbeddableType.ShadowApi.html#sum/3","title":"Ash.EmbeddableType.ShadowApi.sum/3","type":"function"},{"doc":"Callback implementation for Ash.Api.update!/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#update!/2","title":"Ash.EmbeddableType.ShadowApi.update!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.update/2 .","ref":"Ash.EmbeddableType.ShadowApi.html#update/2","title":"Ash.EmbeddableType.ShadowApi.update/2","type":"function"},{"doc":"The Ash engine handles the parallelization/running of requests to Ash. Much of the complexity of this doesn't come into play for simple requests. The way it works is that it accepts a list of Ash.Engine.Request structs. Some of values on those structs will be instances of Ash.Engine.Request.UnresolvedField . These unresolved fields can express a dependence on the field values from other requests. This allows the engine to wait on executing some code until it has its required inputs, or if all of its dependencies are met, it can execute it immediately. The engine's job is to resolve its unresolved fields in the proper order, potentially in parallel. It also has knowledge baked in about certain special fields, like data which is the field we are ultimately trying to resolve, and query which is the field that drives authorization for read requests. Authorization is done on a per engine request basis. As the complexity of a system grows, it becomes very difficult to write code that is both imperative and performant. This is especially true of a framework that is designed to be configurable. What exactly is done, as well as the order it is done in, and whether or not is can be parallelized, varies wildly based on factors like how the resources are configured and what capabilities the data layer has. By implementing a generic &quot;parallel engine&quot;, we can let the engine solve that problem. We only have to express the various operations that must happen, and what other pieces of data they need in order to happen, and the engine handles the rest. There are various tradeoffs in the current design. The original version of the engine started a process for each request. While this had the least constrained performance characteristics of all the designs, it was problematic for various reasons. The primary reason being that it could deadlock without any reasonable way to debug said deadlock because the various states were distributed. The second version of the engine introduced a central Engine process that helped with some of these issues, but ultimately had the same problem. The third (and current) version of the engine is reworked instead to be drastically simpler, potentially at the expense of performance for some requests. Instead of starting a process per request, it opts to only parallelize the data field resolution of fields that are marked as async?: true , (unlike the previous versions which started a process for the whole request.) Although it does its best to prioritize starting any async tasks, it is possible that if some mix of async/sync requests are passed in a potentially long running sync task could prevent it from starting an async task, giving this potentially worse performance characteristics. In practice, this doesn't really matter because the robust data layers support running asynchronously, unless they are in a transaction in which case everything runs serially anyway. The current version of the engine can be seen as an event loop that will async some events and yield them. It also has support for a concurrency limit (per engine invocation, not globally, although that could now be added much more easily). This limit defaults to 2 * schedulers_online . Check out the docs for Ash.Engine.Request for some more information. This is a private interface at the moment, though, so this documentation is just here to explain how it works it is not intended to give you enough information to use the engine directly.","ref":"Ash.Engine.html","title":"Ash.Engine","type":"module"},{"doc":"","ref":"Ash.Engine.html#add_requests/2","title":"Ash.Engine.add_requests/2","type":"function"},{"doc":"","ref":"Ash.Engine.html#do_run/2","title":"Ash.Engine.do_run/2","type":"function"},{"doc":"","ref":"Ash.Engine.html#long_breakdown/1","title":"Ash.Engine.long_breakdown/1","type":"function"},{"doc":"","ref":"Ash.Engine.html#put_nested_key/3","title":"Ash.Engine.put_nested_key/3","type":"function"},{"doc":"","ref":"Ash.Engine.html#run/2","title":"Ash.Engine.run/2","type":"function"},{"doc":"Represents an individual request to be processed by the engine. See new/1 for more information","ref":"Ash.Engine.Request.html","title":"Ash.Engine.Request","type":"module"},{"doc":"","ref":"Ash.Engine.Request.html#add_initial_authorizer_state/1","title":"Ash.Engine.Request.add_initial_authorizer_state/1","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#do_next/1","title":"Ash.Engine.Request.do_next/1","type":"function"},{"doc":"Creates a new request. The field values may be explicit values, or they may be instances of UnresolvedField . When other requests depend on a value from this request, they will not be sent unless this request has completed its authorization (or this request has been configured not to do authorization). This allows requests to depend on each other without those requests happening just before a request fails with a forbidden error. These fields are data , query , changeset and authorized? . A field may not be resolved if the data of a request has been resolved and no other requests depend on that field. Options: query - The query to be used to fetch data. Used to authorize reads. data - The ultimate goal of a request is to compute the data resource - The primary resource of the request. Used for opening transactions on creates/updates/destroys changeset - Any changes to be made to the resource. Used to authorize writes. path - The path of the request. This serves as a unique id, and is the way that other requests can refer to this one action_type - The action_type of the request action - The action being performed on the data async? - Whether or not the request can be asynchronous, defaults to true . api - The api module being called name - A human readable name for the request, used when logging/in errors strict_check_only? - If true, authorization will not be allowed to proceed to a runtime check (so it cannot run db queries unless authorization is assured) actor - The actor performing the action, used for authorization authorize? - Whether or not to perform authorization (defaults to true) verbose? - print informational logs (warning, this will be a whole lot of logs) write_to_data? - If set to false, this value is not returned from the initial call to the engine","ref":"Ash.Engine.Request.html#new/1","title":"Ash.Engine.Request.new/1","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#next/1","title":"Ash.Engine.Request.next/1","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#put_dependency_data/3","title":"Ash.Engine.Request.put_dependency_data/3","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#receive_field/4","title":"Ash.Engine.Request.receive_field/4","type":"function"},{"doc":"Create an unresolved field. Can have dependencies, which is a list of atoms. All elements before the last comprise the path of a request that is also being processed, like [:data] , and the last element is the key of that request that is required. Make sure to pass a list of lists of atoms. The second argument is a map, which contains all of the values you requested, at the same path that they were requested. For example: resolve ( [ [ :data , :query ] , [ :data , :data ] ] , fn %{ data : %{ query : query , data : data } } -&gt; data # This is the data field of the [:data] request query # This is the query field of the [:data] request { :ok , result } # or { :error , error } # or result end )","ref":"Ash.Engine.Request.html#resolve/2","title":"Ash.Engine.Request.resolve/2","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#resource_notification/1","title":"Ash.Engine.Request.resource_notification/1","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#send_field/3","title":"Ash.Engine.Request.send_field/3","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#sort_and_clean_notifications/1","title":"Ash.Engine.Request.sort_and_clean_notifications/1","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#store_dependency/4","title":"Ash.Engine.Request.store_dependency/4","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#summarize/1","title":"Ash.Engine.Request.summarize/1","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#validate_requests!/1","title":"Ash.Engine.Request.validate_requests!/1","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#wont_receive/3","title":"Ash.Engine.Request.wont_receive/3","type":"function"},{"doc":"","ref":"Ash.Engine.Request.html#t:t/0","title":"Ash.Engine.Request.t/0","type":"type"},{"doc":"Represents an unresolved field to be resolved by the engine.","ref":"Ash.Engine.Request.UnresolvedField.html","title":"Ash.Engine.Request.UnresolvedField","type":"module"},{"doc":"","ref":"Ash.Engine.Request.UnresolvedField.html#new/2","title":"Ash.Engine.Request.UnresolvedField.new/2","type":"function"},{"doc":"","ref":"Ash.Engine.Request.UnresolvedField.html#t:t/0","title":"Ash.Engine.Request.UnresolvedField.t/0","type":"type"},{"doc":"Tools to build Ash expressions","ref":"Ash.Expr.html","title":"Ash.Expr","type":"module"},{"doc":"Evaluate an expression. See eval/2 for more.","ref":"Ash.Expr.html#eval!/2","title":"Ash.Expr.eval!/2","type":"function"},{"doc":"Evaluate an expression. This function only works if you have no references, or if you provide the record option.","ref":"Ash.Expr.html#eval/2","title":"Ash.Expr.eval/2","type":"function"},{"doc":"","ref":"Ash.Expr.html#expr/1","title":"Ash.Expr.expr/1","type":"macro"},{"doc":"","ref":"Ash.Expr.html#or_where/2","title":"Ash.Expr.or_where/2","type":"macro"},{"doc":"","ref":"Ash.Expr.html#where/2","title":"Ash.Expr.where/2","type":"macro"},{"doc":"","ref":"Ash.Expr.html#t:t/0","title":"Ash.Expr.t/0","type":"type"},{"doc":"Represents a predicate which can be simplified and/or compared with other predicates Simplification and comparison will need more documentation, but ultimately it is the logic that allows us to have a flexible and powerful authorization system.","ref":"Ash.Filter.Predicate.html","title":"Ash.Filter.Predicate","type":"behaviour"},{"doc":"As long as at least one predicate of the type defined in your module, (and this callback is implemented), it will be called with all of the other predicates present in a filter. The return value is relatively complex, but it should be a list of boolean statements. E.g. {op, left, right} and {:not, predicate} (nested as deep as necessary). The best way to do it is to find lists of predicates that are mutually exclusive or mutually inclusive, and pass those lists into Ash.SatSolver.mutually_exclusive/1 and Ash.SatSolver.mutually_inclusive/1","ref":"Ash.Filter.Predicate.html#c:bulk_compare/1","title":"Ash.Filter.Predicate.bulk_compare/1","type":"callback"},{"doc":"Checks with each predicate module to see if it has a comparison with","ref":"Ash.Filter.Predicate.html#compare/2","title":"Ash.Filter.Predicate.compare/2","type":"function"},{"doc":"Compare two predicates. If possible, use bulk_compare/1 instead","ref":"Ash.Filter.Predicate.html#c:compare/2","title":"Ash.Filter.Predicate.compare/2","type":"callback"},{"doc":"Simplify to a more primitive statement. For example, x in [1, 2] simplifies to x == 1 or x == 2 . Simplifying to filter expressions that already have comparisons lets you avoid writing that logic for a given predicate.","ref":"Ash.Filter.Predicate.html#c:simplify/1","title":"Ash.Filter.Predicate.simplify/1","type":"callback"},{"doc":"","ref":"Ash.Filter.Predicate.html#t:comparison/0","title":"Ash.Filter.Predicate.comparison/0","type":"type"},{"doc":"","ref":"Ash.Filter.Predicate.html#t:predicate/0","title":"Ash.Filter.Predicate.predicate/0","type":"type"},{"doc":"","ref":"Ash.Filter.ShadowApi.html","title":"Ash.Filter.ShadowApi","type":"module"},{"doc":"","ref":"Ash.Filter.ShadowApi.html#aggregate!/3","title":"Ash.Filter.ShadowApi.aggregate!/3","type":"function"},{"doc":"","ref":"Ash.Filter.ShadowApi.html#aggregate/3","title":"Ash.Filter.ShadowApi.aggregate/3","type":"function"},{"doc":"Get the avg of the given field from the given query, raising any errors.","ref":"Ash.Filter.ShadowApi.html#avg!/3","title":"Ash.Filter.ShadowApi.avg!/3","type":"function"},{"doc":"Get the avg of the given field from the given query.","ref":"Ash.Filter.ShadowApi.html#avg/3","title":"Ash.Filter.ShadowApi.avg/3","type":"function"},{"doc":"Callback implementation for Ash.Api.calculate!/3 .","ref":"Ash.Filter.ShadowApi.html#calculate!/3","title":"Ash.Filter.ShadowApi.calculate!/3","type":"function"},{"doc":"Callback implementation for Ash.Api.calculate/3 .","ref":"Ash.Filter.ShadowApi.html#calculate/3","title":"Ash.Filter.ShadowApi.calculate/3","type":"function"},{"doc":"Get the count of results that a query would return, raising any errors.","ref":"Ash.Filter.ShadowApi.html#count!/2","title":"Ash.Filter.ShadowApi.count!/2","type":"function"},{"doc":"Get the count of results that a query would return.","ref":"Ash.Filter.ShadowApi.html#count/2","title":"Ash.Filter.ShadowApi.count/2","type":"function"},{"doc":"Callback implementation for Ash.Api.create!/2 .","ref":"Ash.Filter.ShadowApi.html#create!/2","title":"Ash.Filter.ShadowApi.create!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.create/2 .","ref":"Ash.Filter.ShadowApi.html#create/2","title":"Ash.Filter.ShadowApi.create/2","type":"function"},{"doc":"","ref":"Ash.Filter.ShadowApi.html#default_short_name/0","title":"Ash.Filter.ShadowApi.default_short_name/0","type":"function"},{"doc":"Callback implementation for Ash.Api.destroy!/2 .","ref":"Ash.Filter.ShadowApi.html#destroy!/2","title":"Ash.Filter.ShadowApi.destroy!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.destroy/2 .","ref":"Ash.Filter.ShadowApi.html#destroy/2","title":"Ash.Filter.ShadowApi.destroy/2","type":"function"},{"doc":"Get the first of the given field from the given query, raising any errors.","ref":"Ash.Filter.ShadowApi.html#first!/3","title":"Ash.Filter.ShadowApi.first!/3","type":"function"},{"doc":"Get the first of the given field from the given query.","ref":"Ash.Filter.ShadowApi.html#first/3","title":"Ash.Filter.ShadowApi.first/3","type":"function"},{"doc":"Callback implementation for Ash.Api.get!/3 .","ref":"Ash.Filter.ShadowApi.html#get!/3","title":"Ash.Filter.ShadowApi.get!/3","type":"function"},{"doc":"Callback implementation for Ash.Api.get/3 .","ref":"Ash.Filter.ShadowApi.html#get/3","title":"Ash.Filter.ShadowApi.get/3","type":"function"},{"doc":"Get the list of the given field from the given query, raising any errors.","ref":"Ash.Filter.ShadowApi.html#list!/3","title":"Ash.Filter.ShadowApi.list!/3","type":"function"},{"doc":"Get the list of the given field from the given query.","ref":"Ash.Filter.ShadowApi.html#list/3","title":"Ash.Filter.ShadowApi.list/3","type":"function"},{"doc":"Callback implementation for Ash.Api.load!/3 .","ref":"Ash.Filter.ShadowApi.html#load!/3","title":"Ash.Filter.ShadowApi.load!/3","type":"function"},{"doc":"Callback implementation for Ash.Api.load/3 .","ref":"Ash.Filter.ShadowApi.html#load/3","title":"Ash.Filter.ShadowApi.load/3","type":"function"},{"doc":"Get the max of the given field from the given query, raising any errors.","ref":"Ash.Filter.ShadowApi.html#max!/3","title":"Ash.Filter.ShadowApi.max!/3","type":"function"},{"doc":"Get the max of the given field from the given query.","ref":"Ash.Filter.ShadowApi.html#max/3","title":"Ash.Filter.ShadowApi.max/3","type":"function"},{"doc":"Get the min of the given field from the given query, raising any errors.","ref":"Ash.Filter.ShadowApi.html#min!/3","title":"Ash.Filter.ShadowApi.min!/3","type":"function"},{"doc":"Get the min of the given field from the given query.","ref":"Ash.Filter.ShadowApi.html#min/3","title":"Ash.Filter.ShadowApi.min/3","type":"function"},{"doc":"Callback implementation for Ash.Api.page!/2 .","ref":"Ash.Filter.ShadowApi.html#page!/2","title":"Ash.Filter.ShadowApi.page!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.page/2 .","ref":"Ash.Filter.ShadowApi.html#page/2","title":"Ash.Filter.ShadowApi.page/2","type":"function"},{"doc":"Callback implementation for Ash.Api.read!/2 .","ref":"Ash.Filter.ShadowApi.html#read!/2","title":"Ash.Filter.ShadowApi.read!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.read/2 .","ref":"Ash.Filter.ShadowApi.html#read/2","title":"Ash.Filter.ShadowApi.read/2","type":"function"},{"doc":"Callback implementation for Ash.Api.read_one!/2 .","ref":"Ash.Filter.ShadowApi.html#read_one!/2","title":"Ash.Filter.ShadowApi.read_one!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.read_one/2 .","ref":"Ash.Filter.ShadowApi.html#read_one/2","title":"Ash.Filter.ShadowApi.read_one/2","type":"function"},{"doc":"Callback implementation for Ash.Api.reload!/2 .","ref":"Ash.Filter.ShadowApi.html#reload!/2","title":"Ash.Filter.ShadowApi.reload!/2","type":"function"},{"doc":"","ref":"Ash.Filter.ShadowApi.html#reload/2","title":"Ash.Filter.ShadowApi.reload/2","type":"function"},{"doc":"","ref":"Ash.Filter.ShadowApi.html#spark_dsl_config/0","title":"Ash.Filter.ShadowApi.spark_dsl_config/0","type":"function"},{"doc":"","ref":"Ash.Filter.ShadowApi.html#spark_is/0","title":"Ash.Filter.ShadowApi.spark_is/0","type":"function"},{"doc":"Get the sum of the given field from the given query, raising any errors.","ref":"Ash.Filter.ShadowApi.html#sum!/3","title":"Ash.Filter.ShadowApi.sum!/3","type":"function"},{"doc":"Get the sum of the given field from the given query.","ref":"Ash.Filter.ShadowApi.html#sum/3","title":"Ash.Filter.ShadowApi.sum/3","type":"function"},{"doc":"Callback implementation for Ash.Api.update!/2 .","ref":"Ash.Filter.ShadowApi.html#update!/2","title":"Ash.Filter.ShadowApi.update!/2","type":"function"},{"doc":"Callback implementation for Ash.Api.update/2 .","ref":"Ash.Filter.ShadowApi.html#update/2","title":"Ash.Filter.ShadowApi.update/2","type":"function"},{"doc":"An argument to a flow","ref":"Ash.Flow.Argument.html","title":"Ash.Flow.Argument","type":"module"},{"doc":"","ref":"Ash.Flow.Argument.html#schema/0","title":"Ash.Flow.Argument.schema/0","type":"function"},{"doc":"Executes the requests using the Ash engine, which can parallelize individual steps when possible.","ref":"Ash.Flow.Executor.AshEngine.html","title":"Ash.Flow.Executor.AshEngine","type":"module"},{"doc":"Callback implementation for Ash.Flow.Executor.build/3 .","ref":"Ash.Flow.Executor.AshEngine.html#build/3","title":"Ash.Flow.Executor.AshEngine.build/3","type":"function"},{"doc":"","ref":"Ash.Flow.Executor.AshEngine.html#deps_keys/0","title":"Ash.Flow.Executor.AshEngine.deps_keys/0","type":"function"},{"doc":"Callback implementation for Ash.Flow.Executor.execute/3 .","ref":"Ash.Flow.Executor.AshEngine.html#execute/3","title":"Ash.Flow.Executor.AshEngine.execute/3","type":"function"},{"doc":"The result of running a flow.","ref":"Ash.Flow.Result.html","title":"Ash.Flow.Result","type":"module"},{"doc":"","ref":"Ash.Flow.Result.html#t:t/0","title":"Ash.Flow.Result.t/0","type":"type"},{"doc":"Helpers for working with the Plug connection.","ref":"Ash.PlugHelpers.html","title":"Ash.PlugHelpers","type":"module"},{"doc":"Retrieves the actor from the Plug connection. The actor is stored inside the connection's private fields . Deprecation warning This function checks to see if the actor is already set in the @actor assign, and if so will emit a deprecation warning. This is to allow apps using the previous method a chance to update. Rather than setting the actor in the assigns, please use the set_actor/2 method. Example iex&gt; actor = build_actor ( %{ email : &quot;marty@1985.retro&quot; } ) ...&gt; conn = build_conn ( ) |&gt; put_private ( :ash , %{ actor : actor } ) ...&gt; actor = get_actor ( conn ) %{ email : &quot;marty@1985.retro&quot; } = actor iex&gt; actor = build_actor ( %{ email : &quot;marty@1985.retro&quot; } ) ...&gt; conn = build_conn ( ) |&gt; assign ( :actor , actor ) ...&gt; actor = get_actor ( conn ) %{ email : &quot;marty@1985.retro&quot; } = actor","ref":"Ash.PlugHelpers.html#get_actor/1","title":"Ash.PlugHelpers.get_actor/1","type":"function"},{"doc":"Retrieves the tenant from the Plug connection. The tenant is stored inside the connection's private fields . Deprecation warning This function checks to see if the tenant is already set in the @tenant assign, and if so will emit a deprecation warning. This is to allow apps using the previous method a chance to update. Rather than setting the tenant in the assigns, please use the set_tenant/2 method. Example iex&gt; tenant = build_tenant ( %{ name : &quot;Deliver-yesterday&quot; } ) ...&gt; conn = build_conn ( ) |&gt; put_private ( :ash , %{ tenant : tenant } ) ...&gt; tenant = get_tenant ( conn ) %{ name : &quot;Deliver-yesterday&quot; } = tenant iex&gt; tenant = build_tenant ( %{ name : &quot;Deliver-yesterday&quot; } ) ...&gt; conn = build_conn ( ) |&gt; assign ( :tenant , tenant ) ...&gt; tenant = get_tenant ( conn ) %{ name : &quot;Deliver-yesterday&quot; } = tenant","ref":"Ash.PlugHelpers.html#get_tenant/1","title":"Ash.PlugHelpers.get_tenant/1","type":"function"},{"doc":"Sets the actor inside the Plug connection. The actor is stored inside the connection's private fields . Example iex&gt; actor = build_actor ( %{ email : &quot;marty@1985.retro&quot; } ) ...&gt; conn = build_conn ( ) |&gt; set_actor ( actor ) % Plug.Conn { private : %{ ash : %{ actor : %{ email : &quot;marty@1985.retro&quot; } } } } = conn","ref":"Ash.PlugHelpers.html#set_actor/2","title":"Ash.PlugHelpers.set_actor/2","type":"function"},{"doc":"Sets the tenant inside the Plug connection. The tenant is stored inside the connection's private fields . Example iex&gt; tenant = build_tenant ( %{ name : &quot;Deliver-yesterday&quot; } ) ...&gt; conn = build_conn ( ) |&gt; set_tenant ( tenant ) % Plug.Conn { private : %{ ash : %{ tenant : %{ name : &quot;Deliver-yesterday&quot; } } } } = conn","ref":"Ash.PlugHelpers.html#set_tenant/2","title":"Ash.PlugHelpers.set_tenant/2","type":"function"},{"doc":"The check module used for expr s in policies","ref":"Ash.Policy.Check.Expression.html","title":"Ash.Policy.Check.Expression","type":"module"},{"doc":"Callback implementation for Ash.Policy.Check.auto_filter/3 .","ref":"Ash.Policy.Check.Expression.html#auto_filter/3","title":"Ash.Policy.Check.Expression.auto_filter/3","type":"function"},{"doc":"","ref":"Ash.Policy.Check.Expression.html#auto_filter_not/3","title":"Ash.Policy.Check.Expression.auto_filter_not/3","type":"function"},{"doc":"Callback implementation for Ash.Policy.Check.check/4 .","ref":"Ash.Policy.Check.Expression.html#check/4","title":"Ash.Policy.Check.Expression.check/4","type":"function"},{"doc":"Callback implementation for Ash.Policy.FilterCheck.reject/1 .","ref":"Ash.Policy.Check.Expression.html#reject/1","title":"Ash.Policy.Check.Expression.reject/1","type":"function"},{"doc":"Callback implementation for Ash.Policy.Check.strict_check/3 .","ref":"Ash.Policy.Check.Expression.html#strict_check/3","title":"Ash.Policy.Check.Expression.strict_check/3","type":"function"},{"doc":"","ref":"Ash.Policy.Check.Expression.html#strict_check_context/1","title":"Ash.Policy.Check.Expression.strict_check_context/1","type":"function"},{"doc":"Callback implementation for Ash.Policy.Check.type/0 .","ref":"Ash.Policy.Check.Expression.html#type/0","title":"Ash.Policy.Check.Expression.type/0","type":"function"},{"doc":"Represents a boolean expression","ref":"Ash.Query.BooleanExpression.html","title":"Ash.Query.BooleanExpression","type":"module"},{"doc":"","ref":"Ash.Query.BooleanExpression.html#new/3","title":"Ash.Query.BooleanExpression.new/3","type":"function"},{"doc":"","ref":"Ash.Query.BooleanExpression.html#optimized_new/4","title":"Ash.Query.BooleanExpression.optimized_new/4","type":"function"},{"doc":"Represents a function call/AST node in an Ash query expression","ref":"Ash.Query.Call.html","title":"Ash.Query.Call","type":"module"},{"doc":"Determines if a given related entity exists.","ref":"Ash.Query.Exists.html","title":"Ash.Query.Exists","type":"module"},{"doc":"","ref":"Ash.Query.Exists.html#new/3","title":"Ash.Query.Exists.new/3","type":"function"},{"doc":"A function is a predicate with an arguments list. For more information on being a predicate, see Ash.Filter.Predicate . Most of the complexities are there. A function must meet both behaviours.","ref":"Ash.Query.Function.html","title":"Ash.Query.Function","type":"behaviour"},{"doc":"The number and types of arguments supported.","ref":"Ash.Query.Function.html#c:args/0","title":"Ash.Query.Function.args/0","type":"callback"},{"doc":"","ref":"Ash.Query.Function.html#c:evaluate/1","title":"Ash.Query.Function.evaluate/1","type":"callback"},{"doc":"","ref":"Ash.Query.Function.html#c:new/1","title":"Ash.Query.Function.new/1","type":"callback"},{"doc":"","ref":"Ash.Query.Function.html#new/2","title":"Ash.Query.Function.new/2","type":"function"},{"doc":"Attaches the appropriate suffix to refer to an ordinal number, e.g 1 -&gt; &quot;1st&quot;","ref":"Ash.Query.Function.html#ordinal/1","title":"Ash.Query.Function.ordinal/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.html#c:private?/0","title":"Ash.Query.Function.private?/0","type":"callback"},{"doc":"","ref":"Ash.Query.Function.html#try_cast_arguments/2","title":"Ash.Query.Function.try_cast_arguments/2","type":"function"},{"doc":"","ref":"Ash.Query.Function.html#t:arg/0","title":"Ash.Query.Function.arg/0","type":"type"},{"doc":"Subtracts the given interval from the current time in UTC. For example: deleted_at &gt; ago(7, :day) Documentation + available intervals inspired by the corresponding ecto interval implementation","ref":"Ash.Query.Function.Ago.html","title":"Ash.Query.Function.Ago","type":"module"},{"doc":"","ref":"Ash.Query.Function.Ago.html#args/0","title":"Ash.Query.Function.Ago.args/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Ago.html#eager_evaluate?/0","title":"Ash.Query.Function.Ago.eager_evaluate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Ago.html#evaluate/1","title":"Ash.Query.Function.Ago.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Ago.html#name/0","title":"Ash.Query.Function.Ago.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Ago.html#new/1","title":"Ash.Query.Function.Ago.new/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Ago.html#predicate?/0","title":"Ash.Query.Function.Ago.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Ago.html#private?/0","title":"Ash.Query.Function.Ago.private?/0","type":"function"},{"doc":"Returns true if the first string contains the second. Case insensitive strings are accounted for on either side. contains(&quot;foo&quot;, &quot;fo&quot;) true contains(%Ash.CiString{:string &quot;foo&quot;}, &quot;FoO&quot;) true contains(&quot;foo&quot;, %Ash.CiString{:string &quot;FOO&quot;}) true","ref":"Ash.Query.Function.Contains.html","title":"Ash.Query.Function.Contains","type":"module"},{"doc":"","ref":"Ash.Query.Function.Contains.html#args/0","title":"Ash.Query.Function.Contains.args/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Contains.html#eager_evaluate?/0","title":"Ash.Query.Function.Contains.eager_evaluate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Contains.html#evaluate/1","title":"Ash.Query.Function.Contains.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Contains.html#name/0","title":"Ash.Query.Function.Contains.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Contains.html#new/1","title":"Ash.Query.Function.Contains.new/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Contains.html#predicate?/0","title":"Ash.Query.Function.Contains.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Contains.html#private?/0","title":"Ash.Query.Function.Contains.private?/0","type":"function"},{"doc":"Gets the value at the provided path in the value, which must be a map or embed. If you are using a datalayer that provides a type function (like AshPostgres), it is a good idea to wrap your call in that function, e.g type(author[:bio][:title], :string) , since data layers that depend on knowing types may not be able to infer the type from the path. Ash may eventually be able to figure out the type, in the case that the path consists of only embedded attributes. If an atom key is provided, access is indiscriminate of atoms vs strings. The atom key is checked first. If a string key is provided, that is the only thing that is checked. If the value will or may be a struct, be sure to use atoms. The data layer may handle this differently, for example, AshPostgres only checks strings at the data layer (because thats all it can be in the database anyway). Available in query expressions using bracket syntax, e.g foo[:bar][:baz] .","ref":"Ash.Query.Function.GetPath.html","title":"Ash.Query.Function.GetPath","type":"module"},{"doc":"","ref":"Ash.Query.Function.GetPath.html#args/0","title":"Ash.Query.Function.GetPath.args/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.GetPath.html#eager_evaluate?/0","title":"Ash.Query.Function.GetPath.eager_evaluate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.GetPath.html#evaluate/1","title":"Ash.Query.Function.GetPath.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.GetPath.html#name/0","title":"Ash.Query.Function.GetPath.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.GetPath.html#new/1","title":"Ash.Query.Function.GetPath.new/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.GetPath.html#predicate?/0","title":"Ash.Query.Function.GetPath.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.GetPath.html#private?/0","title":"Ash.Query.Function.GetPath.private?/0","type":"function"},{"doc":"If predicate is truthy, then the second argument is returned, otherwise the third.","ref":"Ash.Query.Function.If.html","title":"Ash.Query.Function.If","type":"module"},{"doc":"","ref":"Ash.Query.Function.If.html#args/0","title":"Ash.Query.Function.If.args/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.If.html#eager_evaluate?/0","title":"Ash.Query.Function.If.eager_evaluate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.If.html#evaluate/1","title":"Ash.Query.Function.If.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.If.html#name/0","title":"Ash.Query.Function.If.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.If.html#new/1","title":"Ash.Query.Function.If.new/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.If.html#predicate?/0","title":"Ash.Query.Function.If.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.If.html#private?/0","title":"Ash.Query.Function.If.private?/0","type":"function"},{"doc":"true if the provided field is nil","ref":"Ash.Query.Function.IsNil.html","title":"Ash.Query.Function.IsNil","type":"module"},{"doc":"","ref":"Ash.Query.Function.IsNil.html#args/0","title":"Ash.Query.Function.IsNil.args/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.IsNil.html#eager_evaluate?/0","title":"Ash.Query.Function.IsNil.eager_evaluate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.IsNil.html#evaluate/1","title":"Ash.Query.Function.IsNil.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.IsNil.html#name/0","title":"Ash.Query.Function.IsNil.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.IsNil.html#new/1","title":"Ash.Query.Function.IsNil.new/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.IsNil.html#predicate?/0","title":"Ash.Query.Function.IsNil.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.IsNil.html#private?/0","title":"Ash.Query.Function.IsNil.private?/0","type":"function"},{"doc":"Returns the length of a list attribute defined by the composite type {:array, Type} . length ( roles ) If the attribute allows nils: length ( roles || [ ] )","ref":"Ash.Query.Function.Length.html","title":"Ash.Query.Function.Length","type":"module"},{"doc":"","ref":"Ash.Query.Function.Length.html#args/0","title":"Ash.Query.Function.Length.args/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Length.html#eager_evaluate?/0","title":"Ash.Query.Function.Length.eager_evaluate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Length.html#evaluate/1","title":"Ash.Query.Function.Length.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Length.html#name/0","title":"Ash.Query.Function.Length.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Length.html#new/1","title":"Ash.Query.Function.Length.new/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Length.html#predicate?/0","title":"Ash.Query.Function.Length.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Length.html#private?/0","title":"Ash.Query.Function.Length.private?/0","type":"function"},{"doc":"Returns the current datetime","ref":"Ash.Query.Function.Now.html","title":"Ash.Query.Function.Now","type":"module"},{"doc":"","ref":"Ash.Query.Function.Now.html#args/0","title":"Ash.Query.Function.Now.args/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Now.html#eager_evaluate?/0","title":"Ash.Query.Function.Now.eager_evaluate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Now.html#evaluate/1","title":"Ash.Query.Function.Now.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Now.html#name/0","title":"Ash.Query.Function.Now.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Now.html#new/1","title":"Ash.Query.Function.Now.new/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Now.html#predicate?/0","title":"Ash.Query.Function.Now.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Now.html#private?/0","title":"Ash.Query.Function.Now.private?/0","type":"function"},{"doc":"Joins a list of values. Ignores nil values and concatenates the remaining non-nil values. An optional joiner can be provided. string_join ( [ first_name , last_name ] , &quot; &quot; ) string_join ( [ item_a , item_b ] )","ref":"Ash.Query.Function.StringJoin.html","title":"Ash.Query.Function.StringJoin","type":"module"},{"doc":"","ref":"Ash.Query.Function.StringJoin.html#args/0","title":"Ash.Query.Function.StringJoin.args/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.StringJoin.html#eager_evaluate?/0","title":"Ash.Query.Function.StringJoin.eager_evaluate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.StringJoin.html#evaluate/1","title":"Ash.Query.Function.StringJoin.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.StringJoin.html#name/0","title":"Ash.Query.Function.StringJoin.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.StringJoin.html#new/1","title":"Ash.Query.Function.StringJoin.new/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.StringJoin.html#predicate?/0","title":"Ash.Query.Function.StringJoin.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.StringJoin.html#private?/0","title":"Ash.Query.Function.StringJoin.private?/0","type":"function"},{"doc":"Casts the value to a given type. Can also be used to provide type hints to data layers, where appropriate.","ref":"Ash.Query.Function.Type.html","title":"Ash.Query.Function.Type","type":"module"},{"doc":"","ref":"Ash.Query.Function.Type.html#args/0","title":"Ash.Query.Function.Type.args/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Type.html#eager_evaluate?/0","title":"Ash.Query.Function.Type.eager_evaluate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Type.html#evaluate/1","title":"Ash.Query.Function.Type.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Type.html#name/0","title":"Ash.Query.Function.Type.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Type.html#new/1","title":"Ash.Query.Function.Type.new/1","type":"function"},{"doc":"","ref":"Ash.Query.Function.Type.html#predicate?/0","title":"Ash.Query.Function.Type.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Function.Type.html#private?/0","title":"Ash.Query.Function.Type.private?/0","type":"function"},{"doc":"Represents the negation of the contained expression","ref":"Ash.Query.Not.html","title":"Ash.Query.Not","type":"module"},{"doc":"","ref":"Ash.Query.Not.html#new/1","title":"Ash.Query.Not.new/1","type":"function"},{"doc":"An operator is a predicate with a left and a right For more information on being a predicate, see Ash.Filter.Predicate . Most of the complexities are there. An operator must meet both behaviours.","ref":"Ash.Query.Operator.html","title":"Ash.Query.Operator","type":"behaviour"},{"doc":"Create a new predicate. There are various return types possible: {:ok, left, right} - Return the left/right values of the operator {:ok, operator} - Return the operator itself, this or the one above are acceptable {:known, boolean} - If the value is already known, e.g 1 == 1 {:error, error} - If there was an error creating the operator","ref":"Ash.Query.Operator.html#c:new/2","title":"Ash.Query.Operator.new/2","type":"callback"},{"doc":"Create a new operator. Pass the module and the left and right values","ref":"Ash.Query.Operator.html#new/3","title":"Ash.Query.Operator.new/3","type":"function"},{"doc":"","ref":"Ash.Query.Operator.html#operator_symbols/0","title":"Ash.Query.Operator.operator_symbols/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.html#operators/0","title":"Ash.Query.Operator.operators/0","type":"function"},{"doc":"The implementation of the inspect protocol. If not defined, it will be inferred","ref":"Ash.Query.Operator.html#c:to_string/2","title":"Ash.Query.Operator.to_string/2","type":"callback"},{"doc":"","ref":"Ash.Query.Operator.Basic.html","title":"Ash.Query.Operator.Basic","type":"module"},{"doc":"","ref":"Ash.Query.Operator.Basic.html#operator_modules/0","title":"Ash.Query.Operator.Basic.operator_modules/0","type":"function"},{"doc":"left == right The simplest operator, matches if the left and right are equal. For comparison, this compares as mutually exclusive with other equality and is_nil checks that have the same reference on the left side","ref":"Ash.Query.Operator.Eq.html","title":"Ash.Query.Operator.Eq","type":"module"},{"doc":"Callback implementation for Ash.Filter.Predicate.bulk_compare/1 .","ref":"Ash.Query.Operator.Eq.html#bulk_compare/1","title":"Ash.Query.Operator.Eq.bulk_compare/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.Eq.html#evaluate/1","title":"Ash.Query.Operator.Eq.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.Eq.html#name/0","title":"Ash.Query.Operator.Eq.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.Eq.html#new/2","title":"Ash.Query.Operator.Eq.new/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.Eq.html#operator/0","title":"Ash.Query.Operator.Eq.operator/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.Eq.html#predicate?/0","title":"Ash.Query.Operator.Eq.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.Eq.html#to_string/2","title":"Ash.Query.Operator.Eq.to_string/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.Eq.html#types/0","title":"Ash.Query.Operator.Eq.types/0","type":"function"},{"doc":"left &gt; right In comparison, simplifies to not(left &lt; right + 1) , so it will never need to be compared against.","ref":"Ash.Query.Operator.GreaterThan.html","title":"Ash.Query.Operator.GreaterThan","type":"module"},{"doc":"","ref":"Ash.Query.Operator.GreaterThan.html#evaluate/1","title":"Ash.Query.Operator.GreaterThan.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThan.html#name/0","title":"Ash.Query.Operator.GreaterThan.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThan.html#new/2","title":"Ash.Query.Operator.GreaterThan.new/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThan.html#operator/0","title":"Ash.Query.Operator.GreaterThan.operator/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThan.html#predicate?/0","title":"Ash.Query.Operator.GreaterThan.predicate?/0","type":"function"},{"doc":"Callback implementation for Ash.Filter.Predicate.simplify/1 .","ref":"Ash.Query.Operator.GreaterThan.html#simplify/1","title":"Ash.Query.Operator.GreaterThan.simplify/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThan.html#to_string/2","title":"Ash.Query.Operator.GreaterThan.to_string/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThan.html#types/0","title":"Ash.Query.Operator.GreaterThan.types/0","type":"function"},{"doc":"left &gt;= right In comparison, simplifies to not(left &lt; right) , so it will never need to be compared against.","ref":"Ash.Query.Operator.GreaterThanOrEqual.html","title":"Ash.Query.Operator.GreaterThanOrEqual","type":"module"},{"doc":"","ref":"Ash.Query.Operator.GreaterThanOrEqual.html#evaluate/1","title":"Ash.Query.Operator.GreaterThanOrEqual.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThanOrEqual.html#name/0","title":"Ash.Query.Operator.GreaterThanOrEqual.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThanOrEqual.html#new/2","title":"Ash.Query.Operator.GreaterThanOrEqual.new/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThanOrEqual.html#operator/0","title":"Ash.Query.Operator.GreaterThanOrEqual.operator/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThanOrEqual.html#predicate?/0","title":"Ash.Query.Operator.GreaterThanOrEqual.predicate?/0","type":"function"},{"doc":"Callback implementation for Ash.Filter.Predicate.simplify/1 .","ref":"Ash.Query.Operator.GreaterThanOrEqual.html#simplify/1","title":"Ash.Query.Operator.GreaterThanOrEqual.simplify/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThanOrEqual.html#to_string/2","title":"Ash.Query.Operator.GreaterThanOrEqual.to_string/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.GreaterThanOrEqual.html#types/0","title":"Ash.Query.Operator.GreaterThanOrEqual.types/0","type":"function"},{"doc":"left in [1, 2, 3] this predicate matches if the left is in the list on the right For comparison, this simplifies to a set of &quot;or equals&quot;, e.g {:or, {:or, {:or, left == 1}, left == 2}, left == 3}","ref":"Ash.Query.Operator.In.html","title":"Ash.Query.Operator.In","type":"module"},{"doc":"Callback implementation for Ash.Filter.Predicate.compare/2 .","ref":"Ash.Query.Operator.In.html#compare/2","title":"Ash.Query.Operator.In.compare/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.In.html#evaluate/1","title":"Ash.Query.Operator.In.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.In.html#name/0","title":"Ash.Query.Operator.In.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.In.html#new/2","title":"Ash.Query.Operator.In.new/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.In.html#operator/0","title":"Ash.Query.Operator.In.operator/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.In.html#predicate?/0","title":"Ash.Query.Operator.In.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.In.html#to_string/2","title":"Ash.Query.Operator.In.to_string/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.In.html#types/0","title":"Ash.Query.Operator.In.types/0","type":"function"},{"doc":"left is_nil true/false This predicate matches if the left is nil when the right is true or if the left is not nil when the right is false","ref":"Ash.Query.Operator.IsNil.html","title":"Ash.Query.Operator.IsNil","type":"module"},{"doc":"Callback implementation for Ash.Filter.Predicate.compare/2 .","ref":"Ash.Query.Operator.IsNil.html#compare/2","title":"Ash.Query.Operator.IsNil.compare/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.IsNil.html#evaluate/1","title":"Ash.Query.Operator.IsNil.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.IsNil.html#name/0","title":"Ash.Query.Operator.IsNil.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.IsNil.html#new/2","title":"Ash.Query.Operator.IsNil.new/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.IsNil.html#operator/0","title":"Ash.Query.Operator.IsNil.operator/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.IsNil.html#predicate?/0","title":"Ash.Query.Operator.IsNil.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.IsNil.html#to_string/2","title":"Ash.Query.Operator.IsNil.to_string/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.IsNil.html#types/0","title":"Ash.Query.Operator.IsNil.types/0","type":"function"},{"doc":"left &lt; right Does not simplify, but is used as the simplification value for Ash.Query.Operator.LessThanOrEqual , Ash.Query.Operator.GreaterThan and Ash.Query.Operator.GreaterThanOrEqual . When comparing predicates, it is mutually exclusive with Ash.Query.Operator.IsNil . Additionally, it compares as mutually inclusive with any Ash.Query.Operator.Eq and any Ash.Query.Operator.LessThan who's right sides are less than it, and mutually exclusive with any Ash.Query.Operator.Eq or Ash.Query.Operator.GreaterThan who's right side's are greater than or equal to it.","ref":"Ash.Query.Operator.LessThan.html","title":"Ash.Query.Operator.LessThan","type":"module"},{"doc":"Callback implementation for Ash.Filter.Predicate.bulk_compare/1 .","ref":"Ash.Query.Operator.LessThan.html#bulk_compare/1","title":"Ash.Query.Operator.LessThan.bulk_compare/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThan.html#evaluate/1","title":"Ash.Query.Operator.LessThan.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThan.html#name/0","title":"Ash.Query.Operator.LessThan.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThan.html#new/2","title":"Ash.Query.Operator.LessThan.new/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThan.html#operator/0","title":"Ash.Query.Operator.LessThan.operator/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThan.html#predicate?/0","title":"Ash.Query.Operator.LessThan.predicate?/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThan.html#to_string/2","title":"Ash.Query.Operator.LessThan.to_string/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThan.html#types/0","title":"Ash.Query.Operator.LessThan.types/0","type":"function"},{"doc":"left &lt;= right In comparison, simplifies to left &lt; right + 1 , so it will never need to be compared against.","ref":"Ash.Query.Operator.LessThanOrEqual.html","title":"Ash.Query.Operator.LessThanOrEqual","type":"module"},{"doc":"","ref":"Ash.Query.Operator.LessThanOrEqual.html#evaluate/1","title":"Ash.Query.Operator.LessThanOrEqual.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThanOrEqual.html#name/0","title":"Ash.Query.Operator.LessThanOrEqual.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThanOrEqual.html#new/2","title":"Ash.Query.Operator.LessThanOrEqual.new/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThanOrEqual.html#operator/0","title":"Ash.Query.Operator.LessThanOrEqual.operator/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThanOrEqual.html#predicate?/0","title":"Ash.Query.Operator.LessThanOrEqual.predicate?/0","type":"function"},{"doc":"Callback implementation for Ash.Filter.Predicate.simplify/1 .","ref":"Ash.Query.Operator.LessThanOrEqual.html#simplify/1","title":"Ash.Query.Operator.LessThanOrEqual.simplify/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThanOrEqual.html#to_string/2","title":"Ash.Query.Operator.LessThanOrEqual.to_string/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.LessThanOrEqual.html#types/0","title":"Ash.Query.Operator.LessThanOrEqual.types/0","type":"function"},{"doc":"left != right In comparison, simplifies to not(left == right)","ref":"Ash.Query.Operator.NotEq.html","title":"Ash.Query.Operator.NotEq","type":"module"},{"doc":"","ref":"Ash.Query.Operator.NotEq.html#evaluate/1","title":"Ash.Query.Operator.NotEq.evaluate/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.NotEq.html#name/0","title":"Ash.Query.Operator.NotEq.name/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.NotEq.html#new/2","title":"Ash.Query.Operator.NotEq.new/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.NotEq.html#operator/0","title":"Ash.Query.Operator.NotEq.operator/0","type":"function"},{"doc":"","ref":"Ash.Query.Operator.NotEq.html#predicate?/0","title":"Ash.Query.Operator.NotEq.predicate?/0","type":"function"},{"doc":"Callback implementation for Ash.Filter.Predicate.simplify/1 .","ref":"Ash.Query.Operator.NotEq.html#simplify/1","title":"Ash.Query.Operator.NotEq.simplify/1","type":"function"},{"doc":"","ref":"Ash.Query.Operator.NotEq.html#to_string/2","title":"Ash.Query.Operator.NotEq.to_string/2","type":"function"},{"doc":"","ref":"Ash.Query.Operator.NotEq.html#types/0","title":"Ash.Query.Operator.NotEq.types/0","type":"function"},{"doc":"true if the provided field is nil Used to access values from the &quot;source&quot; of a given expression. This is used in cases where expressions are given for some relationship path, for example:any() has_many :foo , Foo do filter expr ( priority == :foo and type == parent ( foo_type ) ) end This is supported on a case by case basis by a given data layer and in specific usages.","ref":"Ash.Query.Parent.html","title":"Ash.Query.Parent","type":"module"},{"doc":"","ref":"Ash.Query.Parent.html#new/1","title":"Ash.Query.Parent.new/1","type":"function"},{"doc":"Represents a relation/attribute reference","ref":"Ash.Query.Ref.html","title":"Ash.Query.Ref","type":"module"},{"doc":"Returns the referenced field","ref":"Ash.Query.Ref.html#name/1","title":"Ash.Query.Ref.name/1","type":"function"},{"doc":"Ensures that all resources for a given registry are not embeds.","ref":"Ash.Registry.ResourceValidations.Verifiers.EnsureNoEmbeds.html","title":"Ash.Registry.ResourceValidations.Verifiers.EnsureNoEmbeds","type":"module"},{"doc":"Ensures that all resources for a given registry are compiled.","ref":"Ash.Registry.ResourceValidations.Verifiers.EnsureResourcesCompiled.html","title":"Ash.Registry.ResourceValidations.Verifiers.EnsureResourcesCompiled","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Verifier.verify/1 .","ref":"Ash.Registry.ResourceValidations.Verifiers.EnsureResourcesCompiled.html#verify/1","title":"Ash.Registry.ResourceValidations.Verifiers.EnsureResourcesCompiled.verify/1","type":"function"},{"doc":"Ensures that all related resources are included in an API.","ref":"Ash.Registry.ResourceValidations.Verifiers.ValidateRelatedResourceInclusion.html","title":"Ash.Registry.ResourceValidations.Verifiers.ValidateRelatedResourceInclusion","type":"module"},{"doc":"Types for Ash actions","ref":"Ash.Resource.Actions.html","title":"Ash.Resource.Actions","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.html#t:action/0","title":"Ash.Resource.Actions.action/0","type":"type"},{"doc":"","ref":"Ash.Resource.Actions.html#t:action_type/0","title":"Ash.Resource.Actions.action_type/0","type":"type"},{"doc":"Represents an argument to an action","ref":"Ash.Resource.Actions.Argument.html","title":"Ash.Resource.Actions.Argument","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Argument.html#schema/0","title":"Ash.Resource.Actions.Argument.schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Actions.Argument.html#t:t/0","title":"Ash.Resource.Actions.Argument.t/0","type":"type"},{"doc":"Represents a create action on a resource.","ref":"Ash.Resource.Actions.Create.html","title":"Ash.Resource.Actions.Create","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Create.html#t:t/0","title":"Ash.Resource.Actions.Create.t/0","type":"type"},{"doc":"Represents a destroy action on a resource.","ref":"Ash.Resource.Actions.Destroy.html","title":"Ash.Resource.Actions.Destroy","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Destroy.html#t:t/0","title":"Ash.Resource.Actions.Destroy.t/0","type":"type"},{"doc":"Represents metadata from an action","ref":"Ash.Resource.Actions.Metadata.html","title":"Ash.Resource.Actions.Metadata","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Metadata.html#schema/0","title":"Ash.Resource.Actions.Metadata.schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Actions.Metadata.html#t:t/0","title":"Ash.Resource.Actions.Metadata.t/0","type":"type"},{"doc":"Represents a read action on a resource.","ref":"Ash.Resource.Actions.Read.html","title":"Ash.Resource.Actions.Read","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Read.html#pagination_schema/0","title":"Ash.Resource.Actions.Read.pagination_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Actions.Read.html#transform/1","title":"Ash.Resource.Actions.Read.transform/1","type":"function"},{"doc":"","ref":"Ash.Resource.Actions.Read.html#t:t/0","title":"Ash.Resource.Actions.Read.t/0","type":"type"},{"doc":"Represents the pagination configuration of a read action","ref":"Ash.Resource.Actions.Read.Pagination.html","title":"Ash.Resource.Actions.Read.Pagination","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Read.Pagination.html#transform/1","title":"Ash.Resource.Actions.Read.Pagination.transform/1","type":"function"},{"doc":"Represents a update action on a resource.","ref":"Ash.Resource.Actions.Update.html","title":"Ash.Resource.Actions.Update","type":"module"},{"doc":"","ref":"Ash.Resource.Actions.Update.html#t:t/0","title":"Ash.Resource.Actions.Update.t/0","type":"type"},{"doc":"Represents a named aggregate on the resource that can be loaded","ref":"Ash.Resource.Aggregate.html","title":"Ash.Resource.Aggregate","type":"module"},{"doc":"","ref":"Ash.Resource.Aggregate.html#relationship_path/1","title":"Ash.Resource.Aggregate.relationship_path/1","type":"function"},{"doc":"","ref":"Ash.Resource.Aggregate.html#t:t/0","title":"Ash.Resource.Aggregate.t/0","type":"type"},{"doc":"The root behavior for a custom aggregate. See data layers for their implementation of custom aggregates.","ref":"Ash.Resource.Aggregate.CustomAggregate.html","title":"Ash.Resource.Aggregate.CustomAggregate","type":"behaviour"},{"doc":"","ref":"Ash.Resource.Aggregate.CustomAggregate.html#c:describe/1","title":"Ash.Resource.Aggregate.CustomAggregate.describe/1","type":"callback"},{"doc":"","ref":"Ash.Resource.Aggregate.CustomAggregate.html#t:t/0","title":"Ash.Resource.Aggregate.CustomAggregate.t/0","type":"type"},{"doc":"Represents an attribute on a resource","ref":"Ash.Resource.Attribute.html","title":"Ash.Resource.Attribute","type":"module"},{"doc":"","ref":"Ash.Resource.Attribute.html#create_timestamp_schema/0","title":"Ash.Resource.Attribute.create_timestamp_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Attribute.html#integer_primary_key_schema/0","title":"Ash.Resource.Attribute.integer_primary_key_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Attribute.html#transform/1","title":"Ash.Resource.Attribute.transform/1","type":"function"},{"doc":"","ref":"Ash.Resource.Attribute.html#update_timestamp_schema/0","title":"Ash.Resource.Attribute.update_timestamp_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Attribute.html#uuid_primary_key_schema/0","title":"Ash.Resource.Attribute.uuid_primary_key_schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Attribute.html#t:t/0","title":"Ash.Resource.Attribute.t/0","type":"type"},{"doc":"Represents a named calculation on a resource","ref":"Ash.Resource.Calculation.html","title":"Ash.Resource.Calculation","type":"module"},{"doc":"","ref":"Ash.Resource.Calculation.html#expr_calc/1","title":"Ash.Resource.Calculation.expr_calc/1","type":"function"},{"doc":"","ref":"Ash.Resource.Calculation.html#schema/0","title":"Ash.Resource.Calculation.schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Calculation.html#t:ref/0","title":"Ash.Resource.Calculation.ref/0","type":"type"},{"doc":"","ref":"Ash.Resource.Calculation.html#t:t/0","title":"Ash.Resource.Calculation.t/0","type":"type"},{"doc":"An argument to a calculation","ref":"Ash.Resource.Calculation.Argument.html","title":"Ash.Resource.Calculation.Argument","type":"module"},{"doc":"","ref":"Ash.Resource.Calculation.Argument.html#schema/0","title":"Ash.Resource.Calculation.Argument.schema/0","type":"function"},{"doc":"Represents a function that evaluates a calculation in a resource's code interface","ref":"Ash.Resource.CalculationInterface.html","title":"Ash.Resource.CalculationInterface","type":"module"},{"doc":"","ref":"Ash.Resource.CalculationInterface.html#schema/0","title":"Ash.Resource.CalculationInterface.schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.CalculationInterface.html#transform/1","title":"Ash.Resource.CalculationInterface.transform/1","type":"function"},{"doc":"","ref":"Ash.Resource.CalculationInterface.html#t:t/0","title":"Ash.Resource.CalculationInterface.t/0","type":"type"},{"doc":"Represents a unique constraint on a resource Data layers should (and all built in ones do), discount nil or null (in the case of postgres) values when determining if a unique constraint matches. This often means that you should prefer to use identities with non-nullable columns. Eventually, features could be added to support including nil or null values, but they would need to include a corresponding feature for data layers.","ref":"Ash.Resource.Identity.html","title":"Ash.Resource.Identity","type":"module"},{"doc":"","ref":"Ash.Resource.Identity.html#keys/1","title":"Ash.Resource.Identity.keys/1","type":"function"},{"doc":"","ref":"Ash.Resource.Identity.html#schema/0","title":"Ash.Resource.Identity.schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Identity.html#t:t/0","title":"Ash.Resource.Identity.t/0","type":"type"},{"doc":"Represents a function in a resource's code interface","ref":"Ash.Resource.Interface.html","title":"Ash.Resource.Interface","type":"module"},{"doc":"","ref":"Ash.Resource.Interface.html#interface_options/1","title":"Ash.Resource.Interface.interface_options/1","type":"function"},{"doc":"","ref":"Ash.Resource.Interface.html#schema/0","title":"Ash.Resource.Interface.schema/0","type":"function"},{"doc":"","ref":"Ash.Resource.Interface.html#transform/1","title":"Ash.Resource.Interface.transform/1","type":"function"},{"doc":"","ref":"Ash.Resource.Interface.html#t:t/0","title":"Ash.Resource.Interface.t/0","type":"type"},{"doc":"Types Ash relationships","ref":"Ash.Resource.Relationships.html","title":"Ash.Resource.Relationships","type":"module"},{"doc":"","ref":"Ash.Resource.Relationships.html#t:cardinality/0","title":"Ash.Resource.Relationships.cardinality/0","type":"type"},{"doc":"","ref":"Ash.Resource.Relationships.html#t:relationship/0","title":"Ash.Resource.Relationships.relationship/0","type":"type"},{"doc":"Represents a belongs_to relationship on a resource","ref":"Ash.Resource.Relationships.BelongsTo.html","title":"Ash.Resource.Relationships.BelongsTo","type":"module"},{"doc":"","ref":"Ash.Resource.Relationships.BelongsTo.html#t:t/0","title":"Ash.Resource.Relationships.BelongsTo.t/0","type":"type"},{"doc":"Represents a has_many relationship on a resource","ref":"Ash.Resource.Relationships.HasMany.html","title":"Ash.Resource.Relationships.HasMany","type":"module"},{"doc":"","ref":"Ash.Resource.Relationships.HasMany.html#manual/1","title":"Ash.Resource.Relationships.HasMany.manual/1","type":"function"},{"doc":"","ref":"Ash.Resource.Relationships.HasMany.html#t:t/0","title":"Ash.Resource.Relationships.HasMany.t/0","type":"type"},{"doc":"Represents a has_one relationship on a resource","ref":"Ash.Resource.Relationships.HasOne.html","title":"Ash.Resource.Relationships.HasOne","type":"module"},{"doc":"","ref":"Ash.Resource.Relationships.HasOne.html#t:t/0","title":"Ash.Resource.Relationships.HasOne.t/0","type":"type"},{"doc":"Represents a many_to_many relationship on a resource","ref":"Ash.Resource.Relationships.ManyToMany.html","title":"Ash.Resource.Relationships.ManyToMany","type":"module"},{"doc":"","ref":"Ash.Resource.Relationships.ManyToMany.html#transform/1","title":"Ash.Resource.Relationships.ManyToMany.transform/1","type":"function"},{"doc":"","ref":"Ash.Resource.Relationships.ManyToMany.html#t:t/0","title":"Ash.Resource.Relationships.ManyToMany.t/0","type":"type"},{"doc":"Validates that the action is the specified action.","ref":"Ash.Resource.Validation.ActionIs.html","title":"Ash.Resource.Validation.ActionIs","type":"module"},{"doc":"Callback implementation for Ash.Resource.Validation.init/1 .","ref":"Ash.Resource.Validation.ActionIs.html#init/1","title":"Ash.Resource.Validation.ActionIs.init/1","type":"function"},{"doc":"Shows a warning on potentially incompatible relationship attributes.","ref":"Ash.Resource.Verifiers.ValidateRelationshipAttributesMatch.html","title":"Ash.Resource.Verifiers.ValidateRelationshipAttributesMatch","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Verifier.verify/1 .","ref":"Ash.Resource.Verifiers.ValidateRelationshipAttributesMatch.html#verify/1","title":"Ash.Resource.Verifiers.ValidateRelationshipAttributesMatch.verify/1","type":"function"},{"doc":"Tools for working with the satsolver that drives filter subset checking (for authorization)","ref":"Ash.SatSolver.html","title":"Ash.SatSolver","type":"module"},{"doc":"","ref":"Ash.SatSolver.html#b/1","title":"Ash.SatSolver.b/1","type":"macro"},{"doc":"","ref":"Ash.SatSolver.html#balance/1","title":"Ash.SatSolver.balance/1","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#can_be_used_as_group?/3","title":"Ash.SatSolver.can_be_used_as_group?/3","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#contains?/2","title":"Ash.SatSolver.contains?/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#expand_groups/1","title":"Ash.SatSolver.expand_groups/1","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#find_non_equal_overlap/1","title":"Ash.SatSolver.find_non_equal_overlap/1","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#fully_simplify/1","title":"Ash.SatSolver.fully_simplify/1","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#left_excludes_right/2","title":"Ash.SatSolver.left_excludes_right/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#left_implies_right/2","title":"Ash.SatSolver.left_implies_right/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#lift_equals_out_of_in/1","title":"Ash.SatSolver.lift_equals_out_of_in/1","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#mutually_exclusive/2","title":"Ash.SatSolver.mutually_exclusive/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#mutually_exclusive_and_collectively_exhaustive/1","title":"Ash.SatSolver.mutually_exclusive_and_collectively_exhaustive/1","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#mutually_inclusive/2","title":"Ash.SatSolver.mutually_inclusive/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#overlap?/2","title":"Ash.SatSolver.overlap?/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#right_excludes_left/2","title":"Ash.SatSolver.right_excludes_left/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#right_implies_left/2","title":"Ash.SatSolver.right_implies_left/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#solutions_to_predicate_values/2","title":"Ash.SatSolver.solutions_to_predicate_values/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#solve_expression/1","title":"Ash.SatSolver.solve_expression/1","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#split_in_expressions/2","title":"Ash.SatSolver.split_in_expressions/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#strict_filter_subset/2","title":"Ash.SatSolver.strict_filter_subset/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#synonymous_relationship_paths?/4","title":"Ash.SatSolver.synonymous_relationship_paths?/4","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#to_cnf/1","title":"Ash.SatSolver.to_cnf/1","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#transform/2","title":"Ash.SatSolver.transform/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#transform_and_solve/2","title":"Ash.SatSolver.transform_and_solve/2","type":"function"},{"doc":"","ref":"Ash.SatSolver.html#unbind/2","title":"Ash.SatSolver.unbind/2","type":"function"},{"doc":"A simple tracer that can send traces to the current process or call a module with the trace.","ref":"Ash.Tracer.Simple.html","title":"Ash.Tracer.Simple","type":"module"},{"doc":"","ref":"Ash.Tracer.Simple.html#gather_spans/0","title":"Ash.Tracer.Simple.gather_spans/0","type":"function"},{"doc":"A span produced by Ash.Tracer.Simple","ref":"Ash.Tracer.Simple.Span.html","title":"Ash.Tracer.Simple.Span","type":"module"},{"doc":"","ref":"Comparable.Type.Ash.CiString.To.Ash.CiString.html","title":"Comparable.Type.Ash.CiString.To.Ash.CiString","type":"module"},{"doc":"","ref":"Comparable.Type.Ash.CiString.To.BitString.html","title":"Comparable.Type.Ash.CiString.To.BitString","type":"module"},{"doc":"","ref":"Comparable.Type.BitString.To.Ash.CiString.html","title":"Comparable.Type.BitString.To.Ash.CiString","type":"module"},{"doc":"","ref":"Comparable.Type.BitString.To.Decimal.html","title":"Comparable.Type.BitString.To.Decimal","type":"module"},{"doc":"","ref":"Comparable.Type.Decimal.To.BitString.html","title":"Comparable.Type.Decimal.To.BitString","type":"module"},{"doc":"","ref":"Comparable.Type.Decimal.To.Decimal.html","title":"Comparable.Type.Decimal.To.Decimal","type":"module"},{"doc":"","ref":"Comparable.Type.Decimal.To.Float.html","title":"Comparable.Type.Decimal.To.Float","type":"module"},{"doc":"","ref":"Comparable.Type.Decimal.To.Integer.html","title":"Comparable.Type.Decimal.To.Integer","type":"module"},{"doc":"","ref":"Comparable.Type.Float.To.Decimal.html","title":"Comparable.Type.Float.To.Decimal","type":"module"},{"doc":"","ref":"Comparable.Type.Integer.To.Decimal.html","title":"Comparable.Type.Integer.To.Decimal","type":"module"},{"doc":"Mermaid Diagram helper functions.","ref":"Mix.Mermaid.html","title":"Mix.Mermaid","type":"module"},{"doc":"Generate the option string for a mermaid config file if it exists.","ref":"Mix.Mermaid.html#config/0","title":"Mix.Mermaid.config/0","type":"function"},{"doc":"Generate a Mermaid diagram using the CLI. For more info see https://github.com/mermaid-js/mermaid-cli","ref":"Mix.Mermaid.html#create_diagram/2","title":"Mix.Mermaid.create_diagram/2","type":"function"},{"doc":"Generate a diagram filename next to the source file.","ref":"Mix.Mermaid.html#file/3","title":"Mix.Mermaid.file/3","type":"function"},{"doc":"","ref":"Mix.Mermaid.html#generate_diagram/5","title":"Mix.Mermaid.generate_diagram/5","type":"function"},{"doc":"Generates a Mermaid Flow Chart for each Ash.Flow alongside the flow. If there is a run_flow step in the flow, this will also create an &quot;expanded&quot; Mermaid Flow Chart which includes all child steps. Prerequisites This mix task requires the Mermaid CLI to be installed on your system. See https://github.com/mermaid-js/mermaid-cli Command line options --only - only generates the given Flow file --format - Can be set to one of either: plain - Prints just the mermaid output as text. This is the default. md - Prints the mermaid diagram in a markdown code block. svg - Generates an SVG pdf - Generates a PDF png - Generates a PNG","ref":"Mix.Tasks.Ash.GenerateFlowCharts.html","title":"Mix.Tasks.Ash.GenerateFlowCharts","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Ash.GenerateFlowCharts.html#run/1","title":"Mix.Tasks.Ash.GenerateFlowCharts.run/1","type":"function"},{"doc":"Generates a Livebook for each Ash API. Command line options --only - only generates the given API file","ref":"Mix.Tasks.Ash.GenerateLivebook.html","title":"Mix.Tasks.Ash.GenerateLivebook","type":"task"},{"doc":"","ref":"Mix.Tasks.Ash.GenerateLivebook.html#apis/0","title":"Mix.Tasks.Ash.GenerateLivebook.apis/0","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Ash.GenerateLivebook.html#run/1","title":"Mix.Tasks.Ash.GenerateLivebook.run/1","type":"function"},{"doc":"Generates a Mermaid Resource Diagram for each Ash API. Prerequisites This mix task requires the Mermaid CLI to be installed on your system. See https://github.com/mermaid-js/mermaid-cli Command line options --type - er or class (defaults to class ) --only - only generates the given API file --format - Can be set to one of either: plain - Prints just the mermaid output as text. This is the default. md - Prints the mermaid diagram in a markdown code block. svg - Generates an SVG pdf - Generates a PDF png - Generates a PNG","ref":"Mix.Tasks.Ash.GenerateResourceDiagrams.html","title":"Mix.Tasks.Ash.GenerateResourceDiagrams","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Ash.GenerateResourceDiagrams.html#run/1","title":"Mix.Tasks.Ash.GenerateResourceDiagrams.run/1","type":"function"},{"doc":"Replaces any documentation links with text appropriate for hex docs.","ref":"Mix.Tasks.Ash.ReplaceDocLinks.html","title":"Mix.Tasks.Ash.ReplaceDocLinks","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Ash.ReplaceDocLinks.html#run/1","title":"Mix.Tasks.Ash.ReplaceDocLinks.run/1","type":"function"},{"doc":"Resource extensions allow you to make powerful modifications to resources, and extend the DSL to configure how those modifications are made. If you are using AshPostgres , AshGraphql or AshJsonApi , they are all integrated into a resource using extensions. In this guide we will build a simple extension that adds timestamps to your resource. We'll also show some simple patterns that can help ensure that all of your resources are using your extension.","ref":"extending-resources.html","title":"Extending Resources","type":"extras"},{"doc":"Extensions are modules that expose a set of DSL Transformers and DSL Sections. We'll start with the transformers. Here we create an extension called MyApp.Extensions.Base , and configure a single transformer, called MyApp.Extensions.Base.AddTimestamps defmodule MyApp.Extensions.Base do use Spark.Dsl.Extension , transformers : [ MyApp.Extensions.Base.AddTimestamps ] end","ref":"extending-resources.html#creating-an-extension","title":"Extending Resources - Creating an extension","type":"extras"},{"doc":"Transformers are all run serially against a map of data called dsl_state , which is the data structure that we build as we use the DSL. For example: attributes do attribute :name , :string end Would, under the hood, look something like this: %{ [ :attributes ] =&gt; %{ entities : [ % Ash.Resource.Attribute { name : :name , type : :string } ] } , ... } Spark.Dsl.Transformer provides utilities to work with this data structure, and most introspection utilities also work with that data structure (i.e Ash.Resource.Info.attributes(dsl_state) ). A transformer exposes transform/1 , which takes the dsl_state and returns either {:ok, dsl_state} or {:error, error} defmodule MyApp.Extensions.Base.AddTimestamps do use Spark.Dsl.Transformer alias Spark.Dsl.Transformer def transform ( dsl_state ) do { :ok , inserted_at } = Transformer . build_entity ( Ash.Resource.Dsl , [ :attributes ] , :create_timestamp , name : :inserted_at ) { :ok , updated_at } = Transformer . build_entity ( Ash.Resource.Dsl , [ :attributes ] , :update_timestamp , name : :updated_at ) { :ok , dsl_state |&gt; Transformer . add_entity ( [ :attributes ] , inserted_at ) |&gt; Transformer . add_entity ( [ :attributes ] , updated_at ) } end end This transformer builds and adds a create_timestamp called :inserted_at and an update_timestamp called :updated_at . Introspecting the resource If the resource we are extending already has an attribute called inserted_at or updated_at , we'd most likely want to avoid adding one ourselves (this would cause a compile error about duplicate attribute names). We can check for an existing attribute and make that change like so: def transform ( dsl_state ) do { :ok , dsl_state |&gt; add_attribute_if_not_exists ( :create_timestamp , :inserted_at ) |&gt; add_attribute_if_not_exists ( :update_timestamp , :updated_at ) } end defp add_attribute_if_not_exists ( dsl_state , type , name ) do if Ash.Resource.Info . attribute ( dsl_state , name ) do dsl_state else { :ok , attribute } = Transformer . build_entity ( Ash.Resource.Dsl , [ :attributes ] , type , name : name ) dsl_state |&gt; Transformer . add_entity ( [ :attributes ] , attribute ) end end This is just one example of what you can do with transformers. Check out the functions in Spark.Dsl.Transformer to see what utilities are available. Make the extension configurable So far we've covered transformers, and using them to modify resources, but now lets say we want to make this behavior opt-out. Perhaps certain resources really shouldn't have timestamps, but we want it to be the default. Lets add a &quot;DSL Section&quot; to our extension. defmodule MyApp.Extensions.Base do @base % Spark.Dsl.Section { name : :base , describe : &quot;&quot;&quot; Configure the behavior of our base extension. &quot;&quot;&quot; , examples : [ &quot;&quot;&quot; base do timestamps? false end &quot;&quot;&quot; ] , schema : [ timestamps? : [ type : :boolean , doc : &quot;Set to false to skip adding timestamps&quot; , default : true ] ] } defmodule Info do def timestamps? ( resource ) do Spark.Dsl.Extension . get_opt ( resource , [ :base ] , :timestamps? , true ) end end use Spark.Dsl.Extension , transformers : [ MyApp.Extensions.Base.AddTimestamps ] , sections : [ @base ] end Now we can use this configuration in our transformer, like so: def transform ( dsl_state ) do if MyApp.Extensions.Base.Info . timestamps? ( dsl_state ) do { :ok , dsl_state |&gt; add_attribute_if_not_exists ( :create_timestamp , :inserted_at ) |&gt; add_attribute_if_not_exists ( :update_timestamp , :updated_at ) } else { :ok , dsl_state } end end defp add_attribute_if_not_exists ( dsl_state , type , name ) do if Ash.Resource.Info . attribute ( dsl_state , name ) do dsl_state else { :ok , attribute } = Transformer . build_entity ( Ash.Resource.Dsl , [ :attributes ] , type , name : name ) dsl_state |&gt; Transformer . add_entity ( [ :attributes ] , attribute ) end end And now we have a configurable base extension A note on the ordering of transformers In this case, this transformer can run in any order. However, as we start adding transformers and/or modify the behavior of this one, we may need to ensure that our transformer runs before or after specific transformers. As of the writing of this guide, the best way to look at the list of transformers is to look at the source of the extension, and see what transformers it has and what they do. The Resource DSL for example. If you need to affect the ordering, you can define before?/1 and after?/1 in your transformer, i.e # I go after any other transformer def after? ( _ ) , do : true # except I go before `SomeOtherTransformer` def before? ( SomeOtherTransformer ) , do : true def before? ( _ ) , do : false","ref":"extending-resources.html#creating-a-transformer","title":"Extending Resources - Creating a transformer","type":"extras"},{"doc":"Now it can be used like any other extension: defmodule MyApp.Tweet do use Ash.Resource , extensions : [ MyApp.Extensions.Base ] base do # And you can configure it like so timestamps? false end end Your extension will be automatically supported by the elixir_sense extension, showing inline documentation and auto complete as you type. For more on that, see p Development Utilities","ref":"extending-resources.html#using-your-extension","title":"Extending Resources - Using your extension","type":"extras"},{"doc":"The &quot;Base Resource&quot; pattern has been adopted by some as a way to make it easy to ensure that your base extension is used everywhere. Instead of using Ash.Resource you use MyApp.Resource . Take a look at the Development Utilities guide if you do this, as you will need to update your formatter configuration, if you are using it. defmodule MyApp.Resource do defmacro __using__ ( opts ) do quote do use Ash.Resource , unquote ( Keyword . update ( opts , :extensions , [ MyApp.Extensions.Base ] , &amp; [ MyApp.Extensions.Base | &amp;1 ] ) ) end end end And now you can use it with your resources like this: defmodule MyApp.Tweet do use MyApp.Resource end","ref":"extending-resources.html#making-a-base-resource","title":"Extending Resources - Making a Base Resource","type":"extras"},{"doc":"To do this, you could create an extension very similar to Ash.Registry.ResourceValidations , that ensures that any resource present uses your extension. Spark.extensions/1 can be used to see what extensions a given module or dsl_config has adopted.","ref":"extending-resources.html#ensuring-that-all-resources-use-your-base-extension","title":"Extending Resources - Ensuring that all resources use your base extension","type":"extras"},{"doc":"This documentation is best viewed at ash-hq.org","ref":"get-started.html","title":"Get Started","type":"extras"},{"doc":"In this guide we will: Create a new Elixir application and add Ash as a dependency Create a simple set of resources and show they can be used Illustrate some core concepts of Ash Point you to good next resources so you can explore Ash further","ref":"get-started.html#goals","title":"Get Started - Goals","type":"extras"},{"doc":"Install Elixir Philosophy Guide","ref":"get-started.html#things-you-may-want-to-read-first","title":"Get Started - Things you may want to read first","type":"extras"},{"doc":"If you want to follow along yourself, you will need the following things: Elixir and Erlang installed A text editor to make the changes that we make A terminal to run the examples using iex","ref":"get-started.html#requirements","title":"Get Started - Requirements","type":"extras"},{"doc":"For this tutorial, we'll use examples based around creating a help desk. We will make the following resources: Helpdesk.Support.Ticket Helpdesk.Support.Representative The actions we will be able to take on these resources include: Opening a new Ticket Closing a Ticket Assigning a Ticket to a representative Create a new project We first create a new project with the --sup flag to add a supervision tree. This will be necessary for later steps. # In your terminal mix new --sup helpdesk &amp;&amp; cd helpdesk It is a good idea to make it a git repository and commit the initial project. You'll be able to see what changes we made, and can save your changes once we're done. # Run in your terminal git init git add -A git commit -m &quot;first commit&quot; git branch -M main Open the project in your text editor, and we'll get started. Add Ash to your application Add the ash dependency to your mix.exs defp deps do [ # {:dep_from_hexpm, &quot;~&gt; 0.3.0&quot;}, # {:dep_from_git, git: &quot;https://github.com/elixir-lang/my_dep.git&quot;, tag: &quot;0.1.0&quot;}, { :ash , &quot;~&gt; 2.6.13&quot; } # &lt;-- add this line ] end Add :ash to your .formatter.exs file # Used by &quot;mix format&quot; [ import_deps : [ :ash ] , # &lt;-- add this line, if you have more import_deps, just add it within the array inputs : [ &quot;{mix,.formatter}.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs}&quot; ] ] And run mix deps.get Temporary Config For backwards compatibility, the following configuration is required. Don't worry about it for now, just know that it needs to be set until the behavior is deprecated in the next major release. Create a file at config/config.exs with the following contents. If you already have one, just add the last line. import Config # if you already have a config file, then you&#39;ll just need to add this: config :ash , :use_all_identities_in_manage_relationship? , false Building your first Ash API The basic building blocks of an Ash application are Ash resources. They are tied together by an API module (not to be confused with a web API), which will allow you to interact with those resources. It might be helpful to think of an Ash API as a Bounded Context (in the Domain Driven Design sense), or as a Service (in the microservice sense). Creating our first resource Let's start by creating our first resource along with our first API. We will create the following files: The API [Helpdesk.Support] - lib/helpdesk/support.ex An accompanying registry which lists the resources for our api. - lib/helpdesk/support/registry.ex Our Ticket resource [Helpdesk.Support.Ticket] - lib/helpdesk/support/resources/ticket.ex . To create the required folders and files, you can use the following command in your terminal: mkdir -p lib/helpdesk/support/resources &amp;&amp; touch $_/ticket.ex touch lib/helpdesk/support/registry.ex touch lib/helpdesk/support.ex Your project structure should now look like this: lib / ├ ─ helpdesk / │ ├ ─ support / │ │ ├ ─ registry . ex │ │ ├ ─ resources / │ │ │ ├ ─ ticket . ex │ ├ ─ support . ex Add the following to the files we created # lib/helpdesk/support/resources/ticket.ex defmodule Helpdesk.Support.Ticket do # This turns this module into a resource use Ash.Resource actions do # Add a set of simple actions. You&#39;ll customize these later. defaults [ :create , :read , :update , :destroy ] end # Attributes are the simple pieces of data that exist on your resource attributes do # Add an autogenerated UUID primary key called `:id`. uuid_primary_key :id # Add a string type attribute called `:subject` attribute :subject , :string end end # lib/helpdesk/support/registry.ex defmodule Helpdesk.Support.Registry do use Ash.Registry , extensions : [ # This extension adds helpful compile time validations Ash.Registry.ResourceValidations ] entries do entry Helpdesk.Support.Ticket end end # lib/helpdesk/support.ex defmodule Helpdesk.Support do use Ash.Api resources do # This defines the set of resources that can be used with this API registry Helpdesk.Support.Registry end end Next, add your api to your config.exs Run the following to create your config.exs if it doesn't already exist mkdir - p config touch config / config . exs and add the following contents to it (if the file already exists, just make sure the config line is added) # in config/config.exs import Config config :helpdesk , :ash_apis , [ Helpdesk.Support ] Try our first resource out Run iex -S mix in your project and try it out. To create a ticket, we first make an Ash.Changeset for the :create action of the Helpdesk.Support.Ticket resource. Then we pass it to the create!/1 function on our API module Helpdesk.Support . Helpdesk.Support.Ticket |&gt; Ash.Changeset . for_create ( :create ) |&gt; Helpdesk.Support . create! ( ) This returns what we call a record which is an instance of a resource. # Helpdesk.Support.Ticket &lt; ... , id : &quot;c0f8dc32-a018-4eb4-8656-d5810118f4ea&quot; , subject : nil , ... &gt; Customizing our Actions One thing you may have noticed earlier is that we created a ticket without providing any input, and as a result our ticket had a subject of nil . Additionally, we don't have any other data on the ticket. Lets add a status attribute, ensure that subject can't be nil , and provide a better interface by making a custom action for opening a ticket, called :open . We'll start with the attribute changes: # lib/helpdesk/support/resources/ticket.ex attributes do ... attribute :subject , :string do # Don&#39;t allow `nil` values allow_nil? false end # status is either `open` or `closed`. We can add more statuses later attribute :status , :atom do # Constraints allow you to provide extra rules for the value. # The available constraints depend on the type # See the documentation for each type to know what constraints are available # Since atoms are generally only used when we know all of the values # it provides a `one_of` constraint, that only allows those values constraints [ one_of : [ :open , :closed ] ] # The status defaulting to open makes sense default :open # We also don&#39;t want status to ever be `nil` allow_nil? false end end And then add our customized open action which should take a subject argument: # lib/helpdesk/support/resources/ticket.ex actions do ... create :open do # By default you can provide all public attributes to an action # This action should only accept the subject accept [ :subject ] end end Let's try these changes in iex : We use create! with an exclamation point here because that will raise the error which gives a nicer view of the error in iex # Use this to pick up changes you&#39;ve made to your code, or restart your session recompile ( ) Helpdesk.Support.Ticket |&gt; Ash.Changeset . for_create ( :open , %{ subject : &quot;My mouse won&#39;t click!&quot; } ) |&gt; Helpdesk.Support . create! ( ) And we can see our newly created ticket with a subject and a status. # Helpdesk.Support.Ticket &lt; ... id : &quot;3c94d310-7b5e-41f0-9104-5b193b831a5d&quot; , status : :open , subject : &quot;My mouse won&#39;t click!&quot; , ... &gt; If we didn't include a subject, or left off the arguments completely, we would see an error instead ** (Ash.Error.Invalid) Input Invalid * attribute subject is required Updates and validations Now let's add some logic to close a ticket. This time we'll add an update action. Here we will use a change . Changes allow you to customize how an action executes with very fine-grained control. There are built-in changes that are automatically available as functions, but you can define your own and pass it in as shown below. You can add multiple, and they will be run in order. See the Actions guide for more. # lib/helpdesk/support/resources/ticket.ex actions do ... update :close do # We don&#39;t want to accept any input here accept [ ] change set_attribute ( :status , :closed ) # A custom change could be added like so: # # change MyCustomChange # change {MyCustomChange, opt: :val} end end Try out opening and closing a ticket in iex : # Use this to pick up changes you&#39;ve made to your code, or restart your session recompile ( ) # parenthesis so you can paste into iex ticket = ( Helpdesk.Support.Ticket |&gt; Ash.Changeset . for_create ( :open , %{ subject : &quot;My mouse won&#39;t click!&quot; } ) |&gt; Helpdesk.Support . create! ( ) ) ticket |&gt; Ash.Changeset . for_update ( :close ) |&gt; Helpdesk.Support . update! ( ) # Helpdesk.Support.Ticket &lt; ... status : :closed , subject : &quot;My mouse won&#39;t click!&quot; , ... &gt; Querying without persistence So far we haven't used a data layer that does any persistence, like storing records in a database. All that this simple resource does is return the record back to us. You can see this lack of persistence by attempting to use a read action: Helpdesk.Support . read! ( Helpdesk.Support.Ticket ) Which will raise an error explaining that there is no data to be read for that resource. In order to save our data somewhere, we need to add a data layer to our resources. Before we do that, however, let's go over how Ash allows us to work against many different data layers (or even no data layer at all). Resources without a data layer will implicitly be using Ash.DataLayer.Simple , which will just return structs and won't actually store anything. The way that we make our queries return some data is by leveraging context , a free-form map available on queries and changesets. The simple data layer looks for query.context[:data_layer][:data][resource] . It provides a utility, Ash.DataLayer.Simple.set_data/2 to set it. Try the following in iex . We will open some tickets, and close some of them, and then use Ash.DataLayer.Simple.set_data/2 to use those tickets. # Ash.Query is a macro, so it must be required require Ash.Query tickets = for i &lt;- 0 .. 5 do ticket = Helpdesk.Support.Ticket |&gt; Ash.Changeset . for_create ( :open , %{ subject : &quot;Issue \#{ i } &quot; } ) |&gt; Helpdesk.Support . create! ( ) if rem ( i , 2 ) == 0 do ticket |&gt; Ash.Changeset . for_update ( :close ) |&gt; Helpdesk.Support . update! ( ) else ticket end end Find the tickets where the subject contains &quot;2&quot; . Note that the we're setting the ticket data that we're querying using set_data . Helpdesk.Support.Ticket |&gt; Ash.Query . filter ( contains ( subject , &quot;2&quot; ) ) |&gt; Ash.DataLayer.Simple . set_data ( tickets ) |&gt; Helpdesk.Support . read! ( ) Find the tickets that are closed and their subject does not contain &quot;4&quot; Helpdesk.Support.Ticket |&gt; Ash.Query . filter ( status == :closed and not ( contains ( subject , &quot;4&quot; ) ) ) |&gt; Ash.DataLayer.Simple . set_data ( tickets ) |&gt; Helpdesk.Support . read! ( ) The examples above could be easily implemented with Enum.filter , but the real power here is to allow you to use the same tools when working with any data layer. If you were using the AshPostgres.DataLayer data layer. Even though it doesn't persist data in any way, Ash.DataLayer.Simple can be useful to model static data, or be used for resources where all the actions are manual and inject data from other sources. Adding basic persistence Before we get into working with relationships, let's add some real persistence to our resource. This will let us add relationships and try out querying data. There is a built in data layer that is useful for testing and prototyping, that uses ETS . ETS (Erlang Term Storage) is OTP's in-memory database, so the data won't actually stick around beyond the lifespan of your program, but it's a simple way to try things out. To add it to your resource, modify it like so: # lib/helpdesk/support/resources/ticket.ex use Ash.Resource , data_layer : Ash.DataLayer.Ets Now we can slightly modify our code above, by removing the Ash.DataLayer.Simple.set_data/2 calls, and we can see our persistence in action. Remember, ETS is in-memory, meaning restarting your application/iex session will remove all of the data. # Use this to pick up changes you&#39;ve made to your code, or restart your session recompile ( ) require Ash.Query for i &lt;- 0 .. 5 do ticket = Helpdesk.Support.Ticket |&gt; Ash.Changeset . for_create ( :open , %{ subject : &quot;Issue \#{ i } &quot; } ) |&gt; Helpdesk.Support . create! ( ) if rem ( i , 2 ) == 0 do ticket |&gt; Ash.Changeset . for_update ( :close ) |&gt; Helpdesk.Support . update! ( ) end end # Show the tickets where the subject contains &quot;2&quot; Helpdesk.Support.Ticket |&gt; Ash.Query . filter ( contains ( subject , &quot;2&quot; ) ) |&gt; Helpdesk.Support . read! ( ) # Show the tickets that are closed and their subject does not contain &quot;4&quot; Helpdesk.Support.Ticket |&gt; Ash.Query . filter ( status == :closed and not ( contains ( subject , &quot;4&quot; ) ) ) |&gt; Helpdesk.Support . read! ( ) Adding relationships Now we want to be able to assign a Ticket to a Representative. First, let's create the Representative resource: # lib/helpdesk/support/resources/representative.ex defmodule Helpdesk.Support.Representative do # This turns this module into a resource using the in memory ETS data layer use Ash.Resource , data_layer : Ash.DataLayer.Ets actions do # Add the default simple actions defaults [ :create , :read , :update , :destroy ] end # Attributes are the simple pieces of data that exist on your resource attributes do # Add an autogenerated UUID primary key called `:id`. uuid_primary_key :id # Add a string type attribute called `:name` attribute :name , :string end relationships do # `has_many` means that the destination attribute is not unique, therefore many related records could exist. # We assume that the destination attribute is `representative_id` based # on the module name of this resource and that the source attribute is `id`. has_many :tickets , Helpdesk.Support.Ticket end end Now let's modify our Ticket resource to have the inverse relationship to the Representative. # lib/helpdesk/support/resources/ticket.ex relationships do # belongs_to means that the destination attribute is unique, meaning only one related record could exist. # We assume that the destination attribute is `representative_id` based # on the name of this relationship and that the source attribute is `representative_id`. # We create `representative_id` automatically. belongs_to :representative , Helpdesk.Support.Representative end Finally, let's add our new Representative resource to our registry # lib/helpdesk/support/registry.ex entries do ... entry Helpdesk.Support.Representative end You may notice that if you don't add the resource to the registry, or if you don't add the belongs_to relationship, that you'll get helpful errors at compile time. Helpful compile time validations are a core concept of Ash as we really want to ensure that your application is valid.","ref":"get-started.html#steps","title":"Get Started - Steps","type":"extras"},{"doc":"There are a wide array of options when managing relationships, and we won't cover all of them here. See the guide on Managing Relationships for a full explanation. In this example we'll demonstrate the use of action arguments, the method by which you can accept additional input to an action. Add the assign action to allow us to assign a Ticket to a Representative. # lib/helpdesk/support/resources/ticket.ex update :assign do # No attributes should be accepted accept [ ] # We accept a representative&#39;s id as input here argument :representative_id , :uuid do # This action requires representative_id allow_nil? false end # We use a change here to replace the related Representative # If there is a different representative for this Ticket, it will be changed to the new one # The Representative itself is not modified in any way change manage_relationship ( :representative_id , :representative , type : :append_and_remove ) end Let's try it out in our iex console! Use recompile to pick up changes you've made to your code, or just restart your session. recompile ( ) Open a Ticket ticket = ( Helpdesk.Support.Ticket |&gt; Ash.Changeset . for_create ( :open , %{ subject : &quot;I can&#39;t find my hand!&quot; } ) |&gt; Helpdesk.Support . create! ( ) ) Create a Representative representative = ( Helpdesk.Support.Representative |&gt; Ash.Changeset . for_create ( :create , %{ name : &quot;Joe Armstrong&quot; } ) |&gt; Helpdesk.Support . create! ( ) ) Assign that Representative to the Ticket ticket |&gt; Ash.Changeset . for_update ( :assign , %{ representative_id : representative . id } ) |&gt; Helpdesk.Support . update! ( ) Assigning the Representative to a Ticket during its creation With the current definition of the Ticket resource the following will execute without error, but the representative_id field of the newly generated ticket will still remain empty: Helpdesk.Support.Ticket |&gt; Ash.Changeset . for_create ( :open , %{ subject : &quot;My spoon is too big!&quot; , representative_id : representative . id } ) |&gt; Helpdesk.Support . create! ( ) ) The reason is that belongs_to relationships are not marked as public and writable by default (refer to the define_attribute? option of belongs_to ). With the following modification the attribute can be written to, during the :create action: # lib/helpdesk/support/resources/ticket.ex relationships do belongs_to :representative , Helpdesk.Support.Representative do attribute_writable? true end end What next? What you've seen above barely scratches the surface of what Ash can do. In a lot of ways, it will look very similar to other tools that you've seen. If all that you ever used was the above, then realistically you won't see much benefit to using Ash. Where Ash shines however, is all of the tools that can operate on your resources. You have the ability to extend the framework yourself, and apply consistent design patterns that enable unparalleled efficiency, power and flexibility as your application grows. Clean up your code that uses Ash? Creating and using changesets manually can be verbose, and they all look very similar. Luckily, Ash has your back and can generate these for you using Code Interfaces! Check out the Code Interface Guide to derive things like Helpdesk.Support.Ticket.assign!(representative.id) Persist your data See The AshPostgres getting started guide to see how to back your resources with Postgres. This is highly recommended, as the Postgres data layer provides tons of advanced capabilities. Add an API Check out the AshJsonApi and AshGraphql extensions to effortlessly build APIs around your resources Authorize access and work with users See the Policies guide for information on how to authorize access to your resources using actors and policies.","ref":"get-started.html#working-with-relationships","title":"Get Started - Working with relationships","type":"extras"},{"doc":"The philosophy behind Ash allows us to build an extremely flexible and powerful set of tools, without locking users into specific choices at any level. The framework acts as a spinal cord for your application, with extension points at every level to allow for custom behavior. What follows are the core tenets behind Ash Framework.","ref":"philosophy.html","title":"Philosophy","type":"extras"},{"doc":"&quot;Anything, not Everything&quot; means building a framework capable of doing anything, not providing a framework that already does everything. The first is possible, the second is not. Our primary goal is to provide a framework that unlocks potential, and frees developers to work on the things that make their application special. To this end, there are many prebuilt extensions to use, but there is also a rich suite of tools to build your own extensions. In this way, you can make the framework work for you, instead of struggling to fit your application to a strictly prescribed pattern. Use as much of Ash as you can, and leverage the amazing Elixir ecosystem for everything else.","ref":"philosophy.html#anything-not-everything","title":"Philosophy - Anything, not Everything","type":"extras"},{"doc":"The real superpower behind Ash is the declarative design pattern. All behavior is driven by explicit, static declarations. A resource, for example, is really just a configuration file. On its own it does nothing. It is provided to code that reads that configuration and acts accordingly. You can read more about some simple declarative design patterns outside of the context of Ash Framework in An Incremental Approach to Declarative Design .","ref":"philosophy.html#declarative-introspectable-derivable","title":"Philosophy - Declarative, Introspectable, Derivable","type":"extras"},{"doc":"While Ash does have lofty goals and a roadmap, the priority for development is always what the current users of Ash need or are having trouble with. We focus on simple, pragmatic, and integrated solutions that meld well with the rest of the framework. A high priority is placed on ensuring that our users don't experience feature whip-lash due to poorly thought out implementations, and that any breaking changes (a rare occurrence) have a clean and simple upgrade path. This is something made much easier by the declarative pattern.","ref":"philosophy.html#pragmatism-first","title":"Philosophy - Pragmatism First","type":"extras"},{"doc":"The Ash community comes together and collaborates to make sure that we can all build our software quickly, effectively and in a way that will age gracefully. We have a strict code of conduct, and love working with people of any experience level or background. To experience this first-hand, join our discord !","ref":"philosophy.html#community","title":"Philosophy - Community","type":"extras"},{"doc":"One of the fundamental ideas behind Ash is that when the various components of your system can have consistent expectations of how the other components around them work, you can ultimately do a significant amount more, with less.","ref":"why-ash.html","title":"Why Ash","type":"extras"},{"doc":"Policy authorization is a good example of this. When you're trying to write a flexible system that has secure access patterns, there are tons of ways to do it wrong. For example, lets say you have this policy on your &quot;posts&quot; resource. policy action_type ( :read ) do authorize_if relates_to_actor_via ( :author ) authorize_if relates_to_actor_via ( [ :author , :friends ] ) end Using Ash, if I were to make a simple query like MyApp.Blog.read!(MyApp.Blog.Post, actor: current_user), what it would do is automatically translate those policies to a filter statement. So it is the equivalent to saying: MyApp.Blog.Post |&gt; Ash.Query . filter ( exists ( author , id == ^ current_user . id ) or exists ( author . friends , id == ^ current_user . id ) ) |&gt; MyApp.Blog . read! ( ) And that is something you could potentially hand roll. But what about when you want to say something like this: MyApp.Blog.Comment |&gt; Ash.Query . filter ( exists ( author , email == &quot;daarb@daarb.com&quot; ) ) |&gt; MyApp.Blog . read! ( ) Ash is aware of the policies on author and will translate this under the hood to MyApp.Blog.Comment |&gt; Ash.Query . filter ( exists ( author , id == ^ current_user . id and # Ash.Filter &lt; policies for reading authors &gt; ) ) Or if you want to display aggregate information, i.e in Ash # on an Organization resource aggregates do count :count_of_posts , :posts end That should realistically show &quot;the number of posts the user can see&quot; (by default). So Ash is aware of the policies and details of the resource you are aggregating, meaning that aggregate will just &quot;do the right thing&quot; Policies are just one example of how a tool that is built for this kind of thing can often come with features that would be entirely unreasonable for developers to write by hand for every platform they are building. The declarative design patterns behind Ash allow us to build features that are context aware and extremely powerful.","ref":"why-ash.html#example-policies","title":"Why Ash - Example: Policies","type":"extras"},{"doc":"In all reality &quot;writing less code&quot; is not really a goal that Ash has. The real goal behind helping people to not reinvent the wheel is that if we keep reinventing the wheel every time, the wheel will never be properly iterated on. Policies are one example of this. By ensuring that the various pieces of our system have consistent, stable and rich interfaces, we can easily write reusable extensions. For example, AshArchival will ensure that any given resource is &quot;soft deleted&quot; instead of actually deleted, and AshPaperTrail will keep a log of all changes that happen on a given resource. Both of these behaviors can be introduced to your resources with a single line of code, e.g extensions: [AshPaperTrail.Resource] because resources are composed of elements that have consistent, declarative structures.","ref":"why-ash.html#it-isn-t-about-less-code","title":"Why Ash - It isn't about &quot;less code&quot;","type":"extras"},{"doc":"","ref":"contribute.html","title":"Contribute","type":"extras"},{"doc":"We are delighted to have anyone contribute to Ash, regardless of their skill level or background. We welcome contributions both large and small, from typos and documentation improvements, to bug fixes and features. There is a place for everyone's contribution here. Check the issue tracker or join in the discord to see how you can help! Make sure to read the rules below as well.","ref":"contribute.html#welcome","title":"Contribute - Welcome!","type":"extras"},{"doc":"We have a zero tolerance policy for failure to abide by our code of conduct. It is very standard, but please make sure you have read it. Issues may be opened to propose new ideas, to ask questions, or to file bugs. Before working on a feature, please talk to the core team/the rest of the community via a proposal. We are building something that needs to be cohesive and well thought out across all use cases. Our top priority is supporting real life use cases like yours, but we have to make sure that we do that in a sustainable way. The best compromise there is to make sure that discussions are centered around the use case for a feature, rather than the proposed feature itself. Before starting work, please comment on the issue and/or ask in the discord if anyone is handling an issue. Be aware that if you've commented on an issue that you'd like to tackle it, but no one can reach you and/or demand/need arises sooner, it may still need to be done before you have a chance to finish. However, we will make all efforts to allow you to finish anything you claim.","ref":"contribute.html#rules","title":"Contribute - Rules","type":"extras"},{"doc":"The best practice is typically to try to push things as far down into your resources as possible.","ref":"define-idiomatic-actions.html","title":"Define Idiomatic Actions","type":"extras"},{"doc":"If you were doing a twitter front page, you might have a tweet resource with a simple action like this: # use a simple primary read defaults [ :read , ... ] And in doing that, you could get all the tweets with something like this: Tweet |&gt; Ash.Query . for_read ( :read ) |&gt; Ash.Query . sort ( posted_at : :desc ) |&gt; Ash.Query . filter ( author . id == ^ current_user . id or exists ( author . friends , id == ^ current_user . id ) ) # assuming the name of your api was `Tweets` |&gt; Tweets . read! ( ) And that works and in some cases might be the right way to do what you're trying to do And lets say there was a sort drop down that made it sort by popular instead of recent, you could do something like this: Tweet |&gt; Ash.Query . for_read ( :read ) |&gt; then ( fn query -&gt; case sort do :recent -&gt; Ash.Query . sort ( query , posted_at : :desc ) :popular -&gt; Ash.Query . sort ( query , like_count : :desc ) end end ) |&gt; Ash.Query . filter ( author . id == ^ current_user . id or exists ( author . friends , id == ^ current_user . id ) ) # assuming the name of your api was `Tweets` |&gt; Tweets . read! ( )","ref":"define-idiomatic-actions.html#the-non-idiomatic-way","title":"Define Idiomatic Actions - The Non-idiomatic Way","type":"extras"},{"doc":"But the better way to model this would be something like this: code_interface do define_for MyApp.Tweets define :front_page , args : [ :sort_by ] end read :front_page do argument :sort_by , :atom do constraints one_of : [ :recent , :popular ] end prepare MyApp.Tweets.Tweet.Preparations.SortFrontPage filter expr ( author . id == ^ actor ( :id ) or exists ( author . friends , id == ^ actor ( :id ) ) end Custom preparations allow you to do all sorts of things, in this case handle custom sorting defmodule MyApp.Tweets.Tweet.Preparations.SortFrontPage do use Ash.Resource.Preparation def prepare ( query , _ , _ ) do # We use `prepend?` to put the sort ahead of any other specified sort on the query case Ash.Changeset . get_argument ( query , :sort_by ) do :recent -&gt; Ash.Query . sort ( query , [ posted_at : :desc ] , prepend? : true ) :popular -&gt; Ash.Query . sort ( query , [ like_count : :desc ] , prepend? : true ) end end end And then you can get the front page of tweets far more cleanly: Tweet . front_page! ( socket . assigns . sort_by ) If you were using AshGraphql, you could do something like this: graphql do type :tweet queries do query :front_page , :front_page end end And because you've made the action encompass the entire logic of fetching the front page, you've got automatic support for API access to your system. This is just one example of the benefits of having idiomatic and complete actions.","ref":"define-idiomatic-actions.html#the-idiomatic-way","title":"Define Idiomatic Actions - The Idiomatic Way","type":"extras"},{"doc":"Manual relationships allow you to express complex or non-typical relationships between resources in a standard way. Individual data layers may interact with manual relationships in their own way, so see their corresponding guides. By default, the only thing manual relationships support is being loaded.","ref":"defining-manual-relationships.html","title":"Defining Manual Relationships","type":"extras"},{"doc":"In our Helpdesk example, we'd like to have a way to find tickets In the Rep? resource, define a has_many relationship as manual and point to the module where it will be implemented. relationships do has_many :tickets_above_threshold , Helpdesk.Support.Ticket do manual Helpdesk.Support.Ticket.Relationships.TicketsAboveThreshold end end Using Ash to get the destination records is ideal, so you can authorize access like normal but if you need to use a raw ecto query here, you can. As long as you return the right structure. The TicketsAboveThreshold module is implemented as follows. defmodule Helpdesk.Support.Ticket.Relationships.TicketsAboveThreshold do use Ash.Resource.ManualRelationship require Ash.Query def load ( records , _opts , %{ query : query , actor : actor , authorize? : authorize? } ) do # Use existing records to limit resultds rep_ids = Enum . map ( records , &amp; &amp;1 . id ) { :ok , query |&gt; Ash.Query . filter ( representative_id in ^ rep_ids ) |&gt; Ash.Query . filter ( priority &gt; representative . priority_threshold ) |&gt; Helpdesk.Support . read! ( actor : actor , authorize? : authorize? ) # Return the items grouped by the primary key of the source, i.e representative.id =&gt; [...tickets above threshold] |&gt; Enum . group_by ( &amp; &amp;1 . representative_id ) } end end","ref":"defining-manual-relationships.html#example","title":"Defining Manual Relationships - Example","type":"extras"},{"doc":"Since you likely want to support things like filtering your relationship when being loaded, you will want to make sure that you use the query being provided. However, depending on how you're loading the relationship, you may need to do things like fetch extra records. To do this, you might do things like def load ( records , _opts , %{ query : query , .. } ) do # unset some fields fetch_query = Ash.Query . unset ( query , [ :limit , :offset ] ) # or, to be more safe/explicit, you might make a new query, explicitly setting only a few fields fetch_query = query . resource |&gt; Ash.Query . filter ( ^ query . filter ) |&gt; Ash.Query . sort ( query . sort ) ... end","ref":"defining-manual-relationships.html#using-the-query","title":"Defining Manual Relationships - Using the Query","type":"extras"},{"doc":"There is a difficult balance to cut between informative errors and enabling simple reactions to those errors. Since many extensions may need to work with and/or adapt their behavior based on errors coming from Ash, we need rich error messages. However, when you have a hundred different exceptions to represent the various kinds of errors a system can produce, it becomes difficult to say something like &quot;try this code, and if it is invalid, do x, if it is forbidden, do y. To this effect, exceptions in Ash have one of four classes mapping to the top level exceptions.","ref":"handle-errors.html","title":"Handle Errors","type":"extras"},{"doc":"forbidden - Ash.Error.Forbidden invalid - Ash.Error.Invalid framework - Ash.Error.Framework unknown - Ash.Error.Unknown Since many actions can be happening at once, we want to support the presence of multiple errors as a result of a request to Ash. We do this by grouping up the errors into one before returning or raising. We choose an exception based on the order of the exceptions listed above. If there is a single forbidden, we choose Ash.Error.Forbidden , if there is a single invalid, we choose Ash.Error.Invalid and so on. The actual errors will be included in the errors key on the exception. The exception's message will contain a bulleted list of all the underlying exceptions that occurred. This makes it easy to react to specific kinds of errors, as well as to react to any/all of the errors present. An example of a single error being raised, representing multiple underlying errors: AshExample.Representative |&gt; Ash.Changeset . new ( %{ employee_id : &quot;the best&quot; } ) |&gt; AshExample.Api . create! ( ) ** (Ash.Error.Invalid) Input Invalid * employee_id : must be absent . * first_name , last_name : at least 1 must be present . ( ash 1.3 . 0 ) lib / ash / api / api . ex : 534 : Ash.Api . unwrap_or_raise! / 1 This allows easy rescuing of the major error classes, as well as inspection of the underlying cases try do AshExample.Representative |&gt; Ash.Changeset . new ( %{ employee_id : &quot;dabes&quot; } ) |&gt; AshExample.Api . create! ( ) rescue e in Ash.Error.Invalid -&gt; &quot;Encountered \#{ Enum . count ( e . errors ) } errors&quot; end &quot;Encountered 2 errors&quot; This pattern does add some additional overhead when you want to rescue specific kinds of errors. For example, you may need to do something like this: try do AshExample.Representative |&gt; Ash.Changeset . new ( %{ employee_id : &quot;dabes&quot; } ) |&gt; AshExample.Api . create! ( ) rescue e in Ash.Error.Invalid -&gt; case Enum . find ( e . errors , &amp; ( &amp;1 . __struct__ == A.Specific.Error ) ) do nil -&gt; ... handle errors error -&gt; ... handle specific error you found end end","ref":"handle-errors.html#error-classes","title":"Handle Errors - Error Classes","type":"extras"},{"doc":"","ref":"upgrade.html","title":"Upgrade","type":"extras"},{"doc":"All deprecations will be finalized in version 2.1. Ash.Flow While still more experimental than the rest of the framework, Ash.Flow is no longer feature-gated behind a configuration flag. It has been changed only slightly, and now returns an Ash.Flow.Result in all cases. New DSL tooling The DSL tooling has been moved out of the Ash name space and into a more generalized tool called Spark . If you have written your own extensions, you will need to refer to those modules. They are all the same, but they have different names. You will get compiler errors/warnings on the modules you need to change, for example: Ash.Dsl -&gt; Spark.Dsl and Ash.Dsl.Transformer -&gt; Spark.Dsl.Transformer . One exception, Ash.Error.Dsl.DslError , has been changed to Spark.Error.DslError .","ref":"upgrade.html#upgrading-to-2-0","title":"Upgrade - Upgrading to 2.0","type":"extras"},{"doc":"These should all be straight forward enough to do a simple find and replace in your resources. source_field -&gt; source_attribute destination_field -&gt; destination_attribute define_field? -&gt; define_attribute? field_type -&gt; attribute_type source_field_on_join_table -&gt; source_attribute_on_join_resource destination_field_on_join_table -&gt; destination_attribute_on_join_resource no_fields? -&gt; no_attributes? expensive? -&gt; before_action? (on validations) required? -&gt; allow_nil? (on belongs_to relationships) Be sure to flip the boolean value!! DSL changes A new option has been added to the pub_sub notifier. If you are using it with phoenix, and you want it to publish a %Phoenix.Socket.Broadcast{} struct (which is what it used to do if you specified the name option with pub sub), then you'll need to set broadcast_type :phoenix_broadcast Validation Changes validate match/3 is now validate match/2 . It used to accept a message as its third argument, but there is now support for setting a message on all validations like so: validate match(:attribute, ~r/regex/), message: &quot;message&quot; Policy Changes When using a filter template that references the actor, it was previously acceptable for the actor to be nil and still have the check pass. For example, instead of: authorize_if expr ( actor ( :field ) != 10 ) you might want authorize_if is_nil ( actor ( :field ) ) forbid_if expr ( actor ( :field ) != 10 ) Function Changes The following functions have been moved from Ash.Resource.Info to Ash.Resource . The old functions still exist, but will warn as deprecated. set_metadata/2 put_metadata/3 unload_many/2 unload/2 get_metadata/2 selected?/2 The following functions have been moved from Ash.Api to Ash.Api.Info . The old functions still exist, but will warn as deprecated. resource/2 resources/1 registry/1 allow/1 timeout/1 require_actor?/1 authorize/1 allow_unregistered?/1 The following functions have been moved from Ash.Notifier.PubSub to Ash.Notifier.PubSub.Info . The old functions still exist, but will warn as deprecated. publications/1 module/1 prefix/1 name/1 The following functions have been moved. The old functions still exist, but will warn as deprecated. Ash.DataLayer.Ets.private?/1 -&gt; Ash.DataLayer.Ets.Info.private?/1 Ash.DataLayer.Ets.table/1 -&gt; Ash.DataLayer.Ets.Info.table/1 Ash.DataLayer.Mnesia.table/1 -&gt; Ash.DataLayer.Mnesia.table/1 Ash.Registry.warn_on_empty?/1 -&gt; Ash.Registry.Info.warn_on_empty?/1 Ash.Registry.entries/1 -&gt; Ash.Registry.Info.entries/1 The following functions have been moved: Ash.Resource.extensions/1 -&gt; Spark.extensions/1 The following functions have been deprecated, and will be removed in 2.1 Ash.Changeset.replace_relationship/4 - use manage_relationship/4 instead. Ash.Changeset.append_to_relationship/4 - use manage_relationship/4 instead. Ash.Changeset.remove_from_relationship/4 - use manage_relationship/4 instead. Expression Changes The has operator has been removed from expressions. This is a holdover from when expressions only had partial support for nesting, and is unnecessary now. Now you can do item in list so has is unnecessary.","ref":"upgrade.html#dsl-name-changes","title":"Upgrade - DSL name changes","type":"extras"},{"doc":"Default actions Before 2.0.0, a resource would automatically get the four action types defined. Now, you need to specify them using the defaults option. For example: actions do defaults [ :create , :read , :update , :destroy ] end Primary Actions Primary actions have been simplified for 2.0.0. If there was a single action of a given type before, it would have been marked as primary? automatically. Now, primary? actions are fully optional, although you may still want to configure them. Certain things like managing relationships can be much simpler when paired with primary actions. For a fully explicit experience everywhere, however, you may want to skip primary actions altogether. To make sure your application behaves the same, go to each of your resources and check to see if they only have one action of each type. If they do, mark that single action as primary? . Additionally, the primary_actions? option has been removed now that all primary actions are explicit. Ash.Error.Query.NotFound We used to return/raise this error directly when something wasn't found, but it was the only place in the framework not using an Error Class. So if you had anything matching on %Ash.Error.Query.NotFound{} it should instead now match on %Ash.Error.Invalid{errors: [%Ash.Error.Query.NotFound{}]} .","ref":"upgrade.html#upgrading-to-1-53","title":"Upgrade - Upgrading to 1.53","type":"extras"},{"doc":"If a resource is configured without a data layer, then it will always be working off of a temporary data set that lives only for the life of that query. This can be a powerful way to model input validations and/or custom/complex reads. Technically, resources without a data layer use Ash.DataLayer.Simple , which does no persistence, and expects to find any data it should use for read actions in a context on the query","ref":"use-without-data-layers.html","title":"Use Without Data Layers","type":"extras"},{"doc":"defmodule MyApp.MyComplexResource do use Ash.Resource # notice no data layer is configured attributes do #A primary key is always necessary on a resource, but this will generate one for you automatically uuid_primary_key :id attribute :some_complex_derived_number , :integer end actions do read :read do prepare MyApp.FetchComplexResources end create :validate_input do ... # will validate required inputs, and you can add # validations like you would for any normal resource end end end defmodule MyApp.FetchComplexResources do use Ash.Resource.Preparation def prepare ( query , _ , _ ) do case fetch_data ( query ) do { :ok , data } -&gt; Ash.DataLayer.Simple . set_data ( query , data ) { :error , error } -&gt; Ash.Query . add_error ( query , SomeBuiltinOrCustomAshError . exception ( ... ) ) end end end","ref":"use-without-data-layers.html#example","title":"Use Without Data Layers - Example","type":"extras"},{"doc":"They are used in exactly the same way as regular resources # You can construct changeset over them changeset = Ash.Changeset . for_create ( MyApp.FetchComplexResource , :validate_input , %{ } ) # This will return the structs by default # Although you are free to do custom persistence in your resource changes MyApp.MyApi . create! ( changeset ) # %MyApp.FetchComplexResource{...}","ref":"use-without-data-layers.html#usage","title":"Use Without Data Layers - Usage","type":"extras"},{"doc":"In Ash, there are three kinds of validations. The simple allow_nil? and writable? validations provided for attributes Type constraints, specific to each type The validations section","ref":"validate-changes.html","title":"Validate Changes","type":"extras"},{"doc":"These are considered simple/global enough to warrant being specified at the attribute level. attributes do attribute :some_field , :integer , writable? : false attribute :some_other_field , :integer , allow_nil? : false end To see the equivalent statements using the validations section of a resource, see the corresponding section below.","ref":"validate-changes.html#allow_nil-writable","title":"Validate Changes - allow_nil/writable?","type":"extras"},{"doc":"Each type (including custom types) can expose constraints . When declaring an attribute these constraints can be provided with the constraints option. For example: attributes do attribute :some_field , :integer , constraints : [ min : 1 , max : 5 ] attribute :some_other_field , :string , constraints : [ max_length : 255 ] end","ref":"validate-changes.html#type-constraints","title":"Validate Changes - Type constraints","type":"extras"},{"doc":"The validations section allows you to create validations based on the changeset. The only information available is the changeset. If you want to adjust the behavior based on other details of the request, like the current user, you are most likely looking for authorization. A validation is a module that implements the Ash.Resource.Validation behaviour. The built in validations expose utility functions that are imported into the resource's scope, to make them easier to read. You can do this with custom validations as well. See the documentation in Ash.Resource.Validation for more information. Right now, there are not very many built in validations, but the idea is that eventually we will have a rich library of built in validations to choose from. Validations can be scoped to the type ( :create , :update , :destroy ) of action (but not to specific actions). If you would like to adjust the validations for a specific action, you can place that validation directly in the action, i.e create :create do validate attribute_equals ( :name , &quot; fred ) end Important Note By default, validations in the global validations block will run on create and update only. Many validations don't make sense in the context of destroys. To make them run on destroy, use on: [:create, :update, :destroy] Examples validations do validate present ( [ :foo , :bar ] ) , on : :update validate present ( [ :foo , :bar , :baz ] , at_least : 2 ) , on : :create validate absent ( [ :foo , :bar , :baz ] , exactly : 1 ) , on : [ :update , :destroy ] validate { MyCustomValidation , [ foo : :bar ] } , on : :create end","ref":"validate-changes.html#validations-section","title":"Validate Changes - Validations Section","type":"extras"},{"doc":"","ref":"actions.html","title":"Actions","type":"extras"},{"doc":"Ash has 4 action types :read , :create , :update , :destroy . The purpose of these action types is to provide expectations about what is required to run those actions, and what is returned from them. The actions do not need to do exactly what their action type implies however. Using manual actions, you can define a create action that actually updates something, or using the soft? option for destroy actions you can treat them as updates. The important part to consider is their interface. More action types may be added in the future. Actions either read data or mutate it. :read actions are fundamentally different from :create , :update and :destroy actions. For the most part, :create , :update and :destroy follow all of the same rules, and so will be grouped together when explaining how they behave. Small differences will be pointed out in a few places.","ref":"actions.html#action-types","title":"Actions - Action Types","type":"extras"},{"doc":"Name Your Actions The intent behind Ash is not to have you building simple CRUD style applications. In a typical set up you may have a resource with four basic actions, there is even a shorthand to accomplish this: actions do defaults [ :create , :read , :update , :destroy ] end But that is just a simple way to get started, or to create resources that really don't do anything beyond those four operations. You can have as many actions as you want . The best designed Ash applications will have numerous actions, named after the intent behind how they are used. They won't have all reads going through a single read action, and the same goes for the other action types. The richer the actions on the resource, the better interface you can have. With that said, many resources may only have those four basic actions, especially those that are &quot;managed&quot; through some parent resource. See the guide on Managing Relationships for more. Primary Actions Primary actions are a way to inform the framework which actions should be used in certain &quot;automated&quot; circumstances, or in cases where an action has not been specified. If a primary action is attempted to be used but does not exist, you will get an error about it at runtime. The place you typically need primary actions is, when Managing Relationships . However, some prefer to be as explicit as possible, and so will always indicate an action name, and in that case will never use primary actions. When using the defaults option to add default actions, they are marked as primary. A simple example where a primary action would be used: # No action is specified, so we look for a primary read. Api . get! ( Resource , &quot;8ba0ab56-c6e3-4ab0-9c9c-df70e9945281&quot; ) To mark an action as primary, add the option, i.e read :action_name do primary? true end Put everything inside the action! Ash provides utilities to modify queries and changesets outside of the actions on the resources. This is a very important tool in our tool belt, but it is very easy to abuse. The intent is that as much behavior as possible is put into the action. Here is the &quot;wrong way&quot; to do it. There is a lot going on here, so don't hesitate to check out other relevant guides if you see something you don't understand. def top_tickets ( user_id ) do Ticket |&gt; Ash.Query . for_read ( :read ) |&gt; Ash.Query . filter ( priority in [ :medium , :high ] ) |&gt; Ash.Query . filter ( representative_id == ^ user_id ) |&gt; Ash.Query . filter ( status == :open ) |&gt; Ash.Query . sort ( opened_at : :desc ) |&gt; Ash.Query . limit ( 10 ) |&gt; Helpdesk.Support . read! ( ) end # in the resource defaults [ :read , ... ] And here is the &quot;right way&quot;, where the rules about getting the top tickets have been moved into the resource as a nicely named action, and included in the code_interface of that resource. The reality of the situation is that top_tickets/1 is meant to be obsoleted by your Ash resource! Here is how it should be done. # in the resource code_interface do define_for Helpdesk.Support define :top , args : [ :user_id ] end read :top do argument :user_id , :uuid do allow_nil? false end prepare build ( limit : 10 , sort : [ opened_at : :desc ] ) filter expr ( priority in [ :medium , :high ] and representative_id == ^ arg ( :user_id ) and status == :open ) end Now, whatever code I had that would have called top_tickets/1 can now call Helpdesk.Support.Ticket.top(user.id) . By doing it this way, you get the primary benefit of getting a nice simple Api to call into, but you also have a way to modify how the action is invoked in any way necessary, by going back to the old way of building the query manually. For example, if I also only want to see top tickets that were opened in the last 10 minutes: Ticket |&gt; Ash.Query . for_read ( :top ) |&gt; Ash.Query . filter ( opened_at &gt; ago ( 10 , :minute ) ) |&gt; Helpdesk.Support . read! ( ) That is the best of both worlds! These same lessons transfer to changeset based actions as well.","ref":"actions.html#idiomatic-actions","title":"Actions - Idiomatic Actions","type":"extras"},{"doc":"Ash uses an &quot;engine&quot; internally that takes lists of &quot;requests&quot; that have dependencies on each-other, and resolves them in some acceptable order. This engine allows for things like parallelizing steps and performing complex workflows without having to handwrite all of the control flow. It isn't important that you know how the engine works, but knowing the basic idea of &quot;list of requests get sent to the engine&quot; should help contextualize the following flow charts. Read Actions Read actions operate on an Ash.Query . They take no input by default, but arguments can be added to the action. All read actions expect to work on lists. The act of pagination, or returning a single result, is handled as part of the interface, and is not a concern of the action itself. Here is an example of a read action: # Giving your actions informative names is always a good idea read :ticket_queue do # Use arguments to take in values to run your read action. argument :priorities , { :array , :atom } do constraints items : [ one_of : [ :low , :medium , :high ] ] end # This action may be paginated, and returns a total count of records by default pagination offset : true , countable : :by_default # Use arguments to modify filters # You can also use arguments in custom preparations using `Ash.Changeset.get_argument/2` # This is useful when a simple filter like the one below does not suffice filter expr ( status == :open and priority in ^ arg ( :priorities ) ) end Ash.Query.for_read/4 The following steps are performed when you call Ash.Query.for_read/4 . Gather Process Context Cast input arguments - d:Ash.Resource.Dsl.actions.read.argument Set default argument values - d:Ash.Resource.Dsl.actions.read.argument|default Add errors for missing required arguments | d:Ash.Resource.Dsl.actions.read.argument|allow_nil? Run query preparations | d:Ash.Resource.Dsl.actions.read.prepare Add action filter | d:Ash.Resource.Dsl.actions.read|filter Running the Read Action If the query has not yet been run through Ash.Query.for_read/3 for the action in question, we do that first. Then we perform the following steps. These steps are trimmed down, and are aimed at helping users understand the general flow. Some steps are omitted. Run Ash.Query.for_read/3 if it has not already been run Apply tenant filters for attribute Apply pagination options Run before action hooks Multi-datalayer filter is synthesized. We run queries in other data layers to fetch ids and translate related filters to (destination_field in ^ids) Strict Check &amp; Filter Authorization is run Data layer query is built and validated Data layer query is Run Authorizer &quot;runtime&quot; checks are run (you likely do not have any of these) The following steps happen asynchronously during or after the main data layer query has been run If paginating and count was requested, the count is determined at the same time as the query is run. Any calculations &amp; aggregates that were able to be run outside of the main query are run Any relationships are loaded Create/Update/Destroy Actions These actions operate on an Ash.Changeset . While standard destroy actions don't care about the changes you add to a changeset, you may mark a destroy action as d:Ash.Resource.Dsl.actions.destroy|soft? , which means you will be performing an update that will in some way &quot;hide&quot; the resource. Generally this hiding is done by adding a d:Ash.Resource.Dsl.resource|base_filter i.e base_filter [is_nil: :archived_at] Here is an example create action: create :register do # By default all public attributes are accepted, but this should only take email accept [ :email ] # Accept additional input by adding arguments argument :password , :string do allow_nil? false end argument :password_confirmation , :string do allow_nil? false end # Use the built in `confirm/2` validation validate confirm ( :password , :password_confirmation ) # Call a custom change that will hash the password change MyApp.User.Changes.HashPassword end Changesets for actions The following steps are run when calling Ash.Changeset.for_create/4 , Ash.Changeset.for_update/4 or Ash.Changeset.for_destroy/4 . Gather process context Cast input params | This is any arguments in addition to any accepted attributes Set argument defaults Require any missing arguments Validate all provided attributes are accepted Require any accepted attributes that are allow_nil? false Set any default values for attributes Run action changes &amp; validations Run validations, or add them in before_action hooks if using d:Ash.Resource.Dsl.actions.create.validate|before_action? Running the Create/Update/Destroy Action All of these actions are run in a transaction if the data layer supports it. You can opt out of this behavior by supplying transaction?: false when creating the action. When an action is being run in a transaction, all steps inside of it are serialized, because generally speaking, transactions cannot be split across processes. Authorization is performed on the changes A before action hook is added to set up belongs_to relationships that are managed. This means potentially creating/modifying the destination of the relationship, and then changing the destination_attribute of the relationship. Before transaction hooks are called ( Ash.Changeset.before_transaction/2 ) A transaction is opened if the action is configured for it (by default they are) and the data layer supports transactions Before action hooks are performed in reverse order they were added. (unless append? option was used) For manual actions, a before action hook must have set After action hooks are performed in the order they were added (unless prepend? option was used) For Manual Actions , one of these after action hooks must have returned a result, otherwise an error is returned. Non-belongs-to relationships are managed, creating/updating/destroying related records. A transaction is opened if the action is configured for it (by default they are) and the data layer supports transactions If an after_action option was passed when running the action, it is run with the changeset and the result. Only supported for create &amp; update actions. The transaction is closed, if one was opened After transaction hooks are invoked with the result of the transaction (even if it was an error)","ref":"actions.html#action-lifecycle","title":"Actions - Action Lifecycle","type":"extras"},{"doc":"Aggregates in Ash allow for retrieving summary information over groups of related data. A simple example might be to show the &quot;count of published posts for a user&quot;. Aggregates allow us quick and performant access to this data, in a way that supports being filtered/sorted on automatically. More aggregate types can be added, but you will be restricted to only the supported types. In cases where aggregates don't suffice, use Calculations , which are intended to be much more flexible.","ref":"aggregates.html","title":"Aggregates","type":"extras"},{"doc":"Example: aggregates do count :count_of_posts , :posts do filter expr ( published == true ) end end The available aggregate types are: count - counts related items meeting the criteria first - gets the first related value matching the criteria. Must specify the field to get. sum - sums the related items meeting the criteria. Must specify the field to sum. list - lists the related values. Must specify the field to list. See the docs on d:Ash.Resource.Dsl.aggregates for more information. The aggregates declared on a resource allow for declaring a set of named aggregates that can be used by extensions. As an escape hatch, they can also be loaded in the query using Ash.Query.load/2 , or after the fact using Ash.Api.load/3 . Aggregates declared on the resource will be keys in the resource's struct.","ref":"aggregates.html#declaring-aggregates-on-a-resource","title":"Aggregates - Declaring aggregates on a resource","type":"extras"},{"doc":"Custom aggregates can be added to the query and will be placed in the aggregates key of the results. This is an escape hatch, and is not the primary way that you should be using aggregates. It does, however, allow for dynamism, i.e if you are accepting user input that determines what the filter and/or field should be, that kind of thing. Example: User |&gt; Ash.Query . new ( ) |&gt; Ash.Query . aggregate ( :count_of_posts , :count , :posts , filter : [ published : published? ] ) See the documentation for Ash.Query.aggregate/4 for more information.","ref":"aggregates.html#custom-aggregates-in-the-query","title":"Aggregates - Custom aggregates in the query","type":"extras"},{"doc":"Attributes specify the name, type and properties of a piece of information in a resource.","ref":"attributes.html","title":"Attributes","type":"extras"},{"doc":"There are two ways to write an attribute: attribute :name , :string , allow_nil? : false # or ... attribute :name , :string do allow_nil? false end Both ways will work. Though when you're using many options the latter is preferred. This is also true of any other keyword in the Ash DSL, so you can build a flexible yet concise domain model. For more information on attribute types including composite types and defining your own custom type see Ash.Type You can find a comprehensive of attribute options with detailed descriptions on the d:Ash.Resource.Dsl.attributes page.","ref":"attributes.html#ways-of-writing-attributes","title":"Attributes - Ways of writing attributes","type":"extras"},{"doc":"In Ash there are 4 special attributes these are: create_timestamp update_timestamp integer_primary_key uuid_primary_key These are really just shorthand for an attribute with specific options set. They're outlined below. create_timestamp You may recognise this if you have used Ecto before. This attribute will record the time at which each row is created, by default it uses DateTime.utc_now/1 . create_timestamp :inserted_at is equivalent to an attribute with these options: attribute :inserted_at , :utc_datetime_usec do writeable? false private? true default &amp; DateTime . utc_now / 0 match_other_defaults? true allow_nil? false end update_timestamp This is also similar in Ecto. This attribute records the last time a row was updated, also using DateTime.utc_now/1 by default. update_timestamp :updated_at is equivalent to: attribute :updated_at , :utc_datetime_usec do writeable? false private? true default &amp; DateTime . utc_now / 0 updated_default &amp; DateTime . utc_now / 0 match_other_defaults? true allow_nil? false end uuid_primary_key This attribute is used in almost every resource. It generates a UUID every time a new record is made. uuid_primary_key :id is equivalent to: attribute :id , :uuid do writeable? false default &amp; Ash.UUID . generate / 0 primary_key? true allow_nil? false end integer_primary_key Don't use this attribute unless absolutely necessary, there are a lot of good reasons to not use autoincrementing integer ids . If you do, please make sure these resource are only accessed internally and aren't exposed via a public API. integer_primary_key :id is equivalent to: attribute :id , :integer do writeable? false generated? true primary_key? true allow_nil? false end","ref":"attributes.html#special-attributes","title":"Attributes - Special attributes","type":"extras"},{"doc":"Calculations in Ash allow for displaying complex values as a top level value of a resource.","ref":"calculations.html","title":"Calculations","type":"extras"},{"doc":"Expression Calculations The simplest kind of calculation refers to an Ash expression. For example: calculations do calculate :full_name , :string , expr ( first_name &lt;&gt; &quot; &quot; &lt;&gt; last_name ) end See the Expressions guide for more. Module Calculations When calculations require more complex code or can't be pushed down into the data layer, a module that uses Ash.Calculation can be used. defmodule Concat do # An example concatenation calculation, that accepts the delimiter as an argument, #and the fields to concatenate as options use Ash.Calculation # Optional callback that verifies the passed in options (and optionally transforms them) @impl true def init ( opts ) do if opts [ :keys ] &amp;&amp; is_list ( opts [ :keys ] ) &amp;&amp; Enum . all? ( opts [ :keys ] , &amp; is_atom / 1 ) do { :ok , opts } else { :error , &quot;Expected a `keys` option for which keys to concat&quot; } end end @impl true # A callback to tell Ash what keys must be loaded/selected when running this calculation def load ( _query , opts , _context ) do opts [ :keys ] end @impl true def calculate ( records , opts , %{ separator : separator } ) do Enum . map ( records , fn record -&gt; Enum . map_join ( opts [ :keys ] , separator , fn key -&gt; to_string ( Map . get ( record , key ) ) end ) end ) end # You can implement this callback to make this calculation possible in the data layer # *and* in elixir. Ash expressions are already executable in Elixir or in the data layer, but this gives you fine grain control over how it is done # @impl true # def expression(opts, context) do # end end # Usage in a resource calculations do calculate :full_name , :string , { Concat , keys : [ :first_name , :last_name ] } do # You need to use the [allow_empty?: true, trim?: false] constraints here. # The separator could be an empty string or require a leading or trailing space, # but would be trimmed or even set to `nil` without the constraints shown below. argument :separator , :string do allow_nil? false constraints [ allow_empty? : true , trim? : false ] default &quot;&quot; end end end See the documentation for the calculations section in Ash.Resource.Dsl and the Ash.Calculation docs for more information. The calculations declared on a resource allow for declaring a set of named calculations that can be used by extensions. They can also be loaded in the query using Ash.Query.load/2 , or after the fact using Ash.Api.load/3 . Calculations declared on the resource will be keys in the resource's struct.","ref":"calculations.html#declaring-calculations-on-a-resource","title":"Calculations - Declaring calculations on a resource","type":"extras"},{"doc":"Example: User |&gt; Ash.Query . new ( ) |&gt; Ash.Query . calculate ( :full_name , { Concat , keys : [ :first_name , :last_name ] } , :string , %{ separator : &quot;,&quot; } ) See the documentation for Ash.Query.calculate/4 for more information.","ref":"calculations.html#custom-calculations-in-the-query","title":"Calculations - Custom calculations in the query","type":"extras"},{"doc":"Using the above example with arguments, you can load a calculation with arguments like so: load ( full_name : [ separator : &quot;,&quot; ] ) If the calculation uses an expression, you can also filter and sort on it like so: query |&gt; Ash.Query . filter ( full_name ( separator : &quot;,&quot; ) ) |&gt; Ash.Query . sort ( full_name : { :asc , %{ separator : &quot;,&quot; } } )","ref":"calculations.html#arguments-in-calculations","title":"Calculations - Arguments in calculations","type":"extras"},{"doc":"One of the ways that we interact with our resources is via hand-written code. The general pattern for that looks like building a query or a changeset for a given action, and dispatching it to the api using things like MyApi.read/3 and MyApi.create/3 . This, however, is just one way to use Ash, and is designed to help you build tools that work with resources, and to power things like AshPhoenix.Form , AshGraphql.Resource and AshJsonApi.Resource . When working with your resources in code, we generally want something more idiomatic and simple. For example, on a resource called Helpdesk.Support.Ticket : code_interface do define_for Helpdesk.Support define :open , args : [ :subject ] end This simple setup now allows you to open a ticket with Helpdesk.Support.Ticket.open(subject) . You can cause it to raise errors instead of return them with Helpdesk.Support.Ticket.open!(subject) . For information on the options and additional inputs these defined functions take, look at the generated function documentation, which you can do in iex with h Helpdesk.Support.Ticket.open . For more information on the code interface, read the DSL documentation: d:Ash.Resource.Dsl.code_interface .","ref":"code-interface.html","title":"Code Interface","type":"extras"},{"doc":"Notice how we included a specific Api module using define_for above. Without this, no functions will be defined in the resource. This is because you might want to define the interface for multiple resources in a single module. While we encourage the use of define_for Api , it is not the only way to do it. You could also do something like this: defmodule MyApp.MyApi.Interface do require Ash.CodeInterface Ash.CodeInterface . define_interface ( MyApp.MyApi , MyApp.Resource1 ) Ash.CodeInterface . define_interface ( MyApp.MyApi , MyApp.Resource2 ) end And then call functions on MyApp.MyApi.Interface instead.","ref":"code-interface.html#define_for-and-define_interface","title":"Code Interface - define_for and define_interface","type":"extras"},{"doc":"If the action is an update or destroy, it will take a record or a changeset as its first argument. If the action is a read action, it will take a starting query as an opt in the last argument. All functions will have an optional last argument that accepts options. See Ash.Resource.Interface.interface_options/1 for valid options. For reads: :query - a query to start the action with, can be used to filter/sort the results of the action. For creates: :changeset - a changeset to start the action with They will also have an optional second to last argument that is a freeform map to provide action input. It must be a map . If it is a keyword list, it will be assumed that it is actually options (for convenience). This allows for the following behaviour: # Because the 3rd argument is a keyword list, we use it as options Api . register_user ( username , password , [ tenant : &quot;organization_22&quot; ] ) # Because the 3rd argument is a map, we use it as action input Api . register_user ( username , password , %{ key : &quot;val&quot; } ) # When all arguments are provided it is unambiguous Api . register_user ( username , password , %{ key : &quot;val&quot; } , [ tenant : &quot;organization_22&quot; ] )","ref":"code-interface.html#using-the-code-interface","title":"Code Interface - Using the code interface","type":"extras"},{"doc":"Resource calculations can be run dynamically using YourApi.calculate/3 , but you can also expose them using the code_interface with define_calculation . For example: calculations do calculate :full_name , :string , expr ( first_name &lt;&gt; ^ arg ( :separator ) &lt;&gt; last_name ) do argument :separator , :string do allow_nil? false default &quot; &quot; end end end code_interface do define_for YourApi define_calculation :full_name , args : [ :first_name , :last_name , { :optional , :separator } ] # or if you want to take a record sa an argument define_calculation :full_name , args : [ :_record ] end This could now be used like so: User . full_name ( &quot;Jessie&quot; , &quot;James&quot; , &quot;-&quot; ) # or with a record as an argument User . full_name ( user ) This allows for running calculations without an instance of a resource, i.e Api.load(user, :full_name)","ref":"code-interface.html#calculations","title":"Code Interface - Calculations","type":"extras"},{"doc":"Constraints are a way of validating an input type. This validation can be used in both attributes and arguments. The kinds of constraints you can apply depends on the type the data. You can find all types in Ash.Type . Each type has its own page on which the available constraints are listed. For example in Ash.Type.String you can find 5 constraints: :max_length :min_length :match :trim? :allow_empty? You can also discover these constraints from iex: $ iex -S mix iex(1)&gt; Ash.Type.String.constraints [ max_length: [ type: :non_neg_integer, doc: &quot;Enforces a maximum length on the value&quot; ], min_length: [ type: :non_neg_integer, doc: &quot;Enforces a minimum length on the value&quot; ], match: [ type: {:custom, Ash.Type.String, :match, []}, doc: &quot;Enforces that the string matches a passed in regex&quot; ], trim?: [type: :boolean, doc: &quot;Trims the value.&quot;, default: true], allow_empty?: [ type: :boolean, doc: &quot;If false, the value is set to `nil` if it&#39;s empty.&quot;, default: false ] ]","ref":"constraints.html","title":"Constraints","type":"extras"},{"doc":"To show how constraints can be used in a attribute, here is an example attribute describing a username: defmodule MyProject.MyApi.Account do # ... code_interface do define_for MyProject.MyApi.Account define :create , action : :create end actions do default [ :create , :read , :update , :destroy ] end attributes do uuid_primary_key :id attribute :username , :string do constraints [ max_length : 20 , min_length : 3 , match : ~r/^[a-z_-]*$/ , trim? : true , allow_empty? : false ] end end # ... end If when creating or updating this attribute one of the constraints are not met, an error will be given telling you which constraint was broken. See below: iex(1)&gt; MyProject.MyApi.Account . create! ( %{ username : &quot;hi&quot; } ) ** (Ash.Error.Invalid) Input Invalid * Invalid value provided for username : length must be greater than or equal to 3 . &quot;hi&quot; iex(2)&gt; MyProject.MyApi.Account . create! ( %{ username : &quot;Hello there this is a long string&quot; } ) ** (Ash.Error.Invalid) Input Invalid * Invalid value provided for username : length must be less than or equal to 20 . &quot;Hello there this is a long string&quot; iex(3)&gt; MyProject.MyApi.Account . create! ( %{ username : &quot;hello there&quot; } ) ** (Ash.Error.Invalid) Input Invalid * Invalid value provided for username : must match the pattern ~r/^[a-z_-]*$/ . &quot;hello there&quot; iex(4)&gt; MyProject.MyApi.Account . create! ( %{ username : &quot;&quot; } ) ** (Ash.Error.Invalid) Input Invalid * attribute title is required It will give you the resource as usual on successful requests: iex(5)&gt; MyProject.MyApi.Account . create! ( %{ username : &quot;hello&quot; } ) # MyProject.MyApi.Account &lt; __meta__ : # Ecto.Schema.Metadata &lt; :loaded , &quot;account&quot; &gt; , id : &quot;7ba467dd-277c-4916-88ae-f62c93fee7a3&quot; , username : &quot;hello&quot; , ... &gt;","ref":"constraints.html#attributes-with-constraints","title":"Constraints - Attributes with Constraints","type":"extras"},{"doc":"Arguments are used to input data into actions. As the data we pass in has a type we can apply constraints to validate the input arguments. defmodule MyProject.MyApi.Account do # ... code_interface do define_for MyProject.MyApi.Account define :create_username_with_age , action : :create_username_with_age end actions do default [ :create , :read , :update , :destroy ] create :create_username_with_age do argument :title , :string , allow_nil? : false argument :age , :integer do allow_nil? false constraints min : 18 , max : 99 end change fn changeset , _ -&gt; username = Ash.Changeset . get_argument ( changeset , :username ) age = Ash.Changeset . get_argument ( changeset , :age ) Ash.Changeset . change_attribute ( changeset , :username , &quot; \#{ username } - \#{ age } &quot; ) end end end attributes do uuid_primary_key :id attribute :username , :string do constraints [ max_length : 20 , min_length : 3 , match : ~r/^[a-z0-9_-]*$/ , trim? : true , allow_empty? : false ] end end # ... end If you input argument is going to be used as a attribute directly, its best to put the constraint in the attributes block. But if you are combining multiple arguments to synthesize an attribute, then you should apply constraints to the arguments. Above we have defined a custom action which takes 2 arguments :title and :age this action creates a username where the age of the user is embedded. However we have placed a limitation via the constraints so that only when age &gt;= 18 and age &lt;= 99 is the action allowed to occur. Lets see this in action. iex(1)&gt; MyProject.MyApi.Account . create_username_with_age! ( %{ username : &quot;hello&quot; , age : 100 } ) ** (Ash.Error.Invalid) Input Invalid * Invalid value provided for age : must be less than or equal to 99 . 100 iex(2)&gt; MyProject.MyApi.Account . create_username_with_age! ( %{ username : &quot;hello&quot; , age : 99 } ) # MyProject.MyApi.Account &lt; __meta__ : # Ecto.Schema.Metadata &lt; :loaded , &quot;accounts&quot; &gt; , id : &quot;5a28d5a1-25e6-4363-b173-3dd64e629dc8&quot; , title : &quot;hello-99&quot; , ... &gt;","ref":"constraints.html#arguments-with-constraints","title":"Constraints - Arguments with Constraints","type":"extras"},{"doc":"","ref":"development-utilities.html","title":"Development Utilities","type":"extras"},{"doc":"The Ash ElixirSense plugin offers custom auto complete inside of any Ash DSL module (i.e resource/api/flow/registry) As of this writing, this does not work with the currently released VSCode package. We are waiting for them to do another release to resolve this issue. However, you can clone down the elixir-ls repository, run its release command, and configure VSCode to point at the folder where you did that.","ref":"development-utilities.html#elixirsense-plugin","title":"Development Utilities - ElixirSense Plugin","type":"extras"},{"doc":"The underlying DSL tooling Spark has a formatter plugin that can help you keep your resources consistent and neat. Adding the plugin Add the following to your .formatter.exs [ plugins : [ Spark.Formatter ] , # &lt;- add the plugin here inputs : ... ] Configuration config :spark , :formatter , [ &quot;Ash.Resource&quot; : [ section_order : [ :resource , :identities , :attributes , :relationships , ... ] ] , # If you use a different module than Ash.Resource &quot;MyApp.Resource&quot; : [ type : Ash.Resource , # What extensions might be added by your base module extensions : [ ... ] , section_order : [ :resource , :identities , :attributes , :relationships , ... ] ] ]","ref":"development-utilities.html#formatter-plugin","title":"Development Utilities - Formatter plugin","type":"extras"},{"doc":"Embedded resources function very similarly to embedded schemas in Ecto . The primary difference is the same as the primary difference between Ecto schemas and Ash resources: the full lifecycle of the resource is managed by its configuration. For example, you can add validations, calculations, and even authorization policies to an embedded resource. Here is an example of a simple embedded resource: defmodule MyApp.Profile do use Ash.Resource , data_layer : :embedded # Use the atom `:embedded` as the data layer. attributes do attribute :first_name , :string attribute :last_name , :string end end Embedded resources cannot have relationships or aggregates.","ref":"embedded-resources.html","title":"Embedded Resources","type":"extras"},{"doc":"Embedded resources define an Ash.Type under the hood, meaning you can use them anywhere you would use an Ash type. defmodule MyApp.User do use Ash.Resource , ... attributes do ... attribute :profile , MyApp.Profile attribute :profiles , { :array , MyApp.Profile } # You can also have an array of embeds end end","ref":"embedded-resources.html#adding-embedded-resource-attributes","title":"Embedded Resources - Adding embedded resource attributes","type":"extras"},{"doc":"If you manually supply instances of the embedded structs, the structs you provide are used with no validation. For example: Ash.Changeset . new ( user , %{ profile : % MyApp.Profile { first_name : &quot;first_name&quot; , last_name : &quot; last_name } } ) However, you can also treat embedded resources like regular resources that can be &quot;created&quot;, &quot;updated&quot;, and &quot;destroyed&quot;. To do this, provide maps as the input, instead of structs. In the example above, if you just wanted to change the first_name , you'd provide: Ash.Changeset . new ( user , %{ profile : %{ first_name : &quot;first_name&quot; } } ) This will call the primary update action on the resource. This allows you to define an action on the embed, and add validations to it. For example, you might have something like this: defmodule MyApp.Profile do use Ash.Resource , data_layer : :embedded # Use the atom `:embedded` as the data layer. attributes do attribute :first_name , :string attribute :last_name , :string end validations do validate present ( [ :first_name , :last_name ] , at_least : 1 ) end end","ref":"embedded-resources.html#editing-embedded-attributes","title":"Embedded Resources - Editing embedded attributes","type":"extras"},{"doc":"Calculations can be added to embedded resources. When you use an embedded resource, you declare what calculations to load via a constraint . For example: defmodule MyApp.Profile do use Ash.Resource , data_layer : :embedded # Use the atom `:embedded` as the data layer. attributes do attribute :first_name , :string attribute :last_name , :string end calculations do calculate :full_name , :string , concat ( [ :first_name , :last_name ] , &quot; &quot; ) end end defmodule MyApp.User do use Ash.Resource , ... attributes do attribute :profile , MyApp.Profile do constraints [ load : [ :full_name ] ] end end end","ref":"embedded-resources.html#calculations","title":"Embedded Resources - Calculations","type":"extras"},{"doc":"Remember: default actions are already implemented for a resource, with no need to add them. They are called :create , :update , :destroy , and :read . You can use those without defining them. You only need to define them if you wish to override their configuration. Single Embeds If the current value is nil - a create with the provided values If the current value is not nil - an update with the provided values If the current value is not nil and the new value is nil - a destroy with the original value Array Embeds All values in the original array are destroyed, and all maps in the new array are used to create new records.","ref":"embedded-resources.html#determining-what-action-s-will-be-called","title":"Embedded Resources - Determining what action(s) will be called:","type":"extras"},{"doc":"Adding a primary key to your embedded resources is especially useful when managing lists of data. Specifically, it allows you to consider changes to elements with matching primary key values as updates . For example: defmodule MyApp.Tag do use Ash.Resource , data_layer : :embedded attributes do uuid_primary_key :id attribute :name , :string attribute :counter , :integer end validations do validate { Increasing , field : :counter } , on : :update end end Now, you can accept input meant to update individual list items. The entire list must still be provided, but any items with a matching id will be considered an update instead of a destroy + create . Determining what action(s) will be called with a primary key: Single Embeds with primary keys If you provide a struct, instead of a map, the value provided is used as the new relationship value directly. If the current value is nil - a create with the provided values If the current value is not nil and the primary keys match - an update with the provided values If the current value is not nil and the primary keys don't match - a destroy of the original value and a create of the new value If the current value is not nil and the new value is nil - a destroy with the original value Array Embeds with primary keys If you provide structs, instead of maps, the value provided is used as the new relationship value directly. Any values in the original list with no primary key matching in the new list are destroy ed. Any values in the new list with no primary key matching in the original list are create d. Any values with a primary key match in the original list and the new list are update d","ref":"embedded-resources.html#adding-a-primary-key","title":"Embedded Resources - Adding a primary key","type":"extras"},{"doc":"Identities can be added on an embedded resource, which will ensure that for any given list, they are unique on that identity. For example, if you had an embedded resource called Tag , you could add an identity on name to ensure that nothing has duplicate tag names.","ref":"embedded-resources.html#identities","title":"Embedded Resources - Identities","type":"extras"},{"doc":"The AshJsonApi extension exposes these attributes as maps. However, the AshGraphql extension allows you to specify a type (but not queries/mutations) for an embedded resource. If you do, instead of being treated as a :json type it will get its own named input object type and field type.","ref":"embedded-resources.html#usage-in-extensions","title":"Embedded Resources - Usage in Extensions","type":"extras"},{"doc":"When building changesets for embedded resources, the source changeset will be available in action changes under changeset.context.__source__ . This allows you to customize the action based on the details of the parent changeset.","ref":"embedded-resources.html#accessing-the-source-changeset","title":"Embedded Resources - Accessing the source changeset","type":"extras"},{"doc":"Ash expressions are used in various places like calculations, filters, and policies, and are meant to be portable representations of elixir expressions. You can create an expression using the Ash.Query.expr/1 macro, like so: Ash.Query . expr ( 1 + 2 ) Ash.Query . expr ( x + y ) Ash.Query . expr ( post . title &lt;&gt; &quot; | &quot; &lt;&gt; post . subtitle ) Ash expressions have some interesting properties in their evaluation, primarily because they are made to be portable, i.e executable in some data layer (like SQL) or executable in Elixir. In general, these expressions will behave the same way they do in Elixir. The primary difference is how nil values work. They behave the way that NULL values behave in SQL. This is primarily because this pattern is easier to replicate to various popular data layers, and is generally safer when using expressions for things like authentication. The practical implications of this are that nil values will &quot;poison&quot; many expressions, and cause them to return nil . For example, x + nil would always evaluate to nil .","ref":"expressions.html","title":"Expressions","type":"extras"},{"doc":"The following operators are available and they behave the same as they do in Elixir, except for the nil addendum above. == != &gt; &gt;= &lt; &lt;= in * - / &lt;&gt; || &amp;&amp; is_nil | Custom, accepts a boolean on the right side i.e x is_nil true or x is_nil false .","ref":"expressions.html#operators","title":"Expressions - Operators","type":"extras"},{"doc":"The following functions are built in. Data Layers can add their own functions to expressions. For example, AshPostgres adds a fragment function that allows you to provide SQL directly. The following functions are built in: if | Works like elixir's if . is_nil/1 | Works like elixir's is_nil get_path/2 | i.e get_path(value, [&quot;foo&quot;, &quot;bar&quot;]) . This is what expressions like value[:foo][&quot;bar&quot;] are turned into under the hood. ago/2 | i.e deleted_at &gt; ago(7, :day) . The available time intervals are documented in Ash.Type.DurationName contains/2 | if one string contains another string, i.e contains(&quot;fred&quot;, &quot;red&quot;) length/1 | the length of a list, i.e. length([:foo, :bar]) exists/2 | exists(foo.bar, name == &quot;fred&quot;) takes an expression scoped to the destination resource, and checks if any related entry matches. See the section on exists below. path.exists/2 | Same as exists but the source of the relationship is itself a nested relationship. See the section on exists below. this/1 | Allows an expression scoped to a resource to refer to the &quot;outer&quot; context. type/2 | Cast a given value to a specific type, i.e type(^arg(:id), :uuid) or type(integer_field, :string) now/0 | Evaluates to the current time when the expression is evaluated string_join/1 | Concatenates a list of strings, and ignores any nil values string_join/2 | As above, but with a joiner","ref":"expressions.html#functions","title":"Expressions - Functions","type":"extras"},{"doc":"cond - cond is transformed to a series of if expressions under the hood item[:key] or item[&quot;key&quot;] - accesses keys in a map. In both cases, it prefers a matching atom key, falling back to a matching string key. This is to aid with data stores that store embeds as JSON with string keys (like AshPostgres), so that this expression behaves the same in the data layer as it does in Elixir.","ref":"expressions.html#primitives","title":"Expressions - Primitives","type":"extras"},{"doc":"Most of the time, when you are using an expression, you will actually be creating a template . In this template, you have a few references that can be used, which will be replaced when before the expression is evaluated. The following references are available. The ones that start with ^ must be imported from Ash.Filter.TemplateHelpers . ^ actor ( :key ) # equivalent to `get_in(actor || %{}, [:key])` ^ actor ( [ :key1 , :key2 ] ) # equivalent to `get_in(actor || %{}, [:key, :key2])` ^ arg ( :arg_name ) # equivalent to `Map.get(arguments, :arg_name)` ^ context ( :key ) # equivalent to `get_in(context, :key)` ^ context ( [ :key1 , :key2 ] ) # equivalent to `get_in(context, [:key1, :key2])` ref ( :key ) # equivalent to referring to `key`. Allows for dynamic references ref ( :key , [ :path ] ) # equivalent to referring to `path.key`. Allows for dynamic references with dynamic (or static) paths.","ref":"expressions.html#templates","title":"Expressions - Templates","type":"extras"},{"doc":"Filters The most obvious place we use expressions is when filtering data. For example: Ash.Query . filter ( Ticket , status == :open and opened_at &gt;= ago ( 10 , :day ) ) These filters will be run in the data layer, i.e in the SQL query. Filter semantics &amp; joins The semantics of Ash filters are probably slightly different than what you are used to, and they are important to understand. Every filter expression is always talking about a single row, potentially &quot;joined&quot; to single related rows. By referencing relationships, you are implicitly doing a join. For those familiar with SQL terminology, it is equivalent to a left join, although AshPostgres can detect when it is safe to do an inner join (for performance reason). Lets use an example of posts and comments . Given a filter like the following: Ash.Query . filter ( Post , comments . points &gt; 10 and comments . tag . name == &quot;elixir&quot; ) The filter refers to a single post/comment/tag combination . So in english, this is &quot;posts where they have a comment with more than 10 points and that same comment has a tag with the name elixir &quot;. What this also means is that filters like the above do not compose nicely when new filters are added. For example: def has_comment_with_more_points_than ( query , score ) do Ash.Query . filter ( Post , comments . points &gt; 10 ) end def has_comment_tagged ( query , tag ) do Ash.Query . filter ( Post , comments . tag . name == ^ tag ) end Post |&gt; has_comment_with_more_points_than ( query , 10 ) |&gt; has_comment_tagged ( &quot;elixir&quot; ) That code seems like it ought to produce a filter over Post that would give us any post with a comment having more than 10 points, and with a comment tagged elixir . That is not the same thing as having a single comment that meets both those criteria. So how do we make this better? Exists Lets rewrite the above using exists: def has_comment_with_more_points_than ( query , score ) do Ash.Query . filter ( Post , exists ( comments , points &gt; 10 ) ) end def has_comment_tagged ( query , tag ) do Ash.Query . filter ( Post , exists ( comments . tag . name == ^ tag ) end Post |&gt; has_comment_with_more_points_than ( query , 10 ) |&gt; has_comment_tagged ( &quot;elixir&quot; ) Now, they will compose properly! Generally speaking, you should use exists when you are filtering across any relationships that are to_many relationships *even if you don't expect your filter to be composed. Currently, the filter syntax does not minimize(combine) these exists/2 statements, but doing so is not complex and can be added. While unlikely, please lodge an issue if you see any performance issues with exists . Exists at path Sometimes, you want the ability to say that some given row must have an existing related entry matching a filter. For example: Ash.Query . filter ( Post , author . exists ( roles , name == :admin ) and author . active ) While the above is not common, it can be useful in some specific circumstances, and is used under the hood by the policy authorizer when combining the filters of various resources to create a single filter.","ref":"expressions.html#use-cases-for-expressions","title":"Expressions - Use cases for expressions","type":"extras"},{"doc":"Ash expressions being portable is more important than it sounds. For example, if you were using AshPostgres and had the following calculation, which is an expression capable of being run in elixir or translated to SQL: calculate :full_name , :string , expr ( first_name &lt;&gt; &quot; &quot; &lt;&gt; last_name ) And you did something like the following: User |&gt; Ash.Query . load ( :full_name ) |&gt; Ash.Query . sort ( :full_name ) |&gt; Accounts . read! ( ) You would see that it ran a SQL query with the full_name calculation as SQL. This allows for sorting on that value. However, if you had something like this: # data can be loaded in the query like above, or on demand later Accounts . load! ( user , :full_name ) you would see that no SQL queries are run. The calculation is run directly in Elixir and the value is set.","ref":"expressions.html#portability","title":"Expressions - Portability","type":"extras"},{"doc":"Parent is a way to &quot;jump out&quot; of a scoped expression. Here are some examples: Ash.Query . filter ( exists ( open_tickets , severity &gt;= parent ( severity_threshold ) ) ) COMING SOON The following two examples do not work currently, but are being worked on has_many :relevant_tickets , Ticket * * do * * filter expr ( status == :open and severity &gt;= parent ( severity_threshold ) ) end count :count_of_relevant_tickets , :open_tickets do filter expr ( status == :open and severity &gt;= parent ( severity_threshold ) ) end Referencing related values Related values can be references using dot delimiters, i.e Ash.Query.filter(user.first_name == &quot;fred&quot;) . When referencing related values in filters, if the reference is a has_one or belongs_to , the filter does exactly what it looks like (matches if the related value matches). If it is a has_many or a many_to_many , it matches if any of the related records match. Referencing aggregates and calculations Aggregates are simple, as all aggregates can be referenced in filter expressions (if you are using a data layer that supports it). For calculations, only those that define an expression can be referenced in other expressions. Here are some examples: # given a `full_name` calculation Ash.Query . filter ( User , full_name == &quot;Hob Goblin&quot; ) # given a `full_name` calculation that accepts an argument called `delimiter` Ash.Query . filter ( User , full_name ( delimiter : &quot;~&quot; ) == &quot;Hob~Goblin&quot; )","ref":"expressions.html#parent","title":"Expressions - Parent","type":"extras"},{"doc":"A flow is a static definition of a set of steps to be run. Flows are backed by executors , which determine how the workflow steps are performed. The executor can be overridden on invocation, but not all executors will be capable of running all flows. As of this writing, the default executor is the only one. It runs all steps in parallel unless values must be provided from one step to another, or in steps that are enclosed by a transaction. Ash.Flow is still in its early days, so expect many features, step types, and executors to come in the future. All explanations here pertain to the builtin executor, so be sure to read the documentation of any other executor you may use. Flows are comprised of steps, which each have an input and an result . By default, each step is executed concurrently (or at least may be executed concurrently). When the result of one step is used in another, that will cause them to run in sequence. In the following flow, for example, the :create_user and :create_blank_project steps would happen concurrently, but both would wait on the :create_org step. flow do # Flow arguments allow you to parameterize the flow argument :org_name , :string do allow_nil? false end argument :user_name , :string do allow_nil? false end # The flow returns the result of the `:create_user` step. returns :create_user end steps do # The step is called `:create_org`, and it creates an `Organization` using the `register_org` action. create :create_org , MyApp.Accounts.Organization , :register_org do # The input to the action refers to an argument of the flow input %{ name : arg ( :org_name ) } end # The step is called :create_user, and it creates a `User` using the `:register_user` action. create :create_user , MyApp.Accounts.User , :register_user do input %{ # The input refers to an argument of the flow name : arg ( :user_name ) , # and to the result of another step org : result ( :create_org ) } end # The step is called :create_blank_project, and it creates a `Project` using the `:create_example` action. create :create_blank_project , MyApp.Accounts.Project , :create_example do input %{ # The input refers to the result of another step org : result ( :create_org ) } end end","ref":"flows.html","title":"Flows","type":"extras"},{"doc":"returns determines what the flow returns, and may be one of three things: :step_name - will return the result of the configured step %{step_name: :key} will return a map of each key to the provided step name, i.e %{key: &lt;step_name_result&gt;} [:step_name] - which is equivalent to %{step_name: :step_name} A flow always returns an %Ash.Flow.Result{} , and the return value of a successful flow will be available in %Ash.Flow.Result{result: result} when the flow did not encounter an error. If the flow resulted in an error, error? is set to true , and the result will be nil .","ref":"flows.html#return-values","title":"Flows - Return Values","type":"extras"},{"doc":"A flow can be halted by using the halt_if option on a step, or by a custom step returning {:error, Ash.Flow.Error.Halted.exception(reason: reason)} In this case, the flow will be marked as complete?: false . The result of each step up until this point is saved, and you can then rerun the flow with different inputs by passing the incomplete result into the resume option when running the flow again. Individual steps can be rerun by deleting them from the data field of the flow.","ref":"flows.html#halting-and-resuming-flows","title":"Flows - Halting and Resuming Flows","type":"extras"},{"doc":"Currently, any error anywhere in the flow will fail the flow and will return an error. Over time, error handling behavior will be added, as well as the ability to customize how transactions are rolled back, and to handle errors in a custom way.","ref":"flows.html#errors","title":"Flows - Errors","type":"extras"},{"doc":"Custom steps allow you to implement any custom logic that you need. There aren't really any restrictions on what you do in a custom step, but there is one main consideration if you want your custom step to play nicely with transactions: Generally speaking you should set the touches_resources if you set async? to true. This ensures that the custom step will be run synchronously if any of those resource's data layers is in a corresponding transaction. You don't necessarily need to set all of the resources that will be touched. For example, all AshPostgres resources that share the same repo share the same transaction state.","ref":"flows.html#custom-steps","title":"Flows - Custom steps","type":"extras"},{"doc":"","ref":"glossary.html","title":"Glossary","type":"extras"},{"doc":"An action describes an operation that can be performed for a given resource; it is the verb to a resource's noun . Examples of actions: User. create Comment. delete BlogPost. publish Article. search Ash supports four different types of actions - create , read , update and destroy (collectively often abbreviated as CRUD). A resource can define multiple actions per action type, eg. a publish action would be considered an update because it is updating an existing instance of a resource. Actions are much more flexible than simple CRUD, but these four action types serve as templates for anything you might want to do. See the Actions guide for more information.","ref":"glossary.html#action","title":"Glossary - Action","type":"extras"},{"doc":"The entity that performs an action. Most actions are run on direct user request, eg. if a user presses a Create button on a page then the actor is the user; but an actor might also be an organization, a group, or the system itself. Actors are referenced during authorization - ensuring that the actor is allowed to perform an action, before it takes place. The actor can also be used within actions, to record which entity performed the action. See the Security guide for more information.","ref":"glossary.html#actor","title":"Glossary - Actor","type":"extras"},{"doc":"An aggregate is a special type of field for a resource, one that summarizes related information of the record. A more specialized type of a calculation . If a Project resource has_many Ticket resources, an example of an aggregate on the Project might be to count the tickets associated to each project. See the Aggregates guide for more information.","ref":"glossary.html#aggregate","title":"Glossary - Aggregate","type":"extras"},{"doc":"A method of broadly separating resources into different bounded contexts . Small apps might only have one API, in which case you can set-and-forget it, but apps with larger domains can benefit from different contexts having different views of the same resource. See Ash.Api.Dsl for more information.","ref":"glossary.html#api","title":"Glossary - API","type":"extras"},{"doc":"A piece of data belonging to a resource. The most basic building block; an attribute has a type and a value and is stored within the context of a domain model. See d:Ash.Resource.Dsl.attributes for more information.","ref":"glossary.html#attribute","title":"Glossary - Attribute","type":"extras"},{"doc":"A calculation is a special type of field for a resource, one that is not directly stored in the data layer but generated on-demand when specifically requested as part of a query. Typically it will derive from other information on the record, but it may come from some other data source entirely. See the Calculations guide for more information.","ref":"glossary.html#calculation","title":"Glossary - Calculation","type":"extras"},{"doc":"Changesets encapsulate data changes made while creating or updating an instance of a resource. Similarly to Ecto changesets , they include data validations but they also have their own callback hook lifecycle. See Ash.Changeset for more information.","ref":"glossary.html#changeset","title":"Glossary - Changeset","type":"extras"},{"doc":"A packaged bundle of code that can be included in a resource to provide additional functionality. Built-in functionality such as the resource DSL itself is provided by an extension, and libraries like AshPostgres and AshAdmin also provide extensions that you can add to your resources with just one line of code. See Extending Resources for more information.","ref":"glossary.html#extension","title":"Glossary - Extension","type":"extras"},{"doc":"The tools and functions used to reduce the amount of data returned when running queries on the data layer. This may look like: Fetching Articles that include a certain search term in the title Fetching Posts created by a specific user Fetching Tickets updated in the last week See Ash.Filter for more information.","ref":"glossary.html#filter","title":"Glossary - Filter","type":"extras"},{"doc":"Flows combine actions together into a static workflow, somewhat similarly to Ecto.Multi . The result of running one action in a flow can be used as input to another action, and flows can be halted and resumed on request. Flows also support transactions; steps can be grouped together into transactions or the whole flow can be run inside a single transaction. See the Flows guide for more information.","ref":"glossary.html#flow","title":"Glossary - Flow","type":"extras"},{"doc":"A way to uniquely identify an instance of a resource. A primary key is an example of an identity that is automatically generated; you can manually add others such as a user's email address, or a URL slug for a post. If using AshPostgres, constraints will be created to enforce identities at the database level. See the Identities guide for more information.","ref":"glossary.html#identity","title":"Glossary - Identity","type":"extras"},{"doc":"Notifiers are modules that insert callbacks into the lifecycle of a resource action, to be notified when actions take place. When connected to a resource they are invoked after every action, but via pattern matching on the notification received, they can be made very granular. See the Notifiers guide for more information.","ref":"glossary.html#notifier","title":"Glossary - Notifier","type":"extras"},{"doc":"A set of rules defining who is authorized to perform specific actions on a resource. Common policy checks include rules such as: Forbidding anyone other than the user who wrote a blog post, from editing it Allowing only admins to update site-wide settings See the Policies guide for more information.","ref":"glossary.html#policy","title":"Glossary - Policy","type":"extras"},{"doc":"The tools and functions used for reading and filtering stored data, from the data layer. See Ash.Query for more information.","ref":"glossary.html#query","title":"Glossary - Query","type":"extras"},{"doc":"Relationships (also known as associations ) are named links between resources, that define how they relate to each other. Relationships can be used to signify ownership of a record, membership of a group, or can be used in filtering and querying data. See the Relationships guide for more information.","ref":"glossary.html#relationship","title":"Glossary - Relationship","type":"extras"},{"doc":"A registry defines the set of resources available in your application, via listing entries. You'll probably never need to interact with one directly after setting it up, but it works efficiently for compile-time optimization.","ref":"glossary.html#registry","title":"Glossary - Registry","type":"extras"},{"doc":"The central concept in Ash, a resource is a domain model object in your system, the nouns that your app revolves around. Resources contain definitions of the data they hold in the form of attributes, but also define actions that can be taken on that data and actors that are allowed to run them. It is not a strict requirement that resources contain data - they can be used purely to create a standard interface for performing tasks - but in practice, most resources will be used to manage data. See Ash.Resource.Dsl for more information.","ref":"glossary.html#resource","title":"Glossary - Resource","type":"extras"},{"doc":"Multitenancy is the siloing of your app's data into discrete non-overlapping groups, typically by customer or organization (the tenant). Ash supports multitenancy both at the code level and the data layer level (depending on the data layer; for example, AshPostgres uses schemas to fully separate data per tenant.) See the Multitenancy guide for more information.","ref":"glossary.html#tenant","title":"Glossary - Tenant","type":"extras"},{"doc":"Identities are a way to declare that a record (an instance of a resource) can be uniquely identified by a set of attributes. This information can be used in various ways throughout the framework. The primary key of the resource does not need to be listed as an identity.","ref":"identities.html","title":"Identities","type":"extras"},{"doc":"This will allow these fields to be passed to Ash.Api.get/3 , e.g get(Resource, [email: &quot;foo&quot;]) .","ref":"identities.html#using-api-get","title":"Identities - Using Api.get","type":"extras"},{"doc":"Create actions support the upsert?: true option, if the data layer supports it. An upsert? involves checking for a conflict on some set of attributes, and translating the behavior to an update in the case one is found. By default, the primary key is used when looking for duplicates, but you can set [upsert?: true, upsert_identity: :identity_name] to tell it to look for conflicts on a specific identity.","ref":"identities.html#using-upserts","title":"Identities - Using upserts","type":"extras"},{"doc":"Tools like AshPostgres will create unique constraints in the database automatically for each identity. These unique constraints will honor other configuration on your resource, like the base_filter .","ref":"identities.html#creating-unique-constraints","title":"Identities - Creating unique constraints","type":"extras"},{"doc":"Setting eager_check_with: ApiName on an identity will allow that identity to be checked when building a create changeset over the resource. This allows for showing quick up-front validations about wether some value is taken, for example. If you are using AshPhoenix.Form , for example, this looks for a conflicting record on each call to Form.validate/2 . For updates, it is only checked if one of the involved fields is being changed. For creates, The identity is checked unless your are performing an upsert , and the upsert_identity is this identity. Keep in mind that for this to work properly, you will need to pass the upsert?: true, upsert_identity: :identity_name when creating the changeset instead of passing it to the Api when creating. The primary? action is used to search for a record. This will error if you have not configured one.","ref":"identities.html#eager-checking","title":"Identities - Eager Checking","type":"extras"},{"doc":"pre_check_with: ApiName behaves the same as eager_check_with , but it runs just prior to the action being committed. Useful for data layers that don't support transactions/unique constraints, or manual resources with identities. Ash.DataLayer.Ets will actually require you to set pre_check_with since the ETS data layer has no built in support for unique constraints.","ref":"identities.html#pre-checking","title":"Identities - Pre Checking","type":"extras"},{"doc":"In Ash, managing related data is done via Ash.Changeset.manage_relationship/4 . There are various ways to leverage the functionality expressed there. If you are working with changesets directly, you can call that function. However, if you want that logic to be portable (e.g available in ash_graphql mutations and ash_json_api actions), then you want to use the following argument + change pattern: actions do update :update do argument :add_comment , :map do allow_nil? false end argument :tags , { :array , :uuid } do allow_nil? false end # First argument is the name of the action argument to use # Second argument is the relationship to be managed # Third argument is options. For more, see `Ash.Changeset.manage_relationship/4`. This accepts the same options. change manage_relationship ( :add_comment , :comments , type : :create ) # Second argument can be omitted, as the argument name is the same as the relationship change manage_relationship ( :tags , type : :append_and_remove ) end end With this, those arguments can be used in action input: post |&gt; Ash.Changeset . for_update ( :update , tags : [ tag1 . id , tag2 . id ] , add_comment : %{ text : &quot;comment text&quot; } ) |&gt; MyApi . update! ( )","ref":"managing-relationships.html","title":"Managing Relationships","type":"extras"},{"doc":"Notice how we provided a map as input to add_comment , and a list of UUIDs as an input to manage_relationship . When providing maps or lists of maps, you are generally just providing input that will eventually be passed into actions on the destination resource. However, you can also provide individual values or lists of values. By default, we assume that value maps to the primary key of the destination resource, but you can use the value_is_key option to modify that behavior. For example, if you wanted adding a comment to take a list of strings, you could say: argument :add_comment , :string ... change manage_relationship ( :add_comment , :comments , type : :create , value_is_key : :text ) And then you could use it like so: post |&gt; Ash.Changeset . for_update ( :update , tags : [ tag1 . id , tag2 . id ] , add_comment : &quot;comment text&quot; ) |&gt; MyApi . update! ( )","ref":"managing-relationships.html#argument-types","title":"Managing Relationships - Argument Types","type":"extras"},{"doc":"Determining what will happen when managing related data can be complicated, as the nature of the problem itself is quite complicated. In some simple cases, like type: :create , there may be only one action that will be called. But in order to support all of the various ways that related resources may need to be managed, Ash provides a very rich set of options to determine what happens with the provided input. Tools like AshPhoenix.Form can look at your arguments that have a corresponding manage_relationship change, and derive the structure of those nested forms. Tools like AshGraphql can derive complex input objects to allow manipulating those relationships over a graphql Api. This all works because the options are, ultimately, quite explicit. It can be determined exactly what actions might be called, and therefore what input could be needed.","ref":"managing-relationships.html#derived-behavior","title":"Managing Relationships - Derived behavior","type":"extras"},{"doc":"Manual actions allow you to control how an action is performed instead of simply dispatching to a data layer. To do this, simply specify the manual option with a module that adopts the appropriate behavior. For example: Manual actions are a way to implement an action in a fully custom way. This can be a very useful escape hatch when you have something that you are finding difficult to model with Ash's builtin tools.","ref":"manual-actions.html","title":"Manual Actions","type":"extras"},{"doc":"For manual create/update/destroy actions, you will provide everything works pretty much the same, with the exception that the after_action hooks on a resource will receive a nil value for creates, and the old unmodified value for updates, and you are expected to add an after action hook that changes that nil value into the result of the action. For example: in the action create :special_create do manual MyApp.DoCreate end # The change defmodule MyApp.DoCreate do use Ash.Resource.ManualCreate def create ( changeset , _ , _ ) do do_something_that_creates_the_record ( changeset ) end end","ref":"manual-actions.html#manual-creates-updates-destroy","title":"Manual Actions - Manual Creates/Updates/Destroy","type":"extras"},{"doc":"Manual read actions work the same, except the will also get the &quot;data layer query&quot;. For AshPostgres, this means you get the ecto query that would have been run. # in the resource actions do read :action_name do manual MyApp.ManualRead # or `{MyApp.ManualRead, ...opts}` end end # the implementation defmodule MyApp.ManualRead do use Ash.Resource.ManualRead def read ( ash_query , ecto_query , _opts , _context ) do ... { :ok , query_results } | { :error , error } end end Modifying the query As an alternative to manual read actions, you can also provide the modify_query option, which takes an MFA and allows low level manipulation of the query just before it is dispatched to the data layer. For example: read :read do modify_query { MyApp.ModifyQuery , :modify , [ ] } end defmodule MyApp.ModifyQuery do def modify ( ash_query , data_layer_query ) do { :ok , modify_data_layer_query ( data_layer_query ) } end end This can be used as a last-resort escape hatch when you want to still use resource actions but need to do something that you can't do easily with Ash tools. As with any low level escape hatch, here be dragons.","ref":"manual-actions.html#manual-read-actions","title":"Manual Actions - Manual Read Actions","type":"extras"},{"doc":"Instrumentation Ash has two primary components, Ash.Tracer and :telemetry . Instrumentation is closely tied to observability and monitoring.","ref":"monitoring.html","title":"Monitoring","type":"extras"},{"doc":"Ash emits the following telemetry events, suffixed with :start and :stop . Start events have system_time measurements, and stop events have system_time and duration measurements. All times will be in the native time unit. Important Note the mention of :start and :stop suffixes. The event below [:ash, (api_short_name), :create] , is actually referring to two events, [:ash, (api_short_name), :create, :start] and [:ash, (api_short_name), :create, :stop] . Replace (api_short_name) with your API short name, from d:Ash.Api.Info.short_name . Events [:ash, (api_short_name), :create] - The execution of a create action. Use resource_short_name and action metadata to break down measurements. [:ash, (api_short_name), :update] - The execution of a update action. Use resource_short_name and action metadata to break down measurements. [:ash, (api_short_name), :read] - The execution of a read action. Use resource_short_name and action metadata to break down measurements. [:ash, (api_short_name), :destroy] - The execution of a destroy action. Use resource_short_name and action metadata to break down measurements. [:ash, :changeset] - A changeset being processed for a given action, i.e with Ash.Changeset.for_create . Use resource_short_name metadata to break down measurements. [:ash, :query] - A query being processed for an action, with Ash.Query.for_read . Use resource_short_name metadata to break down measurements. [:ash, :validation] - A validation being run on a changeset. Use resource_short_name and validation metadata to break down measurements. [:ash, :change] - A change being run on a changeset. Use resource_short_name and change metadata to break down measurements. [:ash, :before_action] - A before_action being run on a changeset. Use resource_short_name to break down measurements. [:ash, :after_action] - An after_action being run on a changeset. Use resource_short_name to break down measurements. [:ash, :preparation] - A preparation being run on a changeset. Use resource_short_name and preparation metadata to break down measurements. [:ash, :request_step] - The resolution of an internal request. Ash breaks up its operations internally into multiple requests, this can give you a high resolution insight onto the execution of those internal requests resolution. Use name metadata to break down measurements. [:ash, :flow] - The execution of an Ash flow. Use flow_short_name to break down measurements. [:ash, :flow, :custom_step] - The execution of a custom flow step (only if using the built in runner, which is currently the only runner). Use flow_short_name and name metadata to break down measurements.","ref":"monitoring.html#telemetry","title":"Monitoring - Telemetry","type":"extras"},{"doc":"Tracing is very similar to telemetry, but gives you some additional hooks to set_span_context() and get_span_context() . This allows you to &quot;move&quot; some piece of context between two processes. Ash will call this whenever it starts a new process to do anything. What this means is that if you are using a tracing tool or library you can ensure that any processes spawned by Ash are properly included in the trace. Additionally, you should be able to integrate a tracing library to include Ash actions/spans relatively easily by implementing the other callbacks. A tracer can be configured globally in application config. config :ash , :tracer , MyApp.Tracer Additionally, one can be provide when creating changesets or calling an api, i.e Resource # better to put it here, as changesets are traced as well. It will be carried over to the api action |&gt; Ash.Changeset . for_create ( :create , %{ } , tracer : MyApp.Tracer ) # but you can also pass it here. |&gt; Api . create! ( tracer : MyApp.Tracer ) For customizing the names created for each span, see: d:Ash.Api.Dsl.execution|trace_name d:Ash.Resource.Dsl.resource|trace_name d:Ash.Flow.Dsl.flow|trace_name","ref":"monitoring.html#tracing","title":"Monitoring - Tracing","type":"extras"},{"doc":"Due to the way before/after action hooks run, their execution time won't be included in the span created for the change. In practice, before/after action hooks are where the long running operations tend to be. We start a corresponding span and emit a telemetry event for before and after hooks, but they are only so useful. In a trace, they can highlight that &quot;some hook&quot; took a long time. In telemetry metrics they are of even less use. The cardinality of the metric would be extremely high, and we don't have a &quot;name&quot; or anything to distinguish them. To that end, you can use the macros &amp; functions available in Ash.Tracer to create custom spans and/or emit custom telemetry events from your hooks. They automatically handle cases where the provided tracer is nil , for convenience. For example: defmodule MyApp.CustomChange do use Ash.Resource.Change require Ash.Tracer def change ( changeset , _ , _ ) do changeset |&gt; Ash.Changeset . before_action ( fn changeset -&gt; Ash.Tracer . span ( :custom , &quot;custom name&quot; , changeset . context [ :private ] [ :tracer ] ) do # optionally set some metadata metadata = %{ ... } Ash.Tracer . set_metadata ( changeset . context [ :private ] [ :tracer ] , :custom , metadata ) # will get `:start` and `:stop` suffixed events emitted Ash.Tracer . telemetry_span ( [ :telemetry , :event , :name ] , metadata ) do ## Your logic here end end end ) end end","ref":"monitoring.html#after-before-action-hooks","title":"Monitoring - After/Before Action Hooks","type":"extras"},{"doc":"Multitenancy is the idea of splitting up your data into discrete areas, typically by customer. One of the most common examples of this, is the idea of splitting up a postgres database into &quot;schemas&quot; one for each customer that you have. Then, when making any queries, you ensure to always specify the &quot;schema&quot; you are querying, and you never need to worry about data crossing over between customers. The biggest benefits of this kind of strategy are the simplification of authorization logic, and better performance. Instead of all queries from all customers needing to use the same large table, they are each instead all using their own smaller tables. Another benefit is that it is much easier to delete a single customer's data on request. In Ash, there are a two primary strategies for implementing multitenancy. The first (and simplest) works for any data layer that supports filtering, and requires very little maintenance/mental overhead. It is done via expecting a given attribute to line up with the tenant , and is called :attribute . The second, is based on the data layer backing your resource, and is called :context . For information on context based multitenancy, see the documentation of your datalayer. For example, AshPostgres uses postgres schemas. While the :attribute strategy is simple to implement, it also offers fewer advantages, primarily acting as another way to ensure your data is filtered to the correct tenant.","ref":"multitenancy.html","title":"Multitenancy","type":"extras"},{"doc":"defmodule MyApp.Users do use Ash.Resource , ... multitenancy do strategy :attribute attribute :organization_id end ... relationships do belongs_to :organization , MyApp.Organization end end In this case, if you were to try to run a query without specifying a tenant, you would get an error telling you that the tenant is required. Setting the tenant when using the code API is done via Ash.Query.set_tenant/2 and Ash.Changeset.set_tenant/2 . If you are using an extension, such as AshJsonApi or AshGraphql the method of setting tenant context is explained in that extension's documentation. Example usage of the above: # Error when not setting a tenant MyApp.Users |&gt; Ash.Query . filter ( name == &quot;fred&quot; ) |&gt; MyApi . read! ( ) ** (Ash.Error.Invalid) * &quot;Queries against the Helpdesk.Accounts.User resource require a tenant to be specified&quot; ( ash 1.22 . 0 ) lib / ash / api / api . ex : 944 : Ash.Api . unwrap_or_raise! / 2 # Automatically filtering by `organization_id == 1` MyApp.Users |&gt; Ash.Query . filter ( name == &quot;fred&quot; ) |&gt; Ash.Query . set_tenant ( 1 ) |&gt; MyApi . read! ( ) [ ... ] # Automatically setting `organization_id` to `1` MyApp.Users |&gt; Ash.Changeset . new ( name : &quot;fred&quot; ) |&gt; Ash.Changeset . set_tenant ( 1 ) |&gt; MyApi . create! ( ) % MyApp.User { organization_id : 1 } If you want to enable running queries without a tenant as well as queries with a tenant, the global? option supports this. You will likely need to incorporate this ability into any authorization rules though, to ensure that users from one tenant can't access other tenant's data. multitenancy do strategy :attribute attribute :organization_id global? true end You can also provide the parse_attribute? option if the tenant being set doesn't exactly match the attribute value, e.g the tenant is org_10 and the attribute is organization_id , which requires just 10 .","ref":"multitenancy.html#attribute-multitenancy","title":"Multitenancy - Attribute Multitenancy","type":"extras"},{"doc":"Context multitenancy allows for the data layer to dictate how multitenancy works. For example, a csv data layer might implement multitenancy via saving the file with different suffixes, or an API wrapping data layer might use different subdomains for the tenant. For AshPostgres context multitenancy, which uses postgres schemas and is referred to ash &quot;Schema Based Multitenancy&quot;, see the guide","ref":"multitenancy.html#context-multitenancy","title":"Multitenancy - Context Multitenancy","type":"extras"},{"doc":"","ref":"notifiers.html","title":"Notifiers","type":"extras"},{"doc":"PubSub: Ash.Notifier.PubSub","ref":"notifiers.html#built-in-notifiers","title":"Notifiers - Built-in Notifiers","type":"extras"},{"doc":"A notifier is a simple extension that must implement a single callback notify/1 . Notifiers do not have to implement an Ash DSL extension, but they may in order to configure how that notifier should behave. See Ash.Notifier.Notification for the currently available fields. Notifiers should not do anything intensive synchronously. If any heavy work needs to be done, they should delegate to something else to handle the notification, like sending it to a GenServer or GenStage. Eventually, there may be built in notifiers that will make setting up a GenStage that reacts to your resource changes easy. Until then, you'll have to write your own. For more information on creating a DSL extension to configure your notifier, see the docs for Spark.Dsl.Extension . Example notifier defmodule ExampleNotifier do use Ash.Notifier def notify ( % Ash.Notifier.Notification { resource : resource , action : %{ type : :create } , actor : actor } ) do if actor do Logger . info ( &quot; \#{ actor . id } created a \#{ resource } &quot; ) else Logger . info ( &quot;A non-logged in user created a \#{ resource } &quot; ) end end end Including a notifier in a resource defmodule MyResource do use Ash.Resource , notifiers : [ ExampleNotifier ] end","ref":"notifiers.html#creating-a-notifier","title":"Notifiers - Creating a notifier","type":"extras"},{"doc":"API calls involving resources who's datalayer supports transactions (like Postgres), notifications are saved up and sent after the transaction is closed. For example, the api call below ultimately results in many many database calls. Post |&gt; Ash.Changeset . new ( %{ } ) |&gt; Ash.Changeset . manage_relationship ( :related_posts , [ 1 , 2 , 3 ] , type : :append ) |&gt; Ash.Changeset . manage_relationship ( :related_posts , [ 4 , 5 ] , type : :remove ) |&gt; Ash.Changeset . manage_relationship ( :comments , [ 10 ] , type : :append ) |&gt; Api . update! ( ) Ash doesn't support bulk database operations yet, so it performs the following operations: a read of the currently related posts a read of the currently related comments a creation of a post_link to relate to 1 a creation of a post_link to relate to 2 a creation of a post_link to relate to 3 a destruction of the post_link related to 4 a destruction of the post_link related to 5 an update to comment 10, to set its post_id to this post If all three of these resources have notifiers configured, we need to send a notification for each operation (notifications are not sent for reads). For data consistency reasons, if a data layer supports transactions, all writes are done in a transaction. However, if you try to read the record from the database that you have just received a notification about before the transaction has been closed, in a different process, the information will be wrong. For this reason, Ash accumulates notifications until they can be sent. If you need to perform multiple operations against your resources in your own transaction, you will have to handle that case yourself. To support this, Ash.Api.create/2 , Ash.Api.update/2 and Ash.Api.destroy/2 support a return_notifications?: true option. This causes the api call to return {:ok, result, notifications} in the successful case. Here is an example of how you might use it. result = Ash.DataLayer . transaction ( resource , fn -&gt; { :ok , something , notifications1 } = create_something ( ) { :ok , result , notifications2 } = create_another_thing ( something ) { :ok , notifications3 } = destroy_something ( something ) { result , Enum . concat ( [ notifications1 , notifications2 , notifications3 ] ) } end ) case result do { :ok , value , notifications } -&gt; Ash.Notifier . notify ( notifications ) value { :error , error } -&gt; handle_error ( error ) end","ref":"notifiers.html#transactions","title":"Notifiers - Transactions","type":"extras"},{"doc":"Pagination is configured at the action level. There are two kinds of pagination supported: keyset and offset . There are pros and cons to each. An action can support both at the same time, or only one (or none). A full count of records can be requested by passing page: [count: true] , but it should be kept in mind that doing this requires running the same query twice, one of which is a count of all records. Ash does these in parallel, but it can still be quite expensive on large datasets. For more information on the options for configuring actions to support pagination, see d:Ash.Resource.Dsl.actions.read|prepare","ref":"pagination.html","title":"Pagination","type":"extras"},{"doc":"Offset pagination is done via providing a limit and an offset . A limit is how many records that should be returned on the page. An offset is how many records from the beginning should be skipped. Using this, you might make requests like the following: # Get the first ten records Api . read ( Resource , page : [ limit : 10 ] ) # Get the second ten records Api . read ( Resource , page : [ limit : 10 , offset : 10 ] ) # No need to do this in practice, see `c:Ash.Api.page/2` Offset Pros Simple to think about Possible to skip to a page by number. E.g the 5th page of 10 records is offset: 40 Easy to reason about what page you are currently on (if the total number of records is requested) Can go to the last page (even though, if done by using the full count, the data could have changed) Offset Cons Does not perform well on large datasets (if you have to ask if your dataset is &quot;large&quot;, it probably isn't) When moving between pages, if data was created or deleted, records may appear on multiple pages","ref":"pagination.html#offset-pagination","title":"Pagination - Offset Pagination","type":"extras"},{"doc":"Keyset pagination is done via providing an after or before option, as well as a limit . The value of this option should be a keyset that has been returned from a previous request. Keysets are returned when a request is made with a limit to an action that supports keyset pagination, and they are stored in the __metadata__ key of each record. The keyset is a special value that can be passed into the after or before options, to get records that occur after or before. For example: page = Api . read ( Resource , page : [ limit : 10 ] ) last_record = List . last ( page . results ) # No need to do this in practice, see `c:Ash.Api.page/2` next_page = Api . read ( Resource , page : [ limit : 10 , after : last_record . __metadata__ . keyset ] ) Keyset Pros Performs very well on large datasets (assuming indices exist on the columns being sorted on) Behaves well as data changes. The record specified will always be the first or last item in the page Keyset Cons A bit more complex to use Can't go to a specific page number","ref":"pagination.html#keyset-pagination","title":"Pagination - Keyset Pagination","type":"extras"},{"doc":"Ash plays nicely with phoenix. There are a few things to consider when using them side-by-side.","ref":"phoenix.html","title":"Phoenix","type":"extras"},{"doc":"To add Ash to an existing application is easy, generally only involves updating your Ecto.Repo to use AshPostgres.Repo if you are using AshPostgres . Other than that, you can follow the guides as usual.","ref":"phoenix.html#adding-ash-to-an-existing-phoenix-app","title":"Phoenix - Adding Ash to an existing Phoenix app","type":"extras"},{"doc":"If you want to use AshPostgres , you have two options here: create a phoenix app as normal, and when you set up AshPostgres , ignore the steps for creating the repo, and instead update it to use AshPostgres.Repo . create the app with --no-ecto and follow the AshPostgres guide getting started guide fully.","ref":"phoenix.html#creating-a-new-phoenix-app","title":"Phoenix - Creating a new Phoenix app","type":"extras"},{"doc":"If you are using extensions like AshGraphql or AshJsonApi, you will want to follow their getting started guides separately.","ref":"phoenix.html#using-extensions","title":"Phoenix - Using Extensions","type":"extras"},{"doc":"Policies determine what actions on a resource are permitted for a given actor.","ref":"policies.html","title":"Policies","type":"extras"},{"doc":"Read and understand the Security guide before proceeding, which explains actors, how to set them, and other relevant configurations.","ref":"policies.html#important","title":"Policies - Important!","type":"extras"},{"doc":"You'll need to add the extension to your resource, like so: use Ash.Resource , authorizers : [ Ash.Policy.Authorizer ] Policy Every policy that applies must pass for a given request. For example, a policy might have a condition action_type(:read) and another one might have a condition like actor_attribute_equals(:admin, true) . If both apply (i.e an admin is using a read action), then both policies must pass. A policy can produce one of three results: :forbidden , :authorized , or :unknown . :unknown is treated the same as a :forbidden . A policy contains checks, which determine whether or not the policy passes for a given request. Bypass A bypass policy is just like a policy, except if a bypass passes, then other policies after it do not need to pass . This can be useful for writing complex access rules, or for a simple rule like &quot;an admin can do anything&quot;. The Simplest Policy Lets start with the simplest policy set: policies do policy always ( ) do authorize_if always ( ) end end Here, we have a single policy. The first argument to policy is the &quot;condition&quot;. If the condition is true, then the policy applies to the request. If a given policy applies, then one of the checks inside the policy must authorize that policy. Every policy that applies to a given request must each be authorized for a request to be authorized. Within this policy we have a single check, declared with authorize_if . Checks logically apply from top to bottom, based on their check type. In this case, we'd read the policy as &quot;this policy always applies, and authorizes always&quot;. There are four check types, all of which do what they sound like they do: authorize_if - if the check is true, the policy is authorized. authorize_unless - if the check is false, the policy is authorized. forbid_if - if the check is true, the policy is forbidden. forbid_unless - if the check is false, the policy is forbidden. In each case, if the policy is not authorized or forbidden, the flow moves to the next check.","ref":"policies.html#guide","title":"Policies - Guide","type":"extras"},{"doc":"Not every check must pass! This is described above, but is very important so another example is provided here. Checks go from top to bottom, and the first one that reaches a decision determines the policy result . For example: policy action_type ( :create ) do authorize_if IsSuperUser forbid_if Deactivated authorize_if IsAdminUser forbid_if RegularUserCanCreate authorize_if RegularUserAuthorized end We check those from top to bottom, so the first one of those that returns :authorized or :forbidden determines the entire outcome. For example: authorize_if IsSuperUser # if this is true # None of the rest of them matter forbid_if Deactivated authorize_if IsAdminUser forbid_if RegularUserCanCreate authorize_if RegularUserAuthorized A realistic policy In this example, we use some of the provided built in checks. policies do # Anything you can use in a condition, you can use in a check, and vice-versa # This policy applies if the actor is a super_user # Additionally, this policy is declared as a `bypass`. That means that this check is allowed to fail without # failing the whole request, and that if this check *passes*, the entire request passes. bypass actor_attribute_equals ( :super_user , true ) do authorize_if always ( ) end # This will likely be a common occurrence. Specifically, policies that apply to all read actions policy action_type ( :read ) do # unless the actor is an active user, forbid forbid_unless actor_attribute_equals ( :active , true ) # if the record is marked as public, authorize authorize_if attribute ( :public , true ) # if the actor is related to the data via that data&#39;s `owner` relationship, authorize authorize_if relates_to_actor_via ( :owner ) end end Check Checks, like policies, evaluate from top to bottom. A check can produce one of three results, the same that a policy can produce. While checks are not necessarily evaluated in order, they logically apply in that order, so you may as well think of it in that way. It can be thought of as a simple step-through algorithm. For each check, starting from the top: Run the check. If it returns :authorized , the policy is :authorized If it returns :forbidden , the policy is :forbidden If it returns :unknown , the next check down is checked Builtin Checks To see what checks are built-in, see Ash.Policy.Check.Builtins Custom Checks There are three types of checks. :simple , :filter and :manual . Generally speaking, you will almost always want to write either :simple or :filter checks. They are both a subset of a :manual checks. To implement a manual check, create a module that adopts the Ash.Policy.Check behaviour. Simple and Filter checks are documented below. Simple Checks Simple checks are determined at the outset of a request, and can only cause a request to be authorized or unauthorized. See Filter Checks below for more information on writing checks that can be applied as filters. defmodule MyApp.Checks.ActorIsOldEnough do use Ash.Policy.SimpleCheck def describe ( _ ) do &quot;actor is old enough&quot; end # The context here has the changeset, query, resource, and api. # match? just needs to return true or false, i.e &quot;is the actor old enough&quot; def match? ( % MyApp.User { age : age } , %{ resource : MyApp.Beer } , _ ) do age &gt;= 21 end def match? ( _ , _ , _ ) , do : true end Filter Checks Many checks won't return a status, but instead return a &quot;filter&quot;. Filter checks can be used in policies that may be applied to read, update, and destroy actions. For update and destroy, they apply to the data before the action is run. For reads, they will automatically restrict the returned data to be compliant with the filter. Expression checks, explained in more detail below, are really just Filter Checks. defmodule MyApp.Checks.ActorOverAgeLimit do use Ash.Policy.FilterCheck require Ash.Query import Ash.Filter.TemplateHelpers , only : [ actor : 1 ] # A description is not necessary, as it will be derived from the filter, but one could be added # def describe(_opts), do: &quot;Actor is over the age limit&quot; # filter checks don&#39;t have the `context` available to them def filter ( _options ) do Ash.Query . expr ( age_limit &lt;= ^ actor ( :age ) ) end end Expression Checks A simple way to define a policy is by using expr/1 in the policy. For example: authorize_if expr ( exists ( role , name == &quot;owner&quot; ) ) Keep in mind that, for create actions, many expr/1 checks won't make sense, and may return false when you wouldn't expect. Expression (and other filter) policies apply to &quot;a synthesized result&quot; of applying the action, so related values won't be available. For this reason, you may end up wanting to use other checks that are built for working against changesets, or only simple attribute-based filter checks. Custom checks may also be warranted here. Referencing the actor In expression policies, the actor template can be used (other templates that may work in filter expressions, for example, are not available). For example: authorize_if expr ( author . id == ^ actor ( :id ) ) Using exists Lets compare the following expressions: Filtering on related data by directly referencing the relationship friends . first_name == &quot;ted&quot; and friends . last_name == &quot;dansen&quot; Filtering on related data using exists/2 exists ( friends , first_name == &quot;ted&quot; ) and exists ( friends , last_name == &quot;dansen&quot; ) In policies (and often any time you mean &quot;a related thing exists where some condition is true&quot;) you should generally prefer filter checks, it is advised to use exists/2 when referring to relationships, because of the way that the policy authorizer may mix &amp; match your policies when building filters. This is also true when adding filters to actions. If you use exists , then your policies can be used in filters without excluding unnecessary data, i.e exists(friends, first_name == &quot;ted&quot;) and exists(friends, last_name == &quot;dansen&quot;) means &quot;you have one friend with the first_name &quot;ted&quot; and one friend with the last_name &quot;dansen&quot;. For instance, imagine a scenario where you have an action like this: read :friends_of_ted do filter expr ( friends . first_name == &quot;ted&quot; ) end And someone calls it like so: Resource |&gt; Ash.Query . for_read ( :friends_of_ted ) |&gt; Ash.Query . filter ( friends . last_name == &quot;dansen&quot; ) The resulting filter is friends.first_name == &quot;ted&quot; and friends.last_name == &quot;dansen&quot; . This means that there must be one friend with the name &quot;ted dansen&quot;. Sometimes that is what you mean to do, but generally speaking I would expect the above code to say &quot;friends of ted that also have a friend with the last name &quot;dansen&quot; &quot;. To accomplish that, we can rework the example like so: read :friends_of_ted do filter expr ( exists ( friends , first_name == &quot;ted&quot; ) ) end # Calling it Resource |&gt; Ash.Query . for_read ( :friends_of_ted ) |&gt; Ash.Query . filter ( exists ( friends , last_name == &quot;dansen&quot; ) ) Access Type The default access type is :filter . In most cases this will be all you need. In the example above, if a user made a request for all instances of the resource, it wouldn't actually return a forbidden error. Instead, it attaches the appropriate filter to fetch data that the user can see. If the actor attribute active was false , then the request would be forbidden (because there is no data for which they can pass this policy). However, if active is true , the authorizer would attach the following filter to the request: public or owner == ^ actor ( :_primary_key ) To understand what actor(:_primary_key) means, see the Filter Templates section in Ash.Filter Additionally, some checks have more expensive components that can't be checked before the request is run. To enable those, use the access_type :runtime . All checks that can be implemented as filters or strict checks will still be done that way, but this enables checks to run their check/4 callback if necessary.","ref":"policies.html#important-how-a-decision-is-reached","title":"Policies - IMPORTANT! How a decision is reached","type":"extras"},{"doc":"","ref":"policies.html#policy-breakdowns","title":"Policies - Policy Breakdowns","type":"extras"},{"doc":"Policy breakdowns can be fetched on demand for a given forbidden error (either an Ash.Error.Forbidden that contains one ore more Ash.Error.Forbidden.Policy errors, or an Ash.Error.Forbidden.Policy error itself), via Ash.Error.Forbidden.Policy.report/2 . Here is an example policy breakdown from tests: Policy Breakdown A check status of `?` implies that the solver did not need to determine that check. Some checks may look like they failed when in reality there was no need to check them. Look for policies with `✘` and `✓` in check statuses. A check with a `⬇` means that it didn't determine if the policy was authorized or forbidden, and so moved on to the next check. `🌟` and `⛔` mean that the check was responsible for producing an authorized or forbidden (respectively) status. If no check results in a status (they all have `⬇`) then the policy is assumed to have failed. In some cases, however, the policy may have just been ignored, as described above. Admins and managers can create posts | ⛔: authorize if: actor.admin == true | ✘ | ⬇ authorize if: actor.manager == true | ✘ | ⬇ To remove the help text, you can pass the help_text?: false option, which would leave you with: Policy Breakdown Admins and managers can create posts | ⛔: authorize if: actor.admin == true | ✘ | ⬇ authorize if: actor.manager == true | ✘ | ⬇","ref":"policies.html#explanation","title":"Policies - Explanation","type":"extras"},{"doc":"IMPORTANT WARNING The following configuration should only ever be used in development mode! Instructions For security reasons, authorization errors don't include any extra information, aside from forbidden . To have authorization errors include a policy breakdown (without help text) use the following config. config :ash , :policies , show_policy_breakdowns? : true","ref":"policies.html#including-in-error-message","title":"Policies - Including in error message","type":"extras"},{"doc":"It is generally safe to log authorization error details, even in production. This can be very helpful when investigating certain classes of issue. To have ash automatically log each authorization failure, use config :ash , :policies , log_policy_breakdowns : :error # Use whatever log level you&#39;d like to use here To have ash log all policies breakdowns, even successful ones (this will be lots of noise, and should only be used for dev testing) config :ash , :policies , log_successful_policy_breakdowns : :error # Use whatever log level you&#39;d like to use here","ref":"policies.html#logging","title":"Policies - Logging","type":"extras"},{"doc":"Ash includes a builtin notifier to help you publish events over any kind of pub-sub pattern. This is plug and play with Phoenix.PubSub , but could be used with any pubsub pattern. You configure a module that defines a broadcast/3 function, and then add some &quot;publications&quot; which configure under what conditions an event should be sent and what the topic should be. For the full DSL spec see Ash.Notifier.PubSub","ref":"pub_sub.html","title":"Pub Sub","type":"extras"},{"doc":"It can be quite frustrating when setting up pub_sub when everything appears to be set up properly, but you aren't receiving events. This usually means some kind of mismatch between the event names produced by the resource/config of your publications, and you can use the following flag to display debug information about pub sub events coming from Ash.Notifier.PubSub config :ash , :pub_sub , debug? : true","ref":"pub_sub.html#debugging-pubsub","title":"Pub Sub - Debugging PubSub","type":"extras"},{"doc":"Often you want to include some piece of data in the thing being changed, like the :id attribute. This is done by providing a list as the topic, and using atoms which will be replaced by their corresponding values. They will ultimately be joined with : . For example: prefix &quot;user&quot; publish :create , [ &quot;created&quot; , :user_id ] This might publish a message to &quot;user:created:1&quot; for example. For updates, if the field in the template is being changed, a message is sent to both values. So if you change user 1 to user 2 , the same message would be published to user:updated:1 and user:updated:2 . If there are multiple attributes in the template, and they are all being changed, a message is sent for every combination of substitutions.","ref":"pub_sub.html#topic-templates","title":"Pub Sub - Topic Templates","type":"extras"},{"doc":"If the previous value was nil or the field was not selected on the data passed into the action, then a notification is not sent for the previous value. If the new value is nil then a notification is not sent for the new value.","ref":"pub_sub.html#important","title":"Pub Sub - Important","type":"extras"},{"doc":"Templates may contain lists, in which case all combinations of values in the list will be used. Add nil to the list if you want to produce a pattern where that entry is omitted. The atom :_tenant may be used. If the changeset has a tenant set on it, that value will be used, otherwise that combination of values is ignored. The atom :_pkey may be used. It will be a stringified, concatenation of the primary key fields, or just the primary key if there is only one primary key field. The atom nil may be used. It only makes sense to use it in the context of a list of alternatives, and adds a pattern where that part is skipped. publish :updated , [ [ :team_id , :_tenant ] , &quot;updated&quot; , [ :id , nil ] ] Would produce the following messages, given a team_id of 1, a tenant of org_1 , and an id of 50 : &quot;1:updated:50&quot; &quot;1:updated&quot; &quot;org_1:updated:50&quot; &quot;org_1:updated&quot;","ref":"pub_sub.html#template-parts","title":"Pub Sub - Template parts","type":"extras"},{"doc":"Phoenix expects a specific shape of data to be broadcasted, and since it is so often used with Ash, instead of making you define your own notifier that creates the %Phoenix.Socket.Broadcast struct and publishes it, Ash has an option to do that automatically, via broadcast_type : :phoenix_broadcast","ref":"pub_sub.html#usage-with-phoenix","title":"Pub Sub - Usage with Phoenix","type":"extras"},{"doc":"Relationships are a core component of Ash. They provide a mechanism to describe the relationships between your resources, and through those relationships you can do things like Loading related data Filtering on related data Managing related records through changes on a single resource Authorizing based on the state of related data","ref":"relationships.html","title":"Relationships","type":"extras"},{"doc":"By default, we assume foreign keys that we add by default (for belongs_to relationships) should be :uuid . To change this default, set the following configuration: config :ash , :default_belongs_to_type , :integer","ref":"relationships.html#customizing-default-belongs_to-attribute-type","title":"Relationships - Customizing default belongs_to attribute type","type":"extras"},{"doc":"Loading relationships is a very common use case. There are two ways to load relationships, in the query, and on records. On records Given a set of records, like [user1, user2] , you can load their relationships by calling your Ash Api's load function. YourApi . load ( users , :friends ) This will fetch the friends of each user, and set them in the corresponding friends key. In the query Loading in the query is currently pretty much the same as loading on records, but eventually data layers will be able to optimize these loads, potentially including them as joins in the main query, for example. The following will return the list of users with their friends loaded, as the above example. User |&gt; Ash.Query . load ( :friends ) |&gt; YourApi . read ( ) More complex data loading Multiple relationships can be loaded at once, i.e YourApi . load ( users , [ :friends , :enemies ] ) Nested relationships can be loaded: YourApi . load ( users , friends : [ :friends , :enemies ] ) The queries used for loading can be customized by providing a query as the value. friends = Ash.Query . sort ( User , social_score : :asc ) YourApi . load ( users , friends : friends ) Nested loads will be included in the parent load. friends = User |&gt; Ash.Query . sort ( social_score : :asc ) |&gt; Ash.Query . load ( :friends ) # Will load friends and friends of those friends YourApi . load ( users , friends : friends )","ref":"relationships.html#loading-related-data","title":"Relationships - Loading related data","type":"extras"},{"doc":"See Managing Relationships for more information.","ref":"relationships.html#managing-related-data","title":"Relationships - Managing related data","type":"extras"},{"doc":"All relationships have a source and a destination , as well as a corresponding source_attribute and destination_attribute . Many to many relationships have additional fields which are discussed below. Relationships will validate at compile time that their configured attributes exist. You don't need to have a corresponding &quot;reverse&quot; relationship for every relationship, i.e if you have a MyApp.Tweets resource with belongs_to :user, User you aren't required to have a has_many :tweets, MyApp.Tweet . All that is required is that the attributes used by the relationship exist.","ref":"relationships.html#relationships-basics","title":"Relationships - Relationships Basics","type":"extras"},{"doc":"Belongs To belongs_to :owner , MyApp.User A belongs_to relationship means that there is an attribute ( source_attribute ) on the source resource that uniquely identifies a record with a matching destination_attribute in the destination. In the example above, the source attribute would be owner_id , and if you wanted to change the owner, you'd modify the owner_id to point to a different MyApp.User Belongs to Source Attribute The destination_attribute defaults to :id . By default, a belongs_to relationship will define an attribute called &lt;relationship_name&gt;_id of type :uuid on the resource. To configure this, use options like: d:Ash.Resource.Dsl.relationships.belongs_to|define_attribute? to define it yourself d:Ash.Resource.Dsl.relationships.belongs_to|attribute_type to modify the default type d:Ash.Resource.Dsl.relationships.belongs_to|attribute_writable? to make the source attribute private?: false, writable?: true (both are not the default) For example: belongs_to :owner , MyApp.User do attribute_type :integer attribute_writable? true end Or if you wanted to define the attribute yourself, attributes do attribute :owner_foo , MyApp.CustomType end ... relationships do belongs_to :owner , MyApp.User do define_attribute? false source_attribute :owner_foo end end See the docs for more: d:Ash.Resource.Dsl.relationships.belongs_to Has One # on MyApp.User has_one :profile , MyApp.Profile A has_one is similar to a belongs_to except the &quot;reference&quot; attribute is on the destination resource, instead of the source. In the example above, we'd expect a profile_id to be on MyApp.Profile , and that it is unique. Has One Attribute Defaults By default, the source_attribute is assumed to be :id , and destination_attribute defaults to &lt;snake_cased_last_part_of_module_name&gt;_id . In the above example, it would default destination_attribute to user_id . See the docs for more: d:Ash.Resource.Dsl.relationships.has_one Has Many # on MyApp.Post has_many :comments , Comment A has_many relationship is similar to a has_one in that the reference attribute is on the destination resource. The only difference between this and has_one is that it does not expect the destination attribute is unique on the destination, and therefore will produce a list of related items. Has Many Attribute Defaults By default, the source_attribute is assumed to be :id , and destination_attribute defaults to &lt;snake_cased_last_part_of_module_name&gt;_id . In the above example, it would default destination_attribute to post_id . See the docs for more: d:Ash.Resource.Dsl.relationships.has_many","ref":"relationships.html#kinds-of-relationships","title":"Relationships - Kinds of relationships","type":"extras"},{"doc":"Lets say that individual todo items in our app can be added to multiple lists, and every list has multiple todo items. This is a great case for many_to_many relationships. For example, we could define the following many_to_many relationship: # on MyApp.TodoList many_to_many :todo_items , MyApp.TodoItem do through MyApp.TodoListItem source_attribute_on_join_resource :list_id destination_attribute_on_join_resource :item_id end And then we could define the &quot;join resource&quot; to connect everything: MyApp.TodoListItem defmodule MyApp.TodoListItem do use Ash.Resource , data_layer : your_data_layer attributes do uuid_primary_key :id end relationships do belongs_to :todo_list , MyApp.TodoList do allow_nil? false end belongs_to :item , MyApp.TodoItem do allow_nil? false end end end Now that we have a resource with the proper attributes, Ash will use this automatically under the hood when performing the relationship operations detailed above, like filtering and loading. See the docs for more: d:Ash.Resource.Dsl.relationships.many_to_many","ref":"relationships.html#many-to-many-relationships","title":"Relationships - Many To Many Relationships","type":"extras"},{"doc":"","ref":"security.html","title":"Security","type":"extras"},{"doc":"A great thing to do early on is to be explicit about your security configuration. To that end, once you've read this guide, we highly recommend that you place the configuration found at the bottom of your guide into your api modules, even if you are simply setting them to their default values. Especially the authorize option.","ref":"security.html#important-note","title":"Security - Important Note!","type":"extras"},{"doc":"Authorization in Ash is done via authorizers. Generally, you won't need to create your own authorizer, as the builtin policy authorizer Ash.Policy.Authorizer should work well for any use case. Authorization is performed with a given actor and a query or changeset. Actors An actor is the &quot;entity performing the action&quot;. This is generally a user, but could potentially be an organization, a group, whatever makes sense for your use case. By default, when using Ash in code, authorization does not happen. # Does not perform authorization Api . read! ( User ) However, if you either 1. provide an actor or 2. use the authorize?: true option, then authorization will happen. # Authorize with a `nil` actor (which is valid, i.e if no one is logged in and they are trying to list users) Api . read! ( User , actor : nil ) # Authorize with a `nil` actor Api . read! ( User , authorize? : true ) # Authorize with an actor Api . read! ( User , actor : current_user ) # Authorize with an actor, but being explicit Api . read! ( User , actor : current_user , authorize? : true ) # Skip authorization, but set an actor. The actor can be used in other things than authorization # so this may make sense depending on what you are doing. Api . read! ( User , actor : current_user , authorize? : false ) Where to set the actor When setting an actor, if you are building a query or changeset, you should do so at the time that you call the various for_* functions. This makes the actor available in the context of any change that is run. For example: # DO THIS Resource |&gt; Ash.Query . for_read ( :read , input , actor : current_user ) |&gt; Api . read ( ) # DON&#39;T DO THIS Resource |&gt; Ash.Query . for_read ( :read , input , actor : current_user ) |&gt; Api . read ( actor : current_user ) The second option &quot;works&quot; in most cases, but not all, because some change s might need to know the actor Context Ash can store the actor, query context, or tenant in the process dictionary. This can help simplify things like live views, controllers, or channels where all actions performed share these pieces of context. This can be useful, but the general recommendation is to be explicit by passing options. # in socket connect, liveview mount, or a plug Ash . set_actor ( current_user ) # This will now use the actor set in the context. Api . read! ( User ) Authorization Configuration The default behavior is illustrated above, but it can be customized with the options in the d:Ash.Api.authorization section of the Api module you are calling. d:Ash.Api.Dsl.authorization|require_actor? Requires that an actor is set for all requests. Important: nil is still a valid actor, so this won't prevent providing actor: nil . d:Ash.Api.dsl.authorization|authorize Important! The default value for this is relatively loose, and we intend to change it in the 3.0 release (which is not scheduled for anytime soon). Right now, it is :when_requested , but a better default would be :by_default , and is what you should choose when starting out. When to run authorization for a given request. :always forces authorize?: true on all requests to the Api. :by_default sets authorize?: true if the authorize? option was not set (so it can be set to false ). :when_requested sets authorize?: true whenever an actor is set or authorize?: true is explicitly passed. This is the default behavior.","ref":"security.html#authorization","title":"Security - Authorization","type":"extras"},{"doc":"There are various things that can be stored in the process dictionary as opposed to passing them to every function. This is a stylistic choice, and in many cases could lead to less clear code, so use with caution. See the functions in the Ash module for more. The following things can be stored in the process: Query/changeset context, will be merged with the context of any query/changeset before it is run. The current actor (i.e current_user) Whether or not to run authorization, i.e authorize? The current tracer The current tenant","ref":"store-context-in-process.html","title":"Store Context In Process","type":"extras"},{"doc":"","ref":"testing.html","title":"Testing","type":"extras"},{"doc":"The first thing you will likely want to do, especially if you are using AshPostgres , is to add the following config to your config/test.exs . # config/test.exs config :ash , :disable_async? , true This ensures that Ash does not spawn tasks when executing your requests, which is necessary for doing transactional tests with AshPostgres .","ref":"testing.html#async-tests","title":"Testing - Async tests","type":"extras"},{"doc":"Timeouts in Ash work a bit differently than other tools. The following considerations must be taken into account: If you run a resource action in a transaction, then the timeout applies to the entire transaction. If the resource action you are running, and any of its touches_resources is already in a transaction then the timeout is ignored, as the outer transaction is handling the timeout. If the resource is not in a transaction, and supports async execution (ash_postgres does), then everything is run in a task and awaited with the provided timeout. If the data layer of the resource does not support timeouts, or async execution then timeouts are ignored . As of the writing of this guide, none of the API extensions support specifying a timeout. If/when they do, they will run the action they are meant to run in a Task .","ref":"timeouts.html","title":"Timeouts","type":"extras"},{"doc":"You have a few options. You can specify a timeout when you call an action. This takes the highest precedence. MyApi . read! ( query , timeout : :timer . seconds ( 30 ) ) You can specify one using Ash.Changeset.timeout/2 or Ash.Query.timeout/2 . This can be useful if you want to conditionally set a timeout based on the details of the request. For example, you might do something like this: # in your resource defmodule MyApp.SetReportTimeout do use Ash.Resource.Preparation def prepare ( query , _ , _ ) do if Ash.Query . get_argument ( query , :full_report ) do Ash.Query . timeout ( query , :timer . minutes ( 3 ) ) else Ash.Query . timeout ( query , :timer . minutes ( 1 ) ) end end end actions do read :report_items do argument :full_report , :boolean , default : false prepare MyApp.SetReportTimeout end end And you can specify a default timeout on the Api module that you call your resources with. Overriding an api with a default timeout requires providing a timeout of :infinity in one of the other methods. execution do timeout :timer . seconds ( 30 ) # this is the default end Keep in mind, you can't specify timeouts in a before_action or after_action hook, because at that point you are already &quot;within&quot; the code that should have a timeout applied.","ref":"timeouts.html#ways-to-specify-timeouts","title":"Timeouts - Ways to Specify Timeouts","type":"extras"}]